SystemOrganization addCategory: #'Sight-Dynamic'!
SystemOrganization addCategory: #'Sight-Dynamic-UI-Designs'!
SystemOrganization addCategory: #'Sight-Dynamic-UI-Support'!
SystemOrganization addCategory: #'Sight-Dynamic-Models'!
SystemOrganization addCategory: #'Sight-Dynamic-Models-Code'!
SystemOrganization addCategory: #'Sight-Dynamic-Testbed'!
SystemOrganization addCategory: #'Sight-Dynamic-Events'!
SystemOrganization addCategory: #'Sight-Dynamic-Tests'!
SystemOrganization addCategory: #'Sight-Dynamic-Support'!
SystemOrganization addCategory: #'Sight-Dynamic-Coverage'!
SystemOrganization addCategory: #'Sight-Dynamic-Traits'!
SystemOrganization addCategory: #'Sight-Dynamic-Help'!
SystemOrganization addCategory: #'Sight-Dynamic-Benchmarks'!
SystemOrganization addCategory: #'Sight-Dynamic-UI-Layouts'!

Trait named: #TSdDynamicActivation
	uses: {}
	category: 'Sight-Dynamic-Traits'!

Trait named: #TSdDynamicAccessor
	uses: TSdDynamicActivation
	category: 'Sight-Dynamic-Traits'!

TSdDynamicAccessor classTrait
	uses: TSdDynamicActivation classTrait!

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 11:16:04.92'!
browseArgumentClass: aNode index: anInteger

	aNode argumentClasses ifNil: [
		self collectProperties: #(argumentClasses) inNodeGroups: {{aNode}}].
	
	self classActivated: (aNode argumentClasses at: anInteger).! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 10:31:23.185'!
browseMethod: aNode

	self methodActivated: aNode clientReference.! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 10:31:27.61'!
browseReceiverClass: aNode

	self classActivated: aNode receiverClass.! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 11:16:25.054'!
browseReturnClass: aNode

	aNode returnClass ifNil: [
		self collectProperties: #(returnClass) inNodeGroups: {{aNode}}].
	
	self classActivated: aNode returnClass.! !

!TSdDynamicAccessor methodsFor: 'dynamic - aggregation' stamp: 'mt 7/23/2011 10:44:31.012'!
collectArgumentClasses: nodeGroups
	"All nodes are for one method call. Different to #collectArgumentClassesByCallgraph: this method joins all found classes and returns each class only once."
	
	| args |
	self
		collectProperties: #(argumentClasses)
		inNodeGroups: (nodeGroups collect: [:nodes |
			nodes select: [:node | node argumentClasses isNil]]).
	
	args := nodeGroups first first argumentClasses collect: [:cls | Set new].
	
	"Collect all classes from all traces into sets."
	nodeGroups do: [:nodes | nodes do: [:node |
		node argumentClasses withIndexDo: [:cls :idx |
			(args at: idx) add: cls]]].

	args := args collect: [:arg | arg asOrderedCollection].

	^ args! !

!TSdDynamicAccessor methodsFor: 'dynamic - aggregation' stamp: 'mt 7/23/2011 11:27:22.76'!
collectArgumentClassesByCallgraph: nodeGroups
	"All nodes are for one method call."
	
	self
		collectProperties: #(argumentClasses)
		inNodeGroups: (nodeGroups collect: [:nodes |
			nodes select: [:node | node argumentClasses isNil]]).
	
	^ nodeGroups collect: [:nodes | nodes collect: [:node |
		node argumentClasses]]! !

!TSdDynamicAccessor methodsFor: 'dynamic - tracing' stamp: 'mt 2/16/2012 11:24:40.87'!
collectCoveringNodes: aCompiledMethod
	"Update callgraphs for tests covering the given method."
	
	aCompiledMethod isTestMethod
		ifTrue: [Error signal: 'Test methods do not cover each other!!'].
		
	aCompiledMethod hasMethodExtension
		ifFalse: [Error signal: 'No coverage information available!!'].
	
	Cursor wait showWhile: [
		| nodeGroups |
		nodeGroups := (aCompiledMethod methodExtension tests collect: [:testReference |
			| callgraph |
			callgraph := SdCallGraphEditor callgraphAtTest: testReference.
			
			"Fill callgraph if empty."
			callgraph ifEmpty: [
				callgraph selectedCategories: 
					(PackageOrganizer default packageOfMethod: aCompiledMethod methodReference) systemCategories,
					(PackageOrganizer default packageOfMethod: testReference methodReference) systemCategories.
				
				SdCallgraphTracer new callgraph: callgraph; trace].
			
			"Collect covering call nodes."
			callgraph selectMethodCalls: aCompiledMethod methodReference]).

		^ self sortCoveringNodes: nodeGroups asOrderedCollection]! !

!TSdDynamicAccessor methodsFor: 'dynamic - tracing' stamp: 'mt 7/21/2011 11:11:10.374'!
collectGlobalProperties: someSymbols inCallgraphs: someCallgraphs

	Cursor wait showWhile: [
		someCallgraphs do: [:cg |
			SdCallgraphTracer new
				callgraph: cg;
				collectGlobalProperties: someSymbols]].! !

!TSdDynamicAccessor methodsFor: 'dynamic - tracing' stamp: 'mt 7/23/2011 11:37:28.783'!
collectProperties: someSymbols inNodeGroups: someNodeGroups
	"Every group of nodes should belong to the same callgraph."
	
	Cursor wait showWhile: [
		someNodeGroups
			select: [:nodes | nodes notEmpty]
			thenDo: [:nodes |
				SdCallgraphTracer new
					callgraph: nodes first callgraph;
					collectProperties: someSymbols
					inNodes: nodes]].! !

!TSdDynamicAccessor methodsFor: 'dynamic - tracing' stamp: 'mt 7/23/2011 11:37:22.649'!
collectPropertiesInNodeGroups: someNodeGroups
	"Every group of nodes should belong to the same callgraph."
	
	Cursor wait showWhile: [
		someNodeGroups
			select: [:nodes | nodes notEmpty]
			thenDo: [:nodes |
				SdCallgraphTracer new
					callgraph: nodes first callgraph;
					collectPropertiesInNodes: nodes]].! !

!TSdDynamicAccessor methodsFor: 'dynamic - aggregation' stamp: 'mt 7/21/2011 20:49:55.077'!
collectReturnClasses: nodeGroups
	"All nodes are for one method call."
	
	| returnClasses |
	self
		collectProperties: #(returnClass)
		inNodeGroups: (nodeGroups collect: [:nodes |
			nodes select: [:node | node returnClass isNil]]).
	
	returnClasses := Set new.
	
	"Collect all classes from all traces into sets."
	nodeGroups do: [:nodes | nodes do: [:node |
		returnClasses add: node returnClass]].

	returnClasses := returnClasses asOrderedCollection.

	^ returnClasses! !

!TSdDynamicAccessor methodsFor: 'dynamic - aggregation' stamp: 'mt 7/23/2011 11:27:14.169'!
collectReturnClassesByCallgraph: nodeGroups
	"All nodes are for one method call."
	
	self
		collectProperties: #(returnClass)
		inNodeGroups: (nodeGroups collect: [:nodes |
			nodes select: [:node | node returnClass isNil]]).
	
	^ nodeGroups collect: [:nodes | nodes collect: [:node |
		node returnClass]]! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 11:17:25.134'!
exploreArgumentObject: aNode index: anInteger
	
	aNode argumentObjectsBefore ifNil: [
		aNode requestProperty: #argumentObjectsBefore].
	
	aNode argumentObjectsAfter ifNil: [
		aNode requestProperty: #argumentObjectsAfter].
	
	self collectPropertiesInNodeGroups: {{aNode}}.
	
	self objectActivated: (SdObjectStateChange new
		before: (aNode argumentObjectsBefore at: anInteger);
		after: (aNode argumentObjectsAfter at: anInteger);
		node: aNode).! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 11:17:35.734'!
exploreReceiverObject: aNode

	aNode receiverObjectBefore ifNil: [
		aNode requestProperty: #receiverObjectBefore].
	
	aNode receiverObjectAfter ifNil: [
		aNode requestProperty: #receiverObjectAfter].
	
	self collectPropertiesInNodeGroups: {{aNode}}.
	
	self objectActivated: (SdObjectStateChange new
		before: aNode receiverObjectBefore;
		after: aNode receiverObjectAfter;
		node: aNode).! !

!TSdDynamicAccessor methodsFor: 'dynamic - actions' stamp: 'mt 7/21/2011 11:17:51.91'!
exploreReturnObject: aNode

	aNode returnObject ifNil: [
		self collectProperties: #(returnObject) inNodeGroups: {{aNode}}].
	
	self objectActivated: (SdObjectStateChange new
		before: aNode returnObject;
		after: nil;
		node: aNode).! !

!TSdDynamicAccessor methodsFor: 'dynamic - tracing' stamp: 'mt 2/16/2012 11:23:48.83'!
sortCoveringNodes: someNodeGroups
	"Sort groups by test name."

	^ someNodeGroups sortBy: [:nodes1 :nodes2 |
			| t1 t2 |
			t1 := nodes1 first callgraph traceEvent.
			t2 := nodes2 first callgraph traceEvent.
			 t1 testClass name < t2 testClass name
				or: [t1 testClass name = t2 testClass name
					and: [t1 testSelector <= t2 testSelector]]]! !

!TSdDynamicActivation methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/21/2011 10:38:53.118'!
classActivated: aClass

	self emitInOwnerChain.! !

!TSdDynamicActivation methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/21/2011 10:38:48.73'!
methodActivated: aMethodReference

	self emitInOwnerChain.! !

!TSdDynamicActivation methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/21/2011 10:38:44.341'!
objectActivated: anObject

	self emitInOwnerChain.! !

!TSdDynamicActivation methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/23/2011 11:39:26.205'!
traceActivated: aNode

	self emitInOwnerChain.! !

Trait named: #TSdDynamicMenusForMethod
	uses: {}
	category: 'Sight-Dynamic-Traits'!

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:32:42.187'!
browseMenuForArgument: argIndex nodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	((self collectArgumentClasses: nodeGroups) at: argIndex) do: [:cls |		
		menu
			add: cls name
			selector: #classActivated:
			argument: cls].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:37:53.495'!
browseMenuForMethodNodes: nodeGroups
	
	| menu argNames |
	menu := MenuMorph new defaultTarget: self.
	argNames := nodeGroups first first argumentNames.
		
	menu
		add: 'Result Classes'
		icon: nil
		subMenu: (self browseMenuForReturnNodes: nodeGroups);
		addLine.

	argNames withIndexDo: [:argName :idx |
		menu
			add: argName
			icon: nil
			subMenu: (self browseMenuForArgument: idx nodes: nodeGroups)].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:38:04.122'!
browseMenuForReturnNodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	(self collectReturnClasses: nodeGroups) do: [:cls |		
		menu
			add: cls name
			selector: #classActivated:
			argument: cls].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:32:52.586'!
exploreMenuForArgument: argIndex nodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	self collectArgumentClassesByCallgraph: nodeGroups.
	nodeGroups do: [:nodes | 	
		menu
			add: ('{1} {2} [{3}>>{4}]' format: {
				nodes first argumentClasses at: argIndex.
				nodes first argumentIds ifNotNil: [:ids | ids at: argIndex].
				nodes first callgraph traceEvent testClass.
				nodes first callgraph traceEvent testSelector})
			target: self
			selector: #exploreArgumentObject:index:
			argumentList: {nodes first.argIndex}].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:38:18.309'!
exploreMenuForMethodNodes: nodeGroups
	
	| menu argNames|
	menu := MenuMorph new defaultTarget: self.
	argNames := nodeGroups first first argumentNames.
		
	menu
		add: 'Receivers'
		icon: nil
		subMenu: (self exploreMenuForReceiverNodes: nodeGroups);
		add: 'Results'
		icon: nil
		subMenu: (self exploreMenuForReturnNodes: nodeGroups);
		addLine.

	argNames withIndexDo: [:argName :idx |
		menu
			add: argName
			icon: nil
			subMenu: (self exploreMenuForArgument: idx nodes: nodeGroups)].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:38:28.304'!
exploreMenuForReceiverNodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	nodeGroups do: [:nodes |
		menu
			add: ('{1} {2} [{3}>>{4}]' format: {
				nodes first receiverClass.
				nodes first receiverId.
				nodes first callgraph traceEvent testClass.
				nodes first callgraph traceEvent testSelector})
			target: self
			selector: #exploreReceiverObject:
			argument: nodes first].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:38:35.275'!
exploreMenuForReturnNodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	self collectReturnClassesByCallgraph: nodeGroups.
	nodeGroups do: [:nodes |
		menu
			add: ('{1} {2} [{3}>>{4}]' format: {
				nodes first returnClass.
				nodes first returnId.
				nodes first callgraph traceEvent testClass.
				nodes first callgraph traceEvent testSelector})
			target: self
			selector: #exploreReturnObject:
			argument: nodes first].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 2/16/2012 11:41:52.812'!
implementorsMenuForMethodNodes: nodeGroups
	
	| menu implementors |
	Error signal: 'Implementation broken.'.
	
	menu := MenuMorph new defaultTarget: self.
	implementors := (nodeGroups gather: [:nodes | nodes gather: [:node |
		node children collect: [:childNode | childNode clientReference]]]) asSet asOrderedCollection sortBy: [:ref1 :ref2 |
			ref1 classSymbol < ref2 classSymbol or: [
				ref1 classSymbol = ref2 classSymbol and: [ref1 selector <= ref2 selector]]].
	
	implementors ifEmpty: [^ nil].
	
	implementors do: [:reference |
		menu
			add: ('{1}>>{2}' format: {reference classSymbol. reference selector})
			selector: #methodActivated:
			argument: reference].
		
	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus' stamp: 'mt 7/31/2011 17:31:44.03'!
menuForArgument: argIndex method: aCompiledMethod
	
	| nodeGroups menu |
	menu := MenuMorph new.
	nodeGroups := self collectCoveringNodes: aCompiledMethod.

	menu
		add: 'Browse Class'
		icon: UiSilkIcons scriptCodeIcon
		subMenu: (self browseMenuForArgument: argIndex nodes: nodeGroups).

	menu
		add: 'Explore Object'
		icon: UiFugueIcons propertyIcon
		subMenu: (self exploreMenuForArgument: argIndex nodes: nodeGroups).		
			
	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus' stamp: 'mt 7/31/2011 17:32:19.49'!
menuForMessage: aSymbol method: aCompiledMethod
	
	| nodeGroups menu implementors |
	menu := MenuMorph new defaultTarget: self.
	nodeGroups := self collectCoveringNodes: aCompiledMethod.

	implementors := (nodeGroups gather: [:nodes | nodes gather: [:node |
		node children
			select: [:childNode | childNode clientSelector = aSymbol]
			thenCollect: [:childNode | childNode clientReference]]]) asSet asOrderedCollection
			sortBy: [:ref1 :ref2 |
				ref1 classSymbol < ref2 classSymbol
					or: [ref1 classSymbol = ref2 classSymbol and: [ref1 selector <= ref2 selector]]].

	implementors do: [:reference |
		menu
			add: ('{1}>>{2}' format: {reference classSymbol. reference selector})
			selector: #methodActivated:
			argument: reference].

	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus' stamp: 'mt 2/16/2012 11:42:01.32'!
menuForMethod: aCompiledMethod
	
	| nodeGroups menu |
	menu := MenuMorph new.
	nodeGroups := self collectCoveringNodes: aCompiledMethod.

	nodeGroups ifEmpty: [^ nil].

	menu
		add: 'Browse Class'
		icon: UiSilkIcons scriptCodeIcon
		subMenu: (self browseMenuForMethodNodes: nodeGroups).

	menu
		add: 'Explore Object'
		icon: UiFugueIcons propertyIcon
		subMenu: (self exploreMenuForMethodNodes: nodeGroups).		
		
	menu
		add: 'View Trace'
		icon: UiFugueIcons nodeSelectIcon
		subMenu: (self traceMenuForMethodNodes: nodeGroups).
	
	(self sendersMenuForMethodNodes: nodeGroups) ifNotNil: [:m |
		menu
			addLine;
			add: 'Senders'
			icon: UiFugueIcons arrowStepIcon
			subMenu: m].
		
	"(self implementorsMenuForMethodNodes: nodeGroups) ifNotNil: [:m |
		menu
			add: 'Implementors'
			icon: UiFugueIcons arrowStepOverIcon
			subMenu: m]."
		
	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 2/16/2012 11:34:14.03'!
sendersMenuForMethodNodes: nodeGroups
	
	| menu senders |
	menu := MenuMorph new defaultTarget: self.
	senders := (nodeGroups gather: [:nodes | nodes
		select: [:node | node parent clientMethod isTestMethod not]
		thenCollect: [:node | node parent clientReference]]) asSet asOrderedCollection sortBy: [:ref1 :ref2 |
			ref1 classSymbol < ref2 classSymbol or: [
				ref1 classSymbol = ref2 classSymbol and: [ref1 selector <= ref2 selector]]].
	
	senders ifEmpty: [^ nil].
	
	senders do: [:reference |
		menu
			add: ('{1}>>{2}' format: {reference classSymbol. reference selector})
			selector: #methodActivated:
			argument: reference].
		
	^ menu! !

!TSdDynamicMenusForMethod methodsFor: 'dynamic - menus - support' stamp: 'mt 7/31/2011 17:39:25.439'!
traceMenuForMethodNodes: nodeGroups
	
	| menu |
	menu := MenuMorph new defaultTarget: self.
	
	"Choose only the first call node in a callgraph for each trace/test."
	nodeGroups do: [:nodes |
		menu
			add: ('{1}>>{2}' format: {
				nodes first callgraph traceEvent testClass.
				nodes first callgraph traceEvent testSelector})
			target: self
			selector: #traceActivated:
			argument: nodes first].	

	^ menu! !

HelpTopic subclass: #SdHelpTopic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Help'!

!SdHelpTopic class methodsFor: 'instance creation' stamp: 'mt 7/31/2011 20:23:58.098'!
title: stringOrText icon: aForm contents: string

	^ super
		title: stringOrText
		icon: aForm
		contents: (string copyReplaceAll: '<tab>' with: String tab) asHtmlText
		! !

UserInterface subclass: #SdCallGraphEditorUi
	instanceVariableNames: 'unnamedMorph1 pinBtn hideBtn unnamedMorph2 headerBtn unnamedMorph3 unnamedMorph4 closeBtn unnamedMorph5 infoLbl moreBtn treeView unnamedMorph6 filterEdit addFilterBtn unnamedMorph7 updateBtn timeBtn unnamedMorph8'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdCallGraphEditorUi methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:48:19.601'!
addFilterBtn
	"nil"
	
	^ addFilterBtn! !

!SdCallGraphEditorUi methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:48:19.304'!
closeBtn
	"nil"
	
	^ closeBtn! !

!SdCallGraphEditorUi methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:48:19.546'!
filterEdit
	"nil"
	
	^ filterEdit! !

!SdCallGraphEditorUi methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:48:19.264'!
headerBtn
	"nil"
	
	^ headerBtn! !

!SdCallGraphEditorUi methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:48:19.192'!
hideBtn
	"nil"
	
	^ hideBtn! !

!SdCallGraphEditorUi methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:48:19.359'!
infoLbl
	"nil"
	
	^ infoLbl! !

!SdCallGraphEditorUi methodsFor: 'ui - private' stamp: 'mt 9/1/2011 14:48:19.773'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (296@528).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (1).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (292@21).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	pinBtn := UiToolButton new.
	pinBtn changeTableLayout.
	pinBtn extent: (18@18).
	pinBtn position: (2@3).
	pinBtn hResizing: (#shrinkWrap).
	pinBtn vResizing: (#shrinkWrap).
	pinBtn cellInset: (4).
	pinBtn cellPositioning: (#center).
	pinBtn cellSpacing: (#none).
	pinBtn layoutInset: (0).
	pinBtn listCentering: (#topLeft).
	pinBtn listDirection: (#leftToRight).
	pinBtn listSpacing: (#none).
	pinBtn maxCellSize: (1073741823).
	pinBtn minCellSize: (0).
	pinBtn wrapCentering: (#topLeft).
	pinBtn wrapDirection: (#none).
	pinBtn frameFractions: (0@0 corner: 1@1).
	pinBtn frameOffsets: (0@0 corner: 0@0).
	pinBtn balloonText: (nil).
	pinBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	pinBtn enabled: (true).
	pinBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons pinSmallIcon'.
	pinBtn icon: (UiFugueIcons pinSmallIcon).
	pinBtn text: ('ToolButton').
	pinBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	pinBtn checkable: (true).
	pinBtn checked: (false).
	pinBtn autoExclusive: (false).
	pinBtn autoRaise: (true).
	pinBtn buttonStyle: (#iconOnly).
	pinBtn setProperty: #objectName toValue: 'pinBtn'.
	unnamedMorph1 addMorphBack: pinBtn.
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (20@3).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (77@10).
	unnamedMorph2 position: (38@7).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (61@21).
	headerBtn position: (115@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Call Graph').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (78@10).
	unnamedMorph3 position: (176@7).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 extent: (16@10).
	unnamedMorph4 position: (257@7).
	unnamedMorph4 hResizing: (#rigid).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph1 addMorphBack: unnamedMorph4.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (276@3).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Call Graph').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	unnamedMorph5 := UiContainer new.
	unnamedMorph5 changeTableLayout.
	unnamedMorph5 extent: (292@19).
	unnamedMorph5 position: (2@24).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#shrinkWrap).
	unnamedMorph5 cellInset: (4).
	unnamedMorph5 cellPositioning: (#topCenter).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (0).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#leftToRight).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph5 color: (Color transparent).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	infoLbl := UiLabel new.
	infoLbl changeTableLayout.
	infoLbl extent: (270@19).
	infoLbl position: (2@24).
	infoLbl hResizing: (#spaceFill).
	infoLbl vResizing: (#shrinkWrap).
	infoLbl cellInset: (0).
	infoLbl cellPositioning: (#center).
	infoLbl cellSpacing: (#none).
	infoLbl layoutInset: (0).
	infoLbl listCentering: (#topLeft).
	infoLbl listDirection: (#leftToRight).
	infoLbl listSpacing: (#none).
	infoLbl maxCellSize: (1073741823).
	infoLbl minCellSize: (0).
	infoLbl wrapCentering: (#topLeft).
	infoLbl wrapDirection: (#none).
	infoLbl frameFractions: (0@0 corner: 1@1).
	infoLbl frameOffsets: (0@0 corner: 0@0).
	infoLbl balloonText: (nil).
	infoLbl balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	infoLbl text: ('Tracing...').
	infoLbl setProperty: #formByDesigner toValue: 'nil'.
	infoLbl form: (nil).
	infoLbl setProperty: #objectName toValue: 'infoLbl'.
	unnamedMorph5 addMorphBack: infoLbl.
	moreBtn := UiToolButton new.
	moreBtn changeTableLayout.
	moreBtn extent: (18@18).
	moreBtn position: (276@24).
	moreBtn hResizing: (#shrinkWrap).
	moreBtn vResizing: (#shrinkWrap).
	moreBtn cellInset: (4).
	moreBtn cellPositioning: (#center).
	moreBtn cellSpacing: (#none).
	moreBtn layoutInset: (0).
	moreBtn listCentering: (#topLeft).
	moreBtn listDirection: (#leftToRight).
	moreBtn listSpacing: (#none).
	moreBtn maxCellSize: (1073741823).
	moreBtn minCellSize: (0).
	moreBtn wrapCentering: (#topLeft).
	moreBtn wrapDirection: (#none).
	moreBtn frameFractions: (0@0 corner: 1@1).
	moreBtn frameOffsets: (0@0 corner: 0@0).
	moreBtn balloonText: ('More...').
	moreBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	moreBtn enabled: (true).
	moreBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons bulletArrowDownIcon'.
	moreBtn icon: (UiSilkIcons bulletArrowDownIcon).
	moreBtn text: ('ToolButton').
	moreBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	moreBtn checkable: (true).
	moreBtn checked: (false).
	moreBtn autoExclusive: (false).
	moreBtn autoRaise: (true).
	moreBtn buttonStyle: (#iconOnly).
	moreBtn setProperty: #objectName toValue: 'moreBtn'.
	unnamedMorph5 addMorphBack: moreBtn.
	panel addMorphBack: unnamedMorph5.
	treeView := UiTreeView new.
	treeView extent: (292@440).
	treeView position: (2@44).
	treeView hResizing: (#spaceFill).
	treeView vResizing: (#spaceFill).
	treeView cellInset: (0).
	treeView cellPositioning: (#center).
	treeView cellSpacing: (#none).
	treeView layoutInset: (0).
	treeView listCentering: (#topLeft).
	treeView listDirection: (#topToBottom).
	treeView listSpacing: (#none).
	treeView maxCellSize: (1073741823).
	treeView minCellSize: (0).
	treeView wrapCentering: (#topLeft).
	treeView wrapDirection: (#none).
	treeView frameFractions: (0@0 corner: 1@1).
	treeView frameOffsets: (0@0 corner: 0@0).
	treeView balloonText: (nil).
	treeView balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	treeView widgetResizable: (false).
	treeView horizontalScrollBarPolicy: (#asNeeded).
	treeView verticalScrollBarPolicy: (#asNeeded).
	treeView outerBorderWidth: (1).
	treeView scrollBarThickness: (9).
	treeView modelClass: (nil).
	treeView horizontalHeaderVisible: (false).
	treeView verticalHeaderVisible: (false).
	treeView selectionBehavior: (#selectRows).
	treeView selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	treeView selectionMode: (UiViewSingleSelection).
	treeView setProperty: #objectName toValue: 'treeView'.
	panel addMorphBack: treeView.
	unnamedMorph6 := UiContainer new.
	unnamedMorph6 changeTableLayout.
	unnamedMorph6 extent: (292@22).
	unnamedMorph6 position: (2@485).
	unnamedMorph6 hResizing: (#spaceFill).
	unnamedMorph6 vResizing: (#shrinkWrap).
	unnamedMorph6 cellInset: (2).
	unnamedMorph6 cellPositioning: (#center).
	unnamedMorph6 cellSpacing: (#none).
	unnamedMorph6 layoutInset: (0@0 corner: 0@0).
	unnamedMorph6 listCentering: (#topLeft).
	unnamedMorph6 listDirection: (#leftToRight).
	unnamedMorph6 listSpacing: (#none).
	unnamedMorph6 maxCellSize: (1073741823).
	unnamedMorph6 minCellSize: (0).
	unnamedMorph6 wrapCentering: (#topLeft).
	unnamedMorph6 wrapDirection: (#none).
	unnamedMorph6 frameFractions: (0@0 corner: 1@1).
	unnamedMorph6 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph6 balloonText: (nil).
	unnamedMorph6 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph6 color: (Color white).
	unnamedMorph6 borderWidth: (1).
	unnamedMorph6 borderStyle2: (#inset).
	unnamedMorph6 borderColor: (#inset).
	filterEdit := UiLineEdit new.
	filterEdit extent: (268@20).
	filterEdit position: (3@486).
	filterEdit hResizing: (#spaceFill).
	filterEdit vResizing: (#rigid).
	filterEdit cellInset: (0).
	filterEdit cellPositioning: (#center).
	filterEdit cellSpacing: (#none).
	filterEdit layoutInset: (0).
	filterEdit listCentering: (#topLeft).
	filterEdit listDirection: (#topToBottom).
	filterEdit listSpacing: (#none).
	filterEdit maxCellSize: (1073741823).
	filterEdit minCellSize: (0).
	filterEdit wrapCentering: (#topLeft).
	filterEdit wrapDirection: (#none).
	filterEdit frameFractions: (0@0 corner: 1@1).
	filterEdit frameOffsets: (0@0 corner: 0@0).
	filterEdit balloonText: ('Enter filters here.').
	filterEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	filterEdit widgetResizable: (false).
	filterEdit horizontalScrollBarPolicy: (#alwaysOff).
	filterEdit verticalScrollBarPolicy: (#alwaysOff).
	filterEdit outerBorderWidth: (0).
	filterEdit scrollBarThickness: (9).
	filterEdit theText: ('').
	filterEdit readOnly: (false).
	filterEdit autoConvert: (false).
	filterEdit autoAccept: (false).
	filterEdit acceptOnFocusLost: (true).
	filterEdit scrollingMode: (#none).
	filterEdit scrollingLimit: (10).
	filterEdit helpText: ('Filter by regular expression...').
	filterEdit hideCursor: (true).
	filterEdit setProperty: #objectName toValue: 'filterEdit'.
	unnamedMorph6 addMorphBack: filterEdit.
	addFilterBtn := UiToolButton new.
	addFilterBtn changeTableLayout.
	addFilterBtn extent: (20@16).
	addFilterBtn position: (273@488).
	addFilterBtn hResizing: (#shrinkWrap).
	addFilterBtn vResizing: (#shrinkWrap).
	addFilterBtn cellInset: (4).
	addFilterBtn cellPositioning: (#center).
	addFilterBtn cellSpacing: (#none).
	addFilterBtn layoutInset: (2@0 corner: 2@0).
	addFilterBtn listCentering: (#topLeft).
	addFilterBtn listDirection: (#leftToRight).
	addFilterBtn listSpacing: (#none).
	addFilterBtn maxCellSize: (1073741823).
	addFilterBtn minCellSize: (0).
	addFilterBtn wrapCentering: (#topLeft).
	addFilterBtn wrapDirection: (#none).
	addFilterBtn frameFractions: (0@0 corner: 1@1).
	addFilterBtn frameOffsets: (0@0 corner: 0@0).
	addFilterBtn balloonText: (nil).
	addFilterBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	addFilterBtn enabled: (true).
	addFilterBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons funnelIcon'.
	addFilterBtn icon: (UiFugueIcons funnelIcon).
	addFilterBtn text: ('ToolButton').
	addFilterBtn color: (Color transparent).
	addFilterBtn checkable: (false).
	addFilterBtn checked: (false).
	addFilterBtn autoExclusive: (false).
	addFilterBtn autoRaise: (true).
	addFilterBtn buttonStyle: (#iconOnly).
	addFilterBtn setProperty: #objectName toValue: 'addFilterBtn'.
	unnamedMorph6 addMorphBack: addFilterBtn.
	panel addMorphBack: unnamedMorph6.
	unnamedMorph7 := UiContainer new.
	unnamedMorph7 changeTableLayout.
	unnamedMorph7 extent: (292@18).
	unnamedMorph7 position: (2@508).
	unnamedMorph7 hResizing: (#spaceFill).
	unnamedMorph7 vResizing: (#shrinkWrap).
	unnamedMorph7 cellInset: (4).
	unnamedMorph7 cellPositioning: (#center).
	unnamedMorph7 cellSpacing: (#none).
	unnamedMorph7 layoutInset: (0).
	unnamedMorph7 listCentering: (#topLeft).
	unnamedMorph7 listDirection: (#leftToRight).
	unnamedMorph7 listSpacing: (#none).
	unnamedMorph7 maxCellSize: (1073741823).
	unnamedMorph7 minCellSize: (0).
	unnamedMorph7 wrapCentering: (#topLeft).
	unnamedMorph7 wrapDirection: (#none).
	unnamedMorph7 frameFractions: (0@0 corner: 1@1).
	unnamedMorph7 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph7 balloonText: (nil).
	unnamedMorph7 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph7 color: (Color transparent).
	unnamedMorph7 borderWidth: (0).
	unnamedMorph7 borderStyle2: (#simple).
	unnamedMorph7 borderColor: (Color black).
	updateBtn := UiToolButton new.
	updateBtn changeTableLayout.
	updateBtn extent: (22@18).
	updateBtn position: (2@508).
	updateBtn hResizing: (#shrinkWrap).
	updateBtn vResizing: (#shrinkWrap).
	updateBtn cellInset: (4).
	updateBtn cellPositioning: (#center).
	updateBtn cellSpacing: (#none).
	updateBtn layoutInset: (2@0 corner: 2@0).
	updateBtn listCentering: (#topLeft).
	updateBtn listDirection: (#leftToRight).
	updateBtn listSpacing: (#none).
	updateBtn maxCellSize: (1073741823).
	updateBtn minCellSize: (0).
	updateBtn wrapCentering: (#topLeft).
	updateBtn wrapDirection: (#none).
	updateBtn frameFractions: (0@0 corner: 1@1).
	updateBtn frameOffsets: (0@0 corner: 0@0).
	updateBtn balloonText: ('Auto-update trace when
source code changes').
	updateBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	updateBtn enabled: (true).
	updateBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons arrowCircleDouble135Icon'.
	updateBtn icon: (UiFugueIcons arrowCircleDouble135Icon).
	updateBtn text: ('ToolButton').
	updateBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	updateBtn checkable: (true).
	updateBtn checked: (false).
	updateBtn autoExclusive: (false).
	updateBtn autoRaise: (true).
	updateBtn buttonStyle: (#iconOnly).
	updateBtn setProperty: #objectName toValue: 'updateBtn'.
	unnamedMorph7 addMorphBack: updateBtn.
	timeBtn := UiToolButton new.
	timeBtn changeTableLayout.
	timeBtn extent: (22@18).
	timeBtn position: (28@508).
	timeBtn hResizing: (#shrinkWrap).
	timeBtn vResizing: (#shrinkWrap).
	timeBtn cellInset: (4).
	timeBtn cellPositioning: (#center).
	timeBtn cellSpacing: (#none).
	timeBtn layoutInset: (2@0 corner: 2@0).
	timeBtn listCentering: (#topLeft).
	timeBtn listDirection: (#leftToRight).
	timeBtn listSpacing: (#none).
	timeBtn maxCellSize: (1073741823).
	timeBtn minCellSize: (0).
	timeBtn wrapCentering: (#topLeft).
	timeBtn wrapDirection: (#none).
	timeBtn frameFractions: (0@0 corner: 1@1).
	timeBtn frameOffsets: (0@0 corner: 0@0).
	timeBtn balloonText: ('Measure time for calls.').
	timeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	timeBtn enabled: (true).
	timeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons clockIcon'.
	timeBtn icon: (UiFugueIcons clockIcon).
	timeBtn text: ('ToolButton').
	timeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	timeBtn checkable: (false).
	timeBtn checked: (false).
	timeBtn autoExclusive: (false).
	timeBtn autoRaise: (true).
	timeBtn buttonStyle: (#iconOnly).
	timeBtn setProperty: #objectName toValue: 'timeBtn'.
	unnamedMorph7 addMorphBack: timeBtn.
	unnamedMorph8 := UiSpacer new.
	unnamedMorph8 extent: (240@10).
	unnamedMorph8 position: (54@512).
	unnamedMorph8 hResizing: (#spaceFill).
	unnamedMorph8 vResizing: (#rigid).
	unnamedMorph8 cellInset: (0).
	unnamedMorph8 cellPositioning: (#center).
	unnamedMorph8 cellSpacing: (#none).
	unnamedMorph8 layoutInset: (0).
	unnamedMorph8 listCentering: (#topLeft).
	unnamedMorph8 listDirection: (#topToBottom).
	unnamedMorph8 listSpacing: (#none).
	unnamedMorph8 maxCellSize: (1073741823).
	unnamedMorph8 minCellSize: (0).
	unnamedMorph8 wrapCentering: (#topLeft).
	unnamedMorph8 wrapDirection: (#none).
	unnamedMorph8 frameFractions: (0@0 corner: 1@1).
	unnamedMorph8 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph8 balloonText: (nil).
	unnamedMorph8 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph8 color: (Color blue).
	unnamedMorph8 borderWidth: (0).
	unnamedMorph8 borderStyle2: (#simple).
	unnamedMorph8 borderColor: (Color black).
	unnamedMorph8 orientation: (#horizontal).
	unnamedMorph7 addMorphBack: unnamedMorph8.
	panel addMorphBack: unnamedMorph7.
	panel setProperty: #uiClassName toValue: 'SdCallGraphEditor'.! !

!SdCallGraphEditorUi methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:48:19.404'!
moreBtn
	"nil"
	
	^ moreBtn! !

!SdCallGraphEditorUi methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:48:19.144'!
pinBtn
	"nil"
	
	^ pinBtn! !

!SdCallGraphEditorUi methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:48:19.702'!
timeBtn
	"nil"
	
	^ timeBtn! !

!SdCallGraphEditorUi methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:48:19.483'!
treeView
	"nil"
	
	^ treeView! !

!SdCallGraphEditorUi methodsFor: 'accessing' stamp: 'mt 9/1/2011 14:48:19.645'!
updateBtn
	"nil"
	
	^ updateBtn! !

UserInterface subclass: #SdClassEditorUi
	instanceVariableNames: 'headerContainer pinBtn hideBtn unnamedMorph1 superClassBtn headerBtn subClassBtn unnamedMorph2 unnamedMorph3 closeBtn topContainer unnamedMorph4 findBtn commentBtn definitionBtn testBtn unnamedMorph5 saveAllBtn closeAllBtn browseBtn codeArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:12.513'!
browseBtn
	"nil"
	
	^ browseBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:12.452'!
closeAllBtn
	"nil"
	
	^ closeAllBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:11.998'!
closeBtn
	"nil"
	
	^ closeBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:12.571'!
codeArea
	"nil"
	
	^ codeArea! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:12.207'!
commentBtn
	"nil"
	
	^ commentBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:12.266'!
definitionBtn
	"nil"
	
	^ definitionBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:12.134'!
findBtn
	"nil"
	
	^ findBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:11.843'!
headerBtn
	"nil"
	
	^ headerBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:11.608'!
headerContainer
	"nil"
	
	^ headerContainer! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:11.74'!
hideBtn
	"nil"
	
	^ hideBtn! !

!SdClassEditorUi methodsFor: 'ui - private' stamp: 'mt 7/2/2011 15:25:12.67'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (244@569).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	headerContainer := UiContainer new.
	headerContainer changeTableLayout.
	headerContainer extent: (240@21).
	headerContainer position: (2@2).
	headerContainer hResizing: (#spaceFill).
	headerContainer vResizing: (#shrinkWrap).
	headerContainer cellInset: (0).
	headerContainer cellPositioning: (#center).
	headerContainer cellSpacing: (#none).
	headerContainer layoutInset: (0).
	headerContainer listCentering: (#center).
	headerContainer listDirection: (#leftToRight).
	headerContainer listSpacing: (#none).
	headerContainer maxCellSize: (1073741823).
	headerContainer minCellSize: (0).
	headerContainer wrapCentering: (#topLeft).
	headerContainer wrapDirection: (#none).
	headerContainer frameFractions: (0@0 corner: 1@1).
	headerContainer frameOffsets: (0@0 corner: 0@0).
	headerContainer balloonText: (nil).
	headerContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerContainer color: (Color transparent).
	headerContainer borderWidth: (0).
	headerContainer borderStyle2: (#simple).
	headerContainer borderColor: (Color black).
	headerContainer setProperty: #objectName toValue: 'headerContainer'.
	pinBtn := UiToolButton new.
	pinBtn changeTableLayout.
	pinBtn extent: (18@18).
	pinBtn position: (2@3).
	pinBtn hResizing: (#shrinkWrap).
	pinBtn vResizing: (#shrinkWrap).
	pinBtn cellInset: (4).
	pinBtn cellPositioning: (#center).
	pinBtn cellSpacing: (#none).
	pinBtn layoutInset: (0).
	pinBtn listCentering: (#topLeft).
	pinBtn listDirection: (#leftToRight).
	pinBtn listSpacing: (#none).
	pinBtn maxCellSize: (1073741823).
	pinBtn minCellSize: (0).
	pinBtn wrapCentering: (#topLeft).
	pinBtn wrapDirection: (#none).
	pinBtn frameFractions: (0@0 corner: 1@1).
	pinBtn frameOffsets: (0@0 corner: 0@0).
	pinBtn balloonText: ('Pin this class').
	pinBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	pinBtn enabled: (true).
	pinBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons pinSmallIcon'.
	pinBtn icon: (UiFugueIcons pinSmallIcon).
	pinBtn text: ('ToolButton').
	pinBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	pinBtn checkable: (true).
	pinBtn checked: (false).
	pinBtn autoExclusive: (false).
	pinBtn autoRaise: (true).
	pinBtn buttonStyle: (#iconOnly).
	pinBtn setProperty: #objectName toValue: 'pinBtn'.
	headerContainer addMorphBack: pinBtn.
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (20@3).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: ('Hide editor').
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	headerContainer addMorphBack: hideBtn.
	unnamedMorph1 := UiSpacer new.
	unnamedMorph1 extent: (31@10).
	unnamedMorph1 position: (38@7).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#rigid).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color blue).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph1 orientation: (#horizontal).
	headerContainer addMorphBack: unnamedMorph1.
	superClassBtn := UiToolButton new.
	superClassBtn changeTableLayout.
	superClassBtn extent: (18@18).
	superClassBtn position: (69@3).
	superClassBtn hResizing: (#shrinkWrap).
	superClassBtn vResizing: (#shrinkWrap).
	superClassBtn cellInset: (4).
	superClassBtn cellPositioning: (#center).
	superClassBtn cellSpacing: (#none).
	superClassBtn layoutInset: (0).
	superClassBtn listCentering: (#topLeft).
	superClassBtn listDirection: (#leftToRight).
	superClassBtn listSpacing: (#none).
	superClassBtn maxCellSize: (1073741823).
	superClassBtn minCellSize: (0).
	superClassBtn wrapCentering: (#topLeft).
	superClassBtn wrapDirection: (#none).
	superClassBtn frameFractions: (0@0 corner: 1@1).
	superClassBtn frameOffsets: (0@0 corner: 0@0).
	superClassBtn balloonText: ('Super class chain').
	superClassBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	superClassBtn enabled: (true).
	superClassBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons control090SmallIcon'.
	superClassBtn icon: (UiFugueIcons control090SmallIcon).
	superClassBtn text: ('ToolButton').
	superClassBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	superClassBtn checkable: (false).
	superClassBtn checked: (false).
	superClassBtn autoExclusive: (false).
	superClassBtn autoRaise: (true).
	superClassBtn buttonStyle: (#iconOnly).
	superClassBtn setProperty: #objectName toValue: 'superClassBtn'.
	headerContainer addMorphBack: superClassBtn.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (66@21).
	headerBtn position: (87@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('ToolButton').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	headerContainer addMorphBack: headerBtn.
	subClassBtn := UiToolButton new.
	subClassBtn changeTableLayout.
	subClassBtn extent: (18@18).
	subClassBtn position: (153@3).
	subClassBtn hResizing: (#shrinkWrap).
	subClassBtn vResizing: (#shrinkWrap).
	subClassBtn cellInset: (4).
	subClassBtn cellPositioning: (#center).
	subClassBtn cellSpacing: (#none).
	subClassBtn layoutInset: (0).
	subClassBtn listCentering: (#topLeft).
	subClassBtn listDirection: (#leftToRight).
	subClassBtn listSpacing: (#none).
	subClassBtn maxCellSize: (1073741823).
	subClassBtn minCellSize: (0).
	subClassBtn wrapCentering: (#topLeft).
	subClassBtn wrapDirection: (#none).
	subClassBtn frameFractions: (0@0 corner: 1@1).
	subClassBtn frameOffsets: (0@0 corner: 0@0).
	subClassBtn balloonText: ('Direct subclasses').
	subClassBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	subClassBtn enabled: (true).
	subClassBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons control270SmallIcon'.
	subClassBtn icon: (UiFugueIcons control270SmallIcon).
	subClassBtn text: ('ToolButton').
	subClassBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	subClassBtn checkable: (false).
	subClassBtn checked: (false).
	subClassBtn autoExclusive: (false).
	subClassBtn autoRaise: (true).
	subClassBtn buttonStyle: (#iconOnly).
	subClassBtn setProperty: #objectName toValue: 'subClassBtn'.
	headerContainer addMorphBack: subClassBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (31@12).
	unnamedMorph2 position: (171@6).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	headerContainer addMorphBack: unnamedMorph2.
	unnamedMorph3 := UiContainer new.
	unnamedMorph3 extent: (16@10).
	unnamedMorph3 position: (205@7).
	unnamedMorph3 hResizing: (#rigid).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (4).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph3 color: (Color transparent).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	headerContainer addMorphBack: unnamedMorph3.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (224@3).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('ToolButton').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	headerContainer addMorphBack: closeBtn.
	panel addMorphBack: headerContainer.
	topContainer := UiContainer new.
	topContainer changeTableLayout.
	topContainer extent: (240@21).
	topContainer position: (2@24).
	topContainer hResizing: (#spaceFill).
	topContainer vResizing: (#shrinkWrap).
	topContainer cellInset: (4).
	topContainer cellPositioning: (#center).
	topContainer cellSpacing: (#none).
	topContainer layoutInset: (0).
	topContainer listCentering: (#topLeft).
	topContainer listDirection: (#topToBottom).
	topContainer listSpacing: (#none).
	topContainer maxCellSize: (1073741823).
	topContainer minCellSize: (0).
	topContainer wrapCentering: (#topLeft).
	topContainer wrapDirection: (#none).
	topContainer frameFractions: (0@0 corner: 1@1).
	topContainer frameOffsets: (0@0 corner: 0@0).
	topContainer balloonText: (nil).
	topContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	topContainer color: (Color transparent).
	topContainer borderWidth: (0).
	topContainer borderStyle2: (#simple).
	topContainer borderColor: (Color black).
	topContainer setProperty: #objectName toValue: 'topContainer'.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 changeTableLayout.
	unnamedMorph4 extent: (240@18).
	unnamedMorph4 position: (2@24).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#shrinkWrap).
	unnamedMorph4 cellInset: (0).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (0).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#leftToRight).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	findBtn := UiToolButton new.
	findBtn changeTableLayout.
	findBtn extent: (22@18).
	findBtn position: (2@24).
	findBtn hResizing: (#shrinkWrap).
	findBtn vResizing: (#shrinkWrap).
	findBtn cellInset: (4).
	findBtn cellPositioning: (#center).
	findBtn cellSpacing: (#none).
	findBtn layoutInset: (2@0 corner: 2@0).
	findBtn listCentering: (#topLeft).
	findBtn listDirection: (#leftToRight).
	findBtn listSpacing: (#none).
	findBtn maxCellSize: (1073741823).
	findBtn minCellSize: (0).
	findBtn wrapCentering: (#topLeft).
	findBtn wrapDirection: (#none).
	findBtn frameFractions: (0@0 corner: 1@1).
	findBtn frameOffsets: (0@0 corner: 0@0).
	findBtn balloonText: ('Find Method (CMD+F)').
	findBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	findBtn enabled: (true).
	findBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons magnifierIcon'.
	findBtn icon: (UiFugueIcons magnifierIcon).
	findBtn text: ('ToolButton').
	findBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	findBtn checkable: (true).
	findBtn checked: (false).
	findBtn autoExclusive: (false).
	findBtn autoRaise: (true).
	findBtn buttonStyle: (#iconOnly).
	findBtn setProperty: #objectName toValue: 'findBtn'.
	unnamedMorph4 addMorphBack: findBtn.
	commentBtn := UiToolButton new.
	commentBtn changeTableLayout.
	commentBtn extent: (22@18).
	commentBtn position: (24@24).
	commentBtn hResizing: (#shrinkWrap).
	commentBtn vResizing: (#shrinkWrap).
	commentBtn cellInset: (4).
	commentBtn cellPositioning: (#center).
	commentBtn cellSpacing: (#none).
	commentBtn layoutInset: (2@0 corner: 2@0).
	commentBtn listCentering: (#topLeft).
	commentBtn listDirection: (#leftToRight).
	commentBtn listSpacing: (#none).
	commentBtn maxCellSize: (1073741823).
	commentBtn minCellSize: (0).
	commentBtn wrapCentering: (#topLeft).
	commentBtn wrapDirection: (#none).
	commentBtn frameFractions: (0@0 corner: 1@1).
	commentBtn frameOffsets: (0@0 corner: 0@0).
	commentBtn balloonText: ('Edit class comment').
	commentBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	commentBtn enabled: (true).
	commentBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons commentIcon'.
	commentBtn icon: (UiSilkIcons commentIcon).
	commentBtn text: ('ToolButton').
	commentBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	commentBtn checkable: (true).
	commentBtn checked: (false).
	commentBtn autoExclusive: (false).
	commentBtn autoRaise: (true).
	commentBtn buttonStyle: (#iconOnly).
	commentBtn setProperty: #objectName toValue: 'commentBtn'.
	unnamedMorph4 addMorphBack: commentBtn.
	definitionBtn := UiToolButton new.
	definitionBtn changeTableLayout.
	definitionBtn extent: (22@18).
	definitionBtn position: (46@24).
	definitionBtn hResizing: (#shrinkWrap).
	definitionBtn vResizing: (#shrinkWrap).
	definitionBtn cellInset: (4).
	definitionBtn cellPositioning: (#center).
	definitionBtn cellSpacing: (#none).
	definitionBtn layoutInset: (2@0 corner: 2@0).
	definitionBtn listCentering: (#topLeft).
	definitionBtn listDirection: (#leftToRight).
	definitionBtn listSpacing: (#none).
	definitionBtn maxCellSize: (1073741823).
	definitionBtn minCellSize: (0).
	definitionBtn wrapCentering: (#topLeft).
	definitionBtn wrapDirection: (#none).
	definitionBtn frameFractions: (0@0 corner: 1@1).
	definitionBtn frameOffsets: (0@0 corner: 0@0).
	definitionBtn balloonText: (nil).
	definitionBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	definitionBtn enabled: (true).
	definitionBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons wrenchOrangeIcon'.
	definitionBtn icon: (UiSilkIcons wrenchOrangeIcon).
	definitionBtn text: ('ToolButton').
	definitionBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	definitionBtn checkable: (true).
	definitionBtn checked: (false).
	definitionBtn autoExclusive: (false).
	definitionBtn autoRaise: (true).
	definitionBtn buttonStyle: (#iconOnly).
	definitionBtn setProperty: #objectName toValue: 'definitionBtn'.
	unnamedMorph4 addMorphBack: definitionBtn.
	testBtn := UiToolButton new.
	testBtn changeTableLayout.
	testBtn extent: (22@18).
	testBtn position: (68@24).
	testBtn hResizing: (#shrinkWrap).
	testBtn vResizing: (#shrinkWrap).
	testBtn cellInset: (4).
	testBtn cellPositioning: (#center).
	testBtn cellSpacing: (#none).
	testBtn layoutInset: (2@0 corner: 2@0).
	testBtn listCentering: (#topLeft).
	testBtn listDirection: (#leftToRight).
	testBtn listSpacing: (#none).
	testBtn maxCellSize: (1073741823).
	testBtn minCellSize: (0).
	testBtn wrapCentering: (#topLeft).
	testBtn wrapDirection: (#none).
	testBtn frameFractions: (0@0 corner: 1@1).
	testBtn frameOffsets: (0@0 corner: 0@0).
	testBtn balloonText: ('Indicates result of last
test run and allows to run
all tests.').
	testBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	testBtn enabled: (true).
	testBtn setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0402Normal'.
	testBtn icon: (UiDiagonaIcons icon0402Normal).
	testBtn text: ('ToolButton').
	testBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	testBtn checkable: (false).
	testBtn checked: (false).
	testBtn autoExclusive: (false).
	testBtn autoRaise: (true).
	testBtn buttonStyle: (#iconOnly).
	testBtn setProperty: #objectName toValue: 'testBtn'.
	unnamedMorph4 addMorphBack: testBtn.
	unnamedMorph5 := UiSpacer new.
	unnamedMorph5 extent: (86@10).
	unnamedMorph5 position: (90@28).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#rigid).
	unnamedMorph5 cellInset: (4).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (4).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#topToBottom).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph5 color: (Color blue).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	unnamedMorph5 orientation: (#horizontal).
	unnamedMorph4 addMorphBack: unnamedMorph5.
	saveAllBtn := UiToolButton new.
	saveAllBtn changeTableLayout.
	saveAllBtn extent: (22@18).
	saveAllBtn position: (176@24).
	saveAllBtn hResizing: (#shrinkWrap).
	saveAllBtn vResizing: (#shrinkWrap).
	saveAllBtn cellInset: (4).
	saveAllBtn cellPositioning: (#center).
	saveAllBtn cellSpacing: (#none).
	saveAllBtn layoutInset: (2@0 corner: 2@0).
	saveAllBtn listCentering: (#topLeft).
	saveAllBtn listDirection: (#leftToRight).
	saveAllBtn listSpacing: (#none).
	saveAllBtn maxCellSize: (1073741823).
	saveAllBtn minCellSize: (0).
	saveAllBtn wrapCentering: (#topLeft).
	saveAllBtn wrapDirection: (#none).
	saveAllBtn frameFractions: (0@0 corner: 1@1).
	saveAllBtn frameOffsets: (0@0 corner: 0@0).
	saveAllBtn balloonText: ('Save all changed methods').
	saveAllBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	saveAllBtn enabled: (true).
	saveAllBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons diskMultipleIcon'.
	saveAllBtn icon: (UiSilkIcons diskMultipleIcon).
	saveAllBtn text: ('ToolButton').
	saveAllBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	saveAllBtn checkable: (false).
	saveAllBtn checked: (false).
	saveAllBtn autoExclusive: (false).
	saveAllBtn autoRaise: (true).
	saveAllBtn buttonStyle: (#iconOnly).
	saveAllBtn setProperty: #objectName toValue: 'saveAllBtn'.
	unnamedMorph4 addMorphBack: saveAllBtn.
	closeAllBtn := UiToolButton new.
	closeAllBtn changeTableLayout.
	closeAllBtn extent: (22@18).
	closeAllBtn position: (198@24).
	closeAllBtn hResizing: (#shrinkWrap).
	closeAllBtn vResizing: (#shrinkWrap).
	closeAllBtn cellInset: (4).
	closeAllBtn cellPositioning: (#center).
	closeAllBtn cellSpacing: (#none).
	closeAllBtn layoutInset: (2@0 corner: 2@0).
	closeAllBtn listCentering: (#topLeft).
	closeAllBtn listDirection: (#leftToRight).
	closeAllBtn listSpacing: (#none).
	closeAllBtn maxCellSize: (1073741823).
	closeAllBtn minCellSize: (0).
	closeAllBtn wrapCentering: (#topLeft).
	closeAllBtn wrapDirection: (#none).
	closeAllBtn frameFractions: (0@0 corner: 1@1).
	closeAllBtn frameOffsets: (0@0 corner: 0@0).
	closeAllBtn balloonText: ('Close all editors for this
class').
	closeAllBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeAllBtn enabled: (true).
	closeAllBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons broomIcon'.
	closeAllBtn icon: (UiFugueIcons broomIcon).
	closeAllBtn text: ('ToolButton').
	closeAllBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeAllBtn checkable: (false).
	closeAllBtn checked: (false).
	closeAllBtn autoExclusive: (false).
	closeAllBtn autoRaise: (true).
	closeAllBtn buttonStyle: (#iconOnly).
	closeAllBtn setProperty: #objectName toValue: 'closeAllBtn'.
	unnamedMorph4 addMorphBack: closeAllBtn.
	browseBtn := UiToolButton new.
	browseBtn changeTableLayout.
	browseBtn extent: (22@18).
	browseBtn position: (220@24).
	browseBtn hResizing: (#shrinkWrap).
	browseBtn vResizing: (#shrinkWrap).
	browseBtn cellInset: (4).
	browseBtn cellPositioning: (#center).
	browseBtn cellSpacing: (#none).
	browseBtn layoutInset: (2@0 corner: 2@0).
	browseBtn listCentering: (#topLeft).
	browseBtn listDirection: (#leftToRight).
	browseBtn listSpacing: (#none).
	browseBtn maxCellSize: (1073741823).
	browseBtn minCellSize: (0).
	browseBtn wrapCentering: (#topLeft).
	browseBtn wrapDirection: (#none).
	browseBtn frameFractions: (0@0 corner: 1@1).
	browseBtn frameOffsets: (0@0 corner: 0@0).
	browseBtn balloonText: ('Browse Classes').
	browseBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	browseBtn enabled: (true).
	browseBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons folderExploreIcon'.
	browseBtn icon: (UiSilkIcons folderExploreIcon).
	browseBtn text: ('ToolButton').
	browseBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	browseBtn checkable: (false).
	browseBtn checked: (false).
	browseBtn autoExclusive: (false).
	browseBtn autoRaise: (true).
	browseBtn buttonStyle: (#iconOnly).
	browseBtn setProperty: #objectName toValue: 'browseBtn'.
	unnamedMorph4 addMorphBack: browseBtn.
	topContainer addMorphBack: unnamedMorph4.
	panel addMorphBack: topContainer.
	codeArea := SdScrollArea new.
	codeArea extent: (240@522).
	codeArea position: (2@45).
	codeArea hResizing: (#spaceFill).
	codeArea vResizing: (#spaceFill).
	codeArea cellInset: (0).
	codeArea cellPositioning: (#center).
	codeArea cellSpacing: (#none).
	codeArea layoutInset: (0).
	codeArea listCentering: (#topLeft).
	codeArea listDirection: (#topToBottom).
	codeArea listSpacing: (#none).
	codeArea maxCellSize: (1073741823).
	codeArea minCellSize: (0).
	codeArea wrapCentering: (#topLeft).
	codeArea wrapDirection: (#none).
	codeArea frameFractions: (0@0 corner: 1@1).
	codeArea frameOffsets: (0@0 corner: 0@0).
	codeArea balloonText: (nil).
	codeArea balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	codeArea widgetResizable: (true).
	codeArea horizontalScrollBarPolicy: (#alwaysOff).
	codeArea verticalScrollBarPolicy: (#asNeeded).
	codeArea outerBorderWidth: (0).
	codeArea scrollBarThickness: (9).
	codeArea setProperty: #objectName toValue: 'codeArea'.
	panel addMorphBack: codeArea.
	panel setProperty: #uiClassName toValue: 'SdClassEditor'.! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:11.687'!
pinBtn
	"nil"
	
	^ pinBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:12.379'!
saveAllBtn
	"nil"
	
	^ saveAllBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:11.919'!
subClassBtn
	"nil"
	
	^ subClassBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:11.775'!
superClassBtn
	"nil"
	
	^ superClassBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:12.329'!
testBtn
	"nil"
	
	^ testBtn! !

!SdClassEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:25:12.068'!
topContainer
	"nil"
	
	^ topContainer! !

UserInterface subclass: #SdClassSelectorUi
	instanceVariableNames: 'unnamedMorph1 pinBtn hideBtn unnamedMorph2 headerBtn unnamedMorph3 unnamedMorph4 closeBtn container unnamedMorph5 recentlyList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:02.027'!
closeBtn
	"nil"
	
	^ closeBtn! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:02.066'!
container
	"nil"
	
	^ container! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:01.968'!
headerBtn
	"nil"
	
	^ headerBtn! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:01.899'!
hideBtn
	"nil"
	
	^ hideBtn! !

!SdClassSelectorUi methodsFor: 'ui - private' stamp: 'mt 7/2/2011 15:28:02.194'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (248@388).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (244@21).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	pinBtn := UiToolButton new.
	pinBtn changeTableLayout.
	pinBtn extent: (18@18).
	pinBtn position: (2@3).
	pinBtn hResizing: (#shrinkWrap).
	pinBtn vResizing: (#shrinkWrap).
	pinBtn cellInset: (4).
	pinBtn cellPositioning: (#center).
	pinBtn cellSpacing: (#none).
	pinBtn layoutInset: (0).
	pinBtn listCentering: (#topLeft).
	pinBtn listDirection: (#leftToRight).
	pinBtn listSpacing: (#none).
	pinBtn maxCellSize: (1073741823).
	pinBtn minCellSize: (0).
	pinBtn wrapCentering: (#topLeft).
	pinBtn wrapDirection: (#none).
	pinBtn frameFractions: (0@0 corner: 1@1).
	pinBtn frameOffsets: (0@0 corner: 0@0).
	pinBtn balloonText: (nil).
	pinBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	pinBtn enabled: (true).
	pinBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons pinSmallIcon'.
	pinBtn icon: (UiFugueIcons pinSmallIcon).
	pinBtn text: ('ToolButton').
	pinBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	pinBtn checkable: (true).
	pinBtn checked: (false).
	pinBtn autoExclusive: (false).
	pinBtn autoRaise: (true).
	pinBtn buttonStyle: (#iconOnly).
	pinBtn setProperty: #objectName toValue: 'pinBtn'.
	unnamedMorph1 addMorphBack: pinBtn.
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (20@3).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (41@10).
	unnamedMorph2 position: (38@7).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (85@21).
	headerBtn position: (79@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Choose a Class').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (42@10).
	unnamedMorph3 position: (164@7).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 extent: (16@10).
	unnamedMorph4 position: (209@7).
	unnamedMorph4 hResizing: (#rigid).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph1 addMorphBack: unnamedMorph4.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (228@3).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Choose a Class').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	container := UiContainer new.
	container changeTableLayout.
	container extent: (244@18).
	container position: (2@30).
	container hResizing: (#spaceFill).
	container vResizing: (#shrinkWrap).
	container cellInset: (2).
	container cellPositioning: (#center).
	container cellSpacing: (#none).
	container layoutInset: (0).
	container listCentering: (#topLeft).
	container listDirection: (#topToBottom).
	container listSpacing: (#none).
	container maxCellSize: (1073741823).
	container minCellSize: (0).
	container wrapCentering: (#topLeft).
	container wrapDirection: (#none).
	container frameFractions: (0@0 corner: 1@1).
	container frameOffsets: (0@0 corner: 0@0).
	container balloonText: (nil).
	container balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	container color: (Color transparent).
	container borderWidth: (0).
	container borderStyle2: (#simple).
	container borderColor: (Color black).
	container setProperty: #objectName toValue: 'container'.
	panel addMorphBack: container.
	unnamedMorph5 := UiLabel new.
	unnamedMorph5 changeTableLayout.
	unnamedMorph5 extent: (74@19).
	unnamedMorph5 position: (87@55).
	unnamedMorph5 hResizing: (#shrinkWrap).
	unnamedMorph5 vResizing: (#shrinkWrap).
	unnamedMorph5 cellInset: (0).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (0).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#leftToRight).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph5 text: ('Recently Used').
	unnamedMorph5 setProperty: #formByDesigner toValue: 'nil'.
	unnamedMorph5 form: (nil).
	panel addMorphBack: unnamedMorph5.
	recentlyList := UiListWidget new.
	recentlyList extent: (244@308).
	recentlyList position: (2@78).
	recentlyList hResizing: (#spaceFill).
	recentlyList vResizing: (#spaceFill).
	recentlyList cellInset: (0).
	recentlyList cellPositioning: (#center).
	recentlyList cellSpacing: (#none).
	recentlyList layoutInset: (0).
	recentlyList listCentering: (#topLeft).
	recentlyList listDirection: (#topToBottom).
	recentlyList listSpacing: (#none).
	recentlyList maxCellSize: (1073741823).
	recentlyList minCellSize: (0).
	recentlyList wrapCentering: (#topLeft).
	recentlyList wrapDirection: (#none).
	recentlyList frameFractions: (0@0 corner: 1@1).
	recentlyList frameOffsets: (0@0 corner: 0@0).
	recentlyList balloonText: (nil).
	recentlyList balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.929)).
	recentlyList widgetResizable: (false).
	recentlyList horizontalScrollBarPolicy: (#alwaysOff).
	recentlyList verticalScrollBarPolicy: (#asNeeded).
	recentlyList outerBorderWidth: (0).
	recentlyList scrollBarThickness: (9).
	recentlyList modelClass: (UiListWidgetModel).
	recentlyList horizontalHeaderVisible: (false).
	recentlyList verticalHeaderVisible: (false).
	recentlyList selectionBehavior: (#selectRows).
	recentlyList selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	recentlyList selectionMode: (UiViewSingleSelection).
	recentlyList setProperty: #objectName toValue: 'recentlyList'.
	panel addMorphBack: recentlyList.
	panel setProperty: #uiClassName toValue: 'SdClassSelector'.! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:01.816'!
pinBtn
	"nil"
	
	^ pinBtn! !

!SdClassSelectorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:28:02.128'!
recentlyList
	"nil"
	
	^ recentlyList! !

UserInterface subclass: #SdMethodContainerUi
	instanceVariableNames: 'headerContainer pinBtn headerBtn unnamedMorph1 closeBtn codeArea'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdMethodContainerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:06:38.433'!
closeBtn
	"nil"
	
	^ closeBtn! !

!SdMethodContainerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:06:38.478'!
codeArea
	"nil"
	
	^ codeArea! !

!SdMethodContainerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:06:38.367'!
headerBtn
	"nil"
	
	^ headerBtn! !

!SdMethodContainerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:06:38.229'!
headerContainer
	"nil"
	
	^ headerContainer! !

!SdMethodContainerUi methodsFor: 'ui - private' stamp: 'mt 7/5/2011 15:06:38.564'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (244@569).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	headerContainer := UiContainer new.
	headerContainer changeTableLayout.
	headerContainer extent: (240@22).
	headerContainer position: (2@2).
	headerContainer hResizing: (#spaceFill).
	headerContainer vResizing: (#shrinkWrap).
	headerContainer cellInset: (0).
	headerContainer cellPositioning: (#center).
	headerContainer cellSpacing: (#none).
	headerContainer layoutInset: (2).
	headerContainer listCentering: (#center).
	headerContainer listDirection: (#leftToRight).
	headerContainer listSpacing: (#none).
	headerContainer maxCellSize: (1073741823).
	headerContainer minCellSize: (0).
	headerContainer wrapCentering: (#topLeft).
	headerContainer wrapDirection: (#none).
	headerContainer frameFractions: (0@0 corner: 1@1).
	headerContainer frameOffsets: (0@0 corner: 0@0).
	headerContainer balloonText: (nil).
	headerContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerContainer color: (Color transparent).
	headerContainer borderWidth: (0).
	headerContainer borderStyle2: (#simple).
	headerContainer borderColor: (Color black).
	headerContainer setProperty: #objectName toValue: 'headerContainer'.
	pinBtn := UiToolButton new.
	pinBtn changeTableLayout.
	pinBtn extent: (18@18).
	pinBtn position: (4@4).
	pinBtn hResizing: (#shrinkWrap).
	pinBtn vResizing: (#shrinkWrap).
	pinBtn cellInset: (4).
	pinBtn cellPositioning: (#center).
	pinBtn cellSpacing: (#none).
	pinBtn layoutInset: (0).
	pinBtn listCentering: (#topLeft).
	pinBtn listDirection: (#leftToRight).
	pinBtn listSpacing: (#none).
	pinBtn maxCellSize: (1073741823).
	pinBtn minCellSize: (0).
	pinBtn wrapCentering: (#topLeft).
	pinBtn wrapDirection: (#none).
	pinBtn frameFractions: (0@0 corner: 1@1).
	pinBtn frameOffsets: (0@0 corner: 0@0).
	pinBtn balloonText: ('Pin this class').
	pinBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	pinBtn enabled: (true).
	pinBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons pinSmallIcon'.
	pinBtn icon: (UiFugueIcons pinSmallIcon).
	pinBtn text: ('ToolButton').
	pinBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	pinBtn checkable: (true).
	pinBtn checked: (false).
	pinBtn autoExclusive: (false).
	pinBtn autoRaise: (true).
	pinBtn buttonStyle: (#iconOnly).
	pinBtn setProperty: #objectName toValue: 'pinBtn'.
	headerContainer addMorphBack: pinBtn.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (18@18).
	headerBtn position: (22@4).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons arrowMoveIcon'.
	headerBtn icon: (UiFugueIcons arrowMoveIcon).
	headerBtn text: ('ToolButton').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#iconOnly).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	headerContainer addMorphBack: headerBtn.
	unnamedMorph1 := UiSpacer new.
	unnamedMorph1 extent: (182@12).
	unnamedMorph1 position: (40@7).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#rigid).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color blue).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph1 orientation: (#horizontal).
	headerContainer addMorphBack: unnamedMorph1.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (222@4).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('ToolButton').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	headerContainer addMorphBack: closeBtn.
	panel addMorphBack: headerContainer.
	codeArea := SdScrollArea new.
	codeArea extent: (240@541).
	codeArea position: (2@26).
	codeArea hResizing: (#spaceFill).
	codeArea vResizing: (#spaceFill).
	codeArea cellInset: (0).
	codeArea cellPositioning: (#center).
	codeArea cellSpacing: (#none).
	codeArea layoutInset: (0).
	codeArea listCentering: (#topLeft).
	codeArea listDirection: (#topToBottom).
	codeArea listSpacing: (#none).
	codeArea maxCellSize: (1073741823).
	codeArea minCellSize: (0).
	codeArea wrapCentering: (#topLeft).
	codeArea wrapDirection: (#none).
	codeArea frameFractions: (0@0 corner: 1@1).
	codeArea frameOffsets: (0@0 corner: 0@0).
	codeArea balloonText: (nil).
	codeArea balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	codeArea widgetResizable: (true).
	codeArea horizontalScrollBarPolicy: (#alwaysOff).
	codeArea verticalScrollBarPolicy: (#asNeeded).
	codeArea outerBorderWidth: (0).
	codeArea scrollBarThickness: (9).
	codeArea setProperty: #objectName toValue: 'codeArea'.
	panel addMorphBack: codeArea.
	panel setProperty: #uiClassName toValue: 'SdMethodContainer'.! !

!SdMethodContainerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:06:38.309'!
pinBtn
	"nil"
	
	^ pinBtn! !

UserInterface subclass: #SdMethodFinderUi
	instanceVariableNames: 'inputContainer protocolBtn searchField actionBtn resultList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/25/2011 14:40:38.182'!
actionBtn
	"nil"
	
	^ actionBtn! !

!SdMethodFinderUi methodsFor: 'ui - private' stamp: 'mt 2/15/2012 16:04:08.422'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (218@101).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#shrinkWrap).
	panel cellInset: (0).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	inputContainer := UiContainer new.
	inputContainer changeTableLayout.
	inputContainer extent: (210@23).
	inputContainer position: (4@4).
	inputContainer hResizing: (#spaceFill).
	inputContainer vResizing: (#shrinkWrap).
	inputContainer cellInset: (2).
	inputContainer cellPositioning: (#center).
	inputContainer cellSpacing: (#none).
	inputContainer layoutInset: (0).
	inputContainer listCentering: (#topLeft).
	inputContainer listDirection: (#leftToRight).
	inputContainer listSpacing: (#none).
	inputContainer maxCellSize: (1073741823).
	inputContainer minCellSize: (0).
	inputContainer wrapCentering: (#topLeft).
	inputContainer wrapDirection: (#none).
	inputContainer frameFractions: (0@0 corner: 1@1).
	inputContainer frameOffsets: (0@0 corner: 0@0).
	inputContainer balloonText: (nil).
	inputContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	inputContainer color: (Color white).
	inputContainer borderWidth: (1).
	inputContainer borderStyle2: (#inset).
	inputContainer borderColor: (#inset).
	inputContainer setProperty: #objectName toValue: 'inputContainer'.
	protocolBtn := UiToolButton new.
	protocolBtn changeTableLayout.
	protocolBtn extent: (71@21).
	protocolBtn position: (5@5).
	protocolBtn hResizing: (#shrinkWrap).
	protocolBtn vResizing: (#shrinkWrap).
	protocolBtn cellInset: (4).
	protocolBtn cellPositioning: (#center).
	protocolBtn cellSpacing: (#none).
	protocolBtn layoutInset: (2@0 corner: 2@0).
	protocolBtn listCentering: (#topLeft).
	protocolBtn listDirection: (#leftToRight).
	protocolBtn listSpacing: (#none).
	protocolBtn maxCellSize: (1073741823).
	protocolBtn minCellSize: (0).
	protocolBtn wrapCentering: (#topLeft).
	protocolBtn wrapDirection: (#none).
	protocolBtn frameFractions: (0@0 corner: 1@1).
	protocolBtn frameOffsets: (0@0 corner: 0@0).
	protocolBtn balloonText: ('').
	protocolBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	protocolBtn enabled: (true).
	protocolBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons tagOrangeIcon'.
	protocolBtn icon: (UiSilkIcons tagOrangeIcon).
	protocolBtn text: ('protocol').
	protocolBtn checkable: (false).
	protocolBtn checked: (false).
	protocolBtn autoExclusive: (false).
	protocolBtn autoRaise: (true).
	protocolBtn buttonStyle: (#textBesideIcon).
	protocolBtn setProperty: #objectName toValue: 'protocolBtn'.
	inputContainer addMorphBack: protocolBtn.
	searchField := UiLineEdit new.
	searchField extent: (111@20).
	searchField position: (78@5).
	searchField hResizing: (#spaceFill).
	searchField vResizing: (#rigid).
	searchField cellInset: (0).
	searchField cellPositioning: (#center).
	searchField cellSpacing: (#none).
	searchField layoutInset: (0).
	searchField listCentering: (#topLeft).
	searchField listDirection: (#topToBottom).
	searchField listSpacing: (#none).
	searchField maxCellSize: (1073741823).
	searchField minCellSize: (0).
	searchField wrapCentering: (#topLeft).
	searchField wrapDirection: (#none).
	searchField frameFractions: (0@0 corner: 1@1).
	searchField frameOffsets: (0@0 corner: 0@0).
	searchField balloonText: (nil).
	searchField balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	searchField widgetResizable: (false).
	searchField horizontalScrollBarPolicy: (#alwaysOff).
	searchField verticalScrollBarPolicy: (#alwaysOff).
	searchField outerBorderWidth: (0).
	searchField scrollBarThickness: (9).
	searchField theText: ('').
	searchField readOnly: (false).
	searchField autoConvert: (false).
	searchField autoAccept: (false).
	searchField acceptOnFocusLost: (true).
	searchField helpText: ('Search...').
	searchField setProperty: #objectName toValue: 'searchField'.
	inputContainer addMorphBack: searchField.
	actionBtn := UiToolButton new.
	actionBtn changeTableLayout.
	actionBtn extent: (22@18).
	actionBtn position: (191@6).
	actionBtn hResizing: (#shrinkWrap).
	actionBtn vResizing: (#shrinkWrap).
	actionBtn cellInset: (4).
	actionBtn cellPositioning: (#center).
	actionBtn cellSpacing: (#none).
	actionBtn layoutInset: (2@0 corner: 2@0).
	actionBtn listCentering: (#topLeft).
	actionBtn listDirection: (#leftToRight).
	actionBtn listSpacing: (#none).
	actionBtn maxCellSize: (1073741823).
	actionBtn minCellSize: (0).
	actionBtn wrapCentering: (#topLeft).
	actionBtn wrapDirection: (#none).
	actionBtn frameFractions: (0@0 corner: 1@1).
	actionBtn frameOffsets: (0@0 corner: 0@0).
	actionBtn balloonText: (nil).
	actionBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	actionBtn enabled: (true).
	actionBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons addIcon'.
	actionBtn icon: (UiSilkIcons addIcon).
	actionBtn text: ('ToolButton').
	actionBtn checkable: (false).
	actionBtn checked: (false).
	actionBtn autoExclusive: (false).
	actionBtn autoRaise: (true).
	actionBtn buttonStyle: (#iconOnly).
	actionBtn setProperty: #objectName toValue: 'actionBtn'.
	actionBtn setProperty: #objectDescription toValue: 'This button triggers the main action for the given text.'.
	inputContainer addMorphBack: actionBtn.
	panel addMorphBack: inputContainer.
	resultList := UiListWidget new.
	resultList extent: (210@70).
	resultList position: (4@27).
	resultList hResizing: (#spaceFill).
	resultList vResizing: (#rigid).
	resultList cellInset: (0).
	resultList cellPositioning: (#center).
	resultList cellSpacing: (#none).
	resultList layoutInset: (0).
	resultList listCentering: (#topLeft).
	resultList listDirection: (#topToBottom).
	resultList listSpacing: (#none).
	resultList maxCellSize: (1073741823).
	resultList minCellSize: (0).
	resultList wrapCentering: (#topLeft).
	resultList wrapDirection: (#none).
	resultList frameFractions: (0@0 corner: 1@1).
	resultList frameOffsets: (0@0 corner: 0@0).
	resultList balloonText: (nil).
	resultList balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	resultList widgetResizable: (false).
	resultList horizontalScrollBarPolicy: (#alwaysOff).
	resultList verticalScrollBarPolicy: (#asNeeded).
	resultList outerBorderWidth: (0).
	resultList scrollBarThickness: (9).
	resultList modelClass: (UiListWidgetModel).
	resultList horizontalHeaderVisible: (false).
	resultList verticalHeaderVisible: (false).
	resultList selectionBehavior: (#selectRows).
	resultList selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	resultList selectionMode: (UiViewSingleSelection).
	resultList setProperty: #objectName toValue: 'resultList'.
	panel addMorphBack: resultList.
	panel setProperty: #uiClassName toValue: 'SdMethodFinder'.! !

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/25/2011 14:40:38'!
inputContainer
	"nil"
	
	^ inputContainer! !

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/25/2011 14:40:38.094'!
protocolBtn
	"nil"
	
	^ protocolBtn! !

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/25/2011 14:40:38.217'!
resultList
	"nil"
	
	^ resultList! !

!SdMethodFinderUi methodsFor: 'accessing' stamp: 'mt 4/25/2011 14:40:38.135'!
searchField
	"nil"
	
	^ searchField! !

UserInterface subclass: #SdObjectExplorerUi
	instanceVariableNames: 'unnamedMorph1 pinBtn hideBtn unnamedMorph2 headerBtn unnamedMorph3 unnamedMorph4 closeBtn treeView sourceCodeEdit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdObjectExplorerUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:47:42.96'!
closeBtn
	"nil"
	
	^ closeBtn! !

!SdObjectExplorerUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:47:42.898'!
headerBtn
	"nil"
	
	^ headerBtn! !

!SdObjectExplorerUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:47:42.834'!
hideBtn
	"nil"
	
	^ hideBtn! !

!SdObjectExplorerUi methodsFor: 'ui - private' stamp: 'mt 7/2/2011 15:47:43.177'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (300@530).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (3).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (296@21).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	pinBtn := UiToolButton new.
	pinBtn changeTableLayout.
	pinBtn extent: (18@18).
	pinBtn position: (2@3).
	pinBtn hResizing: (#shrinkWrap).
	pinBtn vResizing: (#shrinkWrap).
	pinBtn cellInset: (4).
	pinBtn cellPositioning: (#center).
	pinBtn cellSpacing: (#none).
	pinBtn layoutInset: (0).
	pinBtn listCentering: (#topLeft).
	pinBtn listDirection: (#leftToRight).
	pinBtn listSpacing: (#none).
	pinBtn maxCellSize: (1073741823).
	pinBtn minCellSize: (0).
	pinBtn wrapCentering: (#topLeft).
	pinBtn wrapDirection: (#none).
	pinBtn frameFractions: (0@0 corner: 1@1).
	pinBtn frameOffsets: (0@0 corner: 0@0).
	pinBtn balloonText: (nil).
	pinBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	pinBtn enabled: (true).
	pinBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons pinSmallIcon'.
	pinBtn icon: (UiFugueIcons pinSmallIcon).
	pinBtn text: ('ToolButton').
	pinBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	pinBtn checkable: (true).
	pinBtn checked: (false).
	pinBtn autoExclusive: (false).
	pinBtn autoRaise: (true).
	pinBtn buttonStyle: (#iconOnly).
	pinBtn setProperty: #objectName toValue: 'pinBtn'.
	unnamedMorph1 addMorphBack: pinBtn.
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (20@3).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (65@10).
	unnamedMorph2 position: (38@7).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (89@21).
	headerBtn position: (103@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('anObject (1234)').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (66@10).
	unnamedMorph3 position: (192@7).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 extent: (16@10).
	unnamedMorph4 position: (261@7).
	unnamedMorph4 hResizing: (#rigid).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph1 addMorphBack: unnamedMorph4.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (280@3).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Call Graph').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	treeView := UiTreeView new.
	treeView extent: (296@467).
	treeView position: (2@26).
	treeView hResizing: (#spaceFill).
	treeView vResizing: (#spaceFill).
	treeView cellInset: (0).
	treeView cellPositioning: (#center).
	treeView cellSpacing: (#none).
	treeView layoutInset: (0).
	treeView listCentering: (#topLeft).
	treeView listDirection: (#topToBottom).
	treeView listSpacing: (#none).
	treeView maxCellSize: (1073741823).
	treeView minCellSize: (0).
	treeView wrapCentering: (#topLeft).
	treeView wrapDirection: (#none).
	treeView frameFractions: (0@0 corner: 1@1).
	treeView frameOffsets: (0@0 corner: 0@0).
	treeView balloonText: (nil).
	treeView balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	treeView widgetResizable: (false).
	treeView horizontalScrollBarPolicy: (#asNeeded).
	treeView verticalScrollBarPolicy: (#asNeeded).
	treeView outerBorderWidth: (1).
	treeView scrollBarThickness: (9).
	treeView modelClass: (nil).
	treeView horizontalHeaderVisible: (false).
	treeView verticalHeaderVisible: (false).
	treeView selectionBehavior: (#selectRows).
	treeView selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	treeView selectionMode: (UiViewSingleSelection).
	treeView setProperty: #objectName toValue: 'treeView'.
	panel addMorphBack: treeView.
	sourceCodeEdit := SdSourceCodeEdit new.
	sourceCodeEdit extent: (296@16).
	sourceCodeEdit position: (2@504).
	sourceCodeEdit hResizing: (#spaceFill).
	sourceCodeEdit vResizing: (#rigid).
	sourceCodeEdit cellInset: (0).
	sourceCodeEdit cellPositioning: (#center).
	sourceCodeEdit cellSpacing: (#none).
	sourceCodeEdit layoutInset: (0).
	sourceCodeEdit listCentering: (#topLeft).
	sourceCodeEdit listDirection: (#topToBottom).
	sourceCodeEdit listSpacing: (#none).
	sourceCodeEdit maxCellSize: (1073741823).
	sourceCodeEdit minCellSize: (0).
	sourceCodeEdit wrapCentering: (#topLeft).
	sourceCodeEdit wrapDirection: (#none).
	sourceCodeEdit frameFractions: (0@0 corner: 1@1).
	sourceCodeEdit frameOffsets: (0@0 corner: 0@0).
	sourceCodeEdit balloonText: (nil).
	sourceCodeEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	sourceCodeEdit widgetResizable: (true).
	sourceCodeEdit horizontalScrollBarPolicy: (#alwaysOff).
	sourceCodeEdit verticalScrollBarPolicy: (#alwaysOff).
	sourceCodeEdit outerBorderWidth: (1).
	sourceCodeEdit scrollBarThickness: (9).
	sourceCodeEdit theText: ('').
	sourceCodeEdit readOnly: (false).
	sourceCodeEdit autoConvert: (false).
	sourceCodeEdit autoAccept: (true).
	sourceCodeEdit acceptOnFocusLost: (false).
	sourceCodeEdit scrollingMode: (#never).
	sourceCodeEdit scrollingLimit: (10).
	sourceCodeEdit setProperty: #objectName toValue: 'sourceCodeEdit'.
	panel addMorphBack: sourceCodeEdit.
	panel setProperty: #uiClassName toValue: 'SdObjectExplorer'.! !

!SdObjectExplorerUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:47:42.752'!
pinBtn
	"nil"
	
	^ pinBtn! !

!SdObjectExplorerUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:47:43.103'!
sourceCodeEdit
	"nil"
	
	^ sourceCodeEdit! !

!SdObjectExplorerUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:47:43.036'!
treeView
	"nil"
	
	^ treeView! !

UserInterface subclass: #SdOverlayMessageBoxUi
	instanceVariableNames: 'messageContainer iconLbl messageLbl titleLbl buttonContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdOverlayMessageBoxUi methodsFor: 'accessing' stamp: 'mt 4/29/2011 10:31:27.241'!
buttonContainer
	"nil"
	
	^ buttonContainer! !

!SdOverlayMessageBoxUi methodsFor: 'accessing' stamp: 'mt 4/29/2011 10:31:27.043'!
iconLbl
	"nil"
	
	^ iconLbl! !

!SdOverlayMessageBoxUi methodsFor: 'ui - private' stamp: 'mt 4/29/2011 10:31:27.326'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeProportionalLayout.
	panel extent: (181@276).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: ('').
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	panel color: ((TranslucentColor r: 0.0 g: 0.0 b: 0.0 alpha: 0.486)).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	messageContainer := UiContainer new.
	messageContainer changeTableLayout.
	messageContainer extent: (74@80).
	messageContainer position: (53@58).
	messageContainer hResizing: (#shrinkWrap).
	messageContainer vResizing: (#spaceFill).
	messageContainer cellInset: (4).
	messageContainer cellPositioning: (#center).
	messageContainer cellSpacing: (#none).
	messageContainer layoutInset: (4).
	messageContainer listCentering: (#topLeft).
	messageContainer listDirection: (#leftToRight).
	messageContainer listSpacing: (#none).
	messageContainer maxCellSize: (1073741823).
	messageContainer minCellSize: (0).
	messageContainer wrapCentering: (#topLeft).
	messageContainer wrapDirection: (#none).
	messageContainer frameFractions: (0@0.2 corner: 1@0.5).
	messageContainer frameOffsets: (0@0 corner: 0@0).
	messageContainer balloonText: ('').
	messageContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	messageContainer color: (Color transparent).
	messageContainer borderWidth: (0).
	messageContainer borderStyle2: (#simple).
	messageContainer borderColor: (Color black).
	messageContainer setProperty: #objectName toValue: 'messageContainer'.
	iconLbl := UiLabel new.
	iconLbl changeTableLayout.
	iconLbl extent: (16@72).
	iconLbl position: (57@62).
	iconLbl hResizing: (#shrinkWrap).
	iconLbl vResizing: (#spaceFill).
	iconLbl cellInset: (0).
	iconLbl cellPositioning: (#center).
	iconLbl cellSpacing: (#none).
	iconLbl layoutInset: (0).
	iconLbl listCentering: (#topLeft).
	iconLbl listDirection: (#leftToRight).
	iconLbl listSpacing: (#none).
	iconLbl maxCellSize: (1073741823).
	iconLbl minCellSize: (0).
	iconLbl wrapCentering: (#topLeft).
	iconLbl wrapDirection: (#none).
	iconLbl frameFractions: (0@0 corner: 1@1).
	iconLbl frameOffsets: (0@0 corner: 0@0).
	iconLbl balloonText: ('').
	iconLbl balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	iconLbl text: ('Label').
	iconLbl setProperty: #formByDesigner toValue: 'UiSilkIcons informationIcon'.
	iconLbl form: (UiSilkIcons informationIcon).
	iconLbl setProperty: #objectName toValue: 'iconLbl'.
	messageContainer addMorphBack: iconLbl.
	messageLbl := UiLabel new.
	messageLbl changeTableLayout.
	messageLbl extent: (46@72).
	messageLbl position: (77@62).
	messageLbl hResizing: (#shrinkWrap).
	messageLbl vResizing: (#spaceFill).
	messageLbl cellInset: (0).
	messageLbl cellPositioning: (#center).
	messageLbl cellSpacing: (#none).
	messageLbl layoutInset: (0).
	messageLbl listCentering: (#topLeft).
	messageLbl listDirection: (#leftToRight).
	messageLbl listSpacing: (#none).
	messageLbl maxCellSize: (1073741823).
	messageLbl minCellSize: (0).
	messageLbl wrapCentering: (#topLeft).
	messageLbl wrapDirection: (#none).
	messageLbl frameFractions: (0@0.2 corner: 1@0.4).
	messageLbl frameOffsets: (0@0 corner: 0@0).
	messageLbl balloonText: (nil).
	messageLbl balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	messageLbl text: ('Message').
	messageLbl setProperty: #formByDesigner toValue: 'nil'.
	messageLbl form: (nil).
	messageLbl setProperty: #objectName toValue: 'messageLbl'.
	messageContainer addMorphBack: messageLbl.
	panel addMorphBack: messageContainer.
	titleLbl := UiLabel new.
	titleLbl changeTableLayout.
	titleLbl extent: (23@19).
	titleLbl position: (79@22).
	titleLbl hResizing: (#shrinkWrap).
	titleLbl vResizing: (#shrinkWrap).
	titleLbl cellInset: (0).
	titleLbl cellPositioning: (#center).
	titleLbl cellSpacing: (#none).
	titleLbl layoutInset: (0).
	titleLbl listCentering: (#topLeft).
	titleLbl listDirection: (#leftToRight).
	titleLbl listSpacing: (#none).
	titleLbl maxCellSize: (1073741823).
	titleLbl minCellSize: (0).
	titleLbl wrapCentering: (#topLeft).
	titleLbl wrapDirection: (#none).
	titleLbl frameFractions: (0@0 corner: 1@0.2).
	titleLbl frameOffsets: (0@0 corner: 0@0).
	titleLbl balloonText: ('').
	titleLbl balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.929)).
	titleLbl text: ('Title').
	titleLbl setProperty: #formByDesigner toValue: 'nil'.
	titleLbl form: (nil).
	titleLbl setProperty: #objectName toValue: 'titleLbl'.
	panel addMorphBack: titleLbl.
	buttonContainer := UiContainer new.
	buttonContainer changeTableLayout.
	buttonContainer extent: (173@134).
	buttonContainer position: (4@138).
	buttonContainer hResizing: (#spaceFill).
	buttonContainer vResizing: (#spaceFill).
	buttonContainer cellInset: (4).
	buttonContainer cellPositioning: (#center).
	buttonContainer cellSpacing: (#none).
	buttonContainer layoutInset: (16).
	buttonContainer listCentering: (#topLeft).
	buttonContainer listDirection: (#topToBottom).
	buttonContainer listSpacing: (#none).
	buttonContainer maxCellSize: (1073741823).
	buttonContainer minCellSize: (0).
	buttonContainer wrapCentering: (#topLeft).
	buttonContainer wrapDirection: (#none).
	buttonContainer frameFractions: (0@0.5 corner: 1@1).
	buttonContainer frameOffsets: (0@0 corner: 0@0).
	buttonContainer balloonText: (nil).
	buttonContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	buttonContainer color: (Color transparent).
	buttonContainer borderWidth: (0).
	buttonContainer borderStyle2: (#simple).
	buttonContainer borderColor: (Color black).
	buttonContainer setProperty: #objectName toValue: 'buttonContainer'.
	panel addMorphBack: buttonContainer.
	panel setProperty: #uiClassName toValue: 'SdOverlayMessageBox'.! !

!SdOverlayMessageBoxUi methodsFor: 'accessing' stamp: 'mt 4/29/2011 10:31:26.936'!
messageContainer
	"nil"
	
	^ messageContainer! !

!SdOverlayMessageBoxUi methodsFor: 'accessing' stamp: 'mt 4/29/2011 10:31:27.108'!
messageLbl
	"nil"
	
	^ messageLbl! !

!SdOverlayMessageBoxUi methodsFor: 'accessing' stamp: 'mt 4/29/2011 10:31:27.178'!
titleLbl
	"nil"
	
	^ titleLbl! !

UserInterface subclass: #SdPackageViewerUi
	instanceVariableNames: 'unnamedMorph1 pinBtn hideBtn unnamedMorph2 headerBtn unnamedMorph3 unnamedMorph4 closeBtn unnamedMorph5 packageCombo synchBtn treeView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:40:10.139'!
closeBtn
	"nil"
	
	^ closeBtn! !

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:40:10.075'!
headerBtn
	"nil"
	
	^ headerBtn! !

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:40:10.035'!
hideBtn
	"nil"
	
	^ hideBtn! !

!SdPackageViewerUi methodsFor: 'ui - private' stamp: 'mt 7/5/2011 14:40:10.383'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (194@197).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (2).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (190@21).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	pinBtn := UiToolButton new.
	pinBtn changeTableLayout.
	pinBtn extent: (18@18).
	pinBtn position: (2@3).
	pinBtn hResizing: (#shrinkWrap).
	pinBtn vResizing: (#shrinkWrap).
	pinBtn cellInset: (4).
	pinBtn cellPositioning: (#center).
	pinBtn cellSpacing: (#none).
	pinBtn layoutInset: (0).
	pinBtn listCentering: (#topLeft).
	pinBtn listDirection: (#leftToRight).
	pinBtn listSpacing: (#none).
	pinBtn maxCellSize: (1073741823).
	pinBtn minCellSize: (0).
	pinBtn wrapCentering: (#topLeft).
	pinBtn wrapDirection: (#none).
	pinBtn frameFractions: (0@0 corner: 1@1).
	pinBtn frameOffsets: (0@0 corner: 0@0).
	pinBtn balloonText: (nil).
	pinBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	pinBtn enabled: (true).
	pinBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons pinSmallIcon'.
	pinBtn icon: (UiFugueIcons pinSmallIcon).
	pinBtn text: ('Pin').
	pinBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	pinBtn checkable: (true).
	pinBtn checked: (false).
	pinBtn autoExclusive: (false).
	pinBtn autoRaise: (true).
	pinBtn buttonStyle: (#iconOnly).
	pinBtn setProperty: #objectName toValue: 'pinBtn'.
	unnamedMorph1 addMorphBack: pinBtn.
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (20@3).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (13@10).
	unnamedMorph2 position: (38@7).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (88@21).
	headerBtn position: (51@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Package Viewer').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (13@10).
	unnamedMorph3 position: (139@7).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 extent: (16@10).
	unnamedMorph4 position: (155@7).
	unnamedMorph4 hResizing: (#rigid).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph1 addMorphBack: unnamedMorph4.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (174@3).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('Close').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	unnamedMorph5 := UiContainer new.
	unnamedMorph5 changeTableLayout.
	unnamedMorph5 extent: (190@28).
	unnamedMorph5 position: (2@24).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#shrinkWrap).
	unnamedMorph5 cellInset: (3).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (0@2 corner: 0@3).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#leftToRight).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph5 color: (Color transparent).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	packageCombo := UiComboBox new.
	packageCombo changeTableLayout.
	packageCombo extent: (165@21).
	packageCombo position: (2@27).
	packageCombo hResizing: (#spaceFill).
	packageCombo vResizing: (#shrinkWrap).
	packageCombo cellInset: (0).
	packageCombo cellPositioning: (#topLeft).
	packageCombo cellSpacing: (#none).
	packageCombo layoutInset: (0).
	packageCombo listCentering: (#topLeft).
	packageCombo listDirection: (#leftToRight).
	packageCombo listSpacing: (#none).
	packageCombo maxCellSize: (1073741823).
	packageCombo minCellSize: (0).
	packageCombo wrapCentering: (#topLeft).
	packageCombo wrapDirection: (#none).
	packageCombo frameFractions: (0@0 corner: 1@1).
	packageCombo frameOffsets: (0@0 corner: 0@0).
	packageCombo balloonText: (nil).
	packageCombo balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	packageCombo readOnly: (true).
	packageCombo setProperty: #objectName toValue: 'packageCombo'.
	unnamedMorph5 addMorphBack: packageCombo.
	synchBtn := UiToolButton new.
	synchBtn changeTableLayout.
	synchBtn extent: (22@22).
	synchBtn position: (170@26).
	synchBtn hResizing: (#shrinkWrap).
	synchBtn vResizing: (#shrinkWrap).
	synchBtn cellInset: (4).
	synchBtn cellPositioning: (#center).
	synchBtn cellSpacing: (#none).
	synchBtn layoutInset: (2).
	synchBtn listCentering: (#topLeft).
	synchBtn listDirection: (#leftToRight).
	synchBtn listSpacing: (#none).
	synchBtn maxCellSize: (1073741823).
	synchBtn minCellSize: (0).
	synchBtn wrapCentering: (#topLeft).
	synchBtn wrapDirection: (#none).
	synchBtn frameFractions: (0@0 corner: 1@1).
	synchBtn frameOffsets: (0@0 corner: 0@0).
	synchBtn balloonText: ('Synchronize').
	synchBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	synchBtn enabled: (true).
	synchBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons databaseRefreshIcon'.
	synchBtn icon: (UiSilkIcons databaseRefreshIcon).
	synchBtn text: ('Synchronize').
	synchBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	synchBtn checkable: (false).
	synchBtn checked: (false).
	synchBtn autoExclusive: (false).
	synchBtn autoRaise: (true).
	synchBtn buttonStyle: (#iconOnly).
	synchBtn setProperty: #objectName toValue: 'synchBtn'.
	unnamedMorph5 addMorphBack: synchBtn.
	panel addMorphBack: unnamedMorph5.
	treeView := UiTreeView new.
	treeView extent: (190@141).
	treeView position: (2@54).
	treeView hResizing: (#spaceFill).
	treeView vResizing: (#spaceFill).
	treeView cellInset: (0).
	treeView cellPositioning: (#center).
	treeView cellSpacing: (#none).
	treeView layoutInset: (0).
	treeView listCentering: (#topLeft).
	treeView listDirection: (#topToBottom).
	treeView listSpacing: (#none).
	treeView maxCellSize: (1073741823).
	treeView minCellSize: (0).
	treeView wrapCentering: (#topLeft).
	treeView wrapDirection: (#none).
	treeView frameFractions: (0@0 corner: 1@1).
	treeView frameOffsets: (0@0 corner: 0@0).
	treeView balloonText: (nil).
	treeView balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	treeView widgetResizable: (false).
	treeView horizontalScrollBarPolicy: (#asNeeded).
	treeView verticalScrollBarPolicy: (#asNeeded).
	treeView outerBorderWidth: (1).
	treeView scrollBarThickness: (9).
	treeView modelClass: (nil).
	treeView horizontalHeaderVisible: (true).
	treeView verticalHeaderVisible: (false).
	treeView selectionBehavior: (#selectRows).
	treeView selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	treeView selectionMode: (UiViewSingleSelection).
	treeView setProperty: #objectName toValue: 'treeView'.
	panel addMorphBack: treeView.
	panel setProperty: #uiClassName toValue: 'SdPackageViewer'.! !

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:40:10.187'!
packageCombo
	"nil"
	
	^ packageCombo! !

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:40:09.964'!
pinBtn
	"nil"
	
	^ pinBtn! !

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:40:10.259'!
synchBtn
	"nil"
	
	^ synchBtn! !

!SdPackageViewerUi methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:40:10.297'!
treeView
	"nil"
	
	^ treeView! !

UserInterface subclass: #SdTranscriptEditorUi
	instanceVariableNames: 'unnamedMorph1 pinBtn hideBtn unnamedMorph2 headerBtn unnamedMorph3 unnamedMorph4 closeBtn transcriptEdit transcriptToolbar timestampBtn redrawBtn unnamedMorph5 clearTranscriptBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:52:12.939'!
clearTranscriptBtn
	"nil"
	
	^ clearTranscriptBtn! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:52:12.683'!
closeBtn
	"nil"
	
	^ closeBtn! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:52:12.607'!
headerBtn
	"nil"
	
	^ headerBtn! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:52:12.549'!
hideBtn
	"nil"
	
	^ hideBtn! !

!SdTranscriptEditorUi methodsFor: 'ui - private' stamp: 'mt 7/2/2011 15:52:13.037'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (252@487).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (1).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (248@21).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	pinBtn := UiToolButton new.
	pinBtn changeTableLayout.
	pinBtn extent: (18@18).
	pinBtn position: (2@3).
	pinBtn hResizing: (#shrinkWrap).
	pinBtn vResizing: (#shrinkWrap).
	pinBtn cellInset: (4).
	pinBtn cellPositioning: (#center).
	pinBtn cellSpacing: (#none).
	pinBtn layoutInset: (0).
	pinBtn listCentering: (#topLeft).
	pinBtn listDirection: (#leftToRight).
	pinBtn listSpacing: (#none).
	pinBtn maxCellSize: (1073741823).
	pinBtn minCellSize: (0).
	pinBtn wrapCentering: (#topLeft).
	pinBtn wrapDirection: (#none).
	pinBtn frameFractions: (0@0 corner: 1@1).
	pinBtn frameOffsets: (0@0 corner: 0@0).
	pinBtn balloonText: (nil).
	pinBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	pinBtn enabled: (true).
	pinBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons pinSmallIcon'.
	pinBtn icon: (UiFugueIcons pinSmallIcon).
	pinBtn text: ('ToolButton').
	pinBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	pinBtn checkable: (true).
	pinBtn checked: (false).
	pinBtn autoExclusive: (false).
	pinBtn autoRaise: (true).
	pinBtn buttonStyle: (#iconOnly).
	pinBtn setProperty: #objectName toValue: 'pinBtn'.
	unnamedMorph1 addMorphBack: pinBtn.
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (20@3).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (56@10).
	unnamedMorph2 position: (38@7).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (59@21).
	headerBtn position: (94@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Transcript').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (57@10).
	unnamedMorph3 position: (153@7).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 extent: (16@10).
	unnamedMorph4 position: (213@7).
	unnamedMorph4 hResizing: (#rigid).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph1 addMorphBack: unnamedMorph4.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (232@3).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('ToolButton').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	transcriptEdit := UiTextEdit new.
	transcriptEdit extent: (248@442).
	transcriptEdit position: (2@24).
	transcriptEdit hResizing: (#spaceFill).
	transcriptEdit vResizing: (#spaceFill).
	transcriptEdit cellInset: (0).
	transcriptEdit cellPositioning: (#center).
	transcriptEdit cellSpacing: (#none).
	transcriptEdit layoutInset: (0).
	transcriptEdit listCentering: (#topLeft).
	transcriptEdit listDirection: (#topToBottom).
	transcriptEdit listSpacing: (#none).
	transcriptEdit maxCellSize: (1073741823).
	transcriptEdit minCellSize: (0).
	transcriptEdit wrapCentering: (#topLeft).
	transcriptEdit wrapDirection: (#none).
	transcriptEdit frameFractions: (0@0 corner: 1@1).
	transcriptEdit frameOffsets: (0@0 corner: 0@0).
	transcriptEdit balloonText: ('Transcript').
	transcriptEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	transcriptEdit widgetResizable: (true).
	transcriptEdit horizontalScrollBarPolicy: (#alwaysOff).
	transcriptEdit verticalScrollBarPolicy: (#alwaysOn).
	transcriptEdit outerBorderWidth: (1).
	transcriptEdit scrollBarThickness: (9).
	transcriptEdit theText: ('').
	transcriptEdit readOnly: (false).
	transcriptEdit autoConvert: (false).
	transcriptEdit autoAccept: (true).
	transcriptEdit acceptOnFocusLost: (false).
	transcriptEdit scrollingMode: (#none).
	transcriptEdit scrollingLimit: (10).
	transcriptEdit setProperty: #objectName toValue: 'transcriptEdit'.
	panel addMorphBack: transcriptEdit.
	transcriptToolbar := UiContainer new.
	transcriptToolbar changeTableLayout.
	transcriptToolbar extent: (248@18).
	transcriptToolbar position: (2@467).
	transcriptToolbar hResizing: (#spaceFill).
	transcriptToolbar vResizing: (#shrinkWrap).
	transcriptToolbar cellInset: (4).
	transcriptToolbar cellPositioning: (#center).
	transcriptToolbar cellSpacing: (#none).
	transcriptToolbar layoutInset: (0).
	transcriptToolbar listCentering: (#topLeft).
	transcriptToolbar listDirection: (#leftToRight).
	transcriptToolbar listSpacing: (#none).
	transcriptToolbar maxCellSize: (1073741823).
	transcriptToolbar minCellSize: (0).
	transcriptToolbar wrapCentering: (#topLeft).
	transcriptToolbar wrapDirection: (#none).
	transcriptToolbar frameFractions: (0@0 corner: 1@1).
	transcriptToolbar frameOffsets: (0@0 corner: 0@0).
	transcriptToolbar balloonText: (nil).
	transcriptToolbar balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	transcriptToolbar color: (Color transparent).
	transcriptToolbar borderWidth: (0).
	transcriptToolbar borderStyle2: (#simple).
	transcriptToolbar borderColor: (Color black).
	transcriptToolbar setProperty: #objectName toValue: 'transcriptToolbar'.
	timestampBtn := UiToolButton new.
	timestampBtn changeTableLayout.
	timestampBtn extent: (22@18).
	timestampBtn position: (2@467).
	timestampBtn hResizing: (#shrinkWrap).
	timestampBtn vResizing: (#shrinkWrap).
	timestampBtn cellInset: (4).
	timestampBtn cellPositioning: (#center).
	timestampBtn cellSpacing: (#none).
	timestampBtn layoutInset: (2@0 corner: 2@0).
	timestampBtn listCentering: (#topLeft).
	timestampBtn listDirection: (#leftToRight).
	timestampBtn listSpacing: (#none).
	timestampBtn maxCellSize: (1073741823).
	timestampBtn minCellSize: (0).
	timestampBtn wrapCentering: (#topLeft).
	timestampBtn wrapDirection: (#none).
	timestampBtn frameFractions: (0@0 corner: 1@1).
	timestampBtn frameOffsets: (0@0 corner: 0@0).
	timestampBtn balloonText: ('Show timestamp on
linebreaks.').
	timestampBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	timestampBtn enabled: (true).
	timestampBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons clockFrameIcon'.
	timestampBtn icon: (UiFugueIcons clockFrameIcon).
	timestampBtn text: ('ToolButton').
	timestampBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	timestampBtn checkable: (true).
	timestampBtn checked: (true).
	timestampBtn autoExclusive: (false).
	timestampBtn autoRaise: (true).
	timestampBtn buttonStyle: (#iconOnly).
	timestampBtn setProperty: #objectName toValue: 'timestampBtn'.
	transcriptToolbar addMorphBack: timestampBtn.
	redrawBtn := UiToolButton new.
	redrawBtn changeTableLayout.
	redrawBtn extent: (22@18).
	redrawBtn position: (28@467).
	redrawBtn hResizing: (#shrinkWrap).
	redrawBtn vResizing: (#shrinkWrap).
	redrawBtn cellInset: (4).
	redrawBtn cellPositioning: (#center).
	redrawBtn cellSpacing: (#none).
	redrawBtn layoutInset: (2@0 corner: 2@0).
	redrawBtn listCentering: (#topLeft).
	redrawBtn listDirection: (#leftToRight).
	redrawBtn listSpacing: (#none).
	redrawBtn maxCellSize: (1073741823).
	redrawBtn minCellSize: (0).
	redrawBtn wrapCentering: (#topLeft).
	redrawBtn wrapDirection: (#none).
	redrawBtn frameFractions: (0@0 corner: 1@1).
	redrawBtn frameOffsets: (0@0 corner: 0@0).
	redrawBtn balloonText: ('Force immediate redraw.').
	redrawBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	redrawBtn enabled: (true).
	redrawBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons arrowCircleDouble135Icon'.
	redrawBtn icon: (UiFugueIcons arrowCircleDouble135Icon).
	redrawBtn text: ('ToolButton').
	redrawBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	redrawBtn checkable: (true).
	redrawBtn checked: (true).
	redrawBtn autoExclusive: (false).
	redrawBtn autoRaise: (true).
	redrawBtn buttonStyle: (#iconOnly).
	redrawBtn setProperty: #objectName toValue: 'redrawBtn'.
	transcriptToolbar addMorphBack: redrawBtn.
	unnamedMorph5 := UiSpacer new.
	unnamedMorph5 extent: (170@10).
	unnamedMorph5 position: (54@471).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#rigid).
	unnamedMorph5 cellInset: (0).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (0).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#topToBottom).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph5 color: (Color blue).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	unnamedMorph5 orientation: (#horizontal).
	transcriptToolbar addMorphBack: unnamedMorph5.
	clearTranscriptBtn := UiToolButton new.
	clearTranscriptBtn changeTableLayout.
	clearTranscriptBtn extent: (22@18).
	clearTranscriptBtn position: (228@467).
	clearTranscriptBtn hResizing: (#shrinkWrap).
	clearTranscriptBtn vResizing: (#shrinkWrap).
	clearTranscriptBtn cellInset: (4).
	clearTranscriptBtn cellPositioning: (#center).
	clearTranscriptBtn cellSpacing: (#none).
	clearTranscriptBtn layoutInset: (2@0 corner: 2@0).
	clearTranscriptBtn listCentering: (#topLeft).
	clearTranscriptBtn listDirection: (#leftToRight).
	clearTranscriptBtn listSpacing: (#none).
	clearTranscriptBtn maxCellSize: (1073741823).
	clearTranscriptBtn minCellSize: (0).
	clearTranscriptBtn wrapCentering: (#topLeft).
	clearTranscriptBtn wrapDirection: (#none).
	clearTranscriptBtn frameFractions: (0@0 corner: 1@1).
	clearTranscriptBtn frameOffsets: (0@0 corner: 0@0).
	clearTranscriptBtn balloonText: ('Clear transcript').
	clearTranscriptBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	clearTranscriptBtn enabled: (true).
	clearTranscriptBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons broomIcon'.
	clearTranscriptBtn icon: (UiFugueIcons broomIcon).
	clearTranscriptBtn text: ('ToolButton').
	clearTranscriptBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	clearTranscriptBtn checkable: (false).
	clearTranscriptBtn checked: (false).
	clearTranscriptBtn autoExclusive: (false).
	clearTranscriptBtn autoRaise: (true).
	clearTranscriptBtn buttonStyle: (#iconOnly).
	clearTranscriptBtn setProperty: #objectName toValue: 'clearTranscriptBtn'.
	transcriptToolbar addMorphBack: clearTranscriptBtn.
	panel addMorphBack: transcriptToolbar.
	panel setProperty: #uiClassName toValue: 'SdTranscriptEditor'.! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:52:12.445'!
pinBtn
	"nil"
	
	^ pinBtn! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:52:12.888'!
redrawBtn
	"nil"
	
	^ redrawBtn! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:52:12.84'!
timestampBtn
	"nil"
	
	^ timestampBtn! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:52:12.735'!
transcriptEdit
	"nil"
	
	^ transcriptEdit! !

!SdTranscriptEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:52:12.794'!
transcriptToolbar
	"nil"
	
	^ transcriptToolbar! !

UserInterface subclass: #SdWorkspaceEditorUi
	instanceVariableNames: 'unnamedMorph1 pinBtn hideBtn unnamedMorph2 headerBtn unnamedMorph3 unnamedMorph4 closeBtn workspaceEdit workspaceToolbar unnamedMorph5 clearWorkspaceBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Designs'!

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:56:34.221'!
clearWorkspaceBtn
	"nil"
	
	^ clearWorkspaceBtn! !

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:56:34.037'!
closeBtn
	"nil"
	
	^ closeBtn! !

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:56:33.956'!
headerBtn
	"nil"
	
	^ headerBtn! !

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:56:33.913'!
hideBtn
	"nil"
	
	^ hideBtn! !

!SdWorkspaceEditorUi methodsFor: 'ui - private' stamp: 'mt 7/2/2011 15:56:34.319'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (252@487).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (1).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (2).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (248@21).
	unnamedMorph1 position: (2@2).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 cellInset: (0).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	pinBtn := UiToolButton new.
	pinBtn changeTableLayout.
	pinBtn extent: (18@18).
	pinBtn position: (2@3).
	pinBtn hResizing: (#shrinkWrap).
	pinBtn vResizing: (#shrinkWrap).
	pinBtn cellInset: (4).
	pinBtn cellPositioning: (#center).
	pinBtn cellSpacing: (#none).
	pinBtn layoutInset: (0).
	pinBtn listCentering: (#topLeft).
	pinBtn listDirection: (#leftToRight).
	pinBtn listSpacing: (#none).
	pinBtn maxCellSize: (1073741823).
	pinBtn minCellSize: (0).
	pinBtn wrapCentering: (#topLeft).
	pinBtn wrapDirection: (#none).
	pinBtn frameFractions: (0@0 corner: 1@1).
	pinBtn frameOffsets: (0@0 corner: 0@0).
	pinBtn balloonText: (nil).
	pinBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	pinBtn enabled: (true).
	pinBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons pinSmallIcon'.
	pinBtn icon: (UiFugueIcons pinSmallIcon).
	pinBtn text: ('ToolButton').
	pinBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	pinBtn checkable: (true).
	pinBtn checked: (false).
	pinBtn autoExclusive: (false).
	pinBtn autoRaise: (true).
	pinBtn buttonStyle: (#iconOnly).
	pinBtn setProperty: #objectName toValue: 'pinBtn'.
	unnamedMorph1 addMorphBack: pinBtn.
	hideBtn := UiToolButton new.
	hideBtn changeTableLayout.
	hideBtn extent: (18@18).
	hideBtn position: (20@3).
	hideBtn hResizing: (#shrinkWrap).
	hideBtn vResizing: (#shrinkWrap).
	hideBtn cellInset: (4).
	hideBtn cellPositioning: (#center).
	hideBtn cellSpacing: (#none).
	hideBtn layoutInset: (0).
	hideBtn listCentering: (#topLeft).
	hideBtn listDirection: (#leftToRight).
	hideBtn listSpacing: (#none).
	hideBtn maxCellSize: (1073741823).
	hideBtn minCellSize: (0).
	hideBtn wrapCentering: (#topLeft).
	hideBtn wrapDirection: (#none).
	hideBtn frameFractions: (0@0 corner: 1@1).
	hideBtn frameOffsets: (0@0 corner: 0@0).
	hideBtn balloonText: (nil).
	hideBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	hideBtn enabled: (true).
	hideBtn setProperty: #iconByDesigner toValue: 'UiSilkIcons eyeIcon'.
	hideBtn icon: (UiSilkIcons eyeIcon).
	hideBtn text: ('ToolButton').
	hideBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	hideBtn checkable: (true).
	hideBtn checked: (true).
	hideBtn autoExclusive: (false).
	hideBtn autoRaise: (true).
	hideBtn buttonStyle: (#iconOnly).
	hideBtn setProperty: #objectName toValue: 'hideBtn'.
	unnamedMorph1 addMorphBack: hideBtn.
	unnamedMorph2 := UiSpacer new.
	unnamedMorph2 extent: (54@10).
	unnamedMorph2 position: (38@7).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#rigid).
	unnamedMorph2 cellInset: (0).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (0).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	unnamedMorph2 color: (Color blue).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	unnamedMorph2 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph2.
	headerBtn := SdDraggableButton new.
	headerBtn changeTableLayout.
	headerBtn extent: (64@21).
	headerBtn position: (92@2).
	headerBtn hResizing: (#shrinkWrap).
	headerBtn vResizing: (#shrinkWrap).
	headerBtn cellInset: (4).
	headerBtn cellPositioning: (#center).
	headerBtn cellSpacing: (#none).
	headerBtn layoutInset: (2@0 corner: 2@0).
	headerBtn listCentering: (#topLeft).
	headerBtn listDirection: (#leftToRight).
	headerBtn listSpacing: (#none).
	headerBtn maxCellSize: (1073741823).
	headerBtn minCellSize: (0).
	headerBtn wrapCentering: (#topLeft).
	headerBtn wrapDirection: (#none).
	headerBtn frameFractions: (0@0 corner: 1@1).
	headerBtn frameOffsets: (0@0 corner: 0@0).
	headerBtn balloonText: (nil).
	headerBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	headerBtn enabled: (true).
	headerBtn setProperty: #iconByDesigner toValue: 'nil'.
	headerBtn icon: (nil).
	headerBtn text: ('Workspace').
	headerBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	headerBtn checkable: (false).
	headerBtn checked: (false).
	headerBtn autoExclusive: (false).
	headerBtn autoRaise: (true).
	headerBtn buttonStyle: (#textBesideIcon).
	headerBtn setProperty: #objectName toValue: 'headerBtn'.
	unnamedMorph1 addMorphBack: headerBtn.
	unnamedMorph3 := UiSpacer new.
	unnamedMorph3 extent: (54@10).
	unnamedMorph3 position: (156@7).
	unnamedMorph3 hResizing: (#spaceFill).
	unnamedMorph3 vResizing: (#rigid).
	unnamedMorph3 cellInset: (0).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (0).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.925)).
	unnamedMorph3 color: (Color blue).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph3 orientation: (#horizontal).
	unnamedMorph1 addMorphBack: unnamedMorph3.
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 extent: (16@10).
	unnamedMorph4 position: (213@7).
	unnamedMorph4 hResizing: (#rigid).
	unnamedMorph4 vResizing: (#rigid).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#topToBottom).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph1 addMorphBack: unnamedMorph4.
	closeBtn := UiToolButton new.
	closeBtn changeTableLayout.
	closeBtn extent: (18@18).
	closeBtn position: (232@3).
	closeBtn hResizing: (#shrinkWrap).
	closeBtn vResizing: (#shrinkWrap).
	closeBtn cellInset: (4).
	closeBtn cellPositioning: (#center).
	closeBtn cellSpacing: (#none).
	closeBtn layoutInset: (0).
	closeBtn listCentering: (#topLeft).
	closeBtn listDirection: (#leftToRight).
	closeBtn listSpacing: (#none).
	closeBtn maxCellSize: (1073741823).
	closeBtn minCellSize: (0).
	closeBtn wrapCentering: (#topLeft).
	closeBtn wrapDirection: (#none).
	closeBtn frameFractions: (0@0 corner: 1@1).
	closeBtn frameOffsets: (0@0 corner: 0@0).
	closeBtn balloonText: (nil).
	closeBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	closeBtn enabled: (true).
	closeBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons minusWhiteIcon'.
	closeBtn icon: (UiFugueIcons minusWhiteIcon).
	closeBtn text: ('ToolButton').
	closeBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	closeBtn checkable: (false).
	closeBtn checked: (false).
	closeBtn autoExclusive: (false).
	closeBtn autoRaise: (true).
	closeBtn buttonStyle: (#iconOnly).
	closeBtn setProperty: #objectName toValue: 'closeBtn'.
	unnamedMorph1 addMorphBack: closeBtn.
	panel addMorphBack: unnamedMorph1.
	workspaceEdit := SdSourceCodeEdit new.
	workspaceEdit extent: (248@442).
	workspaceEdit position: (2@24).
	workspaceEdit hResizing: (#spaceFill).
	workspaceEdit vResizing: (#spaceFill).
	workspaceEdit cellInset: (0).
	workspaceEdit cellPositioning: (#center).
	workspaceEdit cellSpacing: (#none).
	workspaceEdit layoutInset: (0).
	workspaceEdit listCentering: (#topLeft).
	workspaceEdit listDirection: (#topToBottom).
	workspaceEdit listSpacing: (#none).
	workspaceEdit maxCellSize: (1073741823).
	workspaceEdit minCellSize: (0).
	workspaceEdit wrapCentering: (#topLeft).
	workspaceEdit wrapDirection: (#none).
	workspaceEdit frameFractions: (0@0 corner: 1@1).
	workspaceEdit frameOffsets: (0@0 corner: 0@0).
	workspaceEdit balloonText: ('Workspace').
	workspaceEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	workspaceEdit widgetResizable: (true).
	workspaceEdit horizontalScrollBarPolicy: (#alwaysOff).
	workspaceEdit verticalScrollBarPolicy: (#alwaysOn).
	workspaceEdit outerBorderWidth: (1).
	workspaceEdit scrollBarThickness: (9).
	workspaceEdit theText: ('').
	workspaceEdit readOnly: (false).
	workspaceEdit autoConvert: (false).
	workspaceEdit autoAccept: (true).
	workspaceEdit acceptOnFocusLost: (false).
	workspaceEdit scrollingMode: (#none).
	workspaceEdit scrollingLimit: (10).
	workspaceEdit setProperty: #objectName toValue: 'workspaceEdit'.
	panel addMorphBack: workspaceEdit.
	workspaceToolbar := UiContainer new.
	workspaceToolbar changeTableLayout.
	workspaceToolbar extent: (248@18).
	workspaceToolbar position: (2@467).
	workspaceToolbar hResizing: (#spaceFill).
	workspaceToolbar vResizing: (#shrinkWrap).
	workspaceToolbar cellInset: (4).
	workspaceToolbar cellPositioning: (#center).
	workspaceToolbar cellSpacing: (#none).
	workspaceToolbar layoutInset: (0).
	workspaceToolbar listCentering: (#topLeft).
	workspaceToolbar listDirection: (#leftToRight).
	workspaceToolbar listSpacing: (#none).
	workspaceToolbar maxCellSize: (1073741823).
	workspaceToolbar minCellSize: (0).
	workspaceToolbar wrapCentering: (#topLeft).
	workspaceToolbar wrapDirection: (#none).
	workspaceToolbar frameFractions: (0@0 corner: 1@1).
	workspaceToolbar frameOffsets: (0@0 corner: 0@0).
	workspaceToolbar balloonText: (nil).
	workspaceToolbar balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	workspaceToolbar color: (Color transparent).
	workspaceToolbar borderWidth: (0).
	workspaceToolbar borderStyle2: (#simple).
	workspaceToolbar borderColor: (Color black).
	workspaceToolbar setProperty: #objectName toValue: 'workspaceToolbar'.
	unnamedMorph5 := UiSpacer new.
	unnamedMorph5 extent: (222@10).
	unnamedMorph5 position: (2@471).
	unnamedMorph5 hResizing: (#spaceFill).
	unnamedMorph5 vResizing: (#rigid).
	unnamedMorph5 cellInset: (0).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (0).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#topToBottom).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph5 color: (Color blue).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	unnamedMorph5 orientation: (#horizontal).
	workspaceToolbar addMorphBack: unnamedMorph5.
	clearWorkspaceBtn := UiToolButton new.
	clearWorkspaceBtn changeTableLayout.
	clearWorkspaceBtn extent: (22@18).
	clearWorkspaceBtn position: (228@467).
	clearWorkspaceBtn hResizing: (#shrinkWrap).
	clearWorkspaceBtn vResizing: (#shrinkWrap).
	clearWorkspaceBtn cellInset: (4).
	clearWorkspaceBtn cellPositioning: (#center).
	clearWorkspaceBtn cellSpacing: (#none).
	clearWorkspaceBtn layoutInset: (2@0 corner: 2@0).
	clearWorkspaceBtn listCentering: (#topLeft).
	clearWorkspaceBtn listDirection: (#leftToRight).
	clearWorkspaceBtn listSpacing: (#none).
	clearWorkspaceBtn maxCellSize: (1073741823).
	clearWorkspaceBtn minCellSize: (0).
	clearWorkspaceBtn wrapCentering: (#topLeft).
	clearWorkspaceBtn wrapDirection: (#none).
	clearWorkspaceBtn frameFractions: (0@0 corner: 1@1).
	clearWorkspaceBtn frameOffsets: (0@0 corner: 0@0).
	clearWorkspaceBtn balloonText: ('Clear workspace').
	clearWorkspaceBtn balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	clearWorkspaceBtn enabled: (true).
	clearWorkspaceBtn setProperty: #iconByDesigner toValue: 'UiFugueIcons broomIcon'.
	clearWorkspaceBtn icon: (UiFugueIcons broomIcon).
	clearWorkspaceBtn text: ('ToolButton').
	clearWorkspaceBtn color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	clearWorkspaceBtn checkable: (false).
	clearWorkspaceBtn checked: (false).
	clearWorkspaceBtn autoExclusive: (false).
	clearWorkspaceBtn autoRaise: (true).
	clearWorkspaceBtn buttonStyle: (#iconOnly).
	clearWorkspaceBtn setProperty: #objectName toValue: 'clearWorkspaceBtn'.
	workspaceToolbar addMorphBack: clearWorkspaceBtn.
	panel addMorphBack: workspaceToolbar.
	panel setProperty: #uiClassName toValue: 'SdWorkspaceEditor'.! !

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:56:33.836'!
pinBtn
	"nil"
	
	^ pinBtn! !

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:56:34.105'!
workspaceEdit
	"nil"
	
	^ workspaceEdit! !

!SdWorkspaceEditorUi methodsFor: 'accessing' stamp: 'mt 7/2/2011 15:56:34.166'!
workspaceToolbar
	"nil"
	
	^ workspaceToolbar! !

LayoutPolicy subclass: #SdColumnLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Layouts'!

!SdColumnLayout commentStamp: 'mt 7/2/2011 15:13:57.596' prior: 0!
Just a simple layout that layouts its children in one column making them expanding horizontally.!

!SdColumnLayout methodsFor: 'layout' stamp: 'mt 7/2/2011 15:10:45.562'!
layout: aMorph in: newBounds

	| offset verticalSpace numSpaceFillers |
	verticalSpace := newBounds height.
	numSpaceFillers := 0.
	aMorph submorphsDo: [:morph | 
		morph fullBounds.
		morph vResizing ~= #spaceFill
			ifTrue: [verticalSpace := verticalSpace - morph height]
			ifFalse: [numSpaceFillers := numSpaceFillers + 1]].
	
	verticalSpace := verticalSpace max: 0.
	offset := 0.
	aMorph submorphsDo: [:morph |
		morph vResizing ~= #spaceFill
			ifTrue: [
				morph bounds: (newBounds topLeft + (0@offset)
					corner: newBounds topRight + (0@(offset+morph height)))]
			ifFalse: [
				morph bounds: (newBounds topLeft + (0@offset)
					corner: newBounds topRight + (0@(offset+(verticalSpace // numSpaceFillers)))).
				numSpaceFillers := numSpaceFillers - 1.
				verticalSpace := verticalSpace - morph height].
		offset := offset + morph height].! !

LayoutPolicy subclass: #SdMethodEditorColumnLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Layouts'!

!SdMethodEditorColumnLayout methodsFor: 'layout' stamp: 'mt 3/15/2012 17:26:49.17'!
layout: aMorph in: newBounds

	| offset |
	offset := aMorph topLeft.
	aMorph submorphsDo: [:s | 
		s
			width: aMorph width;
			topLeft: offset.
		s fullBounds.
		offset := offset x @ (offset y + s bounds height)].
	aMorph height: offset y.! !

LayoutPolicy subclass: #SdMethodEditorLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Layouts'!

!SdMethodEditorLayout methodsFor: 'layout' stamp: 'mt 3/15/2012 17:25:13.569'!
layout: aMorph in: newBounds

	aMorph submorphsDo: [:s |
		s visible ifTrue: [
			s
				width: aMorph width;
				layoutChanged;
				topLeft: aMorph topLeft.
			s fullBounds.
			aMorph height: s bounds height]].! !

LayoutPolicy subclass: #SdTapeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Layouts'!

!SdTapeLayout methodsFor: 'layout' stamp: 'mt 3/15/2012 16:28:29.525'!
layout: aMorph in: newBounds

	| offset |
	offset := aMorph topLeft.
	aMorph submorphsDo: [:s | 
		s
			height: aMorph height;
			topLeft: offset.
		offset := (offset x + s fullBounds width -1) @ offset y].
	aMorph width: offset x.! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/28/2011 16:28:53.399'!
connectSignal: aSignal toSelector: aSelector

	self
		connectSignal: aSignal
		toSelector: aSelector
		pattern: nil.! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/28/2011 15:53:47.042'!
connectSignal: aSignal toSelector: aSelector pattern: argPattern
	"Connect owner-chain-signals with this receiver. Highly dynamic as sender is unknown at the time of connection setup."
	
	| numArgsSender numArgsReceiver fixedPattern |
	"Convert pattern array to custom pattern object."
	fixedPattern := argPattern ifNotNil: [SignalConnectionPattern new mapping: argPattern].
	
	"Check if messages are available."
	(self respondsTo: aSelector)
		ifFalse: [Error signal: 'Could not connect signal to receiver!!'].
	
	"Check if sender sends at least enough arguments if pattern is empty."
	numArgsSender := aSignal count: [:c | c = $:].
	numArgsReceiver := aSelector count: [:c | c = $:].
	(numArgsSender < numArgsReceiver and: [fixedPattern isNil])
		ifTrue: [Error signal: 'Could not connect sender to receiver!! Receiver expects more arguments!!'].
	
	"Check if pattern size is correct."
	fixedPattern ifNotNil: [
		((fixedPattern hasIndices not or: [fixedPattern minIndex >= 0])
			and: [numArgsReceiver == fixedPattern size]
			and: [fixedPattern hasIndices not or: [numArgsSender >= fixedPattern maxIndex]])
			ifFalse: [Error signal: 'Could not connect sender to receiver!! Pattern is invalid!!']].
	
	"Auto-truncate unnecessary arguments if pattern is not given."
	(numArgsSender > numArgsReceiver and: [fixedPattern isNil])
		ifTrue: [fixedPattern := SignalConnectionPattern new
			mapping: ((1 to: numArgsReceiver) collect: [:i | i])].

	"Add the connection."
	(self signalConnectionsForOwnerChain
		at: aSignal ifAbsentPut: [OrderedCollection new])
		add: (SignalConnectionConfiguration new
			selector: aSelector;
			pattern: fixedPattern).! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/28/2011 16:01:47.938'!
disconnectSignal: aSignal fromSelector: aSelector

	| connections |
	connections := self signalConnectionsForOwnerChain
		at: aSignal ifAbsent: [^ self].
		
	connections removeAllSuchThat: [:c | c selector == aSelector].
	
	connections ifEmpty: [self signalConnectionsForOwnerChain removeKey: aSignal].! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/28/2011 16:49:50.097'!
emitInOwnerChain
	"Special kind of signals that will be handled by the owner-chain."
	
	| signalCtx signal args owner |
	signalCtx := thisContext sender.
	signal := signalCtx method.
	
	"Extract arguments."
	args := Array new: signal numArgs.
	(1 to: signal numArgs) do: [:index |
		args at: index put: (signalCtx tempAt: index)].
	
	"Start handling"
	owner := self.
	[(owner := owner owner) notNil] whileTrue: [
		(owner emitSignalInOwnerChain: signal selector arguments: args sender: self)
			ifTrue: [^ self "Done."]].
	! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/28/2011 16:49:35.115'!
emitSignalInOwnerChain: signal arguments: args sender: aSender
	"Private. Performs the triggering of callbacks."
		
	^ (self signalConnectionsForOwnerChain
		at: signal ifAbsent: [^ false]) allSatisfy: [ :connectionConfiguration |
			| selector pattern filteredArgs |
			selector := connectionConfiguration selector.
			pattern := connectionConfiguration pattern.
					
			filteredArgs := pattern
				ifNil: [args]
				ifNotNil: [pattern mapArguments: args useSender: aSender].
				
			(self perform: selector withArguments: filteredArgs) == true].! !

!Morph methodsFor: '*sight-dynamic' stamp: 'mt 6/28/2011 14:53:07.534'!
ide

	^ self owner ifNotNil: [:o | o ide]! !

!Morph methodsFor: '*sight-dynamic-signals' stamp: 'mt 6/28/2011 15:45:04.011'!
signalConnectionsForOwnerChain

	^ self
		valueOfProperty: #signalConnectionsForOwnerChain
		ifAbsentPut: [Dictionary new]! !

Morph subclass: #SdBreadcrumbTrail
	instanceVariableNames: 'packageBtn categoryBtn classBtn protocolBtn categoryListBtn classListBtn protocolListBtn'
	classVariableNames: 'ArrowIcon'
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:57:34.258'!
category

	^ categoryBtn valueOfProperty: #category! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:02:05.699'!
category: aString

	| packageName shortName |
	packageName := (PackageOrganizer default packageOfSystemCategory: aString) name.
	shortName := aString size == packageName size
		ifTrue: [packageName]
		ifFalse: [aString allButFirst: packageName size + 1].
		
	categoryBtn
		setProperty: #category toValue: aString;
		text: shortName.
		
	self packageName: packageName.! !

!SdBreadcrumbTrail methodsFor: 'signals' stamp: 'mt 7/5/2011 16:17:30.029'!
classActivated: aClass

	self emitInOwnerChain.! !

!SdBreadcrumbTrail methodsFor: 'initialization' stamp: 'mt 7/5/2011 16:56:37.569'!
initialize

	super initialize.
	
	self
		color: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		height: 13.
		
	packageBtn := UiToolButton new text: 'Morphic'; color: Color transparent; autoRaise: true; layoutInset: (0@ -5 corner: 0@ -3).
	categoryBtn := UiToolButton new text: 'Kernel'; color: Color transparent; autoRaise: true;layoutInset: (0@ -5 corner: 0@ -3).
	classBtn := UiToolButton new text: 'Morph'; color: Color transparent; autoRaise: true;layoutInset: (0@ -5 corner: 0@ -3).
	protocolBtn := SdProtocolButton new text: 'initialization'.
	
	self connect: protocolBtn signal: #protocolChanged: toSelector: #protocolChanged:.
	
	ArrowIcon ifNil: [ArrowIcon := (UiFugueIcons control000SmallIcon clippedTo: 8@19) asGrayScale2].
	
	categoryListBtn := UiToolButton new
		buttonStyle: #iconOnly; icon: ArrowIcon;
		layoutInset: (0@ -5 corner: 0@ -3);
		autoRaise: true;
		color: Color transparent.
	classListBtn := UiToolButton new
		buttonStyle: #iconOnly; icon: ArrowIcon;
		layoutInset: (0@ -5 corner: 0@ -3);
		autoRaise: true;
		color: Color transparent.
	protocolListBtn := UiToolButton new
		buttonStyle: #iconOnly; icon: ArrowIcon;
		layoutInset: (0@ -5 corner: 0@ -3);
		autoRaise: true;
		color: Color transparent.
		
	self addAllMorphs: {packageBtn. categoryListBtn. categoryBtn. classListBtn. classBtn. protocolListBtn}.
! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:51:46.866'!
packageName

	^ packageBtn valueOfProperty: #packageName! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:52:32.187'!
packageName: aString

	packageBtn
		setProperty: #packageName toValue: aString;
		text: aString.! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:00:50.139'!
protocol

	^ protocolBtn valueOfProperty: #protocol! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:01:01.742'!
protocol: aProtocol

	protocolBtn setProperty: #protocol toValue: aProtocol.! !

!SdBreadcrumbTrail methodsFor: 'signals' stamp: 'mt 7/5/2011 16:18:05.933'!
protocolChanged: aProtocol

	self emitAlways.! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 15:59:51.077'!
theClass

	^ classBtn valueOfProperty: #class! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:16:35.329'!
theClass: aClass

	classBtn
		setProperty: #class toValue: aClass;
		text: ('<b>', aClass name, '</b>') asHtmlText.
	
	protocolBtn organization: aClass organization.
	
	self category: aClass theNonMetaClass category.! !

!SdBreadcrumbTrail methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:11:21.292'!
theClass: aClass protocol: aProtocol

	self
		theClass: aClass;
		protocol: aProtocol.! !

Morph subclass: #SdColumn
	instanceVariableNames: 'dropTargetPosition lastDropRectangle acceptedDropAreas acceptedDropBlock dropColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

SdColumn subclass: #SdClassEditorColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdClassEditorColumn methodsFor: 'initialization' stamp: 'mt 2/15/2012 16:11:23.909'!
initialize

	super initialize.
	
	self
		vResizing: #spaceFill;
		layoutPolicy: SdColumnLayout new;
		acceptedDropBlock: [:morph | morph isKindOf: SdEditor].! !

!SdClassEditorColumn methodsFor: 'submorphs-add/remove' stamp: 'mt 7/2/2011 14:59:32.548'!
privateAddMorph: anEditor atIndex: index

	"Use the width of the first morph that is added."
	self submorphs ifEmpty: [
		self width: anEditor width].

	super privateAddMorph: anEditor atIndex: index.

	anEditor expand.! !

!SdClassEditorColumn methodsFor: 'submorphs-add/remove' stamp: 'mt 7/1/2011 22:48:31.289'!
removedMorph: aMorph
	"Update layout for the other morphs."

	super removedMorph: aMorph.  
	
	self submorphs ifEmpty: [self delete].! !

!SdColumn methodsFor: 'dropping/grabbing' stamp: 'mt 5/4/2011 10:10:27.77'!
acceptDroppingMorph: aTransferMorph event: evt

	| dtr classElementEditor |
	classElementEditor := aTransferMorph source.
	dtr := self dropTargetRectangle.
	self clearDropRectangle.	
	
	dtr ifNil: [^ self].
	
	classElementEditor grabKeyboard.
	
	((self acceptedDropAreas includes: #left)
		and: [dtr topLeft = self topLeft]
		and: [dtr width = 20])
		ifTrue: [
			((self submorphs includes: classElementEditor)
				and: [self submorphs size = 1]) ifTrue: [^ self].
			^ self editorDroppedInFrontOfMe: classElementEditor].
	
	((self acceptedDropAreas includes: #left)
		and: [dtr bottomRight = self bottomRight]
		and: [dtr width = 20])
		ifTrue: [
			((self submorphs includes: classElementEditor)
				and: [self submorphs size = 1]) ifTrue: [^ self].
			^ self editorDroppedAfterMe: classElementEditor].

	(self acceptedDropAreas includes: #between)
		ifFalse: [^ self].
		
	(self submorphs
		detect: [:m | m bounds containsRect: dtr]
		ifNone: []) ifNotNil: [:m |
			dtr topLeft = m topLeft
				ifTrue: [^ self addMorph: classElementEditor inFrontOf: m].
			dtr bottomRight = m bottomRight
				ifTrue: [^ self addMorph: classElementEditor after: m]].

	^ self addMorphBack: classElementEditor! !

!SdColumn methodsFor: 'accessing' stamp: 'mt 5/2/2011 10:57:46.946'!
acceptedDropAreas

	^ acceptedDropAreas ifNil: [acceptedDropAreas := #(left right between)]! !

!SdColumn methodsFor: 'accessing' stamp: 'mt 5/2/2011 10:57:56.701'!
acceptedDropAreas: anArray

	acceptedDropAreas := anArray.! !

!SdColumn methodsFor: 'accessing' stamp: 'mt 5/2/2011 11:03:51.459'!
acceptedDropBlock

	^ acceptedDropBlock! !

!SdColumn methodsFor: 'accessing' stamp: 'mt 5/2/2011 11:04:19.31'!
acceptedDropBlock: aBlock
	"Decide the behavior of #wantsDropedMorph..."
	
	acceptedDropBlock := aBlock.! !

!SdColumn methodsFor: 'events-processing' stamp: 'mt 5/2/2011 10:03:02.33'!
clearDropRectangle

	dropTargetPosition ifNil: [^ self].
	
	dropTargetPosition := nil.
	self redrawLater.! !

!SdColumn methodsFor: 'submorphs-add/remove' stamp: 'mt 4/25/2011 10:34:43.351'!
delete

	super delete.
	self deleted.! !

!SdColumn methodsFor: 'signals' stamp: 'mt 4/25/2011 10:28:47.558'!
deleted

	self emit.! !

!SdColumn methodsFor: 'drawing' stamp: 'mt 5/2/2011 11:16:57.178'!
drawDropTargetOn: aCanvas

	aCanvas
		frameAndFillRectangle: self dropTargetRectangle
		fillColor: (self dropColor alpha: 0.5)
		borderWidth: 2
		borderColor: self dropColor.! !

!SdColumn methodsFor: 'accessing' stamp: 'mt 5/2/2011 11:18:20.119'!
dropColor

	^ dropColor ifNil: [dropColor := Color blue]! !

!SdColumn methodsFor: 'accessing' stamp: 'mt 5/2/2011 11:19:14.308'!
dropColor: aColor

	dropColor = aColor ifTrue: [^ self].

	dropColor := aColor.
	
	self redrawLater.! !

!SdColumn methodsFor: 'dropping/grabbing' stamp: 'mt 5/4/2011 10:01:13.378'!
dropTargetRectangle

	| leftArea rightArea smAreas|
	leftArea := self topLeft corner: (self left + 20) @ self bottom.
	rightArea := self right - 20 @ self top corner: self bottomRight.
	
	((self acceptedDropAreas includes: #left) and: [leftArea containsPoint: dropTargetPosition])
		ifTrue: [^ leftArea].
	
	((self acceptedDropAreas includes: #right) and: [rightArea containsPoint: dropTargetPosition])
		ifTrue: [^ rightArea].
	
	(self acceptedDropAreas includes: #between)
		ifFalse: [^ nil]  .
	
	smAreas := OrderedCollection new.
	
	self submorphs do: [:m |
		smAreas add: (m topLeft corner: m bottomRight - (0@ (m height // 2))).
		smAreas add: (m topLeft + (0@ (m height // 2)) corner: m bottomRight)].
	
	smAreas do: [:area | (area containsPoint: dropTargetPosition)
		ifTrue: [^ area]].
	
	^ self bottomLeft - (0@20) corner: self bottomRight! !

!SdColumn methodsFor: 'signals' stamp: 'mt 4/25/2011 11:05:55.469'!
editorDroppedAfterMe: aClassElementEditor

	self emit.! !

!SdColumn methodsFor: 'signals' stamp: 'mt 4/25/2011 11:06:00.889'!
editorDroppedInFrontOfMe: aClassElementEditor

	self emit.! !

!SdColumn methodsFor: 'drawing' stamp: 'mt 4/25/2011 10:09:35.465'!
fullDrawOn: aCanvas

	super fullDrawOn: aCanvas.
	
	dropTargetPosition
		ifNotNil: [self drawDropTargetOn: aCanvas].    ! !

!SdColumn methodsFor: 'events-processing' stamp: 'mt 5/2/2011 10:06:39.567'!
handleMouseMove: aMouseEvent
	"Overridden to handly ANY move event."
	
	super handleMouseMove: aMouseEvent.
	
	"Indicate dropping target visually."
	(aMouseEvent hand hasSubmorphs
		and: [self
			wantsDroppedMorph: aMouseEvent hand submorphs first
			event: aMouseEvent])
		ifTrue: [
			dropTargetPosition := aMouseEvent position.
			lastDropRectangle ~= self dropTargetRectangle
				ifTrue: [self redrawLater].
			lastDropRectangle := self dropTargetRectangle]
		ifFalse: [self clearDropRectangle].! !

!SdColumn methodsFor: 'initialization' stamp: 'mt 7/1/2011 22:22:39.88'!
initialize

	super initialize.
	
	self initializeEventHandler.
	
	self
		color: Color transparent;
		dropEnabled: true.! !

!SdColumn methodsFor: 'initialization' stamp: 'mt 4/25/2011 11:03:25.672'!
initializeEventHandler

	self eventHandler: UiEventHandler new.

	self connect: self eventHandler signal: #mouseLeftDragging: toSelector: #clearDropRectangle.! !

!SdColumn methodsFor: 'visiting' stamp: 'mt 7/4/2011 17:48:37.616'!
loadState: anEditorState

	anEditorState loadColumn: self.! !

!SdColumn methodsFor: 'accessing' stamp: 'mt 5/11/2011 11:22:29.479'!
optimalWidth

	| maxWidth |
	maxWidth := 200.
	self submorphs do: [:sm |
		maxWidth := maxWidth max: sm optimalWidth].
	^ maxWidth! !

!SdColumn methodsFor: 'submorphs-add/remove' stamp: 'mt 5/4/2011 10:06:15.27'!
removedMorph: aMorph

	self submorphs
		ifEmpty: [self height: 50].! !

!SdColumn methodsFor: 'visiting' stamp: 'mt 7/4/2011 15:23:51.321'!
saveState: anEditorState

	anEditorState saveColumn: self.! !

!SdColumn methodsFor: 'dropping/grabbing' stamp: 'mt 5/2/2011 11:24:42.987'!
wantsDroppedMorph: aMorph event: evt

	| result |
	result := (super wantsDroppedMorph: aMorph event: evt)
		and: [aMorph isKindOf: TransferMorph]
		and: [self acceptedDropBlock value: aMorph source].
		
	^ result! !

SdColumn subclass: #SdMethodEditorColumn
	instanceVariableNames: 'dropShadow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdMethodEditorColumn methodsFor: 'as yet unclassified' stamp: 'mt 7/2/2011 14:58:49.38'!
addMethodEditor: aMethodEditor

	self assert: self submorphs notEmpty.

	"WORKAROUND for buggy morphic layout."
	aMethodEditor width: self width.
	self addMorph: aMethodEditor inFrontOf: dropShadow.! !

!SdMethodEditorColumn methodsFor: 'as yet unclassified' stamp: 'mt 7/1/2011 22:29:33.681'!
clear

	self removeAllMorphs.
	self addMorphBack: dropShadow.! !

!SdMethodEditorColumn methodsFor: 'initialization' stamp: 'mt 3/15/2012 17:06:51.212'!
initialize

	super initialize.
	
	dropColor := Color green muchDarker.
	dropShadow := SdColumnShadow new
		orientation: #horizontal;
		hResizing: #spaceFill;
		height: 16.
	
	self
		layoutPolicy: SdMethodEditorColumnLayout new;
		acceptedDropAreas: #(between);
		acceptedDropBlock: [:morph | morph isKindOf: SdMethodEditor];
		addMorphBack: dropShadow.! !

!SdMethodEditorColumn methodsFor: 'as yet unclassified' stamp: 'mt 7/1/2011 22:31:08.388'!
methodEditors

	^ self submorphs copyWithout: dropShadow! !

Morph subclass: #SdColumnSeparator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdColumnSeparator methodsFor: 'drawing' stamp: 'mt 7/1/2011 17:33:50.436'!
drawOn: aCanvas
	
	super drawOn: aCanvas.
	self drawTopLineOn: aCanvas.! !

!SdColumnSeparator methodsFor: 'drawing' stamp: 'mt 7/1/2011 17:34:35.493'!
drawTopLineOn: aCanvas
	
	aCanvas
		line: self topLeft to: self topRight - (1@0) color: (Color gray: 0.5);
		line: self topLeft + (0@1) to: self topRight + (-1 @1) color: (Color gray: 0.7).! !

!SdColumnSeparator methodsFor: 'initialization' stamp: 'mt 7/1/2011 17:34:02.906'!
initialize

	super initialize.
	
	self
		color: (Color gray: 0.85);
		hResizing: #shrinkWrap;
		vResizing: #spaceFill;
		changeTableLayout;
		cellInset: 1;
		layoutInset: (0@2 corner: 0@1);
		listDirection: #topToBottom.! !

Morph subclass: #SdColumnShadow
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdColumnShadow methodsFor: 'drawing' stamp: 'mt 7/1/2011 22:32:09.334'!
drawOn: aCanvas

	| c |
	self owner ifNotNil: [:o | o submorphs size = 1 ifTrue: [^ self]].
	
	c := Color black.
	
	self orientation == #vertical ifTrue: [	
		aCanvas
			line: self topLeft + (2@1) to: self bottomLeft + (2@ -1) color: (c alpha: 0.5);
			line: self topLeft + (3@2) to: self bottomLeft + (3@ -1) color: (c alpha: 0.2);
			line: self topLeft + (1@0) to: self bottomLeft + (1@ -1) color: (c alpha: 0.8)].
		
	self orientation == #horizontal ifTrue: [	
		aCanvas
			line: self topLeft + (1@1) to: self topRight + (-1 @ 1) color: (c alpha: 0.5);
			line: self topLeft + (2@2) to: self topRight + (-1 @ 2) color: (c alpha: 0.2);
			line: self topLeft         to: self topRight + (-1 @ 0) color: (c alpha: 0.8)].! !

!SdColumnShadow methodsFor: 'initialization' stamp: 'mt 7/2/2011 09:30:38.712'!
initialize

	super initialize.
	self
		color: (Color gray: 0.6);
		layoutInset: (3@3 corner: 0@0).! !

!SdColumnShadow methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:12:33.503'!
orientation

	^ orientation ifNil: [orientation := #vertical]! !

!SdColumnShadow methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:12:42.409'!
orientation: aSymbol
	"#horizontal, #vertical"
	
	orientation = aSymbol ifTrue: [^ self].
	
	orientation := aSymbol.
	
	self redrawLater.! !

Morph subclass: #SdColumnToolBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdColumnToolBar methodsFor: 'drawing' stamp: 'mt 7/1/2011 18:07:05.949'!
drawOn: aCanvas

	aCanvas
		fillRectangle: (self innerBounds insetBy: (0@0 corner: 1@0))
		fillStyle: self gradient.! !

!SdColumnToolBar methodsFor: 'drawing' stamp: 'mt 7/1/2011 18:03:52.504'!
gradient

	^ (GradientFillStyle ramp: {
			0.0 -> (self color adjustBrightness: 0.1).
			0.1-> (self color adjustBrightness: 0.05).
			0.6 -> (self color darker)})
		origin: self innerBounds topLeft;
		direction: self innerBounds width @ 0.! !

!SdColumnToolBar methodsFor: 'initialization' stamp: 'mt 7/1/2011 18:06:27.294'!
initialize

	super initialize.

	self
		color: (Color gray: 0.85);
		changeTableLayout;
		vResizing: #spaceFill;
		hResizing: #shrinkWrap;
		layoutInset: (0@0 corner: 1@0).! !

Morph subclass: #SdEditor
	instanceVariableNames: 'outerBorderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdEditor commentStamp: 'mt 6/21/2011 10:43:35.761' prior: 0!
This is an editor meant to be placed inside an SdColumn in the IDE.!

SdEditor subclass: #SdCallGraphEditor
	uses: TSdDynamicActivation
	instanceVariableNames: 'ui references previewPanel activeNode'
	classVariableNames: 'CallgraphCache'
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdCallGraphEditor commentStamp: '<historical>' prior: 0!
The current trace describes the piece of code or the test method that is associated with this editor.

The current call graph is the result of the last tracing run.!

SdCallGraphEditor class
	uses: TSdDynamicActivation classTrait
	instanceVariableNames: ''!

!SdCallGraphEditor class methodsFor: 'caching' stamp: 'mt 7/17/2011 20:54:04.821'!
callgraphAt: aTraceEvent

	^ self callgraphCache at: aTraceEvent hash ifAbsentPut: [SdCallgraph new traceEvent: aTraceEvent]! !

!SdCallGraphEditor class methodsFor: 'caching' stamp: 'mt 2/16/2012 11:10:39.862'!
callgraphAtTest: aTestReference

	^ self callgraphAt: (SdTraceItEvent test: aTestReference)! !

!SdCallGraphEditor class methodsFor: 'caching' stamp: 'mt 7/17/2011 20:43:31.316'!
callgraphCache

	^ CallgraphCache ifNil: [CallgraphCache := Dictionary new]! !

!SdCallGraphEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:58:27.164'!
editorDescription

	^ 'Explore a new call graph.'! !

!SdCallGraphEditor class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:57:08.403'!
editorGroup

	^ 2! !

!SdCallGraphEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:23:57.448'!
editorIcon

	^ UiFugueIcons nodeSelectIcon! !

!SdCallGraphEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:58:04.597'!
editorName

	^ 'Call Graph'! !

!SdCallGraphEditor methodsFor: 'actions' stamp: 'mt 2/16/2012 15:27:29.864'!
activateMethod: aNode

	self methodActivated: aNode clientReference.! !

!SdCallGraphEditor methodsFor: 'actions - model index' stamp: 'mt 2/16/2012 16:55:56.794'!
activateNode: aNode
	"Set the reference node index for the status columns."

	aNode checked ifFalse: [^ self].
	self activeNode: aNode node.
	
	"(self ui treeView visibleIndicesIn: 2) do: [:index |
		index node ~= aNode ifTrue: [index node checked: false]]."! !

!SdCallGraphEditor methodsFor: 'accessing' stamp: 'mt 2/16/2012 14:54:01.612'!
activeNode
	"A special node in the current call graph that is used for comparison of other nodes."
	
	^ activeNode! !

!SdCallGraphEditor methodsFor: 'accessing' stamp: 'mt 2/16/2012 16:56:04.907'!
activeNode: aCallgraphNode
		
	activeNode := aCallgraphNode.
			
	"Update status column."
	self ui treeView changeAllItemsWithProperties: #(status).! !

!SdCallGraphEditor methodsFor: 'accessing' stamp: 'mt 2/16/2012 15:31:12.155'!
callgraph

	^ self ui treeView model node! !

!SdCallGraphEditor methodsFor: 'accessing' stamp: 'mt 2/16/2012 15:25:52.613'!
callgraph: aCallgraph

	(self callgraph notNil
		and: [aCallgraph notNil]
		and: [self callgraph traceEvent = aCallgraph traceEvent])
			ifTrue: [^ self].

	self ui treeView model node: aCallgraph.
	self callgraphChanged.! !

!SdCallGraphEditor methodsFor: 'signals' stamp: 'mt 7/17/2011 21:15:42.501'!
callgraphChanged

	self emit.! !

!SdCallGraphEditor methodsFor: 'actions' stamp: 'mt 9/1/2011 11:42:00.377'!
clear

	self callgraph: nil.! !

!SdCallGraphEditor methodsFor: 'selection' stamp: 'mt 2/16/2012 15:23:17.794'!
currentNode

	^ self ui treeView currentNode! !

!SdCallGraphEditor methodsFor: 'selection' stamp: 'mt 2/16/2012 15:32:48.45'!
currentNode: aNode

	| finder |
	self callgraph: aNode callgraph.

	finder := UiItemModelFinder on: self ui treeView model.
	finder nextSatisfying: [:cg | cg node id = aNode id].

	self ui treeView expandIndex: finder currentIndex.
	self ui treeView currentNode: finder current.! !

!SdCallGraphEditor methodsFor: 'filters' stamp: 'mt 6/21/2011 11:48:18.912'!
deleteFilters 

	cgt callgraphModel deleteFilters.

	self ui deleteFiltersBtn balloonText: 'Active filters:'.
	self ui deleteFiltersBtn hide.

	self updateView.! !

!SdCallGraphEditor methodsFor: 'actions - preview' stamp: 'mt 7/31/2011 15:28:44.852'!
hidePreview

	previewPanel ifNil: [^ self].
	previewPanel delete.
	previewPanel := nil.! !

!SdCallGraphEditor methodsFor: 'initialization' stamp: 'mt 9/1/2011 11:39:18.425'!
initialize

	super initialize.
	self initializeUi.! !

!SdCallGraphEditor methodsFor: 'initialization' stamp: 'mt 3/22/2012 15:52:01.349'!
initializeTree
	
	"call tree"
	self ui treeView
		addColumns: {
			UiItemViewColumnSpec newFrom: {#text -> #label. #icon -> #receiverIcon. #menu -> #menu. #headerText -> 'Call Tree'}.
			"(UiItemViewColumnSpec newFrom: {#checked -> #checked})
				balloonTextConverter: [:obj | 'Set receiver as reference object'].
			(UiItemViewColumnSpec newFrom: {#icon -> #status. #headerText -> 'Status'})
				iconConverter: [:node | self statusIconFor: node]"
			};
		model: SdCallgraphModel new.

	self connect: self ui treeView model signal: #classActivated: toSelector: #classActivated:. 
	self connect: self ui treeView model signal: #methodActivated: toSelector: #methodActivated:.
	self connect: self ui treeView model signal: #objectActivated: toSelector: #objectActivated:.
	self connect: self ui treeView model signal: #traceActivated: toSelector: #traceActivated:.
	
	self connect: self signal: #callgraphChanged to: self ui treeView selector: #reset.
	
	self ui treeView disconnectSignal: #doubleClicked:.  
	self connect: self ui treeView signal: #returnPressed: toSelector: #activateMethod:.
	self connect: self ui treeView signal: #doubleClicked: toSelector: #activateMethod:.
	self connect: self ui treeView signal: #changed: toSelector: #activateNode:.
	
	"call tree - source preview"
	self connect: self ui treeView signal: #currentNodeChanged: toSelector: #triggerPreview.
	self connect: self ui treeView viewport eventHandler signal: #focusLost toSelector: #hidePreview.
	self ui treeView viewport eventHandler on: Character escape send: #hidePreview to: self.
	
	! !

!SdCallGraphEditor methodsFor: 'initialization' stamp: 'mt 2/16/2012 15:26:53.81'!
initializeUi

	self ui setupUi: self.
	
	"header"
	self connect: self ui pinBtn signal: #toggled: toSelector: #onPinningChanged:.
	self connect: self ui closeBtn signal: #clicked: toSelector: #clear.
	self connect: self ui closeBtn signal: #clicked: toSelector: #delete.
	self connect: self ui hideBtn signal: #toggled: toSelector: #onVisibilityChanged:.
	self ui headerBtn target: self.
	
	"information label"
	self connect: self ui moreBtn signal: #toggled: toSelector: #updateMoreBtn.
	self connect: self ui moreBtn signal: #toggled: toSelector: #updateInfoLbl.
	self connect: self signal: #callgraphChanged toSelector: #updateInfoLbl.
	
	"control buttons"
	self ui updateBtn enabled: false.
	self connect: self ui timeBtn signal: #clicked: toSelector: #profileDuration.
		
	self initializeTree.
	
	"Initial update."
	self updateInfoLbl.
	
	"filters"
	self connect: self ui filterEdit signal: #returnPressed: toSelector: #newFilter:.
	self connect: self ui addFilterBtn signal: #clicked: toSelector: #newFilter.! !

!SdCallGraphEditor methodsFor: 'testing' stamp: 'mt 5/5/2011 14:15:20.217'!
isTimeMeasured

	^ self ui timeBtn checked! !

!SdCallGraphEditor methodsFor: 'testing' stamp: 'mt 5/5/2011 13:24:51.696'!
isTraceLocked
	"Check whther new trace-it requests should be ignored."
	
	^ self ui lockBtn checked! !

!SdCallGraphEditor methodsFor: 'visiting' stamp: 'mt 7/4/2011 17:59:01.343'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadCallGraphEditor: self.! !

!SdCallGraphEditor methodsFor: 'filters' stamp: 'mt 6/21/2011 11:55:32.668'!
newFilter

	self newFilter: self ui filterEdit theText.! !

!SdCallGraphEditor methodsFor: 'filters' stamp: 'mt 9/1/2011 13:57:26.25'!
newFilter: aText

	| filter |
	filter := aText isEmpty
		ifTrue: [nil]
		ifFalse: [aText asString].
	
	self ui treeView model filter: filter.! !

!SdCallGraphEditor methodsFor: 'geometry' stamp: 'mt 6/10/2011 11:35:00.761'!
optimalWidth

	^ self ui treeView optimalWidth! !

!SdCallGraphEditor methodsFor: 'actions' stamp: 'mt 9/1/2011 11:45:18.756'!
profileDuration

	SdCallgraphTracer new
		callgraph: self callgraph;
		profile: #duration.
		
	self callgraphChanged.! !

!SdCallGraphEditor methodsFor: 'converting' stamp: 'mt 2/16/2012 14:44:25.539'!
referenceForIndex: aModelIndex

	^ (aModelIndex valueOfProperty: #node) ifNotNil: [:node |
		node clientReference]! !

!SdCallGraphEditor methodsFor: 'accessing' stamp: 'mt 5/12/2011 16:43:04.364'!
references

	^ references ifNil: [#()]! !

!SdCallGraphEditor methodsFor: 'visiting' stamp: 'mt 7/4/2011 15:19:41.147'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState saveCallGraphEditor: self.! !

!SdCallGraphEditor methodsFor: 'testing' stamp: 'TM 5/17/2011 15:17:39.736'!
showLabels

	^ self ui labelBtn checked! !

!SdCallGraphEditor methodsFor: 'actions - preview' stamp: 'mt 2/16/2012 15:38:29.77'!
showPreview
	
	self showPreview: self ui treeView currentNode.! !

!SdCallGraphEditor methodsFor: 'actions - preview' stamp: 'mt 2/16/2012 15:40:09.552'!
showPreview: aCallNode
	"Show a preview for the current element if one is selected."
	
	aCallNode node isInstantiation
		ifTrue: [^ self].
	
	"Discard the current preview."
	previewPanel ifNotNil: [self hidePreview].
	
	previewPanel := SdPreviewBuilder createMethodPreviewFor: aCallNode node clientReference.

	previewPanel ifNil: [^ self].
	
	"Ensure visibility of preview box."
	self ui treeView selection currentBounds ifNotNil: [:selectionBounds |
		| globalRight |
		globalRight := (self localPointToGlobal: self topRight) x.
		(globalRight + previewPanel width) > ActiveWorld right
			ifTrue: [(selectionBounds left - previewPanel width) < ActiveWorld left
				ifFalse: [previewPanel topRight: selectionBounds topLeft]
				ifTrue: [previewPanel topLeft: selectionBounds bottomLeft]]
			ifFalse: [previewPanel topLeft: globalRight @ selectionBounds top].
		previewPanel bottom: (ActiveWorld bottom min: previewPanel bottom)].
		
	previewPanel openInWorld.! !

!SdCallGraphEditor methodsFor: 'initialization' stamp: 'mt 2/16/2012 15:53:51.95'!
statusIconFor: aNode

	|container|

	container := Morph new
			extent: (4*16)@16;
			color: Color transparent.

	self activeNode ifNil: [ ^ container ].

	(aNode isInstantiationOf: self activeNode)
		ifTrue: [container addMorph:
			(UiFugueIcons plusButtonIcon asMorph
				position: container position;
				balloonText: ('instantiation of {1} {2}' format: {
					self activeNode receiverClass.
					self activeNode receiverId}))].
				
	(aNode isSameObjectAs: self activeNode)  
		ifTrue: [container addMorph:
			(UiFugueIcons fingerprintIcon asMorph
				position: container position + (16@0);
				balloonText: '= reference object').
				
			(aNode isReadOf: self activeNode) ifTrue: [
				container addMorph: (UiFugueIcons eyeIcon asMorph
					position: container position + (32@0);
					balloonText: 'reads inst var')].
			(aNode isWriteTo: self activeNode) ifTrue: [
				container addMorph: (UiFugueIcons pencilIcon asMorph
					position: container position + (48@0);
					balloonText: 'writes inst var')]].
	
	^ container! !

!SdCallGraphEditor methodsFor: 'actions - preview' stamp: 'mt 2/16/2012 15:43:55.773'!
triggerPreview

	self hidePreview.
	self
		removeAlarm: #showPreview;
		addAlarm: #showPreview
		after: 250.! !

!SdCallGraphEditor methodsFor: 'accessing' stamp: 'mt 5/4/2011 11:01:34.204'!
ui

	^ ui ifNil: [ui := SdCallGraphEditorUi new]! !

!SdCallGraphEditor methodsFor: 'updating' stamp: 'mt 7/16/2011 21:39:51.892'!
updateInfoLbl

	| info needsMore |
	self callgraph ifNil: [
		self ui infoLbl text: 'Nothing traced.'.
		self ui moreBtn checked: false; hide.
		^ self].
	
	info := self callgraph traceEvent itemKind = #expression
		ifTrue: [self callgraph traceEvent itemExpression withBlanksTrimmed]
		ifFalse: [self callgraph traceEvent testClass name, ' >> ', self callgraph traceEvent testSelector].
	needsMore := (info includesSubString: String cr) or: [info size > 60].
	
	self ui moreBtn visible: needsMore.
	
	self ui moreBtn checked
		ifTrue: [self ui infoLbl text: '"', info, '"']
		ifFalse: [self ui infoLbl text: ('"{1}{2}"' format: {
			(info withNoLineLongerThan: 60) lines first.
			needsMore ifTrue: [' <font color="#777777">[...]</font>'] ifFalse: ['']}) asHtmlText].! !

!SdCallGraphEditor methodsFor: 'updating' stamp: 'mt 5/5/2011 13:16:17.146'!
updateMoreBtn

	self ui moreBtn checked
		ifTrue: [self ui moreBtn icon: UiSilkIcons bulletArrowUpIcon]
		ifFalse: [self ui moreBtn icon: UiSilkIcons bulletArrowDownIcon].! !

SdEditor subclass: #SdClassEditor
	instanceVariableNames: 'theClass ui sui finder commentEditor definitionEditor classFinder suppressMethodOpenedSignal'
	classVariableNames: 'LastOpenMethods RecentlyUsedClasses'
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdClassEditor commentStamp: 'mt 4/6/2011 16:27:07.935' prior: 0!
This is an editor for a whole class.

SdClassEditor new
	width: 500;
	theClass: String;
	openInWorld.!

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 4/21/2011 11:04:11.878'!
addRecentlyUsedClass: className

	self recentlyUsedClasses remove: className ifAbsent: [].

	self recentlyUsedClasses addFirst: className.

	self recentlyUsedClasses size > 20
		ifTrue: [self recentlyUsedClasses removeLast].! !

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:42:40.351'!
defaultWidth

	^ (Preferences standardCodeFont widthOfString: (String new: 60 withAll: $x))! !

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:59:01.17'!
editorDescription

	^ 'Create or modify a class.'! !

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:56:31.06'!
editorGroup

	^ 1! !

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 7/2/2011 09:40:06.547'!
editorIcon

	^ UiSilkIcons carIcon! !

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:58:42.024'!
editorName

	^ 'Class Editor'! !

!SdClassEditor class methodsFor: 'testing' stamp: 'mt 6/28/2011 21:09:59.895'!
isStandAlone

	^ true! !

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 4/28/2011 17:40:14.835'!
lastOpenMethods

	^ LastOpenMethods ifNil: [LastOpenMethods := Dictionary new]! !

!SdClassEditor class methodsFor: 'accessing' stamp: 'mt 4/17/2011 12:13:47.564'!
recentlyUsedClasses

	^ RecentlyUsedClasses ifNil: [RecentlyUsedClasses := OrderedCollection new]! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/14/2011 19:20:52.215'!
activateFinder
	"Show the finder and give it the keyboard."
	
	self ui findBtn checked: true.
	finder	grabKeyboard.
	finder ui searchField selectAll.! !

!SdClassEditor methodsFor: 'actions - class' stamp: 'mt 4/17/2011 11:51:54.982'!
addClass: name category: category

	^ Object
		subclass: name
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: category! !

!SdClassEditor methodsFor: 'initialization - method editors' stamp: 'mt 6/28/2011 20:36:08.368'!
addMethodEditor: aSelector isMeta: aBoolean

	| editor |
	editor := (self addMethodEditorForReference: (MethodReference
			class: (aBoolean ifTrue: [self theClass theMetaClass] ifFalse: [self theClass])
			selector: aSelector))
		expand;
		grabKeyboard.
	
	self scrollToShow: editor.
	
	^ editor! !

!SdClassEditor methodsFor: 'initialization - method editors' stamp: 'mt 4/18/2011 15:47:08.821'!
addMethodEditor: aSelector isMeta: aBoolean protocol: protocolName
	"Classifies the selector under the given protocol name."
	
	| m organization |
	m := self addMethodEditor: aSelector isMeta: aBoolean.
	
	"Use method editor to retrieve the correct selector as the user may have entered a full method signature with arguments."
	organization := (aBoolean
		ifTrue: [self theClass theMetaClass]
		ifFalse: [self theClass]) organization.
		
	(organization categoryOfElement: m selector) ~= protocolName
		ifTrue: [organization classify: m selector under: protocolName].! !

!SdClassEditor methodsFor: 'initialization - method editors' stamp: 'mt 7/5/2011 14:53:48.678'!
addMethodEditorForReference: aMethodReference

	| m |
	"aMethodReference isValid ifFalse: [^ self]."

	(self methodEditors
		detect: [:methodEditor | methodEditor reference = aMethodReference]
		ifNone: []) ifNotNil: [:methodEditor | ^ methodEditor].

	m := SdMethodEditor new
			theClass: aMethodReference actualClass
			selector: aMethodReference selector;
			hResizing: #spaceFill.
			
	self methodEditorColumn addMethodEditor: m.
	
	self connect: m sourceCodeEdit signal: #mouseWheelUp:
		to: self ui codeArea verticalScrollBar selector: #decreaseValueBySingleStep.
	self connect: m sourceCodeEdit signal: #mouseWheelDown:
		to: self ui codeArea verticalScrollBar selector: #increaseValueBySingleStep.
	
	"Shortcuts for source code editor."
	m sourceCodeEdit eventHandler on: #(cmd) -> $F send: #activateFinder to: self.
		
	self methodsOpened: {m reference}.
	
	^ m! !

!SdClassEditor methodsFor: 'converting' stamp: 'mt 2/15/2012 16:45:20.59'!
asString

	^ self theClass
		ifNotNil: [:c | c name]
		ifNil: [super asString]! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 15:18:48.952'!
browseClasses

	self
		closeAll;
		switchToSelectUi.! !

!SdClassEditor methodsFor: 'actions - class' stamp: 'mt 4/17/2011 12:22:11.105'!
chooseClass: className

	| class |
	(className isNil or: [className isEmpty]) ifTrue: [^ self].
	
	class := Smalltalk
		at: className
		ifAbsent: [self
			addClass: className
			category: 'Uncategorized'].	
			
	self theClass: class; switchToEditUi.! !

!SdClassEditor methodsFor: 'actions - class' stamp: 'mt 4/17/2011 11:54:09.3'!
chooseClass: className category: category

	| class |
	className ifEmpty: [^ self].
	
	class := Smalltalk
		at: className
		ifAbsent: [self
			addClass: className
			category: category].
		
	class category ~= category
		ifTrue: [class category: category].
			
	self theClass: class; switchToEditUi.! !

!SdClassEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 17:45:23.382'!
classActivated: aClass

	self emitInOwnerChain.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 7/5/2011 14:53:48.957'!
closeAll

	self ui commentBtn checked: false.
	self ui definitionBtn checked: false.    
	
	self methodEditorColumn clear.
	
	finder clear.
	self ui findBtn checked: true.
	finder grabKeyboard.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 7/2/2011 15:39:03.724'!
collapse

	super collapse.
	
	"Handle selection UI separately."
	self sui panel submorphs size = 1
		ifTrue: [^ self "already hidden"].
		
	self
		setProperty: #hiddenSubmorphsForSelectionUi
		toValue: (self sui panel submorphs copyWithout: self sui panel firstSubmorph).
		
	self sui panel
		removeAllMorphsIn: (self valueOfProperty: #hiddenSubmorphsForSelectionUi);
		vResizing: #shrinkWrap.
		
	"Not really necessary but there are some UI interactions that make inconsistency possible here."
	self sui hideBtn checked: false.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 2/15/2012 16:45:08.647'!
delete
	"Close this class editor."
	
	self saveListOfOpenMethods.
	SdFadingToolbar hideAllToolbars.
	
	super delete.! !

!SdClassEditor methodsFor: 'updating' stamp: 'mt 7/5/2011 14:53:48.596'!
editorChange: aSymbol

	aSymbol = #class ifTrue: [
		"Visually inform the user about the new class."
		self ui headerBtn text: ('<b>', self theClass name, '</b>') asHtmlText.
			
		"Inform method finder about new class."
		self finder theClass: self theClass.
			
		"Reset comment editor."
		self loadClassComment.
			
		"Reset definition editor."
		definitionEditor theClass: self theClass.
		self loadClassDefinition.
			
		"Reset editors for new class."
		self methodEditorColumn clear.
			
		"Handle recently used classes."
		self class addRecentlyUsedClass: self theClass name.
		self updateRecentlyList.
			
		"Handle recently used methods."
		self loadListOfOpenMethods.
			
		"Handle test cases."
		self updateTestBtn].
		
	aSymbol = #definition ifTrue: [
		self loadClassDefinition.
		
		"This class can be a subclass of TestCase now."
		self updateTestBtn]! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 7/2/2011 15:35:08.38'!
expand

	super expand.
	
	"Handle selection UI separately."
	self sui panel submorphs size > 1
		ifTrue: [^ self "already visible"].
		
	self sui panel
		addAllMorphs: (self valueOfProperty: #hiddenSubmorphsForSelectionUi);
		vResizing: #spaceFill.
		
	self removeProperty: #hiddenSubmorphsForSelectionUi.
		
	"Not really necessary but there are some UI interactions that make inconsistency possible here."
	self sui hideBtn checked: true.! !

!SdClassEditor methodsFor: 'accessing - private' stamp: 'mt 4/6/2011 16:14:29.696'!
finder

	^ finder! !

!SdClassEditor methodsFor: 'events' stamp: 'mt 7/5/2011 14:59:07.724'!
grabKeyboard

	self methodEditors
		ifNotEmpty: [^ self methodEditorColumn submorphs first grabKeyboard].

	self ui findBtn checked
		ifTrue: [finder grabKeyboard]
		ifFalse: [self ui findBtn checked: true].! !

!SdClassEditor methodsFor: 'testing' stamp: 'mt 5/26/2011 18:01:22.81'!
hasUnacceptedChanges

	^ definitionEditor hasUnacceptedChanges
		or: [commentEditor hasUnacceptedChanges]
		or: [self methodEditors anySatisfy: [:e | e hasUnacceptedChanges]]! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 5/12/2011 16:07:44.669'!
hideFinder

	self ui findBtn checked: false.! !

!SdClassEditor methodsFor: 'layouting' stamp: 'mt 4/11/2011 10:43:31.531'!
hideTopContainer

	self ui topContainer
		hide;
		disableTableLayout: true.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 7/5/2011 14:43:35.924'!
initialize

	super initialize.
	
	finder := SdMethodFinder new hResizing: #spaceFill.
	
	commentEditor := UiTextEdit new
		hResizing: #spaceFill;
		scrollBarThickness: 9;
		colorFocusBackground: Color white;
		colorBackground: (Color gray: 0.85).
	self connect: commentEditor signal: #editingFinished: toSelector: #saveClassComment.
	
	definitionEditor := SdClassDefinitionEdit new
		hResizing: #spaceFill;
		verticalScrollBarPolicy: #alwaysOff;  
		areaResizable: true;
		colorFocusBackground: Color white;
		colorBackground: (Color gray: 0.85).
	self connect: definitionEditor signal: #editingFinished: toSelector: #saveClassDefinition.
	
	classFinder := SdClassFinder new hResizing: #spaceFill.  
	
	Cursor wait showWhile: [
		self
			initializeSystemChangeNotifications;
			initializeEditUi;
			initializeSelectUi;
			switchToSelectUi].! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 7/1/2011 22:54:22.779'!
initializeEditUi

	self ui initializePanel.

	self ui codeArea verticalScrollBar
		singleStep: 20;
		outerBorderWidth: 0;
		color: Color transparent..
	self ui codeArea transformMorph
		color: (Color gray: 0.3);
		text: '<font color="#888888">Drop source code here.</font>' asHtmlText.
	self ui codeArea widget: SdMethodEditorColumn new.
	self ui codeArea connectSignal: #focusChanged: toSelector: #scrollToShowGlobal:.
	
	self ui topContainer addMorphBack: finder.
	self toggleFinder.
		
	self connect: self ui findBtn signal: #toggled: toSelector: #toggleFinder.
	self connect: finder signal: #deleted to: self ui findBtn selector: #checked: pattern: #(=false).
	
	self connect: finder signal: #selectorChosen:isMeta: toSelector: #addMethodEditor:isMeta:.
	self connect: finder signal: #selectorChosen:isMeta:protocol: toSelector: #addMethodEditor:isMeta:protocol:.
	
	self connect: self ui browseBtn signal: #clicked: toSelector: #tryBrowseClasses.
	self connect: self ui closeBtn signal: #clicked: toSelector: #tryDelete.
	self connect: self ui saveAllBtn signal: #clicked: toSelector: #saveAll.
	self connect: self ui closeAllBtn signal: #clicked: toSelector: #tryCloseAll.
	
	self connect: self ui hideBtn signal: #toggled: toSelector: #onVisibilityChanged:.
	
	self connect: self ui commentBtn signal: #toggled: toSelector: #toggleCommentEditor.
	self connect: self ui definitionBtn signal: #toggled: toSelector: #toggleDefinitionEditor.
	
	self connect: self ui pinBtn signal: #toggled: toSelector: #onPinningChanged:.
	self connect: self ui superClassBtn eventHandler signal: #mouseClicked: toSelector: #openSuperClassList:.
	self connect: self ui subClassBtn eventHandler signal: #mouseClicked: toSelector: #openSubClassList:.
	
	commentEditor eventHandler on: #(cmd) -> $w send: #toggle to: self ui commentBtn.
	definitionEditor eventHandler on: #(cmd) -> $w send: #toggle to: self ui definitionBtn.
	
	"For drag operations."
	self ui headerBtn target: self.
	
	"Test handling."
	self connect: self ui testBtn signal: #clicked: toSelector: #openTestResultList.
	
	"General callbacks. Scene-graph based."
	self connectSignal: #symbolActivated: toSelector: #openSymbol:from: pattern: #(1 0).
	self connectSignal: #aboutToDelete toSelector: #passKeyboardFocusFrom: pattern: #(0).
	self connectSignal: #focusLostUpwards toSelector: #passKeyboardFocusUp.
	self connectSignal: #focusLostDownwards toSelector: #passKeyboardFocusDown.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 4/14/2011 14:43:53.632'!
initializeEventHandler

	super initializeEventHandler.

	self eventHandler on: #(cmd) -> $F send: #activateFinder to: self.! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 7/2/2011 15:30:22.867'!
initializeSelectUi

	| resizeHandle |

	self sui initializePanel.

	resizeHandle := SdResizeHandle new orientation: #horizontal.  
	resizeHandle target: classFinder ui resultList.
	self connect: classFinder signal: #deleted to: resizeHandle selector: #delete.
	self sui container
		addMorphBack: classFinder;
		addMorphBack: resizeHandle.  
	classFinder grabKeyboard.

	self sui recentlyList color: Color transparent.
		
	self connect: classFinder signal: #classChosen: toSelector: #chooseClass:.
	self connect: classFinder signal: #classChosen:category: toSelector: #chooseClass:category:.
	
	self updateRecentlyList.
	
	"Show first results if no recent class has been used."
	self sui recentlyList isEmpty ifTrue: [classFinder clear].	
	
	self connect: self sui recentlyList signal: #currentTextChanged: toSelector: #chooseClass:.
	
	self connect: self sui closeBtn signal: #clicked: toSelector: #delete.
	self connect: self sui hideBtn signal: #toggled: toSelector: #onVisibilityChanged:.
	self connect: self sui pinBtn signal: #toggled: to: self ui pinBtn selector: #checked:.
	self connect: self ui pinBtn signal: #toggled: to: self sui pinBtn selector: #checked:.
	
	"For drag operations."
	self sui headerBtn target: self.
	
	! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 4/27/2011 17:32:34.457'!
initializeSystemChangeNotifications

	SystemChangeNotifier uniqueInstance 
		notify: self ofSystemChangesOfItem: SystemChangeNotifier methodKind using: #onMethodChange:;
		notify: self ofSystemChangesOfItem: SystemChangeNotifier classKind using: #onClassChange:;
		notify: self ofSystemChangesOfItem: SystemChangeNotifier protocolKind using: #onProtocolChange:;
		notify: self ofSystemChangesOfItem: SystemChangeNotifier categoryKind using: #onCategoryChange:;
		notify: self ofSystemChangesOfChange: SdMessageEvent changeKind using: #onMessageReceive:.! !

!SdClassEditor methodsFor: 'testing' stamp: 'mt 4/22/2011 16:53:04.923'!
isClassEditor

	^ true! !

!SdClassEditor methodsFor: 'testing' stamp: 'mt 4/27/2011 17:36:44.551'!
isInEditMode
	"Check which UI is visible."
	
	^ self ui panel owner notNil! !

!SdClassEditor methodsFor: 'testing' stamp: 'mt 4/27/2011 17:36:52.035'!
isInSelectionMode
	"Check which UI is visible."
	
	^ self sui panel owner notNil! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 14:16:14.727'!
loadClassComment

	commentEditor theText: self theClass organization classComment.
	self updateCommentBtn.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/18/2011 16:34:50.914'!
loadClassDefinition

	definitionEditor theText:
		self theClass definition,
		'.', String cr,
		self theClass theMetaClass definition.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 10:03:37.832'!
loadListOfOpenMethods

	(self class lastOpenMethods
		at: self theClass name
		ifAbsent: []) ifNotNil: [:methodReferences | self openMethods: methodReferences].! !

!SdClassEditor methodsFor: 'visiting' stamp: 'mt 7/4/2011 18:01:36.713'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadClassEditor: self.! !

!SdClassEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 17:59:22.867'!
methodActivated: aMethodReference

	self emitInOwnerChain.! !

!SdClassEditor methodsFor: 'as yet unclassified' stamp: 'mt 2/15/2012 16:45:41.12'!
methodEditorAdded: aMethodEditor
	"This callback is triggered by SdMethodEditor column whenever method editors are added."! !

!SdClassEditor methodsFor: 'accessing - private' stamp: 'mt 7/5/2011 14:53:48.513'!
methodEditorColumn
	"Container where all class element editors are stored."
	
	^ self ui codeArea widget! !

!SdClassEditor methodsFor: 'accessing - private' stamp: 'mt 7/5/2011 15:01:58.301'!
methodEditors

	^ self methodEditorColumn methodEditors! !

!SdClassEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 18:19:48.501'!
methodsOpened: someMethodReferences

	suppressMethodOpenedSignal == true
		ifTrue: [^ self].

	self emitInOwnerChain.! !

!SdClassEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 18:11:10.638'!
objectActivated: anObject

	self emitInOwnerChain.! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 4/27/2011 17:31:23.815'!
onCategoryChange: categoryKindEvent

	categoryKindEvent isAdded
		ifTrue: [
			self showInformation: ('Class category added: <b>', categoryKindEvent itemCategory, '</b>.') asHtmlText].
		
	classFinder update.! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 5/12/2011 10:05:40.49'!
onClassChange: classKindEvent

	classKindEvent changeKind = SdMessageEvent changeKind
		ifTrue: [^ self].
	
	classKindEvent itemClass theNonMetaClass ~= self theClass
		ifTrue: [^ self "ignore"].
	
	classKindEvent isCommented
		ifTrue: [
			self showInformation: ('Comment changed.') asHtmlText.
			self loadClassComment].
		
	classKindEvent isModified
		ifTrue: [
			self showInformation: ('Definition changed.') asHtmlText.
			self editorChange: #definition].
		
	classKindEvent isAdded
		ifTrue: [classFinder update].! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 4/18/2011 13:24:35.628'!
onMessageReceive: messageEvent

	messageEvent itemClass theNonMetaClass ~= self theClass
		ifTrue: [^ self "ignore"].
	
	messageEvent isInformation ifTrue: [self showInformation: messageEvent text].
	messageEvent isWarning ifTrue: [self showWarning: messageEvent text].
	messageEvent isError ifTrue: [self showError: messageEvent text].! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 2/15/2012 16:13:03.518'!
onMethodChange: methodKindEvent

	| locationString |
	methodKindEvent itemClass theNonMetaClass ~= self theClass
		ifTrue: [^ self "ignore"].
	
	locationString := '<b>', methodKindEvent itemSelector asString, '</b>'.
	methodKindEvent isModified
		ifTrue: [self showInformation: ('Modified ', locationString) asHtmlText].
	methodKindEvent isRemoved
		ifTrue: [self showInformation: ('Removed ', locationString) asHtmlText].
	methodKindEvent isAdded
		ifTrue: [self showInformation: ('Added ', locationString) asHtmlText].
	methodKindEvent isRecategorized
		ifTrue: [self showInformation: ('Recategorized ', locationString, ' into <b>', methodKindEvent itemProtocol, '</b>') asHtmlText].
	
	(self methodEditorColumn submorphs allButLast
		detect: [:m | (m isKindOf: SdMethodEditor)
			and: [m selector = methodKindEvent itemSelector]
			and: [m theClass isMeta = methodKindEvent itemClass isMeta]]
		ifNone: []) ifNotNil: [:methodEditor |
			methodKindEvent isRemoved
				ifTrue: [methodEditor delete]
				ifFalse: [methodEditor editorChange: #method]].
	
	finder update.! !

!SdClassEditor methodsFor: 'system changes' stamp: 'mt 4/18/2011 13:24:59.455'!
onProtocolChange: protocolKindEvent

	protocolKindEvent itemClass theNonMetaClass ~= self theClass
		ifTrue: [^ self "ignore"].
		
	protocolKindEvent isAdded 
		ifTrue: [self showInformation: ('Protocol added: <b>', protocolKindEvent itemProtocol, '</b>') asHtmlText].
		
	finder update.! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 5/23/2011 17:51:00.669'!
openMethod: aMethodReference
	"Open new method editors in a collapsed state if not already opened."
	
	aMethodReference isValid ifTrue: [
		^ self addMethodEditorForReference: aMethodReference].
	
	^ nil! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 4/28/2011 17:55:28.587'!
openMethods

	^ self methodEditors collect: [:methodEditor |
		methodEditor reference]! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 5/12/2011 17:33:59.44'!
openMethods: someMethodReferences
	"Open new method editors in a collapsed state if not already opened."
	
	suppressMethodOpenedSignal := true.
	
	someMethodReferences do: [:ref | self openMethod: ref].
	
	suppressMethodOpenedSignal := false.
	
	self methodsOpened: someMethodReferences.  ! !

!SdClassEditor methodsFor: 'actions - class' stamp: 'mt 6/28/2011 17:45:44.983'!
openSubClassList: aMouseEvent

	| menu |
	menu := MenuMorph new
		defaultTarget: self;
		title: (aMouseEvent shiftPressed
			ifTrue: ['--- Switch to Subclass ---']
			ifFalse: ['--- Open Subclass ---']).
		
	(self theClass subclasses sortBy: [:c1 :c2 | c1 name <= c2 name])
		do: [:class | 
			menu
				add: class name
				selector: (aMouseEvent shiftPressed
					ifTrue: [#tryChangeClass:]
					ifFalse: [#classActivated:])
				argument: class].
		
	menu
		popUpAt: ActiveHand position truncated
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdClassEditor methodsFor: 'actions - class' stamp: 'mt 6/28/2011 17:45:52.629'!
openSuperClassList: aMouseEvent

	| menu |
	menu := MenuMorph new
		defaultTarget: self;
		title: (aMouseEvent shiftPressed
			ifTrue: ['--- Switch to Superclass ---']
			ifFalse: ['--- Open Superclass ---']).
		
	self theClass allSuperclasses reverseDo: [:class | 
		menu
			add: class name
			selector: (aMouseEvent shiftPressed
					ifTrue: [#tryChangeClass:]
					ifFalse: [#classActivated:])
			argument: class].
		
	menu
		popUpAt: ActiveHand position truncated
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 5/20/2011 14:33:00.915'!
openSymbol: aSymbol
	"Open a method editor."
	
	^ self openSymbol: aSymbol from: nil! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 2/15/2012 16:15:40.242'!
openSymbol: aSymbol from: anEditor
	"Open a method editor. Lookup correct type if possible."
	
	"Guess local selectors."
	(self theClass selectors includes: aSymbol)
		ifTrue: [^ self addMethodEditor: aSymbol isMeta: false].
		
	(self theClass theMetaClass selectors includes: aSymbol)
		ifTrue: [^ self addMethodEditor: aSymbol isMeta: true].

	"Guess other classes."
	(Smalltalk includesKey: aSymbol) ifTrue: [ | obj |
		obj := Smalltalk at: aSymbol.
		self classActivated: (obj isBehavior
			ifTrue: [obj] ifFalse: [obj class "global var"])].! !

!SdClassEditor methodsFor: 'test handling' stamp: 'mt 5/12/2011 14:11:44.275'!
openTestResultList
	"Shows a popup menu with the last test runs that allows to open specific methods."
	
	| menu |
	menu := MenuMorph new
		defaultTarget: self;
		addTitle: ('--- {1} passed, {2} failed, {3} errors ---' format: {
			(self theClass lastRun at: #passed) size.
			(self theClass lastRun at: #failures) size.
			(self theClass lastRun at: #errors) size}).
		
	menu
		add: 'Run all tests' action: #runAllTests;
		addLine.
	
	(self theClass lastRun at: #failures) do: [:testSelector |
		menu
			add: testSelector
			selector: #openSymbol:
			argument: testSelector].
		
	menu addLine.
	
	(self theClass lastRun at: #errors) do: [:testSelector |
		menu
			add: testSelector
			selector: #openSymbol:
			argument: testSelector].

	menu
		popUpAt: ActiveHand position truncated
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 5/11/2011 11:17:19.4'!
optimalWidth

	| maxWidth |
	maxWidth := 0.
	self methodEditors do: [:me |
		maxWidth := maxWidth max: me optimalWidth].
	^ maxWidth! !

!SdClassEditor methodsFor: 'actions - focus' stamp: 'mt 7/4/2011 14:24:23.106'!
passKeyboardFocusDown

	| newEditor methodEditors |
	methodEditors := self methodEditors.
	newEditor := (methodEditors at: ((methodEditors indexOf:
		(methodEditors detect: [:m | m hasKeyboard]))
		+ 1 min: methodEditors size)).

	newEditor grabKeyboard.
	self ui codeArea scrollToShow: newEditor bounds duration: 500.! !

!SdClassEditor methodsFor: 'actions - focus' stamp: 'mt 9/1/2011 20:39:07.045'!
passKeyboardFocusFrom: aMethodEditor
	"This is useful when the given editor does not need the focus anymore, e.g., when about to be deleted."
	
	aMethodEditor hasKeyboard
		ifFalse: [^ self].
	
	(self methodEditors indexOf: aMethodEditor) < (self methodEditorColumn submorphs size - 1)
		ifTrue: [self passKeyboardFocusDown]  
		ifFalse: [self passKeyboardFocusUp].
		
	self methodEditorColumn submorphs size = 2 "given + shadow => empty after deletion"
		ifTrue: [self ui findBtn checked: true. finder grabKeyboard].! !

!SdClassEditor methodsFor: 'actions - focus' stamp: 'mt 7/4/2011 14:23:55.271'!
passKeyboardFocusUp

	| newEditor methodEditors |
	methodEditors := self methodEditors.
	newEditor := (methodEditors at: ((methodEditors indexOf:
		(methodEditors detect: [:m | m hasKeyboard]))
		- 1 max: 1)).
	
	newEditor grabKeyboard.
	self ui codeArea scrollToShow: newEditor bounds duration: 500.  ! !

!SdClassEditor methodsFor: 'info messages' stamp: 'mt 4/27/2011 17:37:29.557'!
positionForNextMessage

	| corner |
	corner := self isInEditMode
		ifTrue: [self ui codeArea viewportBounds bottomRight]
		ifFalse: [self sui panel bottomRight].
	^ corner + (-1 @ 
			(((self submorphs
				select: [:m | m isKindOf: UiMessage]
				thenCollect: [:m | m top + 1]), {corner y}) min - corner y))! !

!SdClassEditor methodsFor: 'test handling' stamp: 'mt 5/12/2011 10:51:49.203'!
runAllTests

	Cursor wait showWhile: [
		self theClass suite run
			dispatchResultsIntoHistory].
	
	self updateTestBtn.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 5/26/2011 18:00:55.622'!
saveAll

	commentEditor acceptChanges.
		
	self methodEditors
		do: [:methodEditor | methodEditor saveMethod].! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/13/2011 15:46:01.523'!
saveClassComment

	self theClass organization classComment = commentEditor theText
		ifTrue: [^ self].

	self theClass comment: commentEditor theText.
	self updateCommentBtn.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 15:41:53.82'!
saveClassDefinition

! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 10:03:09.529'!
saveListOfOpenMethods

	self class lastOpenMethods
		at: self theClass name
		put: self openMethods.! !

!SdClassEditor methodsFor: 'visiting' stamp: 'mt 7/4/2011 15:19:41.004'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState saveClassEditor: self.! !

!SdClassEditor methodsFor: 'scrolling' stamp: 'mt 5/23/2011 17:51:29.89'!
scrollToShow: aMethodEditor
	
	self ui codeArea layoutChanged; fullBounds. 
	self ui codeArea scrollToShow: aMethodEditor bounds duration: 500.! !

!SdClassEditor methodsFor: 'info messages' stamp: 'mt 4/8/2011 12:41:36.867'!
showError: aText
		
	self addMorph: ((UiMessage error: aText)
		disableTableLayout: true;  
		bottomRight: self positionForNextMessage).! !

!SdClassEditor methodsFor: 'info messages' stamp: 'mt 4/10/2011 11:26:35.321'!
showInformation: aText
		
	self addMorph: ((UiMessage information: aText)
		disableTableLayout: true;  
		bottomRight: self positionForNextMessage).! !

!SdClassEditor methodsFor: 'layouting' stamp: 'mt 4/11/2011 14:18:43.761'!
showTopContainer

	self ui topContainer
		show;
		disableTableLayout: false.! !

!SdClassEditor methodsFor: 'info messages' stamp: 'mt 4/8/2011 12:40:05.831'!
showWarning: aText
		
	self addMorph: ((UiMessage warning: aText)
		disableTableLayout: true;  
		bottomRight: self positionForNextMessage).! !

!SdClassEditor methodsFor: 'accessing - private' stamp: 'mt 4/11/2011 14:07:50.128'!
sui

	^ sui ifNil: [sui := SdClassSelectorUi new]! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 2/15/2012 16:54:05.767'!
switchToEditUi

	| wasExpanded |
	wasExpanded := self isExpanded.
	
	wasExpanded ifFalse: [self expand].

	self removeAllMorphs.
	self ui setupUi: self.
	self grabKeyboard.
	
	wasExpanded ifFalse: [self collapse].! !

!SdClassEditor methodsFor: 'initialization' stamp: 'mt 4/17/2011 12:07:03.515'!
switchToSelectUi

	self removeAllMorphs.
	self sui setupUi: self.
	
	classFinder grabKeyboard.! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 2/15/2012 16:42:31.486'!
theClass

	^ theClass! !

!SdClassEditor methodsFor: 'accessing' stamp: 'mt 2/15/2012 16:42:59.403'!
theClass: aClassOrMetaClass

	theClass = aClassOrMetaClass theNonMetaClass ifTrue: [^ self].
	
	theClass := aClassOrMetaClass theNonMetaClass.
	
	self editorChange: #class.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 15:31:33.22'!
toggleCommentEditor

	self ui commentBtn checked
		ifTrue: [
			self ui topContainer addMorphBack: commentEditor.
			commentEditor grabKeyboard]
		ifFalse: [commentEditor delete].! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 15:31:45.865'!
toggleDefinitionEditor

	self ui definitionBtn checked
		ifTrue: [
			self ui topContainer addMorphBack: definitionEditor.
			definitionEditor grabKeyboard]
		ifFalse: [definitionEditor delete].! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/15/2011 10:22:56.489'!
toggleFinder

	self ui findBtn checked
		ifTrue: [ | resizeHandle |
			resizeHandle := SdResizeHandle new orientation: #horizontal.  
			resizeHandle target: finder ui resultList.
			self connect: finder signal: #deleted to: resizeHandle selector: #delete.
			self ui topContainer
				addMorphBack: finder;
				addMorphBack: resizeHandle.  
			finder grabKeyboard]
		ifFalse: [finder delete].! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 15:19:39.903'!
tryBrowseClasses

	| msg |
	self hasUnacceptedChanges
		ifFalse: [^ self browseClasses].

	msg := SdOverlayMessageBox new
		title: 'Browse classes';
		message: 'There are unaccepted changes.' icon: UiSilkIcons informationIcon.
	msg addAction: 'Save all changes.' icon: UiSilkIcons diskMultipleIcon receiver: self selectors: #(saveAll tryBrowseClasses).
	msg addAction: 'Ignore all changes.' icon: UiSilkIcons binIcon receiver: self selectors: #(browseClasses).
	msg addAction: 'Abort this action.' icon: UiSilkIcons cancelIcon.
	
	msg showAbove: self.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 5/19/2011 13:49:18.236'!
tryChangeClass: aClass
	"Change the currently used class. The edit UI needs to be visible here."
	
	| msg |
	self saveListOfOpenMethods.
	
	self hasUnacceptedChanges
		ifFalse: [^ self theClass: aClass].

	msg := SdOverlayMessageBox new
		title: 'Switch to class ', aClass name;
		message: 'There are unaccepted changes in ''', self theClass name,'''.' icon: UiSilkIcons informationIcon.
	(msg addAction: 'Save all changes.' icon: UiSilkIcons diskMultipleIcon receiver: self selector: #saveAll)
		ifNotNil: [:button | self connect: button signal: #clicked: toSelector: #tryChangeClass: pattern: {#=. aClass}].
	(msg addAction: 'Ignore all changes.' icon: UiSilkIcons binIcon)
		ifNotNil: [:button | self connect: button signal: #clicked: toSelector: #theClass: pattern: {#=. aClass}].
	msg addAction: 'Abort this action.' icon: UiSilkIcons cancelIcon.
	
	msg showAbove: self.! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 15:04:46.48'!
tryCloseAll

	| msg |
	self hasUnacceptedChanges
		ifFalse: [^ self closeAll].
		
	msg := SdOverlayMessageBox new
		title: 'Close all editors';
		message: 'There are unaccepted changes.' icon: UiSilkIcons informationIcon.
	msg addAction: 'Save all changes.' icon: UiSilkIcons diskMultipleIcon receiver: self selectors: #(saveAll tryCloseAll).
	msg addAction: 'Ignore all changes.' icon: UiSilkIcons binIcon receiver: self selectors: #(closeAll).
	msg addAction: 'Abort this action.' icon: UiSilkIcons cancelIcon.
	
	msg showAbove: self.  ! !

!SdClassEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 15:21:34.248'!
tryDelete

	| msg |
	self hasUnacceptedChanges
		ifFalse: [^ self delete].
		
	msg := SdOverlayMessageBox new
		title: 'Close class editor';
		message: 'There are unaccepted changes.' icon: UiSilkIcons informationIcon.
	msg addAction: 'Save all changes.' icon: UiSilkIcons diskMultipleIcon receiver: self selectors: #(saveAll tryDelete).
	msg addAction: 'Ignore all changes.' icon: UiSilkIcons binIcon receiver: self selectors: #(delete).
	msg addAction: 'Abort this action.' icon: UiSilkIcons cancelIcon.
	
	msg showAbove: self.  ! !

!SdClassEditor methodsFor: 'accessing - private' stamp: 'mt 3/29/2011 10:48:12.049'!
ui

	^ ui ifNil: [ui := SdClassEditorUi new]! !

!SdClassEditor methodsFor: 'updating' stamp: 'mt 4/12/2011 14:16:04.294'!
updateCommentBtn

	commentEditor theText
		ifEmpty: [self ui commentBtn icon: UiSilkIcons commentAddIcon]
		ifNotEmpty: [self ui commentBtn icon: UiSilkIcons commentIcon].! !

!SdClassEditor methodsFor: 'updating - classes' stamp: 'mt 4/17/2011 12:15:08.134'!
updateRecentlyList

	self sui recentlyList
		clear;
		addTextList: self class recentlyUsedClasses.! !

!SdClassEditor methodsFor: 'updating' stamp: 'mt 5/17/2011 12:04:21.927'!
updateTestBtn

	(self theClass inheritsFrom: TestCase)
		ifTrue: [self ui testBtn show]  
		ifFalse: [^ self ui testBtn hide].
		
	self ui testBtn icon: (SdMethodFinder iconForClass: self theClass).! !

!SdEditor class methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:42:06.226'!
defaultWidth

	^ 300! !

!SdEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:57:53.705'!
editorDescription

	^ 'n/a'! !

!SdEditor class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:56:10.122'!
editorGroup

	^ 99 "at last"! !

!SdEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:30:47.202'!
editorIcon

	^ UiFugueIcons questionWhiteIcon! !

!SdEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:57:44.789'!
editorName

	^ 'Editor'! !

!SdEditor class methodsFor: 'testing' stamp: 'mt 6/28/2011 21:09:44.815'!
isStandAlone
	"Check whether this editor is useful when instantiating it with #new."
	^ false! !

!SdEditor class methodsFor: 'testing' stamp: 'mt 6/28/2011 14:24:36.767'!
isWidgetClass

	^ false! !

!SdEditor methodsFor: 'actions' stamp: 'mt 7/2/2011 15:19:45.94'!
collapse

	self ui panel submorphs size = 1
		ifTrue: [^ self "already hidden"].
		
	self
		setProperty: #hiddenSubmorphs
		toValue: (self ui panel submorphs copyWithout: self ui panel firstSubmorph).
		
	self ui panel
		removeAllMorphsIn: (self valueOfProperty: #hiddenSubmorphs);
		vResizing: #shrinkWrap.
		
	self
		vResizing: #shrinkWrap;
		layoutInset: (0 @ 2 corner: 0@ -3).
	
	"Not really necessary but there are some UI interactions that make inconsistency possible here."
	self ui hideBtn checked: false.! !

!SdEditor methodsFor: 'accessing' stamp: 'mt 7/19/2011 16:42:35.8'!
column

	| owner |
	owner := self.
	[(owner := owner owner) notNil] whileTrue: [
		(owner isKindOf: SdClassEditorColumn)
			ifTrue: [^ owner]].
	^ nil! !

!SdEditor methodsFor: 'submorphs-add/remove' stamp: 'mt 6/21/2011 11:14:39.904'!
delete

	super delete.
	self deleted.! !

!SdEditor methodsFor: 'signals' stamp: 'mt 4/13/2011 13:36:19.879'!
deleted

	self emit.! !

!SdEditor methodsFor: 'drawing' stamp: 'mt 7/1/2011 17:33:23.479'!
drawOn: aCanvas
	
	aCanvas
		fillRectangle: self innerBounds
		color: (Color gray: 0.85).
	
	self
		drawOuterBorderOn: aCanvas;		
		drawTopLineOn: aCanvas.! !

!SdEditor methodsFor: 'drawing' stamp: 'mt 7/1/2011 17:33:08.393'!
drawOuterBorderOn: aCanvas
		
	self outerBorderWidth > 0 ifTrue: [
		aCanvas
			frameRoundRect: self outerBounds
			radius: 3
			width: self outerBorderWidth  
			color: (Color gray: 0.3)].! !

!SdEditor methodsFor: 'drawing' stamp: 'mt 7/1/2011 17:32:48.497'!
drawTopLineOn: aCanvas
	
	aCanvas
		line: self topLeft to: self topRight color: (Color gray: 0.5);
		line: self topLeft + (0@1) to: self topRight + (0@1) color: (Color gray: 0.7).! !

!SdEditor methodsFor: 'updating' stamp: 'mt 6/21/2011 10:49:53.958'!
editorChange: aSymbol

	
	! !

!SdEditor methodsFor: 'actions' stamp: 'mt 7/2/2011 15:19:04.426'!
expand

	self ui panel submorphs size > 1
		ifTrue: [^ self "already visible"].
		
	self ui panel
		addAllMorphs: (self valueOfProperty: #hiddenSubmorphs);
		vResizing: #spaceFill.
		
	self
		vResizing: #spaceFill;
		layoutInset: 0;
		removeProperty: #hiddenSubmorphs.
	
	"Not really necessary but there are some UI interactions that make inconsistency possible here."
	self ui hideBtn checked: true.! !

!SdEditor methodsFor: 'testing' stamp: 'mt 4/14/2011 13:50:06.099'!
hasUnacceptedChanges

	^ false! !

!SdEditor methodsFor: 'accessing' stamp: 'mt 3/22/2012 11:41:52.1'!
header

	^ self ui panel submorphs first! !

!SdEditor methodsFor: 'accessing' stamp: 'mt 3/22/2012 12:08:28.221'!
headerColor

	^ self header color! !

!SdEditor methodsFor: 'accessing' stamp: 'mt 3/22/2012 11:59:21.647'!
headerColor: aColor

	| fillStyle header |
	header := self header.
	fillStyle := aColor = (Color gray: 0.85)
		ifTrue: [aColor]
		ifFalse: [(GradientFillStyle ramp: {
			0.15 -> (Color gray: 0.85).
			0.5 -> aColor.
			0.85 -> (Color gray: 0.85)})
			origin: header topLeft;
			direction: 0 @ header height].
	header fillStyle: fillStyle.! !

!SdEditor methodsFor: 'initialization' stamp: 'mt 7/5/2011 14:42:23.029'!
initialize

	super initialize.
	
	self
		initializeEventHandler;
		width: self class defaultWidth.! !

!SdEditor methodsFor: 'initialization' stamp: 'mt 3/22/2012 13:07:34.57'!
initializeEventHandler

	self eventHandler: UiEventHandler new.
	
	self
		connect: self eventHandler
		signal: #focusReceivedInSubmorph:
		toSelector: #setFocus:
		pattern: #(=true).
		
	self
		connect: self eventHandler
		signal: #focusLostInSubmorph:
		toSelector: #setFocus:
		pattern: #(=false).! !

!SdEditor methodsFor: 'testing' stamp: 'mt 4/22/2011 16:52:55.659'!
isClassEditor

	^ false! !

!SdEditor methodsFor: 'testing' stamp: 'mt 7/2/2011 14:57:11.701'!
isCollaped

	^ self isExpanded not! !

!SdEditor methodsFor: 'testing' stamp: 'mt 7/2/2011 14:57:03.704'!
isExpanded

	^ self vResizing == #spaceFill! !

!SdEditor methodsFor: 'testing' stamp: 'mt 5/3/2011 14:44:05.565'!
isFloating

	^ self owner notNil and: [self owner isSystemWindow]! !

!SdEditor methodsFor: 'testing' stamp: 'mt 6/30/2011 11:08:37.242'!
isPackageViewer

	^ false! !

!SdEditor methodsFor: 'visiting' stamp: 'mt 7/4/2011 17:58:13.209'!
loadState: anEditorState

	anEditorState loadEditor: self.! !

!SdEditor methodsFor: 'actions' stamp: 'mt 4/19/2011 11:15:55.564'!
onPinningChanged: aBoolean

	aBoolean
		ifTrue: [self pinned]
		ifFalse: [self unpinned].! !

!SdEditor methodsFor: 'actions' stamp: 'mt 7/1/2011 22:58:41.227'!
onVisibilityChanged: aBoolean

	aBoolean
		ifTrue: [self expand]
		ifFalse: [self collapse].! !

!SdEditor methodsFor: 'initialization' stamp: 'mt 7/5/2011 14:44:53.405'!
open
	"Open in own system window."
	
	^ (SdToolWindow
		morph: self
		label: self asString)! !

!SdEditor methodsFor: 'geometry' stamp: 'mt 6/21/2011 10:52:43.795'!
optimalWidth
	"Editors should provide an optimal width because convenient resize interactions are provided by the IDE."
	
	^ 250! !

!SdEditor methodsFor: 'accessing' stamp: 'mt 4/14/2011 17:04:58.445'!
outerBorderWidth

	^ outerBorderWidth ifNil: [0]! !

!SdEditor methodsFor: 'accessing' stamp: 'mt 4/14/2011 17:05:10.521'!
outerBorderWidth: anInteger

	outerBorderWidth := anInteger.! !

!SdEditor methodsFor: 'geometry' stamp: 'mt 4/14/2011 17:05:24.67'!
outerBounds

	^ self bounds outsetBy: self outerBorderWidth  ! !

!SdEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 17:22:22.852'!
pinned

	self emitInOwnerChain.! !

!SdEditor methodsFor: 'visiting' stamp: 'mt 7/4/2011 15:19:40.718'!
saveState: anEditorState

	anEditorState saveEditor: self.! !

!SdEditor methodsFor: 'accessing' stamp: 'mt 3/22/2012 11:59:58.333'!
setFocus: aBoolean


	aBoolean
		ifTrue: [
			self headerColor: (Color r: 0.2 g: 0.5 b: 1.0).
			"self header submorphsDo: [:m | m color: Color transparent]."
			self ui headerBtn text: ('<font color="#FFFFFF"><b>', self ui headerBtn text asString, '</b></font>') asHtmlText]
		ifFalse: [
			self headerColor: (Color gray: 0.85).
			"self header submorphsDo: [:m | m color: Color transparent]."
			self ui headerBtn text: ('<font color="#000000">', self ui headerBtn text asString, '</font>') asHtmlText	]! !

!SdEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 17:22:26.794'!
unpinned

	self emitInOwnerChain.! !

SdEditor subclass: #SdMethodContainer
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdMethodContainer methodsFor: 'testing' stamp: 'mt 5/26/2011 18:04:47.459'!
hasUnacceptedChanges

	^ self methodEditors anySatisfy: [:e |
		e hasUnacceptedChanges]! !

!SdMethodContainer methodsFor: 'initialization' stamp: 'mt 7/5/2011 14:50:30.508'!
initialize

	super initialize.
	self ui setupUi: self.
	
	"header"
	self connect: self ui pinBtn signal: #toggled: toSelector: #onPinningChanged:.
	self connect: self ui closeBtn signal: #clicked: toSelector: #tryDelete.
	self ui headerBtn target: self.
	
	"Method editor drop target."
	self ui codeArea verticalScrollBar singleStep: 20.
	self ui codeArea transformMorph color: (Color gray: 0.6).
	self ui codeArea widget: SdMethodEditorColumn new.
	
	self ui codeArea verticalScrollBar
		singleStep: 20;
		outerBorderWidth: 0;
		color: Color transparent.
	self ui codeArea transformMorph
		color: (Color gray: 0.3);
		text: '<font color="#888888">Drop source code here.</font>' asHtmlText.
	self ui codeArea connectSignal: #focusChanged: toSelector: #scrollToShowGlobal:.
! !

!SdMethodContainer methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:54:20.5'!
methodEditorColumn

	^ self ui codeArea widget! !

!SdMethodContainer methodsFor: 'accessing' stamp: 'mt 7/5/2011 14:54:40.348'!
methodEditors

	^ self methodEditorColumn methodEditors! !

!SdMethodContainer methodsFor: 'actions' stamp: 'mt 5/26/2011 18:02:43.042'!
saveAll

	self methodEditors do: [:methodEditor |
		methodEditor saveMethod].! !

!SdMethodContainer methodsFor: 'actions' stamp: 'mt 5/26/2011 18:06:18.962'!
tryDelete

	| msg |
	self hasUnacceptedChanges
		ifFalse: [^ self delete].
		
	msg := SdOverlayMessageBox new
		title: 'Close method editor group';
		message: 'There are unaccepted changes.' icon: UiSilkIcons informationIcon.
	msg addAction: 'Save all changes.' icon: UiSilkIcons diskMultipleIcon receiver: self selectors: #(saveAll tryDelete).
	msg addAction: 'Ignore all changes.' icon: UiSilkIcons binIcon receiver: self selectors: #(delete).
	msg addAction: 'Abort this action.' icon: UiSilkIcons cancelIcon.
	
	msg showAbove: self.  ! !

!SdMethodContainer methodsFor: 'accessing' stamp: 'mt 5/26/2011 17:52:27.242'!
ui

	^ ui ifNil: [ui := SdMethodContainerUi new]  ! !

SdEditor subclass: #SdObjectExplorer
	uses: TSdDynamicActivation
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdObjectExplorer class
	uses: TSdDynamicActivation classTrait
	instanceVariableNames: ''!

!SdObjectExplorer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:59:39.164'!
editorDescription

	^ 'Explore an object with all properties in a tree view.'! !

!SdObjectExplorer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:32:01.771'!
editorIcon

	^ UiFugueIcons nodeMagnifierIcon! !

!SdObjectExplorer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 20:59:15.667'!
editorName

	^ 'Object Explorer'! !

!SdObjectExplorer methodsFor: 'actions' stamp: 'mt 3/22/2012 17:01:18.541'!
changeReceiverFor: anObjectExplorerNode
	"Make do-its in source code edit relative to selected object in tree."
	
	self ui sourceCodeEdit doItReceiver:
		(anObjectExplorerNode ifNotNil: [:node | 
			node baseObject]).! !

!SdObjectExplorer methodsFor: 'dynamic - signals - activation' stamp: ''!
classActivated: aClass

	self emitInOwnerChain.! !

!SdObjectExplorer methodsFor: 'events' stamp: 'mt 5/24/2011 16:10:30.557'!
grabKeyboard

	self ui treeView grabKeyboard.! !

!SdObjectExplorer methodsFor: 'initialization' stamp: 'mt 3/22/2012 16:55:47.344'!
initialize

	super initialize.
	self ui setupUi: self.

	self initializeTree.
	
	self connect: self ui pinBtn signal: #toggled: toSelector: #onPinningChanged:.
	self connect: self ui closeBtn signal: #clicked: toSelector: #delete.
	self connect: self ui hideBtn signal: #toggled: toSelector: #onVisibilityChanged:.
	self ui headerBtn target: self.
	
	self ui sourceCodeEdit
		hideInfoButtons;
		colorFocusBackground: Color white;
		colorFocusBorder: (Color gray: 0.3);
		updateFocusColor: false. "TODO: remove"
	
	self ui sourceCodeEdit eventHandler grabKeyboardOnMouseEnter: true.  
	
	self connect: self ui treeView signal: #currentNodeChanged: toSelector: #changeReceiverFor:.
	
	"Bypass workaround in this editor."
	self ui sourceCodeEdit instVarNamed: #fixLayout put: false.! !

!SdObjectExplorer methodsFor: 'initialization' stamp: 'mt 3/22/2012 17:15:49.587'!
initializeTree
	
	self ui treeView
		addColumns: {
			UiItemViewColumnSpec newFrom: {#text -> #tag. #headerText -> 'Property'}.
			UiItemViewColumnSpec newFrom: {#text -> #beforeText. #icon -> #beforeIcon. #menu -> #beforeMenu. #headerText -> 'Before'}.
			UiItemViewColumnSpec newFrom: {#text -> #afterText. #icon -> #afterIcon. #menu -> #afterMenu. #headerText -> 'After'}
			};
		addHorizontalHeader;
		model: SdObjectExplorerModel new.

	self connect: self ui treeView model signal: #classActivated: toSelector: #classActivated:. 
	self connect: self ui treeView model signal: #methodActivated: toSelector: #methodActivated:.
	self connect: self ui treeView model signal: #objectActivated: toSelector: #objectActivated:.
	self connect: self ui treeView model signal: #traceActivated: toSelector: #traceActivated:.
	
	self connect: self ui treeView model signal: #modelReset toSelector: #initializeTreeColumns.! !

!SdObjectExplorer methodsFor: 'initialization' stamp: 'mt 3/22/2012 17:30:31.711'!
initializeTreeColumns
	
	self ui treeView
		setResizeModeForColumn: 2 to: #rigid;
		setWidthForColumn: 2 to: 100;
		setResizeModeForColumn: 3 to: #rigid;
		setWidthForColumn: 3 to: 100.! !

!SdObjectExplorer methodsFor: 'visiting' stamp: 'mt 7/4/2011 18:06:49.715'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadObjectExplorer: self.! !

!SdObjectExplorer methodsFor: 'dynamic - signals - activation' stamp: ''!
methodActivated: aMethodReference

	self emitInOwnerChain.! !

!SdObjectExplorer methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:53:32.041'!
object

	^ self ui treeView model baseObject! !

!SdObjectExplorer methodsFor: 'accessing' stamp: 'mt 3/22/2012 17:05:18.426'!
object: anObject
	"Set the object that is explored."

	self ui treeView model setStateChange: anObject.	
	self ui headerBtn text: (self ui treeView model baseObject asString truncateWithElipsisTo: 25).! !

!SdObjectExplorer methodsFor: 'dynamic - signals - activation' stamp: ''!
objectActivated: anObject

	self emitInOwnerChain.! !

!SdObjectExplorer methodsFor: 'accessing' stamp: 'mt 7/23/2011 11:02:12.872'!
optimalWidth

	^ super optimalWidth max: self ui treeView optimalWidth! !

!SdObjectExplorer methodsFor: 'visiting' stamp: 'mt 7/4/2011 15:19:40.783'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState saveObjectExplorer: self.! !

!SdObjectExplorer methodsFor: 'dynamic - signals - activation' stamp: ''!
traceActivated: aNode

	self emitInOwnerChain.! !

!SdObjectExplorer methodsFor: 'accessing' stamp: 'mt 5/23/2011 10:53:16.147'!
ui

	^ ui ifNil: [ui := SdObjectExplorerUi new]! !

SdEditor subclass: #SdPackageViewer
	uses: TSdDynamicActivation
	instanceVariableNames: 'ui previewPanel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdPackageViewer class
	uses: TSdDynamicActivation classTrait
	instanceVariableNames: ''!

!SdPackageViewer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:00:25.713'!
editorDescription

	^ 'Explore a whole package.'! !

!SdPackageViewer class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:57:01.081'!
editorGroup

	^ 2! !

!SdPackageViewer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:33:54.861'!
editorIcon

	^ UiSilkIcons packageIcon! !

!SdPackageViewer class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:00:10.644'!
editorName

	^ 'Package Viewer'! !

!SdPackageViewer class methodsFor: 'testing' stamp: 'mt 6/28/2011 21:10:37.331'!
isStandAlone

	^ true! !

!SdPackageViewer methodsFor: 'actions' stamp: 'mt 2/14/2012 17:12:18.373'!
chooseItem: aCodeNode

	aCodeNode isMethodNode ifTrue: [
		^ self methodActivated: aCodeNode method methodReference].

	aCodeNode isClassNode ifTrue: [
		^ self classActivated: aCodeNode theClass].
! !

!SdPackageViewer methodsFor: 'actions' stamp: 'mt 2/12/2012 18:21:25.226'!
choosePackage

	self ui packageCombo currentItem ifNil: [^ self].

	self ui treeView model packageInfo:
		(PackageInfo named: (self ui packageCombo currentItem
			at: #package)).! !

!SdPackageViewer methodsFor: 'actions - monticello' stamp: 'mt 5/20/2011 09:30:08.701'!
chooseRepository

	| menu |
	menu := MenuMorph new
		defaultTarget: self.
	
	self workingCopy repositoryGroup repositoriesDo: [:repo | menu add: repo description selector: #synchronizeWith: argument: repo].
	
	menu
		popUpAt: ActiveHand position truncated
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdPackageViewer methodsFor: 'events' stamp: 'mt 2/14/2012 17:00:19.025'!
grabKeyboard

	self ui treeView grabKeyboard.! !

!SdPackageViewer methodsFor: 'actions - preview' stamp: 'mt 7/17/2011 22:04:30.432'!
hidePreview

	previewPanel ifNil: [^ self].
	previewPanel delete.
	previewPanel := nil.! !

!SdPackageViewer methodsFor: 'initialization' stamp: 'mt 2/12/2012 18:16:36.421'!
initialize

	super initialize.
	self ui setupUi: self.
	
	"header"
	self connect: self ui pinBtn signal: #toggled: toSelector: #onPinningChanged:.
	self connect: self ui closeBtn signal: #clicked: toSelector: #delete.
	self connect: self ui hideBtn signal: #toggled: toSelector: #onVisibilityChanged:.
	self ui headerBtn target: self.
	
	"package list"
	self connect: self ui packageCombo signal: #currentTextChanged: toSelector: #choosePackage.
	self connect: self ui synchBtn signal: #clicked: toSelector: #chooseRepository.
	
	"preview"
	self connect: self ui treeView signal: #currentNodeChanged: toSelector: #triggerPreview.
	self connect: self ui treeView viewport eventHandler signal: #focusLost toSelector: #hidePreview.
	self ui treeView viewport eventHandler on: Character escape send: #hidePreview to: self.
	
	"tree"
	self initializeTree.
	
	self initializeSystemChangeNotifications.
	self updatePackageList.! !

!SdPackageViewer methodsFor: 'initialization' stamp: 'mt 5/20/2011 09:55:08.842'!
initializeSystemChangeNotifications

	SystemChangeNotifier uniqueInstance 
		notify: self ofSystemChangesOfItem: SystemChangeNotifier categoryKind using: #onCategoryChange:;
		notify: self ofAllSystemChangesUsing: #updateCurrentPackageItem.! !

!SdPackageViewer methodsFor: 'initialization' stamp: 'mt 2/16/2012 11:00:49.813'!
initializeTree

	self ui treeView
		enableAutoSort;
		addColumns: {
			UiItemViewColumnSpec newFrom: {#text -> 1. #icon -> #icon. #menu -> #menu}.
			(UiItemViewColumnSpec newFrom: {#text -> 2})
				balloonTextConverter: [:obj | 'Number of tests that covered this method.'].
			(UiItemViewColumnSpec newFrom: {#text -> 3})
				balloonTextConverter: [:obj | 'Last author'].
			(UiItemViewColumnSpec newFrom: {#text -> 4})
				balloonTextConverter: [:obj | 'Last modification time']};
		model: SdPackageModel new;
		setHAlignmentForColumn: 2 to: #right; "coverage"
		setHAlignmentForColumn: 3 to: #right; "author"
		horizontalHeaderVisible: false.
	
	self ui treeView disconnectSignal: #doubleClicked:.
	self connect: self ui treeView signal: #returnPressed: toSelector: #chooseItem:.
	self connect: self ui treeView signal: #doubleClicked: toSelector: #chooseItem:.
	
	"Used for menu callbacks. See #showMenuAt:on:."
	self connect: self ui treeView model signal: #methodActivated: toSelector: #methodActivated:.
	self connect: self ui treeView model signal: #classActivated: toSelector: #classActivated:.
	self connect: self ui treeView model signal: #objectActivated: toSelector: #objectActivated:.
	self connect: self ui treeView model signal: #traceActivated: toSelector: #traceActivated:.! !

!SdPackageViewer methodsFor: 'testing' stamp: 'mt 6/30/2011 11:08:44.377'!
isPackageViewer

	^ true! !

!SdPackageViewer methodsFor: 'visiting' stamp: 'mt 7/4/2011 18:08:13.639'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadPackageViewer: self.! !

!SdPackageViewer methodsFor: 'system changes' stamp: 'mt 5/17/2011 09:47:40.562'!
onCategoryChange: aCategoryKindevent

	self updatePackageList.! !

!SdPackageViewer methodsFor: 'geometry' stamp: 'mt 6/10/2011 12:06:22.077'!
optimalWidth

	^ self ui treeView optimalWidth! !

!SdPackageViewer methodsFor: 'accessing' stamp: 'mt 2/14/2012 17:29:59.476'!
packageName

	^ self ui packageCombo currentItem at: #package! !

!SdPackageViewer methodsFor: 'accessing' stamp: 'mt 2/14/2012 17:30:21.021'!
packageName: aPackageName

	self packageName = aPackageName ifTrue: [^ self].

	self ui packageCombo currentItem: (self ui packageCombo list detect: [:item |
		(item at: #package) = aPackageName]).! !

!SdPackageViewer methodsFor: 'visiting' stamp: 'mt 7/4/2011 15:19:41.252'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState savePackageViewer: self.! !

!SdPackageViewer methodsFor: 'selection' stamp: 'mt 2/15/2012 10:29:15.654'!
selectCategory: aSystemCategory

	| checkBlock |
	checkBlock := [:node | node isSystemCategoryNode and: [node category = aSystemCategory]].
	
	self packageName: (PackageOrganizer default packageOfSystemCategory: aSystemCategory) name.

	(self ui treeView currentNode ifNotNil: checkBlock ifNil: [false])
		ifTrue: [^ self "already selected"].

	self ui treeView currentNode: ((UiItemModelFinder on: self ui treeView model)
		traversalMode: #breadthFirst;
		detect: checkBlock
		ifNone: []).! !

!SdPackageViewer methodsFor: 'selection' stamp: 'mt 2/15/2012 10:36:35.83'!
selectProtocol: aProtocol class: aClass

	| finder classNode protocolNode |
	self selectCategory: aClass category.
	
	finder := (UiItemModelFinder on: self ui treeView model)
		traversalMode: #breadthFirst.
		
	classNode := finder nextSatisfying: [:node | node isClassNode and: [node theClass = aClass]].		
	classNode ifNil: [^ self].
	self ui treeView expandIndex: finder currentIndex.
	
	finder root: classNode.
	protocolNode := finder nextSatisfying: [:node | node isProtocolNode and: [node protocol = aProtocol]].
	protocolNode ifNil: [^ self].
	
	"#expandIndex: does not work here because we reset the #root in the finder."
	self ui treeView expandNode: protocolNode.
	self ui treeView currentNode: protocolNode.! !

!SdPackageViewer methodsFor: 'actions - preview' stamp: 'mt 2/15/2012 10:38:34.038'!
showPreview
	
	self showPreview: self ui treeView currentNode.! !

!SdPackageViewer methodsFor: 'actions - preview' stamp: 'mt 3/22/2012 11:34:03.879'!
showPreview: aCodeNode
	"Show a preview for the current element if one is selected."
	
	aCodeNode ifNil: [^ self].
	
	"Discard the current preview."
	previewPanel ifNotNil: [self hidePreview].
	
	aCodeNode isClassNode ifTrue: [
		previewPanel := SdPreviewBuilder createClassPreviewFor: aCodeNode theClass].
	aCodeNode isMethodNode ifTrue: [
		previewPanel := SdPreviewBuilder createMethodPreviewFor: aCodeNode method methodReference].

	previewPanel ifNil: [^ self].
	
	"Ensure visibility of preview box."
	self ui treeView selection currentBounds ifNotNil: [:selectionBounds |
		| globalRight |
		globalRight := (self localPointToGlobal: self topRight) x.
		(globalRight + previewPanel width) > ActiveWorld right
			ifTrue: [(selectionBounds left - previewPanel width) < ActiveWorld left
				ifFalse: [previewPanel topRight: selectionBounds topLeft]
				ifTrue: [previewPanel topLeft: selectionBounds bottomLeft]]
			ifFalse: [previewPanel topLeft: globalRight @ selectionBounds top].
		previewPanel bottom: (ActiveWorld bottom min: previewPanel bottom)].
		
	previewPanel openInWorld.! !

!SdPackageViewer methodsFor: 'actions - monticello' stamp: 'mt 5/20/2011 09:49:47.693'!
synchronizeWith: aRepository

	| newerVersions |
	"Merge new content."
	newerVersions := self workingCopy possiblyNewerVersionsIn: aRepository.
	newerVersions ifNotEmpty: [(aRepository
			versionNamed: newerVersions first
			ifAbsent: []) ifNotNil: [:v | v merge]].
	
	"Save own content."
	self workingCopy needsSaving ifFalse: [^ self].
	self workingCopy newVersion ifNotNil: [:v |
			Cursor wait showWhile: [aRepository storeVersion: v]].
		
	"Description may have changed of MC package."
	self updateCurrentPackageItem.! !

!SdPackageViewer methodsFor: 'actions - preview' stamp: 'mt 2/15/2012 10:40:02.362'!
triggerPreview

	self hidePreview.
	self
		removeAlarm: #showPreview;
		addAlarm: #showPreview
		after: 250.! !

!SdPackageViewer methodsFor: 'accessing' stamp: 'mt 5/16/2011 17:11:45.2'!
ui

	^ ui ifNil: [ui := SdPackageViewerUi new]! !

!SdPackageViewer methodsFor: 'updating' stamp: 'mt 6/30/2011 11:02:46.66'!
updateCurrentPackageItem

	self ui packageCombo currentItem ifNotNil: [:item |
		item text: self workingCopy description].
	self ui packageCombo updateCurrentRow.! !

!SdPackageViewer methodsFor: 'updating' stamp: 'mt 2/12/2012 18:20:25.07'!
updatePackageList

	self ui packageCombo clear.
	self ui packageCombo
		addItemListFrom: PackageOrganizer default packageNames sorted
		using: [:pName :item | | mc |
			item at: #package put: pName.
			mc := MCPackage named: pName.
			mc hasWorkingCopy
				ifTrue: [item text: mc workingCopy description]
				ifFalse: [item text: ('<font color="#777777">', pName, ' (no working copy)</font>') asHtmlText]].! !

!SdPackageViewer methodsFor: 'actions - monticello' stamp: 'mt 2/12/2012 18:21:22.201'!
workingCopy

	^ (MCPackage named: (self ui packageCombo currentItem at: #package)) workingCopy! !

SdEditor subclass: #SdSpacer
	instanceVariableNames: 'closeBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdSpacer class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:53:02.003'!
editorDescription

	^ 'Add some space between editors to organize your working sets.'! !

!SdSpacer class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:55:38.07'!
editorIcon

	^ UiSilkIcons pictureEmptyIcon! !

!SdSpacer class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:52:13.608'!
editorName

	^ 'Spacer'! !

!SdSpacer class methodsFor: 'testing' stamp: 'mt 7/3/2011 08:52:05.963'!
isStandAlone

	^ true! !

!SdSpacer methodsFor: 'actions' stamp: 'mt 7/3/2011 09:05:19.938'!
collapse

	"Cannot collapse."! !

!SdSpacer methodsFor: 'drawing' stamp: 'mt 7/4/2011 18:19:23.017'!
drawInnerShadowOn: aCanvas

	| c |
	c := Color black.

	(self owner submorphs indexOf: self) > 1 ifTrue: [
		aCanvas
			line: self topLeft + (0@1) to: self topRight + (-1@1) color: (c alpha: 0.5);
			line: self topLeft + (0@2) to: self topRight + (-1@2) color: (c alpha: 0.2)].
	
	(self column owner submorphs indexOf: self column) > 1 ifTrue: [
		aCanvas
			line: self topLeft + (2@1) to: self bottomLeft + (2@ -1) color: (c alpha: 0.5);
			line: self topLeft + (3@2) to: self bottomLeft + (3@ -1) color: (c alpha: 0.2)].
		
	aCanvas
		frameRectangle: (self innerBounds insetBy: (1@0 corner: 1@0))
		color: (c alpha: 0.8).! !

!SdSpacer methodsFor: 'drawing' stamp: 'mt 7/3/2011 08:51:50.167'!
drawOn: aCanvas

	self drawInnerShadowOn: aCanvas.! !

!SdSpacer methodsFor: 'actions' stamp: 'mt 7/3/2011 09:05:12.649'!
expand

	"Already expanded."! !

!SdSpacer methodsFor: 'initialization' stamp: 'mt 7/3/2011 09:14:40.646'!
initialize

	super initialize.
	
	closeBtn := UiToolButton new
		buttonStyle: #iconOnly;
		autoRaise: true;
		balloonText: 'Close Spacer';
		color: Color transparent;
		icon: UiFugueIcons crossSmallIcon asGrayScale2.
	self connect: closeBtn signal: #clicked: toSelector: #delete.
	
	self
		color: (Color gray: 0.6);
		changeTableLayout;
		listDirection: #leftToRight;
		listCentering: #bottomRight.
		
	self addMorph: closeBtn.! !

SdEditor subclass: #SdTranscriptEditor
	instanceVariableNames: 'ui transcriptModel lastTimestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdTranscriptEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:03:57.643'!
editorDescription

	^ 'Enhanced debugging output with timestamps.'! !

!SdTranscriptEditor class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:57:18.88'!
editorGroup

	^ 3! !

!SdTranscriptEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:34:09.316'!
editorIcon

	^ UiSilkIcons applicationViewListIcon! !

!SdTranscriptEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:03:38.934'!
editorName

	^ 'Transcript'! !

!SdTranscriptEditor class methodsFor: 'testing' stamp: 'mt 6/28/2011 21:10:43.734'!
isStandAlone

	^ true! !

!SdTranscriptEditor methodsFor: 'actions' stamp: 'mt 5/5/2011 16:38:21.501'!
addEntry: aString

	| timestamp entry |
	entry := aString withoutLineEndings withBlanksTrimmed.
	timestamp := ('<font color="#777777">[', 
			(String streamContents:
				[:aStream | Time now print24: true showSeconds: false on: aStream]),
			']</font> ') asHtmlText.

	((aString startsWith: String cr) or: [aString endsWith: String cr])
		ifTrue: [self ui transcriptEdit theText isEmpty
			ifFalse: [self ui transcriptEdit append: String cr].
			self ui timestampBtn checked
				ifTrue: [self ui transcriptEdit append: timestamp].
			(entry startsWith: '----SNAPSHOT')
				ifTrue: [self ui transcriptEdit append: ('<b>', entry, '</b>') asHtmlText]
				ifFalse: [self ui transcriptEdit append: entry]]
		ifFalse: [self ui transcriptEdit append: entry].
	
	self ui transcriptEdit scrollToBottom.
	
	self ui redrawBtn checked
		ifTrue: [self redraw].! !

!SdTranscriptEditor methodsFor: 'converting' stamp: 'mt 5/5/2011 16:39:02.759'!
asString

	^ 'Transcript'! !

!SdTranscriptEditor methodsFor: 'initialization' stamp: 'mt 3/22/2012 11:39:17.955'!
initialize

	super initialize.
	self ui setupUi: self.
		
	transcriptModel := SdTranscriptModel new.
	self connect: transcriptModel signal: #entryAppended: toSelector: #addEntry:.
	
	self connect: self ui clearTranscriptBtn signal: #clicked: to: self ui transcriptEdit selector: #clear.
	
	self connect: self ui pinBtn signal: #toggled: toSelector: #onPinningChanged:.
	self connect: self ui closeBtn signal: #clicked: toSelector: #delete.
	self connect: self ui hideBtn signal: #toggled: toSelector: #onVisibilityChanged:.
	
	self ui headerBtn target: self.! !

!SdTranscriptEditor methodsFor: 'visiting' stamp: 'mt 7/4/2011 18:09:38.229'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadTranscriptEditor: self.! !

!SdTranscriptEditor methodsFor: 'visiting' stamp: 'mt 7/4/2011 15:19:41.37'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState saveTranscriptEditor: self.! !

!SdTranscriptEditor methodsFor: 'accessing' stamp: 'mt 5/5/2011 16:36:56.597'!
ui

	^ ui ifNil: [ui := SdTranscriptEditorUi new]! !

SdEditor subclass: #SdWorkspaceEditor
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdWorkspaceEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:03:32.976'!
editorDescription

	^ 'Text area plus a lot of support for executable code.'! !

!SdWorkspaceEditor class methodsFor: 'accessing' stamp: 'mt 7/3/2011 08:57:22.924'!
editorGroup

	^ 3! !

!SdWorkspaceEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:34:44.38'!
editorIcon

	^ UiSilkIcons applicationXpTerminalIcon! !

!SdWorkspaceEditor class methodsFor: 'accessing' stamp: 'mt 6/28/2011 21:03:28.241'!
editorName

	^ 'Workspace'! !

!SdWorkspaceEditor class methodsFor: 'testing' stamp: 'mt 6/28/2011 21:10:51.335'!
isStandAlone

	^ true! !

!SdWorkspaceEditor methodsFor: 'converting' stamp: 'mt 5/5/2011 16:39:15.962'!
asString

	^ 'Workspace'! !

!SdWorkspaceEditor methodsFor: 'signals' stamp: 'mt 7/31/2011 15:10:03.161'!
classActivated: aClass

	self emitInOwnerChain.! !

!SdWorkspaceEditor methodsFor: 'events' stamp: 'mt 5/5/2011 16:40:26.251'!
grabKeyboard

	self ui workspaceEdit grabKeyboard.! !

!SdWorkspaceEditor methodsFor: 'initialization' stamp: 'mt 3/22/2012 11:37:41.843'!
initialize

	super initialize.
	self ui setupUi: self.
	
	self ui workspaceEdit
		hideInfoButtons.
		
	self connect: self ui clearWorkspaceBtn signal: #clicked: to: self ui workspaceEdit selector: #clear.
	
	self connect: self ui pinBtn signal: #toggled: toSelector: #onPinningChanged:.
	self connect: self ui closeBtn signal: #clicked: toSelector: #delete.
	self connect: self ui hideBtn signal: #toggled: toSelector: #onVisibilityChanged:.
	
	self ui headerBtn target: self.
	
	self grabKeyboard.
	
	"Bypass workaround in this editor."
	self ui workspaceEdit instVarNamed: #fixLayout put: false.
	
	self ui workspaceEdit eventHandler on: #(cmd) -> $O send: #openSelection to: self.! !

!SdWorkspaceEditor methodsFor: 'visiting' stamp: 'mt 7/4/2011 18:11:23.988'!
loadState: anEditorState

	super loadState: anEditorState.
	anEditorState loadWorkspaceEditor: self.! !

!SdWorkspaceEditor methodsFor: 'signals' stamp: 'mt 7/31/2011 15:10:12.999'!
objectActivated: anObject

	self emitInOwnerChain.! !

!SdWorkspaceEditor methodsFor: 'actions' stamp: 'mt 7/31/2011 15:13:43.776'!
openSelection

	| result |
	result := self ui workspaceEdit evaluateSelection.
	((result isKindOf: FakeClassPool) or: [result == #failedDoit])
		ifTrue: [^ self].
		
	(result isKindOf: Behavior)
		ifTrue: [^ self classActivated: result].
		
	self objectActivated: result.! !

!SdWorkspaceEditor methodsFor: 'accessing' stamp: 'mt 5/12/2011 17:01:22.382'!
optimalWidth

	^ self ui workspaceEdit optimalWidth! !

!SdWorkspaceEditor methodsFor: 'visiting' stamp: 'mt 7/4/2011 15:19:40.893'!
saveState: anEditorState

	super saveState: anEditorState.
	anEditorState saveWorkspaceEditor: self.! !

!SdWorkspaceEditor methodsFor: 'accessing' stamp: 'mt 5/5/2011 16:35:50.549'!
ui

	^ ui ifNil: [ui := SdWorkspaceEditorUi new]! !

Morph subclass: #SdFadingToolbar
	instanceVariableNames: 'leftBar topBar rightBar bottomBar timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdFadingToolbar class methodsFor: 'as yet unclassified' stamp: 'mt 5/2/2011 20:59:49.339'!
hideAllToolbars

	ActiveWorld submorphs
		select: [:m | m isKindOf: SdFadingToolbar]  
		thenDo: [:m | m delete].! !

!SdFadingToolbar methodsFor: 'adding' stamp: 'mt 4/7/2011 14:59:47.001'!
addButton: aButton edge: aSymbol

	aSymbol = #left ifTrue: [leftBar addMorphBack: aButton].
	aSymbol = #top ifTrue: [topBar addMorphBack: aButton].
	aSymbol = #right ifTrue: [rightBar addMorphBack: aButton].
	aSymbol = #bottom ifTrue: [bottomBar addMorphBack: aButton].! !

!SdFadingToolbar methodsFor: 'adding' stamp: 'mt 7/23/2011 11:09:40.668'!
addSpacerToEdge: aSymbol

	| spacer |
	spacer := Morph new
		color: Color transparent;
		extent: 10@10.
		
	aSymbol = #left ifTrue: [leftBar addMorphBack: spacer].
	aSymbol = #top ifTrue: [topBar addMorphBack: spacer].
	aSymbol = #right ifTrue: [rightBar addMorphBack: spacer].
	aSymbol = #bottom ifTrue: [bottomBar addMorphBack: spacer].! !

!SdFadingToolbar methodsFor: 'accessing' stamp: 'mt 4/7/2011 14:48:29.386'!
alpha: aFloat
	
	leftBar alpha: aFloat.
	topBar alpha: aFloat.
	rightBar alpha: aFloat.
	bottomBar alpha: aFloat.! !

!SdFadingToolbar methodsFor: 'layout' stamp: 'mt 4/12/2011 17:26:45.304'!
fullBounds

	fullBounds ifNil: [
		self updateLayout].
	
	^ super fullBounds! !

!SdFadingToolbar methodsFor: 'events-processing' stamp: 'mt 4/7/2011 16:40:08.924'!
handleMouseMove: anEvent

	self mouseMove: anEvent.! !

!SdFadingToolbar methodsFor: 'initialization' stamp: 'mt 4/7/2011 17:01:51.113'!
initialize

	super initialize.

	self
		color: Color transparent;
		initializeEventHandler.
	
	leftBar := SdFadingToolbarPanel new orientation: #vertical; wrapDirection: #rightToLeft.  
	topBar := SdFadingToolbarPanel new orientation: #horizontal; wrapDirection: #bottomToTop.
	rightBar := SdFadingToolbarPanel new orientation: #vertical; wrapDirection: #leftToRight.
	bottomBar := SdFadingToolbarPanel new orientation: #horizontal; wrapDirection: #topToBottom.

	self addAllMorphs: {leftBar. topBar. rightBar. bottomBar}.! !

!SdFadingToolbar methodsFor: 'initialization' stamp: 'mt 5/4/2011 10:30:31.861'!
initializeEventHandler

	self eventHandler: UiEventHandler new.

	self connect: self eventHandler signal: #mouseLeft: toSelector: #alpha: pattern: #(= 0.0).
	self connect: self eventHandler signal: #mouseMoved: toSelector: #updateAlpha:.
	self connect: self eventHandler signal: #mouseEntered: toSelector: #updateAlpha:.
	
	self connect: self eventHandler signal: #mouseMoved: toSelector: #resetTimeout.! !

!SdFadingToolbar methodsFor: 'popup' stamp: 'mt 5/24/2011 16:28:03.091'!
popUpFor: aMorph
	
	self bounds: aMorph visibleBounds.

	self class hideAllToolbars.
	
	self reopen.! !

!SdFadingToolbar methodsFor: 'events-processing' stamp: 'mt 4/7/2011 16:45:39.314'!
rejectsEvent: anEvent

	(self bounds containsPoint: anEvent position)
		ifFalse: [^ super rejectsEvent: anEvent].

	^ (anEvent isMouse and: [
		anEvent isMouseMove
			or: [anEvent isMouseEnter]
			or: [anEvent isMouseLeave]]) not! !

!SdFadingToolbar methodsFor: 'popup' stamp: 'mt 5/4/2011 10:33:34.495'!
reopen

	self owner ifNil: [
		self
			resetTimeout;
			openInWorld].! !

!SdFadingToolbar methodsFor: 'events-processing' stamp: 'mt 5/4/2011 10:22:45.283'!
resetTimeout

	timeout := 3.
	
	self isStepping
		ifFalse: [self startStepping].! !

!SdFadingToolbar methodsFor: 'stepping' stamp: 'mt 5/4/2011 10:23:46.336'!
step

	timeout ifNil: [^ self resetTimeout].
	
	timeout = 0
		ifTrue: [self stopStepping; fadeOutThen: [self delete; show]. ^ self].
		
	timeout := timeout - 1.! !

!SdFadingToolbar methodsFor: 'stepping' stamp: 'mt 5/4/2011 10:21:03.944'!
stepTime

	^ 1000! !

!SdFadingToolbar methodsFor: 'layout' stamp: 'mt 4/7/2011 16:55:21.953'!
updateAlpha: aMouseEvent

	(self bounds containsPoint: aMouseEvent position) ifTrue: [
		leftBar alpha: (1.0 - ((aMouseEvent position x - self left max: 0) / (self width / 2)) max: 0.3).
		topBar alpha: (1.0 - ((aMouseEvent position y - self top max: 0) / (self height / 2)) max: 0.3).
		rightBar alpha: (1.0 - ((self right - aMouseEvent position x max: 0) / (self width / 2)) max: 0.3).
		bottomBar alpha: (1.0 - ((self bottom - aMouseEvent position y max: 0) / (self height / 2)) max: 0.3)].! !

!SdFadingToolbar methodsFor: 'layout' stamp: 'mt 4/7/2011 16:28:56.17'!
updateLayout
	"Simulate #spaceFill behaviour according to the bar's orientation."
	
	leftBar height: self height.
	topBar width: self width.
	rightBar height: self height.
	bottomBar width: self width.

	leftBar topRight: self topLeft.
	topBar bottomLeft: self topLeft.
	rightBar topLeft: self topRight.
	bottomBar topLeft: self bottomLeft.! !

Morph subclass: #SdFadingToolbarPanel
	instanceVariableNames: 'alpha orientation fadeEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdFadingToolbarPanel commentStamp: 'mt 6/21/2010 16:38:29.674' prior: 0!
I just support the XpfCardMorph. You should normally not want to use me directly.

Normally, I contain some buttons and fade them in or out according to my alpha value.!

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/28/2011 12:39:37.687'!
alpha

	self submorphs ifEmpty: [^ 0.0].

	^ alpha ifNil: [alpha := 0.0]! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/28/2011 11:42:54.545'!
alpha: aFloat

	alpha := aFloat.
	
	self submorphs ifNotEmpty: [self redrawLater].! !

!SdFadingToolbarPanel methodsFor: 'drawing' stamp: 'mt 4/28/2011 12:39:55.986'!
drawOn: aCanvas

	aCanvas
		fillRoundRect: self panelBounds
		radius: 5
		fillStyle: (SolidFillStyle color: (Color black alpha: 0.5)).! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 6/21/2010 16:34:33.892'!
fadeEnabled 
	"Respect the alpha value while drawing?"
	
	^ fadeEnabled ifNil: [fadeEnabled := true]! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 6/21/2010 16:35:04.687'!
fadeEnabled: aBoolean

	aBoolean = fadeEnabled ifTrue: [^ self].
	
	fadeEnabled := aBoolean.
	self redrawLater.! !

!SdFadingToolbarPanel methodsFor: 'drawing' stamp: 'mt 6/21/2010 16:37:13.905'!
fullDrawOn: aCanvas

	self alpha = 0.0
		ifTrue: [^ self].

	(self alpha < 0.9 and: [self fadeEnabled])
		ifTrue: [^ super fullDrawOn: ((AnimAlphaBlendingCanvas on: aCanvas) alpha: self alpha)]
		ifFalse: [^ super fullDrawOn: aCanvas]! !

!SdFadingToolbarPanel methodsFor: 'initialization' stamp: 'mt 4/28/2011 12:40:06.131'!
initialize

	super initialize.
	
	self initializeEventHandler.
	
	self
		color: Color white;
		changeTableLayout;
		cellInset: 2;
		layoutInset: 2;
		orientation: #vertical.! !

!SdFadingToolbarPanel methodsFor: 'initialization' stamp: 'mt 4/28/2011 11:53:36.426'!
initializeEventHandler

	self eventHandler: UiEventHandler new.  

	self eventHandler
		grabKeyboardOnMouseEnter: false;  
		setProperty: #handlesMouseDown toValue: [false].

	self connect: self eventHandler signal: #mouseEntered: toSelector: #alpha: pattern: #(= 1.0).
	self connect: self eventHandler signal: #mouseLeft: toSelector: #alpha: pattern: #(= 0.0).
	self connect: self eventHandler signal: #mouseEntered: toSelector: #tryDelete:.
	self connect: self eventHandler signal: #mouseLeft: toSelector: #tryDelete:.! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/7/2011 14:28:28.138'!
orientation

	^ orientation! !

!SdFadingToolbarPanel methodsFor: 'accessing' stamp: 'mt 4/7/2011 14:28:45.026'!
orientation: aSymbol
	"#vertical #horizontal"

	aSymbol = orientation ifTrue: [^ self].

	orientation := aSymbol.
	
	self updateLayout.! !

!SdFadingToolbarPanel methodsFor: 'geometry' stamp: 'mt 4/28/2011 11:32:40.828'!
panelBounds

	^ self submorphBounds outsetBy: 2  ! !

!SdFadingToolbarPanel methodsFor: 'events-processing' stamp: 'mt 4/28/2011 12:42:45.98'!
rejectsEvent: evt

	(self panelBounds containsPoint: evt position)
		ifTrue: [^ false]
		ifFalse: [self tryDelete: evt. ^ true]! !

!SdFadingToolbarPanel methodsFor: 'initialization' stamp: 'mt 4/28/2011 12:43:41.307'!
tryDelete: aMouseEvent

	(self owner morphsAt: aMouseEvent position)
		ifEmpty: [^ self owner delete].
		
	(self submorphs isEmpty and: [self bounds containsPoint: aMouseEvent position])
		ifTrue: [^ self owner delete].! !

!SdFadingToolbarPanel methodsFor: 'layout' stamp: 'mt 4/12/2011 17:33:50.568'!
updateLayout

	self orientation = #vertical
		ifTrue: [self
			width: 22;
			listDirection: #topToBottom].

	self orientation = #horizontal  
		ifTrue: [self
			height: 22;
			listDirection: #leftToRight].! !

Morph subclass: #SdFinder
	instanceVariableNames: 'ui category previewPanel sortOrder preferredItemCount theClass outerBorderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdFinder subclass: #SdClassFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdClassFinder commentStamp: 'mt 4/17/2011 16:30:36.489' prior: 0!
Class hierarchy sorting ported from OmniBrowser framework (OBClassSortFilter).!

!SdClassFinder methodsFor: 'actions' stamp: 'mt 9/1/2011 13:13:20.744'!
addCategory

	self currentElement ifEmpty: [^ self].
	
	self organization addCategory: self currentElement.
	
	"Create package if necessary."
	PackageOrganizer default
		packageOfSystemCategory: self currentElement
		ifNone: [PackageInfo named: self currentElement].! !

!SdClassFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 11:08:07.496'!
allCategories

	^ (super allCategories, PackageOrganizer default packageNames) asSet! !

!SdClassFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 10:08:58.07'!
allElements

	^ Smalltalk globals classNames! !

!SdClassFinder methodsFor: 'building' stamp: 'mt 2/15/2012 15:54:02.865'!
buildCategoryItemFor: aCategoryName

	| isPackage text |
	isPackage := PackageOrganizer default packageNames includes: aCategoryName.
	text := '{1} <font color="#AAAAAA">({2} class(es){3})</font>' format: {
		aCategoryName.
		(self elementsFor: aCategoryName) size.
		isPackage
			ifTrue: [', ', (PackageInfo named: aCategoryName) systemCategories size asString, ' categories']
			ifFalse: ['']}.
	
	^ UiListWidgetItem new
		text: text asHtmlText;
		icon: (isPackage
			ifTrue: [UiSilkIcons packageIcon]
			ifFalse: [self iconForCategory]);
		at: #category put: aCategoryName;
		at: #symbol put: aCategoryName;
		yourself! !

!SdClassFinder methodsFor: 'building' stamp: 'mt 2/15/2012 15:52:19.161'!
buildElementItemFor: anElementName

	| isPackage |
	isPackage := PackageOrganizer default packageNames includes: self category.

	^ UiListWidgetItem new
		text: ((isPackage or: [self category isNil])
			ifTrue: [(anElementName escapeHtmlText, ' <font color="#AAAAAA">(', (self categoryFor: anElementName), ')</font>') asHtmlText]
			ifFalse: [anElementName]);
		"icon: (self iconFor: anElementName);"
		at: #element put: anElementName;
		at: #symbol put: anElementName;
		yourself! !

!SdClassFinder methodsFor: 'building' stamp: 'mt 4/17/2011 16:27:00.534'!
buildElementItemsFor: sortedElements
	"Sorting ported from OmniBrowser code."
	
	| classes order superChain |
	self category ifNil: [^ super buildElementItemsFor: sortedElements].
	
	classes := sortedElements collect: [:e | Smalltalk at: e].
	order := SortedCollection sortBlock: 
					[:assoc1 :assoc2 | | i chain2 chain1 result max |
					result := nil.
					chain1 := assoc1 key.
					chain2 := assoc2 key.
					max := chain1 size min: chain2 size.
					i := 1.
					[result isNil and: [i <= max]] whileTrue: 
							[(chain1 at: i) = (chain2 at: i) 
								ifTrue: [i := i + 1]
								ifFalse: [result := (chain1 at: i) name < (chain2 at: i) name]].
					result isNil ifTrue: [chain1 size < chain2 size] ifFalse: [result]].

	classes do: [:class |
		superChain := class withAllSuperclasses reversed.
		superChain removeAllSuchThat: [:cl | (classes includes: cl) not].
		order add: superChain contents -> class].
	
	^ order collect: [:assoc | 
			(self buildElementItemFor: assoc value name)
				icon: (assoc key size > 1
					ifTrue: [Form extent: (10 * (assoc key size - 1)) @1 depth: 32]
					ifFalse: [])].! !

!SdClassFinder methodsFor: 'queries' stamp: 'mt 2/15/2012 11:04:33.314'!
categoriesFor: aPackageName

	^ (PackageOrganizer default packageNamed: aPackageName ifAbsent: [])
		ifNil: [#()]
		ifNotNil: [:packageInfo | packageInfo systemCategories]! !

!SdClassFinder methodsFor: 'actions' stamp: 'mt 4/18/2011 12:01:45.116'!
chooseElement

	self currentElement ifEmpty: [^ self].

	"Category/package only relevant for new elements."
	self isCurrentElementNew
		ifTrue: [category
			ifNil: [^ self classChosen: self currentElement]
			ifNotNil: [^ self classChosen: self currentElement category: category]].

	self classChosen: self currentElement.! !

!SdClassFinder methodsFor: 'signals' stamp: 'mt 4/17/2011 10:09:39.977'!
classChosen: className

	self emit.! !

!SdClassFinder methodsFor: 'signals' stamp: 'mt 4/17/2011 10:09:50.735'!
classChosen: className category: aSystemCategory

	self emit.! !

!SdClassFinder methodsFor: 'actions' stamp: 'mt 6/30/2011 10:43:53.84'!
clear
	"Just go back to sys cat list in package if package can be found."
	
	| sysCat package matchedCategories |
	sysCat := category.
	
	package := PackageOrganizer default
		packageOfSystemCategory: category
		ifNone: [].
		
	(package isNil or: [package name = category]) ifTrue: [^ super clear].
	
	category := package name.
	self updateResults: self class tokenForAllCategories.
	
	"Select the current category in the list."
	matchedCategories := self ui resultList select: [:item | item text asString startsWith: sysCat].
	matchedCategories ifNotEmpty: [self ui resultList currentItem: matchedCategories first]! !

!SdClassFinder methodsFor: 'actions' stamp: 'mt 7/17/2011 22:20:44.963'!
createPreviewPanelFor: anElement

	previewPanel := SdPreviewBuilder createClassPreviewFor: (Smalltalk at: anElement).! !

!SdClassFinder methodsFor: 'accessing' stamp: 'mt 4/17/2011 15:28:33.834'!
currentPackage

	^ PackageOrganizer default
		packageNamed: self category
		ifAbsent: []! !

!SdClassFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 16:51:17.362'!
element: anElement matches: aToken

	| letters |
	(super element: anElement matches: aToken)
		ifTrue: [^ true].
		
	letters := anElement select: [:e | e isUppercase].
	^ letters includesSubString: aToken  
	! !

!SdClassFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 11:00:24.665'!
elementsFor: aCategoryName

	(PackageOrganizer default packageNames includes: aCategoryName)
		ifFalse: [^ super elementsFor: aCategoryName]
		ifTrue: [^ (PackageInfo named: aCategoryName) systemCategories gather:
			[:cat | (SystemOrganization listAtCategoryNamed: cat)]]! !

!SdClassFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 10:36:08.29'!
iconForCategory

	^ UiSilkIcons folderIcon! !

!SdClassFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 10:36:47.331'!
iconForCategoryAdd

	^ UiSilkIcons folderAddIcon! !

!SdClassFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 10:36:56.874'!
iconForCategoryEdit

	^ UiSilkIcons folderEditIcon! !

!SdClassFinder methodsFor: 'initialization' stamp: 'mt 6/22/2011 12:56:22.788'!
initialize

	preferredItemCount := 10.
	super initialize.! !

!SdClassFinder methodsFor: 'testing' stamp: 'mt 4/17/2011 10:14:15.233'!
isCurrentElementNew

	^ (Smalltalk includesKey: self currentElement) not! !

!SdClassFinder methodsFor: 'accessing' stamp: 'mt 4/17/2011 10:06:20.147'!
organization

	^ SystemOrganization! !

!SdClassFinder methodsFor: 'updating' stamp: 'mt 4/17/2011 15:30:46.864'!
updateCategoryButton

	super updateCategoryButton.

	self currentPackage
		ifNotNil: [self ui protocolBtn icon: UiSilkIcons packageIcon].! !

!SdFinder class methodsFor: 'shortcuts' stamp: 'mt 4/17/2011 09:27:06.456'!
tokenForAllCategories

	^ ';'! !

!SdFinder class methodsFor: 'shortcuts' stamp: 'mt 4/17/2011 09:27:04.42'!
tokenForAllElements

	^ '.'! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 09:21:38.102'!
addCategory

	self subclassResponsibility.! !

!SdFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 10:14:57.794'!
allCategories

	^ self organization categories! !

!SdFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 09:33:32.985'!
allElements

	self subclassResponsibility.! !

!SdFinder methodsFor: 'building' stamp: 'mt 4/17/2011 10:16:53.261'!
buildCategoryItemFor: aCategoryName

	self subclassResponsibility.! !

!SdFinder methodsFor: 'building' stamp: 'mt 4/17/2011 15:36:44.39'!
buildCategoryItemsFor: categories

	^ categories collect: [:category | self buildCategoryItemFor: category].! !

!SdFinder methodsFor: 'building' stamp: 'mt 4/17/2011 10:16:41.228'!
buildElementItemFor: anElementName

	self subclassResponsibility.! !

!SdFinder methodsFor: 'building' stamp: 'mt 4/17/2011 15:36:18.739'!
buildElementItemsFor: elements

	^ elements collect: [:element | self buildElementItemFor: element].! !

!SdFinder methodsFor: 'building' stamp: 'mt 6/22/2011 10:41:26.93'!
buildItemsForCategories: categories elements: elements

	self sortOrder = #categoriesBeforeElements ifTrue: [
		^ (self buildCategoryItemsFor: categories),
			(self buildElementItemsFor: elements)].
		
	self sortOrder = #alphabetical ifTrue: [
		| labels |
		labels := SortedCollection new
			sortBlock: [:e1 :e2 | e1 key <= e2 key].
		labels
			addAll: (categories collect: [:cat | cat -> #category]);
			addAll: (elements collect: [:e | e -> #element]).
			
		^ labels collect: [:label |
			label value = #category
				ifTrue: [self buildCategoryItemFor: label key]
				ifFalse: [self buildElementItemFor: label key]]].! !

!SdFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 11:09:28.629'!
categoriesFor: aCategoryName
	"Allow one level of subcategories."
	
	^ #()! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 4/17/2011 09:10:54.787'!
category

	^ category! !

!SdFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 16:43:48.188'!
category: aCategory matches: aToken

	^ aCategory startsWith: aToken  ! !

!SdFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 17:04:24.828'!
categoryFor: anElementName

	^ self organization categoryOfElement: anElementName.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 11:15:22.559'!
chooseCategory

	category := self currentCategoryInList.
	
	self updateCategoryButton.
	
	self ui searchField theText: self class tokenForAllElements.
	self ui searchField selectAll.
	
	self updateResults.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 09:23:05.795'!
chooseElement

	self subclassResponsibility.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 11:12:50.55'!
chooseItem
	"Decide the next action depending on the current search token and the current protocol."

	self currentCategoryInList
		ifNotNil: [^ self chooseCategory].
		
	^ self chooseElement! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 12:05:11.457'!
chooseNextResult

	self ui resultList isEmpty ifTrue: [^ self].
	
	self ui resultList currentRow
		ifNil: [self ui resultList currentRow: 1]
		ifNotNil: [self ui resultList currentRow:
			(self ui resultList currentRow + 1 min: self ui resultList size)].! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 12:05:07.766'!
choosePrevResult

	self ui resultList isEmpty ifTrue: [^ self].
	
	self ui resultList currentRow
		ifNil: [self ui resultList currentRow: 1]
		ifNotNil: [self ui resultList currentRow:
			(self ui resultList currentRow - 1 max: 1)].! !

!SdFinder methodsFor: 'actions' stamp: 'mt 6/30/2011 10:44:30.903'!
clear

	category
		ifNotNil: [:cat | | matchedCategories |
			category := nil.
			self updateResults: self class tokenForAllCategories.

			"Select the current category in the list."
			matchedCategories := self ui resultList select: [:item | item text asString startsWith: cat].
			matchedCategories
				ifEmpty: [self update]
				ifNotEmpty: [self ui resultList currentItem: matchedCategories first]]
		ifNil: [
			self ui searchField theText: self class tokenForAllCategories.
			self updateResults.
			self ui searchField selectAll.]



	
	
	! !

!SdFinder methodsFor: 'actions' stamp: 'mt 5/11/2011 09:38:41.767'!
createPreviewPanelFor: anElement

	self subclassResponsibility.! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 2/15/2012 10:58:05.8'!
currentCategory

	category ifNotNil: [^ category].
	
	self ui resultList currentItem ifNil: [^ nil].
	
	^ self ui resultList currentItem
		at: #category
		ifAbsent: []! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 2/15/2012 10:57:59.489'!
currentCategoryInList
	
	self ui resultList currentItem ifNil: [^ nil].
	
	^ self ui resultList currentItem
		at: #category
		ifAbsent: []! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 4/17/2011 09:26:59.967'!
currentElement
		
	| token |
	token := self ui searchField theText asString.
	
	({self class tokenForAllElements. self class tokenForAllCategories} includes: token)
		ifTrue: [^ '']
		ifFalse: [^ token asSymbol].! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 2/15/2012 10:57:50.43'!
currentElementInList

	self ui resultList currentItem ifNil: [^ nil].
	
	^ self ui resultList currentItem
		at: #element
		ifAbsent: []! !

!SdFinder methodsFor: 'submorphs-add/remove' stamp: 'mt 2/15/2012 16:47:33.425'!
delete

	super delete.
	self deleted.! !

!SdFinder methodsFor: 'signals' stamp: 'mt 2/15/2012 16:47:24.104'!
deleted

	self emit.! !

!SdFinder methodsFor: 'drawing' stamp: 'mt 2/15/2012 15:47:13.558'!
drawOn: aCanvas

	aCanvas
		fillRectangle: self innerBounds
		color: (Color gray: 0.85).
		
	self outerBorderWidth > 0 ifTrue: [
		aCanvas
			frameRoundRect: self outerBounds
			radius: 3
			width: self outerBorderWidth  
			color: (Color gray: 0.3)].! !

!SdFinder methodsFor: 'drawing' stamp: 'mt 2/15/2012 10:59:52.149'!
drawOverlayOn: aCanvas
	
	self hasSubmorphKeyboard ifFalse: [
		aCanvas
			fillRectangle: self outerBounds
			color: ((Color gray: 0.85) alpha: 0.5)].! !

!SdFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 16:43:58.319'!
element: anElement matches: aToken

	^ anElement startsWith: aToken  ! !

!SdFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 10:06:01.159'!
elementsFor: aCategoryName

	^ self organization listAtCategoryNamed: aCategoryName  ! !

!SdFinder methodsFor: 'events' stamp: 'mt 4/17/2011 09:27:34.612'!
grabKeyboard

	self ui searchField grabKeyboard.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 09:29:31.283'!
hideCategory

	self ui protocolBtn delete.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 5/11/2011 09:40:54.508'!
hidePreview

	previewPanel ifNil: [^ self].
	previewPanel delete.
	previewPanel := nil.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 09:29:28.951'!
hideResults

	self ui resultList delete.! !

!SdFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 09:38:33.333'!
iconFor: anElementName

	^ nil! !

!SdFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:45:32.551'!
iconForCategory

	self subclassResponsibility.! !

!SdFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:46:08.294'!
iconForCategoryAdd

	self subclassResponsibility.! !

!SdFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:47:59.367'!
iconForCategoryEdit

	self subclassResponsibility.! !

!SdFinder methodsFor: 'initialization' stamp: 'mt 2/15/2012 16:06:17.19'!
initialize

	super initialize.

	self ui setupUi: self.
	self ui panel
		layoutInset: 0;  
		vResizing: #shrinkWrap.
		
	self ui searchField
		deferEditSignalTime: 250. 
	
	self connect: self ui searchField signal: #textEdited: toSelector: #updateResults.
	self connect: self ui searchField signal: #textEdited: toSelector: #updateSelection.
	
	self connect: self ui resultList signal: #currentTextChanged: toSelector: #updateSearchField.
	
	"Preview"
	self connect: self ui resultList signal: #currentNodeChanged: toSelector: #triggerPreview.
	self connect: self ui resultList viewport eventHandler signal: #focusLost toSelector: #hidePreview.
	self connect: self ui searchField eventHandler signal: #focusLost toSelector: #hidePreview.

	self connect: self ui searchField signal: #textChanged: toSelector: #updateActionButton.
	self connect: self ui searchField signal: #textChanged: toSelector: #updateCategoryButton.
	
	self connect: self ui actionBtn signal: #clicked: toSelector: #chooseItem.
	"self connect: self ui searchField signal: #returnPressed: toSelector: #chooseItem."
	self connect: self ui resultList signal: #clicked: toSelector: #chooseItem.
	
	self connect: self ui searchField eventHandler signal: #mouseWheelUp: to: self ui resultList verticalScrollBar selector: #decreaseValueBySingleStep.
	self connect: self ui searchField eventHandler signal: #mouseWheelDown: to: self ui resultList verticalScrollBar selector: #increaseValueBySingleStep.
	
	"Access keyboard focus updates in important edit fields."
	self flag: #refactor.
	self connect: self ui searchField eventHandler signal: #focusReceived toSelector: #redrawLater.
	self connect: self ui searchField eventHandler signal: #focusLost toSelector: #redrawLater.
	self connect: self ui resultList viewport eventHandler signal: #focusReceived toSelector: #redrawLater.
	self connect: self ui resultList viewport eventHandler signal: #focusLost toSelector: #redrawLater.
	
	"keyboard shortcuts"
	self ui searchField eventHandler on: Character arrowDown send: #chooseNextResult to: self.
	self ui searchField eventHandler on: Character arrowUp send: #choosePrevResult to: self.
	self ui searchField eventHandler on: Character escape send: #clear to: self.
	self ui searchField eventHandler on: #(shift) -> Character cr send: #addCategory to: self.
	self ui searchField eventHandler on: Character cr send: #chooseItem to: self.
	
	self
		color: (Color gray: 0.85);
		outerBorderWidth: 1;
		layoutInset: (0@1 corner: 0@0);
		vResizing: #shrinkWrap;  
		update.! !

!SdFinder methodsFor: 'testing' stamp: 'mt 4/17/2011 09:50:03.078'!
isCurrentElementNew

	self subclassResponsibility.! !

!SdFinder methodsFor: 'testing' stamp: 'mt 4/17/2011 10:01:02.529'!
isValid
	"Indicate whether calculcations, updates and signal emittations work properly. "
	
	^ true! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 4/17/2011 10:04:06.659'!
organization

	^ self subclassResponsibility! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 2/15/2012 15:45:57.799'!
outerBorderWidth

	^ outerBorderWidth ifNil: [0]! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 2/15/2012 15:45:48.33'!
outerBorderWidth: anInteger

	outerBorderWidth := anInteger.! !

!SdFinder methodsFor: 'geometry' stamp: 'mt 2/15/2012 15:46:33.178'!
outerBounds

	^ self bounds outsetBy: self outerBorderWidth! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/22/2011 12:53:35.849'!
preferredItemCount
	"Number of visible items before scrolling is used."
	
	^ preferredItemCount ifNil: [preferredItemCount := 5]! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/22/2011 12:55:54.628'!
preferredItemCount: anInteger
	
	preferredItemCount := anInteger.
	
	self updateResultListExtent.! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/21/2011 16:30:42.671'!
previewPanel

	^ previewPanel! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/21/2011 16:30:50.225'!
previewPanel: aMorph

	previewPanel := aMorph.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 4/17/2011 09:29:25.131'!
showCategory

	self ui protocolBtn owner ifNotNil: [^ self].

	self ui inputContainer addMorphFront: self ui protocolBtn.! !

!SdFinder methodsFor: 'actions' stamp: 'mt 2/15/2012 16:00:27.012'!
showPreview
	"Show a preview for the current element if one is selected."
	
	| currentElement |
	currentElement := self currentElementInList.
	
	currentElement ifNil: [^ self].
	
	"Discard the current preview."
	previewPanel ifNotNil: [self hidePreview].
	
	self createPreviewPanelFor: currentElement.
	previewPanel ifNil: [^ self].
	
	"Ensure visibility of preview box."
	self ui resultList selection currentBounds ifNotNil: [:selectionBounds |
		| globalRight |
		globalRight := (self localPointToGlobal: self topRight) x.
		(globalRight + previewPanel width) > ActiveWorld right
			ifTrue: [(selectionBounds left - previewPanel width) < ActiveWorld left
				ifFalse: [previewPanel topRight: selectionBounds topLeft]
				ifTrue: [previewPanel topLeft: selectionBounds bottomLeft]]
			ifFalse: [previewPanel topLeft: globalRight @ selectionBounds top].
		previewPanel bottom: (ActiveWorld bottom min: previewPanel bottom)].
		
	previewPanel openInWorld.	! !

!SdFinder methodsFor: 'actions' stamp: 'mt 6/22/2011 12:55:44.784'!
showResults

	self updateResultListExtent.
	
	self ui resultList owner ifNil: [
		self ui panel addMorphBack: self ui resultList].! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/22/2011 10:24:35.464'!
sortOrder

	^ sortOrder ifNil: [sortOrder := #categoriesBeforeElements]! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/22/2011 10:25:55.034'!
sortOrder: aSymbol
	"#categoriesBeforeElements, #alphabetical"

	sortOrder = aSymbol ifTrue: [^ self].
	
	sortOrder := aSymbol.
	self updateResults.! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 2/15/2012 11:02:13.846'!
theClass

	^ theClass! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 2/15/2012 11:02:05.368'!
theClass: aClass

	theClass := aClass.
	self clear.! !

!SdFinder methodsFor: 'accessing' stamp: 'mt 6/21/2011 17:08:23.928'!
theClassSilent: aClass
	"Change the current class without notification."
	
	theClass := aClass.! !

!SdFinder methodsFor: 'actions - private' stamp: 'mt 2/15/2012 16:06:10.985'!
triggerPreview

	self hidePreview.
		
	self
		removeAlarm: #showPreview;
		addAlarm: #showPreview
		after: 250.! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 4/17/2011 09:12:59.695'!
ui

	^ ui ifNil: [ui := SdMethodFinderUi new]! !

!SdFinder methodsFor: 'accessing - ui' stamp: 'mt 6/21/2011 16:02:58.597'!
ui: aMorph

	ui := aMorph.! !

!SdFinder methodsFor: 'updating' stamp: 'mt 4/17/2011 09:30:44.872'!
update

	self
		updateResults;
		updateSelection;
		updateActionButton;
		updateCategoryButton.! !

!SdFinder methodsFor: 'updating' stamp: 'mt 4/17/2011 10:02:05.212'!
updateActionButton

	self isValid
		ifFalse: [^ self ui actionBtn hide]
		ifTrue: [self ui actionBtn show].
	
	self currentElement ifEmpty: [^ self ui actionBtn hide].
	
	(self currentCategory notNil and: [category isNil]) ifTrue: [
		^ self ui actionBtn icon: self iconForCategoryEdit].
	
	self isCurrentElementNew
		ifFalse: [self ui actionBtn icon: UiSilkIcons pencilIcon]
		ifTrue: [
			({self class tokenForAllElements. self class tokenForAllCategories}
				includes: self currentElement)
					ifTrue: [self ui actionBtn hide]
					ifFalse: [	self ui actionBtn icon: UiFugueIcons asteriskYellowIcon]].! !

!SdFinder methodsFor: 'updating' stamp: 'mt 4/17/2011 09:47:46.568'!
updateCategoryButton

	self ui protocolBtn disconnectSignal: #clicked: from: self.

	category
		ifNil: [
			self hideCategory.
			
			(self currentCategory isNil and: [self currentElement notEmpty]) ifTrue: [
				"Show protocol button as action to create a new protocol."
				self ui inputContainer
					addMorph: self ui protocolBtn
					inFrontOf: self ui actionBtn.
				self ui protocolBtn
					icon: self iconForCategoryAdd;
					buttonStyle: #iconOnly;
					balloonText: 'Add new category'.
				self connect: self ui protocolBtn signal: #clicked: toSelector: #addCategory.]]
		ifNotNil: [
			self showCategory.
			
			self ui protocolBtn
				icon: self iconForCategory;
				buttonStyle: #textBesidesIcon;
				text: ('<font color="#AAAAAA">', category, '</font>') asHtmlText;
				balloonText: 'Discard filter'.
				
			self connect: self ui protocolBtn signal: #clicked: toSelector: #clear.]! !

!SdFinder methodsFor: 'updating - results' stamp: 'mt 2/15/2012 16:05:18.107'!
updateItemsForResults
	"Icons or text or items may have to be updated."
	
	self ui resultList items do: [:listWidgetItem |
		(listWidgetItem includesKey: #element)
			ifTrue: [ | s i t |
				s := listWidgetItem at: #element.
				i := self iconFor: s.
				t := self category ifNil: [(s escapeHtmlText,
					' <font color="#AAAAAA">(',
					(self categoryFor: s),
					')</font>') asHtmlText] ifNotNil: [s].
					
				i ~~ listWidgetItem icon ifTrue: [listWidgetItem icon: i].
				t ~= listWidgetItem text ifTrue: [listWidgetItem text: t]]].! !

!SdFinder methodsFor: 'updating - results' stamp: 'mt 1/23/2012 09:47:21.991'!
updateResultListExtent

	self ui resultList height: 
		UiItemViewColumnSpec defaultItemExtent y 
			* (self ui resultList size min: self preferredItemCount)
			+ 1.! !

!SdFinder methodsFor: 'updating - results' stamp: 'mt 4/17/2011 09:41:20.518'!
updateResults

	self updateResults: self ui searchField theText.  ! !

!SdFinder methodsFor: 'updating - results' stamp: 'mt 2/15/2012 11:03:08.506'!
updateResults: stringOrText

	| token elements categories |
	token := stringOrText asString asSymbol.

	(self isValid not or: [token isEmpty]) ifTrue: [
		self ui resultList clear.
		^ self hideResults].

	"Find all elements, consider the current category and search token."
	elements := ((category
		ifNil: [self allElements]
		ifNotNil: [:cat | self elementsFor: cat])
		select: [:selector | token = self class tokenForAllElements or: [self element: selector matches: token]]) sorted.

	"Add categories to result if no current category is set."
	categories := ((category
		ifNil: [self allCategories]
		ifNotNil: [self categoriesFor: category])
		select: [:cat | token = self class tokenForAllCategories or: [self category: cat matches: token]]) sorted.
	
	"Only update the list if any changes occured."
	categories, elements = (self ui resultList items
		"Use extra property and not the text of the item to allow more rich information to be displayed, e.g., the category for an element."
		collect: [:item | item at: #symbol]) asArray
		ifTrue: [^ self updateItemsForResults].
	
	"Discard the old contents of the list because all new contents have been gathered."
	self ui resultList clear.
	
	self ui resultList addItemList: (self
		buildItemsForCategories: categories
		elements: elements).
	
	self ui resultList isEmpty
		ifTrue: [self hideResults]
		ifFalse: [self showResults].! !

!SdFinder methodsFor: 'updating' stamp: 'mt 2/15/2012 15:54:41.089'!
updateSearchField
	"Completes the search field with the current text in the result list. Select that part that has not been typed yet."

	| userText currentItemToken currentSearchToken i |
	self ui resultList currentItem ifNil: [^ self].
	
	currentItemToken := (self ui resultList currentItem at: #symbol) asString.
	currentSearchToken := self ui searchField theText asString.

	currentItemToken = currentSearchToken 
		ifTrue: [^ self].
	
	userText := currentSearchToken allButLast: self ui searchField selectedText size.
	
	(currentItemToken startsWith: userText)
		ifTrue: [i := userText size + 1].

	self ui searchField theText: currentItemToken.
	
	i
		ifNil: [self ui searchField selectAll]
		ifNotNil: [self ui searchField select: (i to: self ui searchField theText size)].
			
	self grabKeyboard.
! !

!SdFinder methodsFor: 'updating' stamp: 'mt 2/15/2012 11:02:56.314'!
updateSelection
	"Try to find an exact match in the result list and select that item."
	
	self ui resultList currentItem: (self ui resultList items
		detect: [:item | (item at: #symbol) = self currentElement]
		ifNone: []).! !

SdFinder subclass: #SdItemFinder
	instanceVariableNames: 'classFinder methodFinder classLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdItemFinder commentStamp: 'mt 6/21/2011 15:38:00.676' prior: 0!
A generic finder for packages, classes, methods, ...!

!SdItemFinder methodsFor: 'actions' stamp: 'mt 6/21/2011 15:59:32.825'!
addCategory

	"Not possible."! !

!SdItemFinder methodsFor: 'queries' stamp: 'mt 6/21/2011 17:59:26.059'!
allElements

	^ self filterByClass
		ifTrue: [methodFinder allElements]
		ifFalse: [classFinder allElements]! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 6/30/2011 11:07:43.645'!
categoryChosen: categoryName

	(PackageOrganizer default packageNames includes: categoryName)
		ifTrue: [self packageChosen: categoryName].
		
	self emit.! !

!SdItemFinder methodsFor: 'actions' stamp: 'mt 6/22/2011 13:15:37.297'!
chooseCategory

	self filterByClass
		ifTrue: [self
			protocolChosen: self currentCategoryInList
			class: methodFinder theClass]
		ifFalse: [self categoryChosen: self currentCategoryInList].
		
	self close.! !

!SdItemFinder methodsFor: 'actions' stamp: 'mt 6/22/2011 13:15:43.13'!
chooseElement

	self currentElementInList ifNil: [^ self].

	self filterByClass
		ifTrue: [
			self
				selectorChosen: self currentElementInList
				class: methodFinder theClass.
			self methodChosen: (MethodReference
				class: methodFinder theClass
				selector: self currentElementInList)]
		ifFalse: [self classChosen: (Smalltalk at: self currentElementInList)].
		
	self close.! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 6/21/2011 16:22:30.883'!
classChosen: aClass

	self emit.! !

!SdItemFinder methodsFor: 'actions' stamp: 'mt 6/22/2011 13:14:15.804'!
clear

	self close.! !

!SdItemFinder methodsFor: 'actions' stamp: 'mt 6/22/2011 13:14:10.865'!
close

	self owner ifNotNil: [:o | o delete].! !

!SdItemFinder methodsFor: 'actions' stamp: 'mt 6/21/2011 16:31:52.432'!
createPreviewPanelFor: anElement

	self filterByClass
		ifTrue: [
			methodFinder createPreviewPanelFor: anElement.
			previewPanel := methodFinder previewPanel]
		ifFalse: [
			classFinder createPreviewPanelFor: anElement.
			previewPanel := classFinder previewPanel].! !

!SdItemFinder methodsFor: 'accessing' stamp: 'mt 6/21/2011 15:57:55.899'!
currentElement
		
	| tokens |
	tokens := self tokens.
	tokens ifEmpty: [^ ''].
	
	({self class tokenForAllElements. self class tokenForAllCategories} includes: tokens last)
		ifTrue: [^ '']
		ifFalse: [^ tokens last asSymbol].! !

!SdItemFinder methodsFor: 'testing' stamp: 'mt 6/21/2011 15:49:31.391'!
filterByClass

	^ methodFinder isValid! !

!SdItemFinder methodsFor: 'icons' stamp: 'mt 6/21/2011 17:31:37.063'!
iconForCategory

	^ self filterByClass
		ifTrue: [methodFinder iconForCategory]
		ifFalse: [classFinder iconForCategory].! !

!SdItemFinder methodsFor: 'icons' stamp: 'mt 6/21/2011 17:31:42.652'!
iconForCategoryAdd

	^ self filterByClass
		ifTrue: [methodFinder iconForCategoryAdd]
		ifFalse: [classFinder iconForCategoryAdd].! !

!SdItemFinder methodsFor: 'icons' stamp: 'mt 6/21/2011 17:31:49.259'!
iconForCategoryEdit

	^ self filterByClass
		ifTrue: [methodFinder iconForCategoryEdit]
		ifFalse: [classFinder iconForCategoryEdit].! !

!SdItemFinder methodsFor: 'initialization' stamp: 'mt 6/22/2011 14:10:57.209'!
initialize

	"Use my UI to let the helper objects fill my result list."
	classFinder := SdClassFinder new ui: self ui.
	methodFinder := SdMethodFinder new ui: self ui.
	
	classLabel := UiLabel new.
	
	super initialize.
	
	classFinder
		sortOrder: #alphabetical;
		preferredItemCount: 10.
	methodFinder
		sortOrder: #alphabetical;
		preferredItemCount: 10.
	
	self ui searchField
		deferEditSignalTime: 500.
		
	self ui panel color: (Color gray: 0.9).! !

!SdItemFinder methodsFor: 'testing' stamp: 'mt 6/21/2011 17:28:44.459'!
isCurrentElementNew

	^ false! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 6/22/2011 13:01:24.463'!
methodChosen: aMethodReference

	self emit.! !

!SdItemFinder methodsFor: 'accessing' stamp: 'mt 6/21/2011 15:58:55.943'!
organization

	^ self filterByClass
		ifTrue: [methodFinder organization]
		ifFalse: [classFinder organization]! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 6/30/2011 11:06:44.034'!
packageChosen: packageName

	self emit.! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 6/21/2011 16:22:07.071'!
protocolChosen: aProtocolName class: aClass

	self emit.! !

!SdItemFinder methodsFor: 'signals' stamp: 'mt 6/21/2011 16:22:24.59'!
selectorChosen: aSelector class: aClass

	self emit.! !

!SdItemFinder methodsFor: 'accessing' stamp: 'mt 6/21/2011 18:53:32.419'!
tokenDelimiter

	^ $#! !

!SdItemFinder methodsFor: 'accessing' stamp: 'mt 6/21/2011 18:52:18.675'!
tokens

	^ self ui searchField theText asString
		findTokens: self tokenDelimiter! !

!SdItemFinder methodsFor: 'updating' stamp: 'mt 6/21/2011 17:42:49.704'!
updateCategoryButton

	self hideCategory.! !

!SdItemFinder methodsFor: 'updating' stamp: 'mt 6/22/2011 14:06:26.336'!
updateClassLabel

	self filterByClass ifFalse: [^ classLabel delete].
	
	classLabel text: (classFinder buildElementItemFor: methodFinder theClass name) text.
	
	classLabel owner ifNil: [
		self ui panel addMorph: classLabel after: self ui inputContainer].! !

!SdItemFinder methodsFor: 'updating - results' stamp: 'mt 6/22/2011 14:02:10.545'!
updateResults: stringOrText

	| tokens finder |
	tokens := self tokens.
	
	methodFinder
		theClassSilent: nil;
		isMeta: false.
	
	tokens size >= 2 ifTrue: [
		"filter by class"
		| class |
		class := (classFinder allElements
			detect: [:e | classFinder element: e matches: tokens first]
			ifNone: []) ifNotNil: [:className | Smalltalk at: className].
		methodFinder theClassSilent: class].
	
	tokens size = 3 ifTrue: [
		methodFinder isMeta: true].
	
	finder := self filterByClass
		ifTrue: [methodFinder]
		ifFalse: [classFinder].
	
	tokens
		ifEmpty: [finder updateResults: stringOrText]
		ifNotEmpty: [finder updateResults: tokens last].
		
	self updateClassLabel.! !

!SdItemFinder methodsFor: 'updating' stamp: 'mt 2/15/2012 11:06:23.661'!
updateSearchField
	"Completes the search field with the current text in the result list. Select that part that has not been typed yet."
	
	| tokens userText prefixText currentItemToken currentSearchToken i |
	self ui resultList currentItem ifNil: [^ self].
	
	tokens := self tokens.
	
	"tokens size = 1 ifTrue: [^ super updateSearchField]."
	
	currentItemToken := (self ui resultList currentItem at: #symbol) asString.
	currentSearchToken := tokens
		ifEmpty: ['']
		ifNotEmpty: [tokens last].

	currentItemToken = currentSearchToken 
		ifTrue: [^ self].
	
	userText := currentSearchToken allButLast: self ui searchField selectedText size.
	
	(currentItemToken startsWith: userText)
		ifTrue: [i := userText size + 1]
		ifFalse: [i := 1].

	prefixText := tokens allButLast
		inject: ''
		into: [:text :token | text, token, self tokenDelimiter].
	i := i + prefixText size.
		
	self ui searchField theText: prefixText, currentItemToken.
	
	i
		ifNil: [self ui searchField selectAll]
		ifNotNil: [self ui searchField select: (i to: self ui searchField theText size)].
			
	self grabKeyboard.
! !

!SdItemFinder methodsFor: 'updating' stamp: 'mt 2/15/2012 11:06:35.421'!
updateSelection
	"Select any item that is a close match."
	
	| tokens check |
	tokens := self tokens.
	
	tokens ifEmpty: [^ self ui resultList currentItem: nil].
	
	check := self filterByClass
		ifTrue: [[:item | methodFinder
				element: (item at: #symbol)
				matches: tokens last]]
		ifFalse: [[:item | classFinder
			element: (item at: #symbol)
			matches: tokens last]].
	
	self ui resultList currentItem: (self ui resultList items
		detect: check
		ifNone: []).! !

SdFinder subclass: #SdMethodFinder
	instanceVariableNames: 'sideBtn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdMethodFinder class
	instanceVariableNames: 'iconCache'!

SdMethodFinder class
	instanceVariableNames: 'iconCache'!

!SdMethodFinder class methodsFor: 'custom icons' stamp: 'mt 4/14/2011 20:00:18.291'!
arrowUpDownIcon

	^ self icons
		at: #arrowUpDown
		ifAbsentPut: [
			| form canvas |
			form := Form extent: 16@16 depth: 32.
			canvas := form getCanvas.
			
			canvas
				translucentImage: UiFugueIcons control270SmallIcon
				at: 0 @ 3;
				translucentImage: UiFugueIcons control090SmallIcon
				at: 0 @ -3.
				
			form]! !

!SdMethodFinder class methodsFor: 'custom icons' stamp: 'mt 4/14/2011 20:09:44.359'!
blankIcon

	^ self icons
		at: #blank
		ifAbsentPut: [Form extent: 16@16 depth: 32].! !

!SdMethodFinder class methodsFor: 'as yet unclassified' stamp: 'mt 5/17/2011 12:59:18.715'!
iconForClass: aClassDescription

	(aClassDescription inheritsFrom: Morph)
		ifTrue: [^ aClassDescription widgetClassIcon].

	(aClassDescription inheritsFrom: TestCase) ifFalse: [^ nil].
	
	^ (aClassDescription lastRun at: #errors)
		ifNotEmpty: [UiDiagonaIcons icon0401Small]
		ifEmpty: [(aClassDescription lastRun at: #failures)
			ifNotEmpty: [UiDiagonaIcons icon0404Small]
			ifEmpty: [(aClassDescription lastRun at: #passed)
				ifNotEmpty: [UiDiagonaIcons icon0402Small]
				ifEmpty: [UiDiagonaIcons icon0410Small]]]! !

!SdMethodFinder class methodsFor: 'method icons' stamp: 'mt 5/17/2011 12:09:19.492'!
iconForClass: aClassDescription selector: aSelector
	"Answer an icon to be shown for the selector aSymbol in aClassDescription."

	((aClassDescription inheritsFrom: TestCase) and: [aSelector startsWith: #test])
		ifTrue: [^ self iconForTestClass: aClassDescription selector: aSelector].

	aClassDescription methodDictionary at: aSelector ifPresent: [ :method |
		method literalsDo: [ :literal |
			(literal == #halt or: [ literal == #halt: or: [ literal == #haltIfNil or: [ literal == #haltIf: or: [ literal == #haltOnce or: [ literal == #haltOnce: or: [ literal == #haltOnCount: or: [ literal == #halt:onCount: ] ] ] ] ] ] ])
				ifTrue: [ ^ UiSilkIcons exclamationIcon].
			(literal == #flag: or: [ literal == #needsWork or: [ literal == #notYetImplemented ] ])
				ifTrue: [ ^ UiSilkIcons flagGreenIcon].

			literal == #emit
				ifTrue: [^ UiSilkIcons transmitIcon].
			literal == #emitAlways
				ifTrue: [^ UiSilkIcons transmitBlueIcon].
			(literal == #shouldBeImplemented or: [literal == #subclassResponsibility])
				ifTrue: [^ UiFugueIcons controlStopSquareSmallIcon] ] ].
		
		
		
	^ (self isOverride: aSelector in: aClassDescription)
		ifTrue: [
			(self isOverridden: aSelector in: aClassDescription)
				ifTrue: [ self arrowUpDownIcon ]
				ifFalse: [ UiFugueIcons control090SmallIcon ] ]
		ifFalse: [
			(self isOverridden: aSelector in: aClassDescription)
				ifTrue: [ UiFugueIcons control270SmallIcon ]
				ifFalse: [ self blankIcon ] ]! !

!SdMethodFinder class methodsFor: 'method icons' stamp: 'mt 5/17/2011 12:59:59.821'!
iconForTestClass: aClassDescription selector: aSelector
	"Answer an icon to be shown for the selector aSymbol in aClassDescription."

	"((aClassDescription inheritsFrom: TestCase) and: [aSelector startsWith: #test])
		ifFalse: [^ nil]."
		
	^ ((aClassDescription lastRun at: #errors) includes: aSelector)
		ifTrue: [UiDiagonaIcons icon0401Small]
		ifFalse: [((aClassDescription lastRun at: #failures) includes: aSelector)
			ifTrue: [UiDiagonaIcons icon0404Small]
			ifFalse: [((aClassDescription lastRun at: #passed) includes: aSelector)
				ifTrue: [UiDiagonaIcons icon0402Small]
				ifFalse: [UiDiagonaIcons icon0410Small]]]
! !

!SdMethodFinder class methodsFor: 'custom icons' stamp: 'mt 4/14/2011 19:51:48.27'!
icons

	^ iconCache ifNil: [iconCache := Dictionary new]! !

!SdMethodFinder class methodsFor: 'support' stamp: 'mt 4/27/2011 15:12:25.288'!
isOverridden: aSelector in: aClass
	aClass allSubclassesDo: [ :class |
		(class includesSelector: aSelector)
			ifTrue: [ ^ true ] ].
	^ false! !

!SdMethodFinder class methodsFor: 'support' stamp: 'mt 4/27/2011 15:12:07.62'!
isOverride: aSelector in: aClass
	aClass allSuperclassesDo: [ :class | 
		(class includesSelector: aSelector) 
			ifTrue: [ ^ true ] ].
	^ false! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 4/18/2011 15:47:23.429'!
addCategory

	self currentElement ifEmpty: [^ self].
	
	self organization addCategory: self currentElement.
	
	"TODO: Move notification into class categorizer."
	SystemChangeNotifier uniqueInstance trigger: ((AddedEvent
		item: self currentElement
		kind: AbstractEvent protocolKind)
		itemClass: self theClass).! !

!SdMethodFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 09:34:14.123'!
allElements

	^ self theClass selectors! !

!SdMethodFinder methodsFor: 'building' stamp: 'mt 2/15/2012 15:54:08.65'!
buildCategoryItemFor: aCategoryName

	^ UiListWidgetItem new
		text: (aCategoryName, ' <font color="#AAAAAA">(', (self elementsFor: aCategoryName) size asString, ' method(s))</font>') asHtmlText;
		icon: self iconForCategory;
		at: #category put: aCategoryName;
		at: #symbol put: aCategoryName;
		yourself! !

!SdMethodFinder methodsFor: 'building' stamp: 'mt 2/15/2012 15:52:24.355'!
buildElementItemFor: anElementName

	^ UiListWidgetItem new
		text: (self category
			ifNil: [(anElementName escapeHtmlText, ' <font color="#AAAAAA">(', (self categoryFor: anElementName), ')</font>') asHtmlText]
			ifNotNil: [anElementName]);
		icon: (self iconFor: anElementName);
		at: #element put: anElementName;
		at: #symbol put: anElementName;
		yourself! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 4/18/2011 14:23:44.072'!
chooseElement

	self currentElement ifEmpty: [^ self].
	
	self isCurrentElementNew
		ifTrue: [category
			ifNil: [^ self selectorChosen: self currentElement isMeta: self isMeta]
			ifNotNil: [^ self selectorChosen: self currentElement isMeta: self isMeta protocol: category]].
	
	self selectorChosen: self currentElement isMeta: self isMeta.! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 7/17/2011 22:13:29.399'!
createPreviewPanelFor: anElement

	^ previewPanel := SdPreviewBuilder createMethodPreviewFor: (
		MethodReference
			class: (self isMeta
				ifTrue: [self theClass theMetaClass]
				ifFalse: [self theClass])
			selector: anElement)! !

!SdMethodFinder methodsFor: 'queries' stamp: 'mt 4/17/2011 09:38:52.26'!
iconFor: anElementName

	^ self class iconForClass: self theClass selector: anElementName! !

!SdMethodFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:46:02.656'!
iconForCategory

	^ UiSilkIcons tagOrangeIcon! !

!SdMethodFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:46:15.175'!
iconForCategoryAdd

	^ UiSilkIcons tagBlueAddIcon! !

!SdMethodFinder methodsFor: 'icons' stamp: 'mt 4/17/2011 09:48:09.681'!
iconForCategoryEdit

	^ UiSilkIcons tagBlueEditIcon! !

!SdMethodFinder methodsFor: 'initialization' stamp: 'mt 2/15/2012 16:07:55.81'!
initialize

	super initialize.
	
	sideBtn := UiToolButton new
		text: #instance;
		icon: SdIcons instanceSideIcon;
		buttonStyle: #iconOnly;
		layoutInset: 0.
		
	self ui inputContainer addMorphFront: sideBtn.
	
	self connect: sideBtn signal: #clicked: toSelector: #toggleSide.
	self ui searchField eventHandler on: #(cmd) -> $q send: #toggleSide to: self.! !

!SdMethodFinder methodsFor: 'testing' stamp: 'mt 4/18/2011 14:21:27.112'!
isCurrentElementNew

	^ (self theClass includesSelector: self currentElement) not! !

!SdMethodFinder methodsFor: 'testing' stamp: 'mt 4/18/2011 14:05:08.566'!
isMeta

	sideBtn ifNil: [^ false].
	
	^ sideBtn text = #class! !

!SdMethodFinder methodsFor: 'accessing' stamp: 'mt 6/21/2011 18:12:32.635'!
isMeta: aBoolean

	aBoolean
		ifTrue: [sideBtn text: #class]
		ifFalse: [sideBtn text: #instance].! !

!SdMethodFinder methodsFor: 'testing' stamp: 'mt 4/17/2011 10:01:22.085'!
isValid
	"The method finder needs a class."
	
	^ self theClass notNil! !

!SdMethodFinder methodsFor: 'accessing' stamp: 'mt 4/18/2011 14:17:58.907'!
organization

	^ self theClass organization! !

!SdMethodFinder methodsFor: 'signals' stamp: 'mt 4/18/2011 13:03:31.962'!
selectorChosen: aSymbol isMeta: aBoolean
	"Emitted whenever the user decided for a symbol. This can be a new one."
	
	self emit.! !

!SdMethodFinder methodsFor: 'signals' stamp: 'mt 4/18/2011 13:04:03.486'!
selectorChosen: aSymbol isMeta: aBoolean protocol: protocolName
	"Emitted whenever the user decided for a symbol. This can be a new one."
		
	self emit.! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 4/18/2011 13:59:35.056'!
showCategory

	self ui protocolBtn owner ifNotNil: [^ self].

	"Side button should always be the first one."
	self ui inputContainer addMorph: self ui protocolBtn after: sideBtn.! !

!SdMethodFinder methodsFor: 'accessing' stamp: 'mt 4/18/2011 14:19:36.992'!
theClass

	super theClass ifNil: [^ nil].

	^ self isMeta
		ifTrue: [super theClass theMetaClass]
		ifFalse: [super theClass]! !

!SdMethodFinder methodsFor: 'actions' stamp: 'mt 4/18/2011 14:02:00.607'!
toggleSide

	self isMeta
		ifTrue: [sideBtn text: #instance]
		ifFalse: [sideBtn text: #class].
		
	self
		updateSideBtn;
		clear.! !

!SdMethodFinder methodsFor: 'updating' stamp: 'mt 4/28/2011 15:28:16.48'!
updateSideBtn

	self isMeta
		ifTrue: [sideBtn
			icon: SdIcons classSideIcon;
			balloonText: 'class side - click to toggle (CMD+Q)'.]
		ifFalse: [sideBtn
			icon: SdIcons instanceSideIcon;
			balloonText: 'instance side - click to toggle (CMD+Q)'].! !

Morph subclass: #SdMethodEditor
	uses: TSdDynamicAccessor + TSdDynamicMenusForMethod
	instanceVariableNames: 'sourceCodeEdit summaryContainer toggleBtn separator deleteBtn saveBtn revertBtn scrollingModeBtn moveBtn dynamicBtn toolbar toolbarVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

SdMethodEditor class
	uses: TSdDynamicAccessor classTrait + TSdDynamicMenusForMethod classTrait
	instanceVariableNames: ''!

!SdMethodEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 18:30:06.088'!
aboutToDelete

	self emitInOwnerChain.! !

!SdMethodEditor methodsFor: 'converting' stamp: 'mt 5/2/2011 10:47:46.783'!
asString

	^ '{1} >> {2}' format: {
		self theClass name.
		self selector}! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 4/11/2011 11:26:23.287'!
collapse

	toggleBtn checked: false.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 4/28/2011 14:37:03.669'!
decreaseScrollingLimit

	self sourceCodeEdit scrollingLimit:
		(self sourceCodeEdit scrollingLimit - 5 max: 5).! !

!SdMethodEditor methodsFor: 'submorphs-add/remove' stamp: 'mt 2/15/2012 16:57:00.011'!
delete

	self aboutToDelete.
	SdFadingToolbar hideAllToolbars.
	super delete.
	self deleted.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 4/12/2011 17:31:36.671'!
deleteMethod

	deleteBtn buttonStyle = #iconOnly
		"User needs to confirm deletion!!"
		ifTrue: [
			deleteBtn buttonStyle: #textBesideIcon.
			self toolbar updateLayout. "new toolbar extent"
			^ self]  
		"User confirmed the deletion..."
		ifFalse: [
			self theClass removeSelector: self selector.
			deleteBtn buttonStyle: #iconOnly.
			self delete].! !

!SdMethodEditor methodsFor: 'signals' stamp: 'mt 2/15/2012 16:38:36.551'!
deleted

	self emit.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 5/12/2011 16:20:46.509'!
disableHightlight

	self sourceCodeEdit displayMode ~= #highlight
		ifTrue: [^ self "already not highlighted"].

	self ignoresColorMappings: false.
	self sourceCodeEdit
		displayMode: #normal;
		updateFocusColor: self sourceCodeEdit hasKeyboard.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 5/12/2011 16:20:30.541'!
enableHightlight

	self sourceCodeEdit displayMode == #highlight
		ifTrue: [^ self "already highlighted"].

	self ignoresColorMappings: true.
	self sourceCodeEdit
		displayMode: #highlight;
		updateFocusColor: self sourceCodeEdit hasKeyboard.
	self redrawLater.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 5/23/2011 17:10:46.212'!
expand

	toggleBtn checked: true.! !

!SdMethodEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 18:38:45.267'!
focusLostDownwards

	self emitInOwnerChain.! !

!SdMethodEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 18:38:41.016'!
focusLostUpwards

	self emitInOwnerChain.! !

!SdMethodEditor methodsFor: 'events' stamp: 'mt 5/11/2011 12:08:47.163'!
grabKeyboard

	self expand.
	sourceCodeEdit grabKeyboard.! !

!SdMethodEditor methodsFor: 'events' stamp: 'mt 2/15/2012 16:35:38.373'!
handleMouseMove: evt
	"Handle every mouse move event."

	"Do not handle mouse moves if dragging something."
	evt hand submorphs ifNotEmpty: [^ self].

	^ self mouseMove: evt! !

!SdMethodEditor methodsFor: 'testing' stamp: 'mt 4/22/2011 17:28:13.727'!
hasKeyboard

	^ self sourceCodeEdit textMorph hasKeyboard! !

!SdMethodEditor methodsFor: 'testing' stamp: 'mt 4/14/2011 13:51:34.921'!
hasUnacceptedChanges

	^ sourceCodeEdit hasUnacceptedChanges! !

!SdMethodEditor methodsFor: 'toolbar - actions' stamp: 'mt 2/15/2012 16:31:52.242'!
hideToolbar

	self toolbarVisible ifFalse: [^ self].
	
	self toolbar delete.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 4/28/2011 14:36:48.858'!
increaseScrollingLimit

	self sourceCodeEdit scrollingLimit:
		self sourceCodeEdit scrollingLimit + 5.! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 3/15/2012 16:51:14.271'!
initialize

	super initialize.
	self initializeEventHandler.

	sourceCodeEdit := SdSourceCodeEdit new
		hResizing: #spaceFill;
		verticalScrollBarPolicy: #alwaysOff;
		areaResizable: true;
		outerBorderWidth: 0;
		scrollingMode: #limit;
		scrollBarThickness: 9;
		colorFocusBackground: Color white;
		colorFocusBorder: (Color gray: 0.3);
		colorBackground: (Color gray: 0.85).
	sourceCodeEdit verticalScrollBar buttonMode: #none.
		
	self connect: sourceCodeEdit signal: #editingFinished: toSelector: #updateToolbarButtons.
	self connect: sourceCodeEdit signal: #textChanged: toSelector: #updateToolbarButtons.
	self connect: sourceCodeEdit signal: #symbolActivated: toSelector: #symbolActivated:.
	self connect: sourceCodeEdit signal: #classActivated: toSelector: #classActivated:.
	self connect: sourceCodeEdit signal: #methodActivated: toSelector: #methodActivated:.
	self connect: sourceCodeEdit signal: #objectActivated: toSelector: #objectActivated:.
	self connect: sourceCodeEdit signal: #traceActivated: toSelector: #traceActivated:.

	self addMorphBack: sourceCodeEdit.

	self
		initializeToolbar;
		initializeSummaryContainer;
		initializeKeyboardShortcuts.

	separator := Morph new
		extent: 10@1;
		color: (Color gray: 0.6);
		hResizing: #spaceFill.
		
	self
		color: Color red;
		layoutPolicy: SdMethodEditorLayout new;
		updateLayout.! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 2/15/2012 16:32:57.037'!
initializeEventHandler

	self eventHandler: UiEventHandler new.
	
	self connect: self eventHandler signal: #mouseEntered: toSelector: #showToolbar.
	self connect: self eventHandler signal: #mouseMoved: toSelector: #reopenToolbar.! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 6/28/2011 18:39:33.76'!
initializeKeyboardShortcuts

	sourceCodeEdit eventHandler on: #(cmd) -> $W send: #tryDelete to: self.
	sourceCodeEdit eventHandler on: #(cmd) -> $O send: #requestOpenSelection to: self.
	
	sourceCodeEdit eventHandler on: #(cmd) -> Character arrowUp send: #focusLostUpwards to: self.
	sourceCodeEdit eventHandler on: #(cmd) -> Character arrowDown send: #focusLostDownwards to: self.! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 3/15/2012 16:50:54.776'!
initializeSummaryContainer
	"That container is visible of the editor is collapsed."

	| closeBtn |
	summaryContainer := Morph new
		color: (Color gray: 0.85);
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill.  
	
	toggleBtn := UiToolButton new
		color: (Color gray: 0.85);
		autoRaise: true;  
		checkable: true;
		hResizing: #spaceFill.
	
	closeBtn := UiToolButton new
		color: (Color gray: 0.85);
		autoRaise: true;  
		buttonStyle: #iconOnly;
		icon: UiFugueIcons minusWhiteIcon.
	
	summaryContainer
		addMorphBack: toggleBtn;
		addMorphBack: closeBtn.
	
	self connect: toggleBtn signal: #toggled: toSelector: #updateLayout.
	self connect: toggleBtn signal: #clicked: to: self selector: #showToolbar.
	self connect: closeBtn signal: #clicked: toSelector: #tryDelete.
	
	self addMorphBack: summaryContainer.! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 2/15/2012 16:27:48.764'!
initializeToolbar

	self toolbar: SdFadingToolbar new.
	
	self toolbarActions do: [:action |
		| button |
		action size = 1
			ifTrue: [self toolbar addSpacerToEdge: action first]
			ifFalse: [button := (action sixth ifNil: [UiToolButton]) new
				autoRaise: true;
				color: (Color gray: 0.3);  
				buttonStyle: #iconOnly;
				icon: action third;
				balloonText: action fourth.
		
				self connect: button signal: #clicked: toSelector: action fifth.
				self toolbar addButton: button edge: action first.
				action second ifNotNil: [:iname | self instVarNamed: iname put: button]]].

	"Configure move button for dragging of method editors."
	moveBtn target: self.
	self connect: moveBtn eventHandler signal: #mouseDragStarted: toSelector: #hideToolbar.

	"Set the message, that is displayed to the user to confirm the deletion."	
	deleteBtn text: '<font color="#FFFFFF">Sure?</font>'.

	self updateToolbarButtons.! !

!SdMethodEditor methodsFor: 'testing' stamp: 'mt 7/4/2011 17:17:30.089'!
isExpanded

	^ toggleBtn checked! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 7/31/2011 20:16:29.855'!
method

	^ [self theClass >> self selector]
		on: Error do: []! !

!SdMethodEditor methodsFor: 'layout' stamp: 'mt 3/15/2012 16:47:34.548'!
minExtent

	"WORKAROUND: Fix buggy layouting due to #minExtent implementation in some cases."
"	self flag: #workaround.
	self owner ifNotNil: [:o |
		self hResizing == #spaceFill ifTrue: [self width: self owner width].
		self vResizing == #spaceFill ifTrue: [self height: self owner height]]."
	
	^ super minExtent! !

!SdMethodEditor methodsFor: 'geometry' stamp: 'mt 5/20/2011 12:49:03.938'!
optimalWidth

	"If source code is not visible, width does not matter."
	toggleBtn checked ifFalse: [^ 0].

	^ self sourceCodeEdit optimalWidth! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 4/28/2011 17:54:25.114'!
reference

	^ MethodReference
		class: self theClass
		selector: self selector! !

!SdMethodEditor methodsFor: 'toolbar - actions' stamp: 'mt 2/15/2012 16:31:56.756'!
reopenToolbar

	self toolbarVisible ifFalse: [^ self].
	self toolbar reopen.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 7/31/2011 15:20:23.858'!
requestOpenSelection
	"Take the current selection, convert it into a symbol and request open operation."
	
	sourceCodeEdit selectedText ifEmpty: [
		"If the cursor is at a text link, follow that link."
		((sourceCodeEdit theText attributesAt: sourceCodeEdit cursorPosition)
			detect: [:attr | attr isKindOf: PluggableTextAttribute]
			ifNone: [^ self]) actOnClickFor: nil].
	
	sourceCodeEdit selectedSelector
		ifNotNil: [:s | self symbolActivated: s]
		ifNil: [self symbolActivated: sourceCodeEdit selectedText asString withBlanksTrimmed asSymbol].! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 4/20/2011 15:56:50.883'!
revertMethod

	sourceCodeEdit revertChanges.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 4/13/2011 15:33:27.075'!
saveMethod

	sourceCodeEdit acceptChanges.! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:24:51.55'!
selector

	^ sourceCodeEdit selector! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 4/12/2011 15:51:33.205'!
selectorText

	| result |
	result := self selector asString asText.
	self sourceCodeEdit hasUnacceptedChanges
		ifTrue: [result addAttribute: TextEmphasis bold].
	"result addAttribute: (TextFontReference toFont: (sourceCodeEdit textMorph textStyle defaultFont))."
	^ result
	! !

!SdMethodEditor methodsFor: 'actions - dynamic' stamp: 'mt 7/31/2011 17:40:58.886'!
showMenuForMethod
	
	(self menuForMethod: self method) ifNotNil: [:m | m
		popUpAt: ActiveHand position
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false].! !

!SdMethodEditor methodsFor: 'toolbar - actions' stamp: 'mt 2/15/2012 16:32:01.639'!
showToolbar

	self toolbarVisible ifFalse: [^ self].
	
	self toolbar popUpFor: self.! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 4/4/2011 15:10:26.493'!
sourceCodeEdit

	^ sourceCodeEdit! !

!SdMethodEditor methodsFor: 'signals' stamp: 'mt 6/28/2011 17:38:34.33'!
symbolActivated: aSymbol

	sourceCodeEdit hideDynamicContext.
	self emitInOwnerChain.! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 2/15/2012 16:24:45.699'!
theClass

	^ sourceCodeEdit theClass! !

!SdMethodEditor methodsFor: 'accessing' stamp: 'mt 2/15/2012 16:19:12.592'!
theClass: aClassOrMetaClass selector: aSymbol

	sourceCodeEdit
		theClass: aClassOrMetaClass
		selector: aSymbol.

	sourceCodeEdit reset.
	self updateLayout.! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 4/28/2011 14:41:02.334'!
toggleScrollingMode

	self sourceCodeEdit scrollingMode:
		((Dictionary newFrom: {#never -> #limit. #limit -> #always. #always -> #never. #none -> #none})
			at: self sourceCodeEdit scrollingMode).
			
	scrollingModeBtn icon: ((Dictionary newFrom: {#limit -> UiSilkIcons bulletGreenIcon. #always -> UiSilkIcons bulletPinkIcon. #never -> UiSilkIcons bulletBlackIcon. #none -> nil}) at: self sourceCodeEdit scrollingMode).! !

!SdMethodEditor methodsFor: 'toolbar - accessing' stamp: 'mt 2/15/2012 16:29:50.314'!
toolbar

	^ toolbar! !

!SdMethodEditor methodsFor: 'toolbar - accessing' stamp: 'mt 2/15/2012 16:29:57.084'!
toolbar: aToolbar

	toolbar := aToolbar.
	toolbar ifNotNil: [self toolbarVisible: true].! !

!SdMethodEditor methodsFor: 'initialization' stamp: 'mt 7/26/2011 15:51:34.342'!
toolbarActions

	^ {
	{#top. #moveBtn. UiFugueIcons arrowMoveIcon. 'Move method editor'. #yourself. SdDraggableButton}.
	{#top}.
	{#top. #dynamicBtn. UiFugueIcons lightningIcon. 'Access Dynamic Information'. #showMenuForMethod. nil}.
	{#top}.
	{#right. nil. UiFugueIcons minusWhiteIcon. 'Close method editor (CMD+W)'. #tryDelete. nil}.
	{#right. nil. UiSilkIcons eyeIcon. 'Collapse method editor'. #collapse. nil}.
	{#top}.
	{#top. #saveBtn. UiSilkIcons diskIcon. 'Save changed source'. #saveMethod. nil}.
	{#top. #revertBtn. UiFugueIcons arrowReturn180LeftIcon. 'Discard changed source'. #revertMethod. nil}.
	{#top}.
	{#top. #deleteBtn. UiSilkIcons binIcon. 'Delete selector'. #deleteMethod. nil}.
	{#left. #scrollingModeBtn. UiSilkIcons bulletGreenIcon. 'Toggle Scrolling Mode'. #toggleScrollingMode. nil}.
	{#left. nil. UiFugueIcons sortMinusIcon. 'Decrease height'. #decreaseScrollingLimit. nil}.
	{#left. nil. UiFugueIcons sortPlusIcon. 'Increase height'. #increaseScrollingLimit. nil}.
	
	"EXPERIMENTAL"
	"{#bottom. nil. UiFugueIcons lightningIcon. 'Highlight'. #xToggleHighlight. nil}.
	{#left. nil. UiFugueIcons arrowReturn180LeftIcon. 'Reset'. #xReset}.
	{#left. nil. UiFugueIcons magnifierZoomInIcon. 'Zoom in'. #xScaleUp}.
	{#left. nil. UiFugueIcons magnifierZoomOutIcon. 'Zoom out'. #xScaleDown}.
	{#left. nil. UiSilkIcons fontIcon. 'Change Font'. #xChangeFont}.
	{#left. nil. UiFugueIcons editSizeIcon. 'Override Signature Size'. #xOverrideSignatureSize}.
	{#left. nil. UiSilkIcons commentsDeleteIcon. 'Remove comments'. #xRemoveComments}.
	{#left. nil. UiFugueIcons arrowResizeIcon. 'Remove leading tabs'. #xRemoveLeadingTabs}.
	{#left. nil. UiFugueIcons wandIcon. 'Replace tabs with spaces'. #xReplaceTabsWithSpaces}.
	{#left. nil. UiFugueIcons balloonEllipsisIcon. 'Reduce to four lines'. #xReduceToFourLines}.
	{#left. nil. UiFugueIcons uiScrollBarIcon. 'Use vertical scroll bars'. #xUseScrollBars}"}! !

!SdMethodEditor methodsFor: 'toolbar - accessing' stamp: 'mt 2/15/2012 16:30:07.674'!
toolbarVisible

	^ self toolbar notNil and: [toolbarVisible ifNil: [false]]! !

!SdMethodEditor methodsFor: 'toolbar - accessing' stamp: 'mt 2/15/2012 16:30:01.943'!
toolbarVisible: aBoolean

	toolbarVisible := aBoolean.
	
	aBoolean
		ifFalse: [self toolbar ifNotNil: [:tb | tb delete]].! !

!SdMethodEditor methodsFor: 'actions' stamp: 'mt 4/29/2011 15:33:35.511'!
tryDelete

	| msg |
	self hasUnacceptedChanges
		ifFalse: [^ self delete].
		
	msg := SdOverlayMessageBox new
		title: 'Close #', self selector;
		message: 'There are unaccepted changes.' icon: UiSilkIcons informationIcon.
	msg addAction: 'Save changes.' icon: UiSilkIcons diskMultipleIcon receiver: self selectors: #(saveMethod tryDelete).
	msg addAction: 'Ignore changes.' icon: UiSilkIcons binIcon receiver: self selectors: #(delete).
	msg addAction: 'Abort this action.' icon: UiSilkIcons cancelIcon.
	
	msg showAbove: self.  ! !

!SdMethodEditor methodsFor: 'updating' stamp: 'mt 3/15/2012 17:01:07.839'!
updateLayout

	toggleBtn checked
		ifTrue: [
			summaryContainer hide.
			sourceCodeEdit show.
			sourceCodeEdit grabKeyboard].
	toggleBtn checked not
		ifTrue: [
			sourceCodeEdit hide.
			summaryContainer show].

	toggleBtn text: self selectorText.

	self toolbarVisible: toggleBtn checked.
	
	self layoutChanged.! !

!SdMethodEditor methodsFor: 'updating' stamp: 'mt 7/26/2011 15:54:14.548'!
updateToolbarButtons

	revertBtn visible: sourceCodeEdit hasUnacceptedChanges.
	saveBtn visible: revertBtn visible.
	dynamicBtn visible: (self method ifNil: [false ] ifNotNil: [:m | m isTestMethod not]).! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:44:10.34'!
xChangeFont

	| menu |
	menu := MenuMorph new
		defaultTarget: self;
		add: 'Envy Code R' action: #xUseEnvy;
		add: 'Segoe UI' action: #xUseSegoe;
		add: 'Accujen' action: #xUseAccujen.
		
	menu popUpForHand: ActiveHand in: ActiveWorld.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 17:38:37.35'!
xOverrideSignatureSize

	| attrs symbols anythingRemoved |
	attrs := self sourceCodeEdit textMorph styler customTextAttributes.
	symbols := #(patternBinary patternKeyword patternUnary).
	anythingRemoved := false.

	symbols do: [:s | (attrs includesKey: s)	ifTrue: [
		anythingRemoved := true.
		attrs removeKey: s]].

	anythingRemoved ifTrue: [^ self].

	symbols do: [:s |
		attrs at: s put: {TextFontReference toFont:
			(self sourceCodeEdit textMorph textStyle fontOfPointSize: 10)}].
		
	self sourceCodeEdit textMorph style.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 18:55:32.157'!
xReduceToFourLines
	
	self sourceCodeEdit readOnly: true.  
	
	self sourceCodeEdit theText:
		((((((self theClass >> self selector) getSource asString copyWithRegex: '"[^"]*"' matchesReplacedWith: '')
		lines inject: '' into: [:sum :each | each withBlanksTrimmed
			ifNotEmpty: [sum, ((each startsWith: String tab)
					ifTrue: [each allButFirst: 1]
					ifFalse: [each]), String cr] ifEmpty: [sum]])
		copyWithRegex: '\t' matchesReplacedWith: ' ')
		lines first: 5) inject: '' into: [:sum :each | sum, each, String cr]).
		
	self sourceCodeEdit textMorph style.
	self sourceCodeEdit append: '...'.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 18:02:51.206'!
xRemoveComments

	self sourceCodeEdit readOnly: true.
	
	self sourceCodeEdit theText:
		((self sourceCodeEdit theText asString copyWithRegex: '"[^"]*"' matchesReplacedWith: '')
		lines inject: '' into: [:sum :each | each withBlanksTrimmed ifNotEmpty: [sum, each, String cr] ifEmpty: [sum]])
		withBlanksTrimmed.
		
	self sourceCodeEdit textMorph style.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 18:15:02.322'!
xRemoveLeadingTabs

	self sourceCodeEdit readOnly: true.
	
	self sourceCodeEdit theText:
		((self theClass >> self selector) getSource asString lines inject: '' into: [:sum :each |
			each withBlanksTrimmed
				ifNotEmpty: [sum, ((each startsWith: String tab)
					ifTrue: [each allButFirst: 1]
					ifFalse: [each]), String cr]
				ifEmpty: [sum]])
		withBlanksTrimmed.
		
	self sourceCodeEdit textMorph style.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 18:39:46.937'!
xReplaceTabsWithSpaces

	self sourceCodeEdit readOnly: true.
	
	self sourceCodeEdit theText:
		(self sourceCodeEdit theText asString lines inject: '' into: [:sum :each |
			each withBlanksTrimmed
				ifNotEmpty: [sum, (each copyWithRegex: '\t' matchesReplacedWith: '  '), String cr]
				ifEmpty: [sum]])
		withBlanksTrimmed.
		
	self sourceCodeEdit textMorph style.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 18:03:28.368'!
xReset

	self sourceCodeEdit readOnly: false; reset.  ! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:36:23.432'!
xScaleDown

	| textStyle |
	textStyle := self sourceCodeEdit textMorph textStyle.
	self sourceCodeEdit textMorph
		font: (textStyle fontOfPointSize: textStyle defaultFont pointSize - 1);
		recompose.
! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:38:04.541'!
xScaleUp

	| textStyle |
	textStyle := self sourceCodeEdit textMorph textStyle.
	self sourceCodeEdit textMorph
		font: (textStyle fontOfPointSize: textStyle defaultFont pointSize + 1);
		recompose.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 5/10/2011 17:25:55.129'!
xToggleHighlight

	self ignoresColorMappings
		ifTrue: [self disableHightlight]  
		ifFalse: [self enableHightlight].! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:45:22.452'!
xUseAccujen

	self sourceCodeEdit textMorph
		font: (TextStyle named: #Accujen) defaultFont;
		recompose.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:45:17.3'!
xUseEnvy

	self sourceCodeEdit textMorph
		font: (TextStyle named: #'Bitmap Envy Code R') defaultFont;
		recompose.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/21/2011 17:01:45.95'!
xUseScrollBars

	self sourceCodeEdit verticalScrollBarPolicy: #alwaysOn.
	self sourceCodeEdit scrollBarThickness: 9.
	self sourceCodeEdit height: 100.! !

!SdMethodEditor methodsFor: 'actions - experimental' stamp: 'mt 4/20/2011 16:45:14.615'!
xUseSegoe

	self sourceCodeEdit textMorph
		font: (TextStyle named: #'Bitmap Segoe UI') defaultFont;
		recompose.! !

Morph subclass: #SdOverlayMessageBox
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdOverlayMessageBox class methodsFor: 'examples' stamp: 'mt 4/29/2011 10:28:12.065'!
example01

	| box |
	box := self new.
	box title: 'Example Message'.
	box message: 'Wanna clear the<br>transcript?' icon: UiSilkIcons helpIcon.
	box addAction: 'Yes.' icon: UiSilkIcons acceptIcon receiver: Transcript selector: #clear.
	box addAction: 'No!!' icon: UiSilkIcons cancelIcon.
	
	box
		extent: 200@200;
		center: ActiveWorld center;
		openInWorld.! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 4/29/2011 15:51:29.39'!
addAction: textOrString icon: aForm

	| button |
	button := UiPushButton new
		icon: aForm;
		text: textOrString;
		hResizing: #spaceFill.
	self connect: button signal: #clicked: toSelector: #delete.
	
	self ui buttonContainer addMorphBack: button.
	self updateShortcuts.
	
	^ button  ! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 4/29/2011 15:51:34.855'!
addAction: textOrString icon: aForm receiver: anObject selector: aSymbol

	| button |
	button := UiPushButton new
		icon: aForm;
		text: textOrString;
		hResizing: #spaceFill.
	self connect: button signal: #clicked: toSelector: #delete.
	self connect: button signal: #clicked: to: anObject selector: aSymbol.
	
	self ui buttonContainer addMorphBack: button.
	self updateShortcuts.
		
	^ button  ! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 4/29/2011 15:51:40.011'!
addAction: textOrString icon: aForm receiver: anObject selectors: someSymbols

	| button |
	button := UiPushButton new
		icon: aForm;
		text: textOrString;
		hResizing: #spaceFill.
	self connect: button signal: #clicked: toSelector: #delete.
	
	someSymbols do: [:symbol |
		self connect: button signal: #clicked: to: anObject selector: symbol].
	
	self ui buttonContainer addMorphBack: button.
	self updateShortcuts.
	
	^ button  ! !

!SdOverlayMessageBox methodsFor: 'geometry' stamp: 'mt 5/2/2011 15:30:50.387'!
extent: aPoint

	| extentChanged |
	extentChanged := aPoint ~= self extent.

	super extent: aPoint.

	extentChanged ifFalse: [^ self].
	
	(aPoint x > aPoint y and: [self ui buttonContainer submorphs size < 3])
		ifTrue: [self ui buttonContainer listDirection: #leftToRight]
		ifFalse: [self ui buttonContainer listDirection: #topToBottom].
		
	self ui buttonContainer
		layoutInset: (self ui buttonContainer listDirection = #leftToRight
			ifTrue: [(self width * 0.30)@0 corner: (self width * 0.30)@0]
			ifFalse: [(self width * 0.20)@0 corner: (self width * 0.20)@0]).
		
	(self ui buttonContainer listDirection = #leftToRight
		ifFalse: [#(0.1 0.2 0.5 0.9)]  
		ifTrue: [#(0.0 0.2 0.75 1.0)]) overlappingPairsWithIndexDo: [:top :bottom :index |
			(self ui panel submorphs at: index)
				frameFractions: (0@top corner: 1@bottom)].
			
	self ui buttonContainer submorphs size = 1 ifTrue: [
		self ui buttonContainer listCentering: #center.
		self ui buttonContainer submorphs first hResizing: #shrinkWrap].
	self ui buttonContainer submorphs size > 1 ifTrue: [
		self ui buttonContainer listCentering: #topLeft.
		self ui buttonContainer submorphs first hResizing: #spaceFill].! !

!SdOverlayMessageBox methodsFor: 'initialization' stamp: 'mt 5/12/2011 15:44:13.107'!
initialize

	super initialize.
	
	self ui setupUi: self.
	
	"Order morphs."
	self ui buttonContainer comeToFront.
	self ui messageContainer comeToFront.
	self ui titleLbl comeToFront.
	
	self eventHandler: UiEventHandler new. 
	
	self ignoresColorMappings: true.  ! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 5/2/2011 15:54:49.573'!
message: aString

	self ui messageLbl text: ('<font color="#FFFFFF">', aString, '</font>') asHtmlText.! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 5/2/2011 15:54:45.89'!
message: aString icon: anIcon

	self ui iconLbl form: anIcon.
	self ui messageLbl text: ('<font color="#FFFFFF">', aString, '</font>') asHtmlText.! !

!SdOverlayMessageBox methodsFor: 'popup' stamp: 'mt 4/29/2011 15:48:11.589'!
showAbove: aMorph

	self grabKeyboard.  

	self
		extent: aMorph extent;
		topLeft: aMorph topLeft;
		disableTableLayout: true.

	aMorph height < self minExtent y
		ifFalse: [^ aMorph addMorphFront: self].
		
	"Show NOT embedded in morph."
	self
		borderColor: Color white;
		borderWidth: 1;
		height: self minExtent y + 5;
		topLeft: (aMorph localPointToGlobal: aMorph topLeft);
		openInWorld.  ! !

!SdOverlayMessageBox methodsFor: 'configuration' stamp: 'mt 4/29/2011 10:26:32.788'!
title: aString

	self ui titleLbl text: ('<font color="#FFFFFF"><b>', aString, '</b></font>') asHtmlText.! !

!SdOverlayMessageBox methodsFor: 'accessing' stamp: 'mt 4/25/2011 17:14:24.177'!
ui

	^ ui ifNil: [ui := SdOverlayMessageBoxUi new]! !

!SdOverlayMessageBox methodsFor: 'initialization' stamp: 'mt 4/29/2011 15:51:56.612'!
updateShortcuts
	"Set number keys as shortcuts for buttons."
	
	self eventHandler removeAllShortcuts.
	
	self ui buttonContainer submorphs withIndexDo: [:button :index |
		self eventHandler on: (Character digitValue: index) send: #doClick to: button].! !

Morph subclass: #SdTestMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Testbed'!

!SdTestMorph methodsFor: 'accessing' stamp: 'mt 6/28/2011 16:24:26.253'!
value

	^ self valueOfProperty: #value ifAbsent: [nil]! !

!SdTestMorph methodsFor: 'accessing' stamp: 'mt 6/28/2011 16:29:53.927'!
value: aValue

	self setProperty: #value toValue: aValue.
	self valueChanged: aValue.! !

!SdTestMorph methodsFor: 'signals' stamp: 'mt 6/28/2011 16:20:40.323'!
valueChanged: aValue

	self emitInOwnerChain.! !

!SdTestMorph methodsFor: 'signals' stamp: 'mt 6/28/2011 16:23:55.029'!
valueChanged: aValue and: anotherValue

	self emitInOwnerChain.! !

Morph subclass: #SdTranscriptModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models'!

!SdTranscriptModel commentStamp: 'mt 4/18/2011 17:23:29.339' prior: 0!
I map transcript changes to signals. I am a morph because of the implementation of TranscriptStream>>#release.!

!SdTranscriptModel methodsFor: 'signals' stamp: 'mt 4/18/2011 17:19:37.539'!
cleared

	self emit.! !

!SdTranscriptModel methodsFor: 'signals' stamp: 'mt 4/18/2011 17:20:01.716'!
closed

	self emit.! !

!SdTranscriptModel methodsFor: 'signals' stamp: 'mt 4/18/2011 17:29:18.593'!
entryAppended: aString

	self emit.! !

!SdTranscriptModel methodsFor: 'initialization' stamp: 'mt 4/18/2011 17:19:17.698'!
initialize

	super initialize.
	
	Transcript addDependent: self.! !

!SdTranscriptModel methodsFor: 'updating' stamp: 'mt 4/18/2011 17:35:07.382'!
update: aSymbol

	aSymbol = #clearText ifTrue: [self cleared].
	aSymbol = #close ifTrue: [self closed].
	aSymbol = #appendEntry ifTrue: [self entryAppended: Transcript contents].! !

CustomHelp subclass: #SdHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Help'!

!SdHelp class methodsFor: 'construction' stamp: 'mt 7/31/2011 19:50:12.523'!
appendCode: aString toText: aText

	| snippet styler |
	snippet := aString asText.
	snippet addAttribute: (TextFontReference toFont: Preferences standardCodeFont).

	styler := SdTextStyler new.
	styler font: Preferences standardCodeFont.

	snippet := styler format: snippet.
	snippet := (styler styledTextFor: snippet).
	snippet addAttribute: (TextFontReference toFont: Preferences standardCodeFont).
		
	aText append: snippet.! !

!SdHelp class methodsFor: 'accessing' stamp: 'mt 7/31/2011 19:22:17.077'!
bookName

	^ 'Sight Dynamic IDE'! !

!SdHelp class methodsFor: 'pages' stamp: 'mt 9/1/2011 15:06:34.132'!
keyboardShortcuts

	^ SdHelpTopic
		title: 'Keyboard Shortcuts'
		icon: UiFugueIcons keyboardIcon
		contents: '<b>Keyboard Shortcuts</b><br>
1. General<br>
<i>These shortcuts need an element having keyboard focus within the IDE.</i><br>
ctrl + shift + f<tab>open finder (packages, classes, methods)<br>
2. Finder<br>
arrow up/down<tab>navigate in search results
escape<tab><tab><tab>exit current search scope
return<tab><tab><tab>choose current item or enter scope (i.e., package filter)<br>
2.1. Class Finder<br>
return<tab><tab><tab>open/create class or enter category scope
shift + return<tab><tab>create class category<br>
2.2. Method Finder<br>
return<tab><tab><tab>open/create class or enter protocol scope
shift + return<tab><tab>create method protocol
cmd + q<tab><tab><tab>toggle class/instance side<br>
3. Class Editor<br>
cmd + f<tab><tab>activate method finder
cmd + w<tab><tab>close comment editor, class definition editor, method editor<br>
4. Method Editor<br>
cmd + w<tab><tab><tab><tab><tab>close editor
cmd + arrow up/down<tab>focus previous/next method
cmd + o<tab><tab><tab><tab><tab>open selected symbol (i.e., selector, class, global variable)
ctrl<tab><tab><tab><tab><tab><tab>show/hide text links for dynamic information
cmd + s<tab><tab><tab><tab><tab>save changes<br>
5. Workspace<br>
cmd + d<tab><tab>evaluate current selection
cmd + o<tab><tab>evaluate current selection and open result (i.e., browse class or explore object)
cmd + t<tab><tab>trace current selection and open call tree<br>
6. Transcript<br>
<i>No keyboard shortcuts.</i><br>
7. Package Viewer<br>
return<tab>browse class/method source<br>
8. Callgraph Editor<br>
return<tab>browse method source'.! !

!SdHelp class methodsFor: 'accessing' stamp: 'mt 7/31/2011 19:23:08.21'!
pages

	^ #(keyboardShortcuts)! !

UiIcons subclass: #SdIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdIcons class methodsFor: 'accessing' stamp: 'mt 4/18/2011 13:51:34.853'!
classSideIcon
	
	^ Icons
		at: #classSide
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self classSideIconContents readStream) ].! !

!SdIcons class methodsFor: 'contents' stamp: 'mt 4/18/2011 13:50:50.089'!
classSideIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAARnQU1B
AACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAZdEVYdFNvZnR3YXJlAFBhaW50Lk5F
VCB2My41Ljg3O4BdAAABG0lEQVQ4T2NgoCmod9NgqHc1IM2OencFhjq3+UD8nqHe7T8c17kt
J2wYyDZ0jciGgNmuCdhdBHIuVDNHs/f/1oPL/n/4/uU/CIBoEJ+l0QPqIncHTEPAToQ4ee/d
82CN6KDryCqIAXVu51ENqLfnAAp+B0mazsyB6/NZWgvW4LG46v+rL+//r7l66D9Xiy/UFciB
C/I71PaUjX1wA1ACEW9Y1LtYUGiAlwTMAGQvgJwOEteakgL2ws7bZ/6LdIbAotYDNRzq3I4T
CsQN149CA9H1OQMo3FBAvVsAzABQNE46sR4lGkF8kDhUTQGOtODagD/gwFE4H3/SrneNYKgD
OREpGUPiHpi0gRYQDcBeArkIjCMw/Uy0SfgVAgD7EDtPjuUW4gAAAABJRU5ErkJggg=='! !

!SdIcons class methodsFor: 'accessing' stamp: 'mt 4/18/2011 13:51:50.81'!
instanceSideIcon
	
	^ Icons
		at: #instanceSide
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self instanceSideIconContents readStream) ].! !

!SdIcons class methodsFor: 'contents' stamp: 'mt 4/18/2011 13:50:55.035'!
instanceSideIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAAXNSR0IArs4c6QAAAARnQU1B
AACxjwv8YQUAAAAJcEhZcwAADsMAAA7DAcdvqGQAAAAZdEVYdFNvZnR3YXJlAFBhaW50Lk5F
VCB2My41Ljg3O4BdAAAAyElEQVQ4T2NgoCmY9F+DYcp/A9LsmP5fgWHqv/kMU/69B2r+j8D/
lhM2DGQbhkZkQ8DsBOwuAjsX1db/UOC4Hs2Qyf8dMA2ZAnYikpNh2v//xzTg33lUA+b/52CY
/O870QZALEIKXLDfMfwKdwKGCyBqkcJi4j8LygyY8l+CdAP+eaCGw5R/x4kOg8n/njOAwg0F
TPofQIIBBdjTwuT/Ddi8giIGSqV4weR/EcAofY5pEDCRgSwgGoC8BNIAxkBDMfxMtEn4FQIA
y3l/8JebCsMAAAAASUVORK5CYII='! !

!SdIcons class methodsFor: 'license' stamp: 'mt 4/18/2011 13:49:52.176'!
license

	^ 'Composed or self-made icons by Marcel Taeumel (c) 2011.'! !

UiTransformMorph subclass: #SdTransformMorph
	instanceVariableNames: 'footer icon text background'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:15:45.925'!
background

	^ background! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:15:54.341'!
background: aForm

	background := aForm.
	self redrawLater.! !

!SdTransformMorph methodsFor: 'drawing' stamp: 'mt 7/1/2011 22:16:34.181'!
drawBackgroundOn: aCanvas

	self background ifNil: [^ self].
	
	aCanvas
		clipBy: self bounds
		during: [:c | c
			paintImage: self background
			at: self topLeft - ((self background width - self width)@0)].! !

!SdTransformMorph methodsFor: 'drawing' stamp: 'mt 7/1/2011 22:35:32.781'!
drawFooterOn: aCanvas

	footer ifNil: [^ self].

	footer asMorph
		bottomRight: self bottomRight - (5@0);
		fullDrawOn: aCanvas.! !

!SdTransformMorph methodsFor: 'drawing' stamp: 'mt 7/1/2011 16:45:20.185'!
drawInnerShadowOn: aCanvas

	| c |
	c := Color black.

	aCanvas
		line: self topLeft + (0@1) to: self topRight + (-1@1) color: (c alpha: 0.5);
		line: self topLeft + (0@2) to: self topRight + (-1@2) color: (c alpha: 0.2).
			
	aCanvas
		line: self topLeft + (1@1) to: self bottomLeft + (1@ -1) color: (c alpha: 0.5);
		line: self topLeft + (2@2) to: self bottomLeft + (2@ -1) color: (c alpha: 0.2).
		
	aCanvas
		frameRectangle: self innerBounds
		color: (c alpha: 0.8).! !

!SdTransformMorph methodsFor: 'drawing' stamp: 'mt 7/1/2011 22:04:18.184'!
drawMessageOn: aCanvas

	| textMorph |
	self text ifNil: [^ self].
	
	"Only show a message if no real content is there."
	(self firstSubmorph ifNotNil: [:m | m submorphs size > 1])
		ifTrue: [^ self].
		
	textMorph := self text asMorph.
	textMorph topLeft: self topLeft + (self extent - textMorph extent // 2) + (self icon width + 5 @ 0).
	
	textMorph fullDrawOn: aCanvas.
	
	aCanvas
		translucentImage: self icon
		at: textMorph topLeft - (self icon width + 5 @ -2).! !

!SdTransformMorph methodsFor: 'drawing' stamp: 'mt 7/1/2011 22:35:38.064'!
drawOn: aCanvas

	super drawOn: aCanvas.
	
	self
		drawBackgroundOn: aCanvas;
		drawInnerShadowOn: aCanvas;
		drawFooterOn: aCanvas;
		drawMessageOn: aCanvas.! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:18:36.034'!
footer

	^ footer! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:18:43.691'!
footer: aText

	footer := aText.
	self redrawLater.! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 22:09:37.618'!
icon

	^ icon ifNil: [Form extent: 0@0]! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 21:52:17.797'!
icon: anIcon

	icon := anIcon.
	self redrawLater.! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 21:52:36.259'!
text

	^ text! !

!SdTransformMorph methodsFor: 'accessing' stamp: 'mt 7/1/2011 21:52:30.03'!
text: aText

	text := aText.
	self redrawLater.! !

OController subclass: #SdCompletionController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Support'!

!SdCompletionController methodsFor: 'menu morph' stamp: 'mt 4/28/2011 10:38:15.19'!
openMenuFor: anEditor

	super openMenuFor: anEditor.
	
	menuMorph ifNotNil: [
		menuMorph position: (anEditor morph editView localPointToGlobal: menuMorph position)].! !

!SdCompletionController methodsFor: 'menu morph' stamp: 'mt 4/28/2011 10:38:21.041'!
openXMenuFor: anEditor

	super openXMenuFor: anEditor.
	
	menuMorph ifNotNil: [
		menuMorph position: (anEditor morph editView localPointToGlobal: menuMorph position)].! !

BorderedMorph subclass: #SdIDE
	instanceVariableNames: 'toolbar finder border scrollArea windowSize windowBounds'
	classVariableNames: 'Images'
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdIDE class methodsFor: 'application' stamp: 'mt 3/22/2012 17:06:31.067'!
appName

	^ 'vivide'! !

!SdIDE class methodsFor: 'application' stamp: 'mt 5/2/2011 16:08:42.089'!
appVersion

	^ (Smalltalk at: #ConfigurationOfSightDynamic ifAbsent: [])
		ifNotNil: [:conf | [conf project currentVersion] on: Error do: []]! !

!SdIDE class methodsFor: 'application' stamp: 'mt 5/5/2011 17:11:27.832'!
appVersionString

	^ self appName, ' ', (self appVersion
		ifNil: ['*unknown version*']
		ifNotNil: [:version | version versionString, (version blessing == #development
			ifTrue: [' *dev*']
			ifFalse: [''])])! !

!SdIDE class methodsFor: 'images' stamp: 'mt 7/8/2011 11:59:45.495'!
background1

	^ self images
		at: #background1
		ifAbsentPut:[Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self background1Contents readStream)].! !

!SdIDE class methodsFor: 'images' stamp: 'mt 7/1/2011 16:12:34.84'!
background1Contents

 ^ 'iVBORw0KGgoAAAANSUhEUgAABAAAAAMACAQAAAAQs92GAAAACXBIWXMAAAsTAAALEwEAmpwY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'! !

!SdIDE class methodsFor: 'images' stamp: 'mt 7/8/2011 11:59:36.104'!
images

	^ Images ifNil: [Images := Dictionary new]! !

!SdIDE class methodsFor: 'instance creation' stamp: 'mt 5/1/2011 19:56:17.766'!
open

	^ self new open! !

!SdIDE class methodsFor: 'images' stamp: 'mt 7/1/2011 16:31:32.361'!
resetImages

	Images := Dictionary new.! !

!SdIDE methodsFor: 'add/remove - editors' stamp: 'mt 5/9/2011 10:08:05.979'!
addClassEditorFor: aClass

	^ self addClassEditorFor: aClass after: nil! !

!SdIDE methodsFor: 'add/remove - editors' stamp: 'mt 6/28/2011 18:20:09.642'!
addClassEditorFor: aClass after: anotherEditor

	| classEditor |
	classEditor := self
		addEditor: SdClassEditor
		after: anotherEditor.
	
	aClass ifNotNil: [:c |
		classEditor
			theClass: c;
			switchToEditUi].
			
	^ classEditor! !

!SdIDE methodsFor: 'add/remove - editors' stamp: 'mt 5/9/2011 10:06:13.508'!
addClassSelector

	^ self addClassEditorFor: nil  ! !

!SdIDE methodsFor: 'add/remove - columns' stamp: 'mt 7/4/2011 17:36:20.674'!
addColumnIn: container after: anotherMorph

	| column |
	column := SdClassEditorColumn new.

	anotherMorph
		ifNil: [container addMorphBack: column]
		ifNotNil: [container
			addMorph: column after: (container submorphs
				"Find resize handle."
				at: (container submorphs indexOf: anotherMorph) + 1)].
	
	self addResizeHandleFor: column.
	
	self
		connect: column
		signal: #editorDroppedInFrontOfMe:
		toSelector: #addColumnIn:for:inFrontOf:
		pattern: {#=. container. 1. 0}.

	self
		connect: column
		signal: #editorDroppedAfterMe:
		toSelector: #addColumnIn:for:after:
		pattern: {#=. container. 1. 0}.
	
	^ column! !

!SdIDE methodsFor: 'add/remove - columns' stamp: 'mt 6/28/2011 14:45:07.494'!
addColumnIn: container for: aMorph

	self addColumnIn: container for: aMorph inFrontOf: border.! !

!SdIDE methodsFor: 'add/remove - columns' stamp: 'mt 7/4/2011 17:44:21.924'!
addColumnIn: container for: aClassEditor after: anotherMorph

	^ (self addColumnIn: container after: anotherMorph)
		addMorphBack: aClassEditor! !

!SdIDE methodsFor: 'add/remove - columns' stamp: 'mt 7/4/2011 17:44:59.684'!
addColumnIn: container for: aClassEditor inFrontOf: anotherMorph

	^ (self addColumnIn: container inFrontOf: anotherMorph)
		addMorphBack: aClassEditor! !

!SdIDE methodsFor: 'add/remove - columns' stamp: 'mt 7/4/2011 17:44:34.792'!
addColumnIn: container inFrontOf: anotherMorph

	| column |
	column := SdClassEditorColumn new.
	
	container addMorph: column inFrontOf: anotherMorph.
	
	self addResizeHandleFor: column.
	
	self
		connect: column
		signal: #editorDroppedInFrontOfMe:
		toSelector: #addColumnIn:for:inFrontOf:
		pattern: {#=. container. 1. 0}.

	self
		connect: column
		signal: #editorDroppedAfterMe:
		toSelector: #addColumnIn:for:after:
		pattern: {#=. container. 1. 0}.
	
	^ column! !

!SdIDE methodsFor: 'add/remove - editors' stamp: 'mt 5/9/2011 10:03:42.515'!
addEditor: anEditorClass

	^ self addEditor: anEditorClass after: nil! !

!SdIDE methodsFor: 'add/remove - editors' stamp: 'mt 2/15/2012 16:55:07.56'!
addEditor: anEditorClass after: anotherEditor

	| editor |
	editor := anEditorClass new vResizing: #spaceFill. "spaceFill is an indicator for #isExpanded. See SdEditor."
	editor color: (Color gray: 0.85).

	anotherEditor
		ifNotNil: [self
			addColumnIn: anotherEditor column owner "scrollArea widget"
			for: editor
			after: anotherEditor column]
		ifNil: [self
			addColumnIn: scrollArea widget
			for: editor].
	
	"Scroll into view."
	self scrollToShow: editor.
	
	^ editor! !

!SdIDE methodsFor: 'add/remove - editors' stamp: 'mt 3/22/2012 11:29:10.187'!
addResizeHandleFor: aColumn

	| resizeHandle container toolBtn |
	container := SdColumnSeparator new.
	
	toolBtn := UiToolButton new
		buttonStyle: #iconOnly;
		color: (Color gray: 0.85);
		icon: (UiFugueIcons plusSmallWhiteIcon clippedTo: 9@9);
		autoRaise: true;
		layoutInset: 0;
		width: 9.
	self connect: toolBtn eventHandler signal: #mouseClicked: toSelector: #openEditorList:forColumn: pattern: {1. #=. aColumn}.
	
	resizeHandle := SdResizeHandle new vResizing: #spaceFill.
	resizeHandle target: aColumn.
	
	self connect: aColumn signal: #deleted to: container selector: #delete.

	container addAllMorphs: {toolBtn.resizeHandle}.

	aColumn owner
		addMorph: container
		after: aColumn.! !

!SdIDE methodsFor: 'accessing - private' stamp: 'mt 7/4/2011 17:50:31.435'!
border

	^ border! !

!SdIDE methodsFor: 'accessing - private' stamp: 'mt 6/28/2011 18:14:24.751'!
callGraphEditors

	^ self editors
		select: [:editor | editor isKindOf: SdCallGraphEditor]! !

!SdIDE methodsFor: 'accessing - private' stamp: 'mt 5/10/2011 18:21:09.725'!
classEditors

	^ self editors
		select: [:editor | editor isClassEditor]! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:45:49.209'!
columns

	^ self submorphs, scrollArea widget submorphs
		select: [:m | m isKindOf: SdColumn]

! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 7/4/2011 15:43:43.488'!
columnsFixed

	^ self submorphs
		select: [:m | m isKindOf: SdColumn]

! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 7/4/2011 15:43:31.668'!
columnsScrollable

	^ scrollArea widget submorphs
		select: [:m | m isKindOf: SdColumn]

! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 3/22/2012 15:12:11.297'!
createFullScreenButton
		
	| button |
	button := UiToolButton new
		buttonStyle: #iconOnly;
		icon: UiFugueIcons applicationResizeFullIcon;
		balloonText: 'Toggle full screen';
		layoutInset: (2@3 corner: 2@3).
	self connect: button signal: #clicked: toSelector: #toggleFullScreen.
	^ button! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 3/22/2012 15:16:28.679'!
createToolbarButtons
		
	^ ((SdEditor allSubclasses sortBy: [:c1 :c2 | c1 editorGroup <= c2 editorGroup])
		select: [:editorClass | editorClass isStandAlone]
		thenCollect: [:editorClass |
			| button |
			button := UiToolButton new
				"color: Color transparent;"
				autoRaise: true;
				buttonStyle: #iconOnly;
				icon: editorClass editorIcon;
				balloonText: editorClass editorDescription;
				layoutInset: (2@3 corner: 2@3).
			self connect: button signal: #clicked: toSelector: #addEditor: pattern: {#=. editorClass}.
			button]), {self createFullScreenButton}! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 4/26/2011 08:13:27.76'!
editors

	| result |
	result := OrderedCollection new.
	self columns do: [:col | result addAll: col submorphs].
	^ result! !

!SdIDE methodsFor: 'actions' stamp: 'mt 7/18/2011 15:02:07.306'!
exploreObject: anObject

	^ self exploreObject: anObject after: nil! !

!SdIDE methodsFor: 'actions' stamp: 'mt 7/18/2011 15:04:11.807'!
exploreObject: anObject after: anotherEditor

	(self addEditor: SdObjectExplorer after: anotherEditor)
		ifNotNil: [:explorer |
			explorer object: anObject.
			self scrollToShow: explorer.
			explorer grabKeyboard.
			^ explorer].! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 9/1/2011 11:01:42.354'!
focusedEditor

	^ self editors detect: [:editor | editor hasAnyKeyboard] ifNone: []! !

!SdIDE methodsFor: 'events-processing' stamp: 'mt 6/22/2011 14:18:12.231'!
handleListenEvent: aKeyboardEvent

	"<Ctrl-Shift-f>"
	(aKeyboardEvent isKeystroke
		and: [aKeyboardEvent controlKeyPressed]
		and: [aKeyboardEvent shiftPressed]
		and: [aKeyboardEvent keyValue = 6]
		and: [self hasAnyKeyboard])
		ifTrue: [self showFinder].! !

!SdIDE methodsFor: 'events-processing' stamp: 'mt 9/1/2011 13:25:39.829'!
handleTraceItEvent: aTraceItEvent

	| callgraph |
	callgraph := SdCallGraphEditor callgraphAt: aTraceItEvent.
	callgraph isEmpty ifTrue: [
		SdCallgraphTracer new
			callgraph: callgraph;
			trace].

	self openTrace: callgraph after: self focusedEditor.! !

!SdIDE methodsFor: 'actions' stamp: 'mt 6/28/2011 18:17:17.596'!
highlightReferences

	self callGraphEditors do: [:cge |
		self highlightReferencesFrom: cge].! !

!SdIDE methodsFor: 'actions' stamp: 'mt 5/12/2011 17:58:59.516'!
highlightReferences: someMethodReferences
	"Check open editors if they need highlight."

	self classEditors do: [:ce | ce methodEditors do: [:me |
		(someMethodReferences includes: me reference)
			ifTrue: [me enableHightlight]  
			ifFalse: [me disableHightlight]]].! !

!SdIDE methodsFor: 'actions' stamp: 'mt 5/16/2011 15:48:46.068'!
highlightReferencesFrom: aCallGraphEditor
	"Update highlighted references using a callgraph editor."
	
	aCallGraphEditor ifNil: [^ self].
	
	self highlightReferences: aCallGraphEditor references.  ! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 6/28/2011 14:53:17.93'!
ide

	^ self! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 9/1/2011 11:03:00.627'!
initialize

	super initialize.
	
	self
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: -1.  
		
	self
		initializeToolbar;
		initializeFinder;
		initializeEvents;
		initializeSystemChangeNotifications;
		initializeScrollArea.
	 	
	self addAllMorphs: {toolbar.scrollArea}.
	
	self connectSignal: #pinned toSelector: #pinMorph: pattern: #(0).
	self connectSignal: #unpinned toSelector: #unpinMorph: pattern: #(0).
	
	self connectSignal: #classActivated: toSelector: #openClass:after: pattern: #(1 0).
	self connectSignal: #methodActivated: toSelector: #openReference:after: pattern: #(1 0).
	self connectSignal: #objectActivated: toSelector: #exploreObject:after: pattern: #(1 0).
	self connectSignal: #traceActivated: toSelector: #openTrace:after: pattern: #(1 0).
! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 6/22/2011 13:18:49.746'!
initializeEvents

	ActiveHand addKeyboardListener: self.! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 6/30/2011 11:26:29.312'!
initializeFinder

	finder := SdItemFinder new.
	
	self connect: finder signal: #methodChosen: toSelector: #openReference:.
	self connect: finder signal: #classChosen: toSelector: #openClass:.
	self connect: finder signal: #packageChosen: toSelector: #openPackage:.
	self connect: finder signal: #categoryChosen: toSelector: #openCategory:.
	self connect: finder signal: #protocolChosen:class: toSelector: #openProtocol:class:.! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 3/15/2012 16:29:40.563'!
initializeScrollArea

	scrollArea := SdScrollArea new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		verticalScrollBarPolicy: #alwaysOff;
		horizontalScrollBarPolicy: #asNeeded;  
		widgetResizable: true;
		widget: (Morph new color: Color transparent);
		outerBorderWidth: 0.
		
	scrollArea transformMorph
		color: (Color gray: 0.3);
		background: SdIDE background1;
		icon: UiFugueIcons arrow180MediumIcon asGrayScale2;
		text: '<font color="#888888">Choose a tool from the side bar and start development.</font>' asHtmlText;
		footer: ('<font color="#888888">', SdIDE appVersion versionString, '</font>') asHtmlText.
	scrollArea horizontalScrollBar
		singleStep: 50;
		outerBorderWidth: 1;
		color: (Color gray: 0.3).  
		
	"Speedup redraw."
	scrollArea transformMorph drawCacheActive: true.  
		
	scrollArea widget
		layoutPolicy: SdTapeLayout new.
		
	border := SdColumnShadow new
		changeTableLayout;
		vResizing: #spaceFill;
		hResizing: #rigid;
		width: 20.
	border addAllMorphs: self createToolbarButtons.
	
	scrollArea widget addMorph: border.
	
	scrollArea connectSignal: #focusChanged: toSelector: #scrollToShowGlobal:.! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 1/31/2012 18:26:18.145'!
initializeSystemChangeNotifications

	SystemChangeNotifier uniqueInstance 
		notify: self ofSystemChangesOfItem: AbstractEvent expressionKind change: SdTraceItEvent changeKind using: #handleTraceItEvent:;
		notify: self ofSystemChangesOfItem: #test change: SdTraceItEvent changeKind using: #handleTraceItEvent:.! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 7/2/2011 09:32:00.086'!
initializeToolbar

	toolbar := SdColumnToolBar new.
	toolbar addAllMorphs: self createToolbarButtons.! !

!SdIDE methodsFor: 'visiting' stamp: 'mt 7/4/2011 17:48:24.148'!
loadState: anEditorState

	anEditorState loadIDE: self.! !

!SdIDE methodsFor: 'focus' stamp: 'mt 6/28/2011 14:45:49.441'!
onFocusChanged: aGlobalRectangle

	scrollArea scrollToShow: 
		((scrollArea widget globalPointToLocal: aGlobalRectangle topLeft)
			extent: aGlobalRectangle extent).! !

!SdIDE methodsFor: 'initialization' stamp: 'mt 2/12/2012 15:11:32.309'!
open
	
	| window |

	self extent: 800@500.

	window := (SdSystemWindow
		morph: self
		label: self class appName).
	
	self connect: window signal: #aboutRequested toSelector: #showAbout.
	
	self
		color: (Color gray: 0.85);
		borderColor: Color black.! !

!SdIDE methodsFor: 'actions' stamp: 'mt 6/30/2011 11:18:37.165'!
openCategory: aSystemCategory

	self openCategory: aSystemCategory after: nil.! !

!SdIDE methodsFor: 'actions' stamp: 'mt 6/30/2011 11:18:25.893'!
openCategory: aSystemCategory after: anEditor
	
	(self openPackage: (PackageOrganizer default packageOfSystemCategory: aSystemCategory) name after: anEditor)
		ifNotNil: [:packageViewer | packageViewer selectCategory: aSystemCategory].! !

!SdIDE methodsFor: 'actions' stamp: 'mt 5/17/2011 14:43:20.409'!
openClass: aClass

	^ self openClass: aClass theNonMetaClass after: nil! !

!SdIDE methodsFor: 'actions' stamp: 'mt 6/30/2011 11:09:29.109'!
openClass: aClass after: aClassEditor

	(self classEditors
		detect: [:ce | ce theClass == aClass] ifNone: [])
		ifNil: [^ self addClassEditorFor: aClass after: aClassEditor]
		ifNotNil: [:classEditor |
			self scrollToShow: classEditor.
			classEditor grabKeyboard.
			^ classEditor].! !

!SdIDE methodsFor: 'accessing' stamp: 'mt 5/16/2011 15:22:01.411'!
openClasses

	^ self classEditors collect: [:classEditor | classEditor theClass]! !

!SdIDE methodsFor: 'actions' stamp: 'mt 7/3/2011 09:19:26.967'!
openEditorList: aMouseEvent forColumn: aColumn

	| menu |
	menu := MenuMorph new.
		
	(SdEditor allSubclasses sortBy: [:c1 :c2 | c1 editorGroup <= c2 editorGroup])
		select: [:editorClass | editorClass isStandAlone]
		thenDo: [:editorClass |
			menu
				add: editorClass editorName
				target: self
				selector: #addEditor:after:
				argumentList: {editorClass.aColumn firstSubmorph}.
			menu lastItem icon: editorClass editorIcon].
		
	menu
		popUpAt: ActiveHand position truncated
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdIDE methodsFor: 'actions' stamp: 'mt 6/30/2011 11:05:37.802'!
openPackage: aPackageName
	
	self openPackage: aPackageName after: nil.! !

!SdIDE methodsFor: 'actions' stamp: 'mt 6/30/2011 11:10:46.239'!
openPackage: aPackageName after: anEditor
	
	(self packageViewers 
		detect: [:pv | pv packageName = aPackageName] ifNone: [])
		ifNil: [^ (self addEditor: SdPackageViewer after: anEditor)
			packageName: aPackageName]
		ifNotNil: [:pv |
			self scrollToShow: pv.
			pv grabKeyboard.
			^ pv].! !

!SdIDE methodsFor: 'actions' stamp: 'mt 6/30/2011 11:27:38.492'!
openProtocol: aProtocol class: aClass
	
	self openProtocol: aProtocol class: aClass after: nil.! !

!SdIDE methodsFor: 'actions' stamp: 'mt 6/30/2011 11:27:24.036'!
openProtocol: aProtocol class: aClass after: anEditor
	
	(self openPackage: (PackageOrganizer default packageOfClass: aClass) name after: anEditor)
		ifNotNil: [:packageViewer | packageViewer selectProtocol: aProtocol class: aClass].! !

!SdIDE methodsFor: 'actions' stamp: 'mt 5/20/2011 13:11:04.321'!
openReference: aMethodReference

	self openReference: aMethodReference after: nil! !

!SdIDE methodsFor: 'actions' stamp: 'mt 6/28/2011 20:40:03.664'!
openReference: aMethodReference after: aClassEditor

	aMethodReference isValid ifFalse: [^ self].
	
	(self openClass: aMethodReference actualClass theNonMetaClass after: aClassEditor)
		ifNotNil: [:classEditor |
			classEditor
				scrollToShow: ((classEditor openMethod: aMethodReference)
					expand;
					grabKeyboard).
			classEditor hideFinder].! !

!SdIDE methodsFor: 'actions' stamp: 'mt 7/23/2011 12:04:36.452'!
openTrace: aNode

	self openTrace: aNode after: nil.
! !

!SdIDE methodsFor: 'actions' stamp: 'mt 9/1/2011 11:12:22.195'!
openTrace: aNode after: anotherEditor

	((self callGraphEditors
		detect: [:cge | cge callgraph traceEvent = aNode callgraph traceEvent] ifNone: [])
		ifNil: [self addEditor: SdCallGraphEditor after: anotherEditor]
		ifNotNil: [:cge | self scrollToShow: cge. cge grabKeyboard. cge])
			currentNode: aNode.! !

!SdIDE methodsFor: 'accessing - private' stamp: 'mt 6/30/2011 11:09:00.26'!
packageViewers

	^ self editors
		select: [:editor | editor isPackageViewer]! !

!SdIDE methodsFor: 'pinning' stamp: 'mt 6/28/2011 14:45:49.649'!
pinMorph: aMorph

	"Remove from old owner."
	aMorph delete.
	
	"Reset width because we remove it from the scrolling container."
	aMorph width: 250.
	
	"Append it to the list of pinned morphs."
	self
		addColumnIn: self
		for: aMorph
		inFrontOf: scrollArea.! !

!SdIDE methodsFor: 'visiting' stamp: 'mt 7/4/2011 15:29:59.046'!
saveState: anEditorState

	anEditorState saveIDE: self.! !

!SdIDE methodsFor: 'accessing - private' stamp: 'mt 7/4/2011 15:48:33.889'!
scrollArea

	^ scrollArea! !

!SdIDE methodsFor: 'focus' stamp: 'mt 6/28/2011 14:45:49.126'!
scrollToShow: anEditor
	"Editor needs to be inside the scrolling container."
	
	scrollArea layoutChanged; fullBounds. "force re-layout"
	SdFadingToolbar hideAllToolbars.
	scrollArea scrollToShow: anEditor bounds duration: 500.! !

!SdIDE methodsFor: 'actions' stamp: 'mt 5/5/2011 17:08:16.065'!
showAbout

	| msg |
	msg := SdOverlayMessageBox new
		title: 'About "', self class appName, '"'.

	self class appVersion
		ifNil: [msg message: 'Could not fetch current version information!!' icon: UiFugueIcons exclamationFrameIcon]
		ifNotNil: [:version | | message |
			message := 'Current version:<br>   <font color="#00AA00">', version asString escapeHtmlText, '</font>'.
			message := message, '<br><br>Other modules:'.
			#(Animations Signals Widgets) do: [:suffix | 
				message := message, '<br>   ', (Smalltalk at: (#ConfigurationOf, suffix) asSymbol) project currentVersion asString escapeHtmlText].
			msg message: message icon: UiSilkIcons informationIcon].

	msg addAction: 'Close' icon: UiSilkIcons acceptIcon.
	
	msg showAbove: self.  ! !

!SdIDE methodsFor: 'actions' stamp: 'mt 6/22/2011 13:05:30.79'!
showFinder

	| container |
	finder owner ifNotNil: [:o | o delete].
	
	container := Morph new
		color: (Color black alpha: 0.5);
		changeProportionalLayout;
		disableTableLayout: true;
		cellPositioning: #topCenter.
		
	container addMorph: finder.

	finder
		frameFractions: (0.3@0.5 corner: 0.7@1.0);
		hResizing: #spaceFill.
	
	container bounds: self bounds.

	self addMorphFront: container.
	
	finder grabKeyboard.! !

!SdIDE methodsFor: 'actions' stamp: 'mt 3/22/2012 15:17:31.676'!
toggleFullScreen

	| isFullScreen |
	isFullScreen := self owner == ActiveWorld.
	
	isFullScreen
		ifTrue: [self open bounds: windowBounds]
		ifFalse: [windowBounds := self owner bounds. self owner delete. self openInWorld. self bounds: ActiveWorld bounds].! !

!SdIDE methodsFor: 'pinning' stamp: 'mt 6/28/2011 14:45:49.333'!
unpinMorph: aMorph

	aMorph delete.
	
	self
		addColumnIn: scrollArea widget
		for: aMorph.
		
	scrollArea scrollToShow: aMorph fullBounds.
	aMorph grabKeyboard.! !

UiToolButton subclass: #SdDraggableButton
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdDraggableButton class methodsFor: 'accessing' stamp: 'mt 4/25/2011 10:42:50.921'!
widgetCategory

	^ 'Sight-Dynamic'! !

!SdDraggableButton class methodsFor: 'accessing' stamp: 'mt 4/25/2011 10:42:38.703'!
widgetClassName

	^ 'Draggable Button'! !

!SdDraggableButton methodsFor: 'initialization' stamp: 'mt 4/25/2011 10:53:32.387'!
initialize

	super initialize.
	
	self
		dragEnabled: true;
		autoRaise: true.! !

!SdDraggableButton methodsFor: 'initialization' stamp: 'mt 4/25/2011 10:45:51.888'!
initializeEventHandler

	super initializeEventHandler.
	
	self connect: self eventHandler signal: #mouseDragStarted: toSelector: #mouseStartDrag:.  ! !

!SdDraggableButton methodsFor: 'dragging' stamp: 'mt 5/2/2011 10:52:36.793'!
mouseStartDrag: evt 
	
	evt hand hasSubmorphs ifTrue: [^ self].
	self dragEnabled ifFalse: [^ self].
	
	self down: false; flatten.
	
	[evt hand grabMorph: (TransferMorph
		withPassenger: ('<font color="#FFFFFF">', self target asString escapeHtmlText, '</font>') asHtmlText asMorph
		from: self target)]
		ensure: [Cursor normal show. evt hand releaseMouseFocus: self].! !

!SdDraggableButton methodsFor: 'accessing' stamp: 'mt 4/25/2011 10:47:23.444'!
target
	"The class element editor that is attached to the transfer morph."
	
	^ target! !

!SdDraggableButton methodsFor: 'accessing' stamp: 'mt 4/25/2011 10:47:34.226'!
target: aClassElementEditor
	
	target := aClassElementEditor.! !

UiToolButton subclass: #SdFadingButton
	instanceVariableNames: 'fadeAnimation fadeEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdFadingButton class methodsFor: 'testing' stamp: 'mt 4/19/2011 10:15:31.048'!
isWidgetClass

	^ false! !

!SdFadingButton methodsFor: 'accessing' stamp: 'mt 5/12/2011 13:07:44.85'!
fadeEnabled

	^ fadeEnabled ifNil: [fadeEnabled := true]! !

!SdFadingButton methodsFor: 'accessing' stamp: 'mt 5/12/2011 13:15:18.664'!
fadeEnabled: aBoolean

	aBoolean = fadeEnabled ifTrue: [^ self].

	fadeEnabled := aBoolean.
	
	fadeEnabled
		ifFalse: [self fadeIn]
		ifTrue: [self fadeOutInstantly].
	! !

!SdFadingButton methodsFor: 'animations' stamp: 'mt 5/12/2011 13:14:48.722'!
fadeIn

	self visible ifFalse: [^ self].

	fadeAnimation
		ifNil: [^ self]
		ifNotNil: [:anim |
			anim unregister.
			fadeAnimation := nil].
	
	self fadeEnabled
		ifFalse: [^ self].
	
	(AnimAlphaBlendAnimation new
		morph: self;
		duration: 200;
		startValue: 0.3;
		endValue: 1.0;
		register;
		start: #deleteWhenFinished).! !

!SdFadingButton methodsFor: 'animations' stamp: 'mt 5/12/2011 13:11:59.723'!
fadeOut

	(self visible not or: [self fadeEnabled not])
		ifTrue: [^ self].
	
	fadeAnimation ifNil: [fadeAnimation := (AnimAlphaBlendAnimation
		fadeOutOn: self
		to: 0.3
		duration: 200)
		register;
		start: #keepWhenFinished].! !

!SdFadingButton methodsFor: 'animations' stamp: 'mt 5/12/2011 13:12:54.534'!
fadeOutInstantly

	self fadeOut.
	
	fadeAnimation ifNotNil: [fadeAnimation
		stop;
		toEnd].! !

!SdFadingButton methodsFor: 'initialization' stamp: 'mt 5/12/2011 13:11:08.276'!
initialize

	super initialize.
	
	self
		fadeOutInstantly;
		layoutInset: (0@ -5 corner: 0@ -3).! !

!SdFadingButton methodsFor: 'initialization' stamp: 'mt 4/18/2011 15:56:09.335'!
initializeEventHandler

	super initializeEventHandler.
	
	self connect: self eventHandler signal: #mouseEntered: toSelector: #fadeIn.
	self connect: self eventHandler signal: #mouseLeft: toSelector: #fadeOut.! !

SdFadingButton subclass: #SdProtocolButton
	instanceVariableNames: 'organization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdProtocolButton methodsFor: 'initialization' stamp: 'mt 4/18/2011 16:03:39.71'!
initialize

	super initialize.
	
	self
		color: Color yellow paler;
		text: 'protocol';
		balloonText: 'method protocol'.! !

!SdProtocolButton methodsFor: 'initialization' stamp: 'mt 4/18/2011 15:56:15.093'!
initializeEventHandler

	super initializeEventHandler.
	
	self connect: self eventHandler signal: #mouseClicked: toSelector: #openProtocolList:.! !

!SdProtocolButton methodsFor: 'actions' stamp: 'mt 5/12/2011 14:13:26.672'!
openProtocolList: aMouseEvent

	| menu |
	menu := MenuMorph new
		defaultTarget: self.
		
	self organization categories
		select: [:category | category ~= self text asString asSymbol]
		thenDo: [:category | 
			menu
				add: category
				selector: #protocolChanged:
				argument: (category = #'as yet unclassified'
					ifTrue: []
					ifFalse: [category])].
	
	menu
		popUpAt: aMouseEvent hand position truncated
		forHand: aMouseEvent hand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdProtocolButton methodsFor: 'accessing' stamp: 'mt 4/14/2011 15:33:52.892'!
organization

	^ organization! !

!SdProtocolButton methodsFor: 'accessing' stamp: 'mt 4/14/2011 15:34:18.601'!
organization: anOrganizer

	organization := anOrganizer.! !

!SdProtocolButton methodsFor: 'signals' stamp: 'mt 4/14/2011 15:52:23.076'!
protocolChanged: newProtocolName

	self emitAlways.! !

SHTextStylerST80 subclass: #SdTextStyler
	instanceVariableNames: 'customTextAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Support'!

!SdTextStyler commentStamp: 'mt 4/25/2011 09:38:47.223' prior: 0!
Regular Shout text styler with the ability to override some attributes dynamically.!

!SdTextStyler class methodsFor: 'style table' stamp: 'mt 4/20/2011 17:09:48.067'!
defaultStyleTable
	"color can be a valid argument to Color class>>colorFrom: , or nil to
	use the editor text color.
	Multiple emphases can be specified using an array e.g. #(bold italic).
	If emphasis is not specified, #normal will be used.
	if pixel height is not specified , then the editor font size will be used.
	"
								
^#(
	"(symbol	color		[emphasisSymbolOrArray		[textStyleName [pixelHeight]]])"		
						
	(default 								( black )	)
	(invalid 								( red ) 	)
	(excessCode 							( red )	)
	(comment 								( green	muchDarker ) nil	#'Bitmap Segoe UI' 15)
	(unfinishedComment 					( green	muchDarker )	)
	(#'$'									( magenta muchDarker) 	)
	(character							( magenta muchDarker) 	)
	(integer								( magenta muchDarker) 	)
	(number								( magenta muchDarker) 	)
	(#-										( magenta muchDarker) 	)
	(symbol									( magenta muchDarker) 	)	
	(stringSymbol							( magenta muchDarker) 	)	
	(literalArray							( magenta muchDarker) 	)
	(string									( magenta ) 	)
	(unfinishedString						( magenta ) 	)
	(assignment								( black )					)
	(ansiAssignment 						( black )					)
	(literal									( black )					)
	(keyword								( black )					)
	(binary 								( black )					)
	(unary									( black )					)
	(incompleteKeyword						( black )					)
	(incompleteBinary 						( black )					)
	(incompleteUnary						( black )					)
	(undefinedKeyword						( red )					)
	(undefinedBinary 						( red )					)
	(undefinedUnary						( red )					)													
	(patternKeyword 						( black ) bold				)
	(patternBinary 							( black ) bold				)
	(patternUnary							( black ) bold				)
	(#self 									( cyan muchDarker )	bold	)
	(#super									( cyan muchDarker )	bold	)
	(#true 									( cyan muchDarker )	bold	)
	(#false 									( cyan muchDarker )	bold	)
	(#nil 									( cyan muchDarker )	bold	)
	(#thisContext 							( cyan muchDarker )	bold	)
	(#return								( black )	bold				)
	(patternArg 							( blue muchDarker ) 		)	
	(methodArg 								( blue muchDarker ) 		)		
	(blockPatternArg 						( yellow muchDarker ) 		)		
	(blockArg 								( yellow muchDarker ) 		)	
	(argument 								( blue muchDarker ) 		)		
	(blockArgColon							black		) 
	(leftParenthesis							black		) 
	(rightParenthesis						black		) 
	(leftParenthesis1						black		) 
	(rightParenthesis1						black		) 
	(leftParenthesis2						black		)  
	(rightParenthesis2						black		)  
	(leftParenthesis3						black		) 
	(rightParenthesis3						black		) 
	(leftParenthesis4						black		) 
	(rightParenthesis4						black		) 
	(leftParenthesis5						black		)  
	(rightParenthesis5						black		) 
	(leftParenthesis6						black		) 
	(rightParenthesis6						black		) 
	(leftParenthesis7						black		) 
	(rightParenthesis7						black		) 
	(blockStart 								black		) 
	(blockEnd 								black		) 
	(blockStart1								black		) 
	(blockEnd1								black		) 
	(blockStart2								black		) 
	(blockEnd2								black		) 
	(blockStart3								black		) 
	(blockEnd3								black		) 
	(blockStart4								black		) 
	(blockEnd4								black		) 
	(blockStart5								black		) 
	(blockEnd5								black		) 
	(blockStart6								black		) 
	(blockEnd6								black		) 
	(blockStart7								black		) 
	(blockEnd7								black		) 																																																
	(arrayStart								black		) 
	(arrayEnd								black		) 
	(arrayStart1							black		) 
	(arrayEnd1								black		) 
	(byteArrayStart								black		) 
	(byteArrayEnd								black		) 
	(byteArrayStart1							black		) 
	(byteArrayEnd1								black		) 
	(leftBrace 								black		) 
	(rightBrace 								black		) 
	(cascadeSeparator 						black		) 
	(statementSeparator 						black		) 
	(externalCallType 						black		) 
	(externalCallTypePointerIndicator 		black		) 
	(primitiveOrExternalCallStart 			black		) 
	(primitiveOrExternalCallEnd				black		)
	(methodTempBar							black		) 
	(blockTempBar 							black		) 
	(blockArgsBar							black		) 
	(primitive								gray		)
	(externalFunctionCallingConvention		gray		)
	(module									gray		)
	(blockTempVar 							( gray darker ) 		)	
	(blockPatternTempVar					( gray darker ) 		)	
	(instVar 								( blue muchDarker ) 		)	
	(workspaceVar							( blue muchDarker ) 		)	
	(undefinedIdentifier						( red ) 		)	
	(incompleteIdentifier					( blue muchDarker ) 		)	
	(tempVar								( gray darker ) 		)	
	(patternTempVar						( gray darker ) 		)	
	(poolConstant							( blue muchDarker ) 		)	
	(classVar								( blue muchDarker ) 	bold	)	
	(globalVar								( blue muchDarker ) 	bold	) )
							! !

!SdTextStyler class methodsFor: 'style table' stamp: 'mt 4/20/2011 17:10:02.525'!
subduedStyleTable

	^ self defaultStyleTable! !

!SdTextStyler methodsFor: 'private' stamp: 'mt 4/27/2011 13:30:52.11'!
attributesFor: aSymbol

	^ (((super attributesFor: aSymbol) ifNil: [#()]), 
		(self customTextAttributes at: aSymbol ifAbsent: [#()])) ifEmpty: []! !

!SdTextStyler methodsFor: 'accessing' stamp: 'mt 4/20/2011 17:21:02.301'!
customTextAttributes

	^ customTextAttributes ifNil: [customTextAttributes := IdentityDictionary new].! !

!MouseButtonEvent methodsFor: '*sight-dynamic-override' stamp: 'mt 5/24/2011 14:36:10.059'!
blueButtonChanged
	"Answer true if the blue mouse button has changed. This is the third mouse button or cmd+click on the Mac."

	^ self blueButtonPressed! !

!MouseButtonEvent methodsFor: '*sight-dynamic' stamp: 'mt 5/24/2011 14:45:40.387'!
blueButtonPressed
	"Workaround for wrong VM behavior."
	
	^ super blueButtonPressed and: [super controlKeyPressed not]    ! !

!MouseButtonEvent methodsFor: '*sight-dynamic' stamp: 'mt 5/24/2011 14:45:16.715'!
controlKeyPressed

	^ super controlKeyPressed and: [
		super blueButtonPressed not]! !

!MouseButtonEvent methodsFor: '*sight-dynamic' stamp: 'mt 5/24/2011 14:34:27.038'!
redButtonPressed
	"Workaround for wrong VM behavior."
	
	^ super redButtonPressed or: [
		super blueButtonPressed and: [self controlKeyPressed]]! !

AbstractEvent subclass: #SdMessageEvent
	instanceVariableNames: 'text messageKind'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Events'!

!SdMessageEvent commentStamp: 'mt 4/10/2011 11:17:28.228' prior: 0!
This system event is used to send text messages targeted at classes or messages. Different message kinds allow visual customization.!

!SdMessageEvent class methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:05:10.142'!
changeKind

	^ #Message! !

!SdMessageEvent class methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:06:00.826'!
supportedKinds

	^ {self classKind. self methodKind}! !

!SdMessageEvent class methodsFor: 'instance creation' stamp: 'mt 4/10/2011 11:16:43.624'!
text: stringOrText class: aClass

	^ self
		text: stringOrText
		kind: #information
		class: aClass! !

!SdMessageEvent class methodsFor: 'instance creation' stamp: 'mt 4/10/2011 11:16:26.427'!
text: stringOrText kind: messageKind class: aClass

	| instance |
	instance := self class: aClass.
	instance
		messageKind: messageKind;  
		text: stringOrText.
	^ instance! !

!SdMessageEvent methodsFor: 'testing' stamp: 'mt 4/10/2011 11:18:29.019'!
isError

	^ self messageKind = #error! !

!SdMessageEvent methodsFor: 'testing' stamp: 'mt 4/10/2011 11:18:11.069'!
isInformation

	^ self messageKind = #information! !

!SdMessageEvent methodsFor: 'testing' stamp: 'mt 4/10/2011 11:18:19.13'!
isWarning

	^ self messageKind = #warning! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:17:02.382'!
messageKind
	"The kind of a message can be used to display it differently."
	
	^ messageKind ifNil: [#information]! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:15:53.638'!
messageKind: aSymbol
	"#information, #warning, #error"
	
	messageKind := aSymbol! !

!SdMessageEvent methodsFor: 'printing' stamp: 'mt 4/10/2011 11:06:36.472'!
printEventKindOn: aStream

	aStream nextPutAll: 'Message'! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:09:44.207'!
text

	^ text! !

!SdMessageEvent methodsFor: 'accessing' stamp: 'mt 4/10/2011 11:09:54.777'!
text: aText

	text := aText.! !

!SdMessageEvent methodsFor: 'triggering' stamp: 'mt 4/10/2011 11:24:38.657'!
trigger

	SystemChangeNotifier uniqueInstance trigger: self.! !

UiScrollArea subclass: #SdScrollArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdScrollArea class methodsFor: 'accessing' stamp: 'mt 1/2/2012 17:34:02.777'!
widgetCategory

	^ 'Sight-Dynamic'! !

!SdScrollArea methodsFor: 'accessing' stamp: 'mt 7/1/2011 16:39:50.958'!
transformMorphClass

	^ SdTransformMorph! !

UiTextEdit subclass: #SdSourceCodeEdit
	uses: TSdDynamicAccessor + TSdDynamicMenusForMethod
	instanceVariableNames: 'theClass selector protocolBtn sideBtn testBtn completionController fixLayout doItReceiver doItContext breadcrumbTrail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdSourceCodeEdit commentStamp: 'mt 3/24/2011 11:22:15.769' prior: 0!
This is a text edit to modify a method's source.!

SdSourceCodeEdit class
	uses: TSdDynamicAccessor classTrait + TSdDynamicMenusForMethod classTrait
	instanceVariableNames: ''!

SdSourceCodeEdit subclass: #SdClassDefinitionEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdClassDefinitionEdit class methodsFor: 'accessing' stamp: 'mt 4/19/2011 10:29:58.038'!
widgetClassIcon

	^ UiFugueIcons scriptTextIcon! !

!SdClassDefinitionEdit class methodsFor: 'accessing' stamp: 'mt 4/19/2011 10:29:10.332'!
widgetClassName

	^ 'Class Definition Edit'! !

!SdClassDefinitionEdit methodsFor: 'actions' stamp: 'mt 4/12/2011 15:40:00.775'!
compile
	"No classic compile but code evaluation."
	
	Compiler evaluate: self theText asString.
	
	^ true! !

!SdClassDefinitionEdit methodsFor: 'initialization' stamp: 'mt 4/19/2011 10:34:55.522'!
initialize

	super initialize.
	
	self hideInfoButtons.! !

!SdClassDefinitionEdit methodsFor: 'accessing' stamp: 'mt 9/1/2011 12:56:49.65'!
method

	^ nil! !

!SdClassDefinitionEdit methodsFor: 'actions' stamp: 'mt 4/12/2011 15:39:54.224'!
parse

	^ true! !

!SdClassDefinitionEdit methodsFor: 'initialization' stamp: 'mt 4/14/2011 15:16:40.77'!
reset

	self theClass ifNotNil: [:c |
		self textMorph styler classOrMetaClass: c].! !

!SdSourceCodeEdit class methodsFor: 'testing' stamp: 'mt 4/19/2011 10:27:49.834'!
isWidgetClass

	^ true! !

!SdSourceCodeEdit class methodsFor: 'accessing' stamp: 'mt 4/19/2011 10:28:04.954'!
widgetCategory

	^ 'Sight-Dynamic'! !

!SdSourceCodeEdit class methodsFor: 'accessing' stamp: 'mt 4/19/2011 10:28:53.312'!
widgetClassIcon

	^ UiFugueIcons scriptCodeIcon! !

!SdSourceCodeEdit class methodsFor: 'accessing' stamp: 'mt 4/19/2011 10:28:25.21'!
widgetClassName

	^ 'Source Code Edit'! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 4/20/2011 17:41:23.81'!
acceptChanges

	self readOnly
		ifTrue: [^ self].

	self hasUnacceptedChanges
		ifFalse: [^ self].
		
	(self parse and: [self compile])
		ifTrue: [^ super acceptChanges].
		
	self grabKeyboard.! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 4/14/2011 16:58:36.182'!
changeProtocol: newProtocolName

	self theClass organization
		classify: self selector
		under: newProtocolName
		suppressIfDefault: false.! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 5/12/2011 12:07:24.103'!
checkSelector
	"Check current selector and reload source if necessary."

	self selector: (Compiler parserClass new parseSelector: self theText asString).
	
	"This method could be a test method now."
	self updateTestBtn.! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 7/19/2011 16:38:33.547'!
classActivated: aClass

	self emitAlways.! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 4/19/2011 10:37:43.938'!
compile

	self theClass ifNil: [^ true].

	[self theClass
		compile: self theText
		classified: (MethodReference
			class: self theClass
			selector: self selector) category.
			
	self checkSelector.
	
	^ true]
		on: SyntaxErrorNotification "Manual catch to disable interactive compilation."
		do: [:err | 
			Transcript cr; show: '[Syntax] ', err asString.
			(SdMessageEvent
				text: 'Compilation failed: ', self theClass asString, ' >> ', self selector asString
				kind: #warning
				class: self theClass) trigger.
				
			self notify: err errorMessage at: err location in: err messageText.
			
			^ false]
		on: Error
		do: [:err |
			Transcript cr; show: '[Error] ', err asString.
			(SdMessageEvent
				text: 'Compilation error: ', self theClass asString, ' >> ', self selector asString
				kind: #error
				class: self theClass) trigger.
				
			^ false].! !

!SdSourceCodeEdit methodsFor: 'completion' stamp: 'mt 4/25/2011 17:54:08.899'!
completionController

	^ completionController ifNil: [
		completionController := SdCompletionController model: self]! !

!SdSourceCodeEdit methodsFor: 'do-its' stamp: 'mt 5/23/2011 11:11:00.174'!
doItContext

	^ doItContext! !

!SdSourceCodeEdit methodsFor: 'do-its' stamp: 'mt 5/23/2011 11:11:21.82'!
doItContext: aContext

	doItContext := aContext.! !

!SdSourceCodeEdit methodsFor: 'do-its' stamp: 'mt 5/23/2011 11:11:05.1'!
doItReceiver

	^ doItReceiver! !

!SdSourceCodeEdit methodsFor: 'do-its' stamp: 'mt 5/23/2011 11:11:11.682'!
doItReceiver: anObject

	doItReceiver := anObject.! !

!SdSourceCodeEdit methodsFor: 'drawing' stamp: 'mt 5/12/2011 16:17:15.997'!
drawOn: aCanvas

	| c |
	super drawOn: aCanvas.
	
	self hasKeyboard ifTrue: [c := self colorFocusBorder].
	self displayMode == #highlight ifTrue: [c := self colorHighlightedBorder].
	
	c ifNotNil: [
			
		aCanvas
			line: self topLeft + (0@1) to: self topRight + (-1@1) color: (c alpha: 0.5);
			line: self topLeft + (0@2) to: self topRight + (-1@2) color: (c alpha: 0.2).
			
		aCanvas
			line: self topLeft + (1@1) to: self bottomLeft + (1@ -1) color: (c alpha: 0.5);
			line: self topLeft + (2@2) to: self bottomLeft + (2@ -1) color: (c alpha: 0.2).
		
		aCanvas
			frameRectangle: self innerBounds
			color: (c alpha: 0.8)].! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 7/31/2011 15:13:35.64'!
evaluateSelection

	^ self textMorph editor evaluateSelection! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 6/28/2011 16:45:56.296'!
focusChanged: aGlobalRectangle

	self emitInOwnerChain.! !

!SdSourceCodeEdit methodsFor: 'drawing' stamp: 'mt 7/5/2011 16:46:04.349'!
fullDrawOn: aCanvas

	| font overlay |
	super fullDrawOn: aCanvas.
	
	(self selector isNil or: [self visible not])
		ifTrue: [^ self].

	self displayMode == #highlight
		ifTrue: [^ self].
	
	self textMorph hasKeyboard ifFalse: [
		font := self textMorph textStyle fontOfPointSize: 11. 
		overlay := self overlayText asMorph.
		overlay font: font.
		overlay
			topLeft: self topLeft + self margins topLeft;
			wrapFlag: true;
			width: self width;
			autoFit: true.
			
		aCanvas
			fillRectangle: overlay bounds
			color: self color.
			
		self displayMode == #normal ifTrue: [
			aCanvas
				fillRectangle: self bounds
				color: (self color alpha: 0.5)].
		
		overlay fullDrawOn: aCanvas]! !

!SdSourceCodeEdit methodsFor: 'completion' stamp: 'mt 4/28/2011 10:46:02.507'!
guessTypeForName: aString

	^ nil! !

!SdSourceCodeEdit methodsFor: 'dynamic context' stamp: 'mt 5/24/2011 09:51:57.552'!
hideDynamicContext

	self textMorph style.! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 5/12/2011 12:11:39.106'!
hideInfoButtons

	protocolBtn delete.
	sideBtn delete.
	testBtn delete.! !

!SdSourceCodeEdit methodsFor: 'initialization' stamp: 'mt 7/13/2011 16:45:10.879'!
initialize

	protocolBtn := SdProtocolButton new.
	sideBtn := SdFadingButton new
		balloonText: 'class side method';
		color: Color green muchDarker;
		text: '<font color="#FFFFFF">c</font>' asHtmlText.
	testBtn := SdFadingButton new
		color: Color transparent;
		layoutInset: 0;
		autoRaise: true;  
		icon: UiDiagonaIcons icon0402Normal;
		buttonStyle: #iconOnly;
		fadeEnabled: false.
	breadcrumbTrail := SdBreadcrumbTrail new.
	
	super initialize.
	
	self textMorph
		font: Preferences standardCodeFont;
		styler: SdTextStyler new;
		margins: (4@0 corner: 4@0).
	
	self connect: self textMorph signal: #focusChanged: toSelector: #onFocusChanged:.

	self connect: self eventHandler signal: #mouseWheelUp: toSelector: #mouseWheelUp:.
	self connect: self eventHandler signal: #mouseWheelDown: toSelector: #mouseWheelDown:.
	
	self connect: self eventHandler signal: #keyPressed: toSelector: #toggleDynamicContext:.
	self connect: self eventHandler signal: #keyReleased: toSelector: #toggleDynamicContext:.
	
	protocolBtn topRight: self transformMorph topRight.
	sideBtn topRight: protocolBtn bottomRight.
	testBtn topRight: protocolBtn bottomRight.

	self connect: protocolBtn signal: #protocolChanged: toSelector: #changeProtocol:.
	self connect: testBtn signal: #clicked: toSelector: #runTest.

	self
		addMorphFront: protocolBtn;
		addMorphFront: sideBtn.! !

!SdSourceCodeEdit methodsFor: 'test handling - testing' stamp: 'mt 5/12/2011 11:57:14.512'!
isTestMethod

	^ (self theClass inheritsFrom: TestCase)
		and: [self selector startsWith: #test]! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 7/18/2011 17:08:17.046'!
method

	^ self theClass >> self selector! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 7/26/2011 19:50:51.022'!
methodActivated: aMethodReference

	self emitAlways.! !

!SdSourceCodeEdit methodsFor: 'layout' stamp: 'mt 3/15/2012 16:47:10.604'!
minExtent

	"WORKAROUND: Fix buggy layouting due to #minExtent implementation in some cases."
	"self flag: #workaround.
	self owner ifNotNil: [:o |
		fixLayout ~= false ifTrue: [
			self hResizing == #spaceFill ifTrue: [
				self width: self owner width]]]."
		
	^ super minExtent! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 4/28/2011 14:18:09.888'!
mouseWheelDown: aMouseEvent

	self verticalScrollBarPolicy ~= #alwaysOff
		ifTrue: [^ self].
		
	self emitAlways.! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 4/28/2011 14:18:15.519'!
mouseWheelUp: aMouseEvent

	self verticalScrollBarPolicy ~= #alwaysOff
		ifTrue: [^ self].

	self emitAlways.! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 4/10/2011 12:20:28.782'!
notify: aMessage at: aLocation in: aSource

	| message |
	self textMorph editor selectAt: aLocation.
	
	"Trigger manual focus changes. Should be automatic on selection changed?"
	self onFocusChanged: (self textMorph editor pointBlock).
	
	message := ((UiMessage information: aMessage)
		topLeft: (self textMorph localPointToGlobal: (self textMorph editor pointBlock bottomLeft))).
	message openInWorld.! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 7/19/2011 16:38:22.589'!
objectActivated: anObject

	self emitAlways.! !

!SdSourceCodeEdit methodsFor: 'focus' stamp: 'mt 4/8/2011 12:13:17.821'!
onFocusChanged: aLocalRectangle

	self focusChanged:
		((self textMorph localPointToGlobal: aLocalRectangle topLeft)
		extent: aLocalRectangle extent).! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 6/30/2011 11:54:40.735'!
optimalWidth
	"Override to ignore comments."
	
	| maxWidth |
	maxWidth := 0.

	((self theText asString copyWithRegex: '"[^"]*"' matchesReplacedWith: '')
		copyReplaceAll: String tab with: '   ')
	   linesDo: [:line | 
			maxWidth := maxWidth max: (self textMorph textStyle defaultFont widthOfString: line)].
		
	^ maxWidth + self scrollBarThickness + 20 ! !

!SdSourceCodeEdit methodsFor: 'drawing' stamp: 'mt 5/5/2011 10:21:17.6'!
overlayText

	| result |
	result := '<b>{1}{3}{2}<font color="#777777"> ({4})</font></b>' format: {
		"underline metaclass selectors"
		self theClass isMeta ifTrue: ['<u>'] ifFalse: [''].
		self theClass isMeta ifTrue: ['</u>'] ifFalse: [''].
		self selector asString escapeHtmlText escapeHtmlText "due to #format:".
		self theClass organization categoryOfElement: self selector}.
	^ result asHtmlText! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 5/1/2011 14:31:13.449'!
parse

	| helper |
	self theClass ifNil: [^ true].
	
	helper := SdParserHelper new
		text: self theText;
		view: self.
	
	[Parser new
		parse: self theText asString readStream
		class: self theClass
		category: (MethodReference
			class: self theClass
			selector: self selector) category
		noPattern: false
		context: nil
		notifying: helper
		ifFail: [^ false]]
		on: ParserNotification "Manual catch to disable interactive compilation."
		do: [:err |
			(err isKindOf: UnusedVariable) ifTrue: [
				(SdMessageEvent
					text: 'Unused Variable found: ', self theClass asString, ' >> ', self selector asString
					kind: #information
					class: self theClass) trigger.

				err resume: false].
			
			(err isKindOf: UnknownSelector) ifTrue: [
				self notify: err class name at: helper selection first in: self theText.
				err resume: helper selectedText asString asSymbol].
			
			(SdMessageEvent
				text: 'Parsing failed: ', self theClass asString, ' >> ', self selector asString
				kind: #warning
				class: self theClass) trigger.
				
			self notify: err class name at: helper selection first in: self theText.
			self select: helper selection.
			
			^ false].
		
	^ true! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 7/5/2011 16:23:48.726'!
protocol

	^ self theClass organization categoryOfElement: self selector! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 7/18/2011 17:08:36.477'!
reference

	^ MethodReference
		class: self theClass
		selector: self selector! !

!SdSourceCodeEdit methodsFor: 'initialization' stamp: 'mt 7/5/2011 16:31:13.239'!
reset

	self theClass ifNil: [^ self].

	self textMorph styler classOrMetaClass: self theClass.
		
	self theClass isMeta
		ifTrue: [sideBtn show]
		ifFalse: [sideBtn hide].
	
	(self theClass includesSelector: self selector)
		ifTrue: [self hasUnacceptedChanges
			ifTrue: [self originalText: (self theClass >> self selector) getSource]
			ifFalse: [self theText: (self theClass >> self selector) getSource]]
		ifFalse: [
			"New method."
			
			(self theClass canUnderstand:
				(Compiler parserClass new parseSelector: self selector))
				ifTrue: ["Will be overridden. Add super call."
					self selector:
						self selector, String cr, String cr, String tab,
						'^ super ', self selector].
			
			self
				scrollingMode: #always;  
				theText: self selector;
				originalText: '';
				acceptChanges.].
		
	protocolBtn
		organization: self theClass organization;
		text: self protocol.
	breadcrumbTrail
		theClass: self theClass
		protocol: self protocol.
	
	self
		updateButtonLayout;
		updateTestBtn.! !

!SdSourceCodeEdit methodsFor: 'test handling' stamp: 'mt 5/12/2011 13:06:00.625'!
runTest

	self isTestMethod ifFalse: [Error signal: 'This is no test method!!'].

	(self theClass run: self selector)
		dispatchResultsIntoHistory.
		
	self updateTestBtn.! !

!SdSourceCodeEdit methodsFor: 'do-its' stamp: 'mt 5/23/2011 11:16:24.276'!
selectedClass

	^ self doItReceiver class! !

!SdSourceCodeEdit methodsFor: 'completion' stamp: 'mt 4/25/2011 17:39:48.348'!
selectedClassOrMetaClass

	^ self theClass! !

!SdSourceCodeEdit methodsFor: 'selection' stamp: 'mt 6/9/2011 13:50:53.428'!
selectedSelector
	"If possible, return the selector that is behind the current selection."
	
	^ self textMorph editor selectedSelector! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:01:21.227'!
selector

	^ selector! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/25/2011 11:56:38.599'!
selector: aSymbol

	selector := aSymbol.! !

!SdSourceCodeEdit methodsFor: 'drawing' stamp: 'mt 3/15/2012 16:45:09.585'!
show

	super show.
	self grabKeyboard.! !

!SdSourceCodeEdit methodsFor: 'dynamic context' stamp: 'mt 2/16/2012 11:49:33.517'!
showDynamicContext
	
	self theClass ifNil: [^ self].
	self method ifNil: [^ self].
	
	"Check whether dynamic information are available at all."
	self method hasMethodExtension ifFalse: [^ self].
	self method methodExtension tests ifEmpty: [^ self].
	
	self
		showDynamicContextForMessageSends;
		showDynamicContextForArguments.
	
	"Redraw text links."
	self textMorph redrawLater.! !

!SdSourceCodeEdit methodsFor: 'dynamic context' stamp: 'mt 7/31/2011 13:48:22.724'!
showDynamicContextForArguments
		
	((SHParserST80 new
		source: self theText asString;
		classOrMetaClass: self theClass;
		parse;
		ranges) select: [:range | range type == #patternArg])
		withIndexDo: [:range :idx |
			self theText
				addAttribute: (SdInformationLink argument
					evalBlock: [self showMenuForArgument: idx])
				from: range start
				to: range end].! !

!SdSourceCodeEdit methodsFor: 'dynamic context' stamp: 'mt 7/31/2011 13:47:54.973'!
showDynamicContextForMessageSends
	"Add a text link to all message sends."
	
	| rootNode searcher |
	[rootNode := RBParser parseMethod: self theText asString]
		on: Error do: [^ self].
	
	searcher := RBParseTreeSearcher new.
	searcher matches: '``@rcv `@msg: ``@args'
		do: [:aNode :answer | answer add: aNode; yourself].
	
	(searcher executeTree: rootNode initialAnswer: OrderedCollection new)
		do: [:node | | selector |
			selector := node selector.
			node selectorParts do: [:token |
				self theText
					addAttribute: (SdInformationLink message
						evalBlock: [self showMenuForMessage: selector])
					from: token start
					to: token stop]].! !

!SdSourceCodeEdit methodsFor: 'actions' stamp: 'mt 4/19/2011 10:34:46.645'!
showInfoButtons

	self addMorphBack: protocolBtn; addMorphBack: sideBtn.    ! !

!SdSourceCodeEdit methodsFor: 'dynamic context' stamp: 'mt 7/31/2011 17:33:40.396'!
showMenuForArgument: argIndex
	
	(self menuForArgument: argIndex method: self method)
		popUpAt: ActiveHand position
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdSourceCodeEdit methodsFor: 'dynamic context' stamp: 'mt 7/31/2011 17:33:34.132'!
showMenuForMessage: aSymbol
	
	(self menuForMessage: aSymbol method: self method)
		popUpAt: ActiveHand position
		forHand: ActiveHand
		in: ActiveWorld
		allowKeyboard: false.! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 3/24/2011 11:37:39.359'!
sourceCodeResetted

	self emit.! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 5/23/2011 16:57:22.216'!
symbolActivated: aSymbol

	self emit.! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/24/2011 11:01:05.836'!
theClass

	^ theClass! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/25/2011 11:56:42.188'!
theClass: aClassOrMetaClass

	theClass := aClassOrMetaClass.! !

!SdSourceCodeEdit methodsFor: 'accessing' stamp: 'mt 3/25/2011 11:56:45.885'!
theClass: aClassOrMetaClass selector: aSymbol

	theClass := aClassOrMetaClass.
	selector := aSymbol.! !

!SdSourceCodeEdit methodsFor: 'dynamic context' stamp: 'mt 5/24/2011 10:16:08.178'!
toggleDynamicContext: aKeyboardEvent

	"Press control key."
	(aKeyboardEvent isKeyDown
		and: [aKeyboardEvent keyValue == 17
		or: [aKeyboardEvent keyValue == 113]])
		ifTrue: [self showDynamicContext].
	
	"Release control key."	
	(aKeyboardEvent isKeyUp
		and: [aKeyboardEvent keyValue == 17])	
		ifTrue: [self hideDynamicContext].
		
	
	! !

!SdSourceCodeEdit methodsFor: 'signals' stamp: 'mt 7/23/2011 11:40:28.823'!
traceActivated: aNode

	self emitAlways.! !

!SdSourceCodeEdit methodsFor: 'layouting' stamp: 'mt 7/5/2011 17:00:40.548'!
updateButtonLayout
	
	protocolBtn
		fullBounds;
		topRight: self transformMorph topRight.
		
	sideBtn topRight: protocolBtn bottomRight.
	testBtn topRight: protocolBtn bottomRight.
	
	breadcrumbTrail topLeft: self transformMorph topLeft + (1@1).! !

!SdSourceCodeEdit methodsFor: 'layouting' stamp: 'mt 4/28/2011 13:55:05.575'!
updateLayout

	super updateLayout.
	self updateButtonLayout.! !

!SdSourceCodeEdit methodsFor: 'test handling' stamp: 'mt 5/17/2011 12:07:08.86'!
updateTestBtn

	self isTestMethod
		ifTrue: [testBtn owner ifNil: [self addMorphFront: testBtn]]
		ifFalse: [^ testBtn delete].
		
	testBtn icon: (SdMethodFinder
		iconForTestClass: self theClass
		selector: self selector).! !

SystemWindow subclass: #SdSystemWindow
	instanceVariableNames: 'applicationBox'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdSystemWindow commentStamp: 'mt 5/1/2011 11:13:55.168' prior: 0!
A system window with a different appearance.!

!SdSystemWindow class methodsFor: 'initializing' stamp: 'mt 5/1/2011 11:22:01.852'!
borderWidth

	^ 0! !

!SdSystemWindow class methodsFor: 'initializing' stamp: 'mt 5/1/2011 12:17:25.923'!
closeBoxImage

	^ UiFugueIcons crossButtonIcon! !

!SdSystemWindow class methodsFor: 'initializing' stamp: 'mt 5/1/2011 12:19:52.703'!
collapseBoxImage

	^ UiFugueIcons minusButtonIcon asGrayScale2! !

!SdSystemWindow class methodsFor: 'initializing' stamp: 'mt 5/1/2011 12:18:13.498'!
expandBoxImage

	^ UiFugueIcons plusButtonIcon asGrayScale2! !

!SdSystemWindow class methodsFor: 'instance creation' stamp: 'mt 5/1/2011 11:22:23.26'!
morph: aMorph label: aString
	"Like Morph>>#openInWindowLabeled:inWorld:."
	
	| window extent |

	window := (self labelled: aString) model: nil.
	window 
		" guess at initial extent"
		bounds: (RealEstateAgent
			initialFrameFor: window
			initialExtent: aMorph fullBounds extent
			world: ActiveWorld);
		addMorph: aMorph frame: (0@0 extent: 1@1);
		updatePaneColors.
	" calculate extent after adding in case any size related attributes were changed.  Use
	fullBounds in order to trigger re-layout of layout morphs"
	extent := aMorph fullBounds extent + 
			(window borderWidth@window labelHeight) + window borderWidth.
	window extent: extent.
	ActiveWorld addMorph: window.
	window activate.
	ActiveWorld startSteppingSubmorphsOf: window.
	
	^window
! !

!SdSystemWindow methodsFor: 'signals' stamp: 'mt 5/2/2011 16:12:35.236'!
aboutRequested

	self emitAlways.! !

!SdSystemWindow methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2011 12:26:05.802'!
activateWindow

	super activateWindow.
	label color: Color white.
	self setStripeColorsFrom: self paneColorToUse.! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/1/2011 12:11:32.293'!
addApplicationBox
	
	labelArea ifNil: [^ self].

	applicationBox ifNotNil: [applicationBox delete].
	applicationBox := self createApplicationBox.
	labelArea addMorphBack: applicationBox! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/1/2011 12:14:15.052'!
addCloseBox
	"If I have a labelArea, add a close box to it"

	labelArea
		ifNil: [^ self].
	closeBox ifNotNil: [closeBox delete].
	closeBox := self createCloseBox.
	closeBox layoutFrame: self class closeBoxFrame.
	labelArea addMorphBack: closeBox! !

!SdSystemWindow methodsFor: 'label' stamp: 'mt 5/1/2011 11:42:59.639'!
addLabel

	(labelArea isNil or: [label isNil]) ifTrue: [^ self].

	labelArea addMorphBack: label.

	label on: #startDrag send: #startDragFromLabel: to: self.
	self class clickOnLabelToEdit
		ifTrue: [label on: #mouseUp send: #relabel to: self].
	self class doubleClickOnLabelToExpand
		ifTrue: [label on: #doubleClick send: #expandBoxHit to: self].! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/1/2011 11:38:13.541'!
addLabelArea

	labelArea ifNotNil: [labelArea abandon].
	
	labelArea := Morph new
		color: Color transparent;
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill.
		
	self addMorph: labelArea.    ! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/1/2011 11:43:36.498'!
addSpacer

	labelArea ifNil: [^ self].

	labelArea addMorphBack: (UiSpacer new height: 5).! !

!SdSystemWindow methodsFor: 'menu' stamp: 'mt 5/2/2011 16:14:12.012'!
buildWindowMenu
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.

	aMenu add: 'About...' action: #aboutRequested.
	aMenu addLine.

	self unexpandedFrame 
		ifNil: [aMenu add: 'Show full screen' translated action: #expandBoxHit]
		ifNotNil: [aMenu add: 'Show original size' translated action: #expandBoxHit].

	aMenu addLine.
	aMenu add: 'Close' action: #delete.

	^aMenu! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/2/2011 16:10:39.773'!
createAboutBox
	^ (self createBox: UiFugueIcons informationButtonIcon)
		actionSelector: #aboutRequested;
		setBalloonText: 'About' translated! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/1/2011 12:12:39.39'!
createApplicationBox
	^ (self createBox: UiFugueIcons lightningIcon)
		actionSelector: #offerApplicationMenu;
		setBalloonText: 'Application Menu' translated! !

!SdSystemWindow methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2011 12:46:14.678'!
getRawLabel

	^ label! !

!SdSystemWindow methodsFor: 'initialization' stamp: 'mt 5/2/2011 16:11:30.637'!
initializeLabelArea

	"Initialize the label area (titlebar) for the window."
	label := UiLabel new text: ('<font color="#DDDDDD"><b>', labelString, '</b></font>') asHtmlText.
	label fullBounds.
	
	"Add collapse box so #labelHeight will work"
	collapseBox := self createCollapseBox.
	stripes := Array
				with: (RectangleMorph newBounds: bounds)
				with: (RectangleMorph newBounds: bounds).
	
	"see extent:"
	self addLabelArea.
	self setLabelWidgetAllowance.
	self addApplicationBox.
	self addLabel; addSpacer.
	
	labelArea addMorphBack: self createAboutBox.
	labelArea addMorphBack: collapseBox.
	self addExpandBox.
	self addCloseBox.
			
	self setFramesForLabelArea.! !

!SdSystemWindow methodsFor: 'label' stamp: 'mt 5/1/2011 12:05:24.445'!
labelHeight

	^ label height! !

!SdSystemWindow methodsFor: 'menu' stamp: 'mt 5/1/2011 12:12:31.329'!
offerApplicationMenu

	| aMenu |
	aMenu := self buildWindowMenu.
	model ifNotNil:
		[model addModelItemsToWindowMenu: aMenu].
	aMenu popUpEvent: self currentEvent in: self world! !

!SdSystemWindow methodsFor: 'panes' stamp: 'mt 7/1/2011 17:57:36.847'!
paneColorToUse

	^ Display depth <= 2
		ifTrue: [Color white]
		ifFalse:[self isActive
			ifTrue: [(Color gray: 0.3) alpha: 0.8]
			ifFalse: [(Color gray: 0.5) alpha: 0.5]]! !

!SdSystemWindow methodsFor: 'as yet unclassified' stamp: 'mt 5/1/2011 12:28:10.415'!
passivate

	super passivate.
	label color: (Color gray: 0.2).! !

SdSystemWindow subclass: #SdToolWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdToolWindow methodsFor: 'as yet unclassified' stamp: 'mt 5/3/2011 14:42:46.822'!
initializeLabelArea

	"Initialize the label area (titlebar) for the window."
	label := UiLabel new text: ('<font color="#DDDDDD"><b>', labelString, '</b></font>') asHtmlText.
	label fullBounds.
	
	"Add collapse box so #labelHeight will work"
	collapseBox := self createCollapseBox.
	stripes := Array
				with: (RectangleMorph newBounds: bounds)
				with: (RectangleMorph newBounds: bounds).
	
	"see extent:"
	self addLabelArea.
	self setLabelWidgetAllowance.
	self addLabel; addSpacer.
	
"	labelArea addMorphBack: self createAboutBox.
	labelArea addMorphBack: collapseBox.
	self addExpandBox.
"	self addCloseBox.
			
	self setFramesForLabelArea.! !

PluggableTextAttribute subclass: #SdInformationLink
	instanceVariableNames: 'color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Support'!

!SdInformationLink class methodsFor: 'instance creation' stamp: 'mt 7/31/2011 13:59:08.688'!
argument

	^ self new color: (Color r: 69/255 g: 115/255 b: 213/255)! !

!SdInformationLink class methodsFor: 'instance creation' stamp: 'mt 7/31/2011 13:58:54.104'!
message

	^ self new color: (Color r: 69/255 g: 115/255 b: 213/255)! !

!SdInformationLink methodsFor: 'accessing' stamp: 'mt 7/18/2011 16:38:07.651'!
color

	^ color ifNil: [Purple]! !

!SdInformationLink methodsFor: 'accessing' stamp: 'mt 7/18/2011 16:38:15.793'!
color: aColor

	color := aColor.! !

!SdInformationLink methodsFor: 'styling' stamp: 'mt 7/18/2011 16:58:05.489'!
emphasizeScanner: scanner

	scanner
		textColor: self color;
		addEmphasis: 4 "underlined".! !

UiTestCase subclass: #SdOwnerChainSignalsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Tests'!

!SdOwnerChainSignalsTests methodsFor: 'as yet unclassified' stamp: 'mt 6/28/2011 16:26:29.1'!
subjectClass

	^ SdTestMorph! !

!SdOwnerChainSignalsTests methodsFor: 'tests' stamp: 'mt 6/28/2011 16:38:57.999'!
test01Connect

	sut connectSignal: #valueChanged: toSelector: #value.
	self
		assert: (sut signalConnectionsForOwnerChain includesKey: #valueChanged:);
		assert: 1 equals: (sut signalConnectionsForOwnerChain at: #valueChanged:) size.! !

!SdOwnerChainSignalsTests methodsFor: 'tests' stamp: 'mt 6/28/2011 16:42:28.881'!
test02Signal

	SdTestMorph new addMorph: (
		SdTestMorph new addMorph: sut).
		
	self
		assert: nil equals: sut value;
		assert: nil equals: sut owner value;
		assert: nil equals: sut owner owner value.
	
	sut owner owner connectSignal: #valueChanged: toSelector: #value:.
	sut value: #foobar.
	
	self
		assert: #foobar equals: sut value;
		assert: nil equals: sut owner value;
		assert: #foobar equals: sut owner owner value.! !

!SdOwnerChainSignalsTests methodsFor: 'tests' stamp: 'mt 6/28/2011 16:43:47.71'!
test03Disconnect

	sut connectSignal: #valueChanged: toSelector: #value:.
	self assert: sut signalConnectionsForOwnerChain notEmpty.
	
	sut disconnectSignal: #valueChanged: fromSelector: #value:.
	self assert: sut signalConnectionsForOwnerChain isEmpty.! !

UiPushButton subclass: #SdResizeHandle
	instanceVariableNames: 'flattened fadeAnimation mouseDownEventPosition mouseDownTargetExtent target orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdResizeHandle commentStamp: 'mt 4/13/2011 13:23:38.993' prior: 0!
A handle to resize morphs in width.!

!SdResizeHandle class methodsFor: 'testing' stamp: 'mt 4/14/2011 10:35:12.804'!
isWidgetClass

	^ false! !

!SdResizeHandle methodsFor: 'initialization' stamp: 'mt 4/15/2011 10:02:21.155'!
addGrips

	| container |
	container := Morph new
		color: Color transparent;
		changeTableLayout;
		listDirection: (self orientation = #vertical ifTrue: [#topToBottom] ifFalse: [#leftToRight]);  
		vResizing: (self orientation = #vertical ifTrue: [#spaceFill] ifFalse: [#shrinkWrap]);
		hResizing: (self orientation = #vertical ifTrue: [#shrinkWrap] ifFalse: [#spaceFill]);
		cellInset: 1;
		addMorphBack: (UiSpacer new orientation: self orientation; extent: 5@5).
		  
	4 timesRepeat: [container addMorphBack: (
		Morph new
			extent: 3@3;
			color: (Color gray: 0.7);
			borderStyle: (BorderStyle raised width: 1);
			ignoresColorMappings: true)].
		
	container addMorphBack: (UiSpacer new orientation: self orientation; extent: 5@5).
	
	self
		removeAllMorphs;
		addMorphBack: container.  ! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 4/15/2011 10:27:39.249'!
doHandleMovement: aMouseMoveEvent

	self target ifNil: [^ self].
	
	self orientation = #vertical ifTrue: [
		self target width:
			((mouseDownTargetExtent
				+ aMouseMoveEvent position
				- mouseDownEventPosition) x
			max: 50)].
		
	self orientation = #horizontal ifTrue: [
		self target height:
			((mouseDownTargetExtent
				+ aMouseMoveEvent position
				- mouseDownEventPosition) y
			max: 50)].! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 4/13/2011 13:02:53.838'!
fadeIn

	self visible ifFalse: [^ self].
	
	fadeAnimation
		ifNil: [^ self]
		ifNotNil: [:anim |
			anim unregister.
			fadeAnimation := nil].
	
	super fadeIn.! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 4/13/2011 13:19:26.159'!
fadeOut

	self visible ifFalse: [^ self].
	mouseDownEventPosition ifNotNil: [^ self].
	
	fadeAnimation ifNil: [fadeAnimation := (AnimAlphaBlendAnimation
		fadeOutOn: self
		duration: 200)
		register;
		start: #keepWhenFinished].! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 4/15/2011 10:17:02.852'!
finishHandleMovement: aMouseEvent

	mouseDownEventPosition := nil.
	mouseDownTargetExtent := nil.
	
	(self bounds containsPoint: aMouseEvent position)
		ifFalse: [self fadeOut].! !

!SdResizeHandle methodsFor: 'initialization' stamp: 'mt 5/9/2011 09:19:32.911'!
initialize

	orientation := #vertical.

	super initialize.
	
	self
		extent: 9@10;
		color: (Color gray: 0.85);
		listCentering: #center;
		layoutInset: 0;
		updateLayout;
		fadeOut.

	self connect: self eventHandler signal: #mouseEntered: toSelector: #fadeIn.
	self connect: self eventHandler signal: #mouseLeft: toSelector: #fadeOut.
	
	self connect: self eventHandler signal: #mousePressed: toSelector: #startHandleMovement:.
	self connect: self eventHandler signal: #mouseMoved: toSelector: #doHandleMovement:.
	self connect: self eventHandler signal: #mouseReleased: toSelector: #finishHandleMovement:.
	
	self connect: self eventHandler signal: #mouseClicked: toSelector: #onClick.
	
	"No keyboard handling."
	self eventHandler setProperty: #handlesKeyboard toValue: [false].
	self eventHandler disconnectSignal: #mousePressed: from: self selector: #grabKeyboard.! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 9/1/2011 13:15:49.366'!
onClick

	self target ifNil: [^ self].
	
	self orientation = #vertical
		ifTrue: [self target width: (self target optimalWidth max: 250)].! !

!SdResizeHandle methodsFor: 'accessing' stamp: 'mt 4/15/2011 09:50:35.156'!
orientation

	^ orientation! !

!SdResizeHandle methodsFor: 'accessing' stamp: 'mt 4/15/2011 09:55:12.167'!
orientation: aSymbol
	"#horizontal, #vertical"

	orientation = aSymbol ifTrue: [^ self].

	orientation := aSymbol.
	
	self
		extent: self height @ self width; "flip"
		updateLayout.! !

!SdResizeHandle methodsFor: 'actions' stamp: 'mt 5/9/2011 09:22:40.539'!
startHandleMovement: aMouseEvent

	self target ifNil: [^ self].

	mouseDownEventPosition := aMouseEvent position.
	mouseDownTargetExtent := self target extent.
! !

!SdResizeHandle methodsFor: 'accessing' stamp: 'mt 4/15/2011 09:48:53.381'!
target
	"Morph to be resized."
	
	^ target! !

!SdResizeHandle methodsFor: 'accessing' stamp: 'mt 4/15/2011 09:48:08.132'!
target: aMorph

	target := aMorph.! !

!SdResizeHandle methodsFor: 'updating' stamp: 'mt 4/15/2011 09:56:33.897'!
updateLayout

	self removeAllMorphs.
	
	self orientation = #horizontal ifTrue: [
		self
			hResizing: #spaceFill;
			vResizing: #rigid;
			listDirection: #topToBottom].
	
	self orientation = #vertical ifTrue: [
		self
			hResizing: #rigid;
			vResizing: #spaceFill;
			listDirection: #leftToRight].

	self addGrips.! !

Object subclass: #SdBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Benchmarks'!

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'abc 8/18/2011 19:41:38.481'!
all

	| results |
	results := OrderedCollection new.
	#(Monticello Seaside Magritte Pier) do: [:packageName |
		#(#coverageFor: #overheadForCoverage: #allTracesFor: #coveredTracesFor:) do: [:action |
			results add: (SdBenchmark perform: action with: packageName)]].
	
	^ results! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'mt 1/31/2012 13:57:14.527'!
allTracesFor: packageName

	| nums |
	nums := OrderedCollection new.
	
	SCoverageCollector updateCoverageForPackage: packageName.
	
	(PackageInfo named: packageName) classes
		select: [:c | (c inheritsFrom: TestCase) and: [c isAbstract not]]
		thenDo: [:c |
			(c shouldInheritSelectors
				ifTrue: [c allTestSelectors]
				ifFalse: [c testSelectors]) do: [:s |
				nums add: [SdCallgraphTracer new traceTest: c method: s] timeToRunWithoutGC]].
		
	^ {
	nums size.
	nums min.
	nums max.
	nums average asFloat.
	nums sum.
	nums median}! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'abc 8/20/2011 06:13:33.921'!
coverageFor: packageName

	| package nums methods nonTestMethods |
	package := PackageInfo named: packageName.
	
	"SdCoverageInstrumentor updateCoverageForPackage: packageName."
	
	nums := OrderedCollection new.

	package actualMethodsDo: [:method |
		nums add: method coveringTestMethods size].

	methods := package methods collect: [:m | m compiledMethod].
	nonTestMethods := (methods reject: [:m | m isTestMethod]).

	^ {
	nonTestMethods size.
	self numberOfTestsFor: packageName.
	nums average asFloat.
	(nums reject: [:i | i = 0]) size.
	(nums reject: [:i | i = 0]) average asFloat.
	(nums reject: [:i | i = 0]) median.
	(nums reject: [:i | i = 0]) size / nonTestMethods size asFloat.
	nums max}! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'mt 1/31/2012 13:57:20.376'!
coveredTracesFor: packageName

	| package nums |
	package := PackageInfo named: packageName.
	nums := OrderedCollection new.
	
	SCoverageCollector updateCoverageForPackage: packageName.

	package actualMethodsDo: [:method |
		| runs |
		runs := OrderedCollection new.

		method coveringTestMethods do: [:testMethod |
			runs add: [SdCallgraphTracer new
				traceTest: testMethod methodClass
				method: testMethod selector] timeToRunWithoutGC].
		runs ifNotEmpty: [nums add: runs sum]].

	^ {
	nums max.
	nums average asFloat.
	nums median}! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'abc 8/19/2011 09:20:56.622'!
methodsToTestsFor: packageName

	| packageInfo result cm |
	packageInfo := PackageInfo named: packageName.
	result := OrderedCollection new.
	cm := (packageInfo methods
		select: [:m | m compiledMethod coveringTestMethods size > 20]
		thenCollect: [:m | m compiledMethod]).

	Transcript cr; show: cm size.
	
	cm do: [:method1 | cm do: [:method2 |
		method1 ~~ method2 ifTrue: [
		result add: (method1 coveringTestMethods, method2 coveringTestMethods) size
			]]].
	
	^ {
	result size.
	result average asFloat.
	result max.
	result min.
	result median}! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'abc 8/18/2011 18:32:02.839'!
numberOfTestsFor: packageName

	| selectors |
	selectors := OrderedCollection new.

	(PackageInfo named: packageName) classes
		select:[:c | (c inheritsFrom: TestCase) and: [c isAbstract not]]
		thenDo: [:c | c shouldInheritSelectors
			ifTrue: [selectors addAll: c allTestSelectors]
			ifFalse: [selectors addAll: c testSelectors]].
		
	^ selectors size! !

!SdBenchmark class methodsFor: 'as yet unclassified' stamp: 'mt 1/31/2012 13:57:08.605'!
overheadForCoverage: packageName

	| suite testCases r1 r2 |
	testCases := (PackageInfo named: packageName) classes select: [:c |
		(c inheritsFrom: TestCase) and: [c isAbstract not]].
		
	r1 := [suite := TestSuite new.		
		testCases do: [:c | c addToSuiteFromSelectors: suite].
		suite run] timeToRunWithoutGC.
	
	r2 := [SCoverageCollector updateCoverageForPackage: packageName] timeToRunWithoutGC.
	
	^ {r1. r2}! !

Object subclass: #SdCallgraphModel
	uses: TUiItemModel + TSdDynamicAccessor
	instanceVariableNames: 'node checked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models'!

!SdCallgraphModel commentStamp: 'mt 3/23/2011 14:44:06.545' prior: 0!
| cgt tree |
cgt := SdCallgraphTracer new.
cgt profilingMode: #ms.
cgt selectedCategories: (PackageInfo named: #Widgets) systemCategories.
cgt callgraphModel: SdCallgraph new.
cgt traceSourceCode: 'UiTextEdit new'.
tree := UiTreeView new model: (SdCallgraphModel new root: cgt callgraphModel).
tree openInWorld.!

SdCallgraphModel class
	uses: TUiItemModel classTrait + TSdDynamicAccessor classTrait
	instanceVariableNames: ''!

!SdCallgraphModel methodsFor: 'comparing' stamp: 'mt 2/16/2012 15:34:59.999'!
= anObject

	^ self species = anObject species
		and: [self node == anObject node]! !

!SdCallgraphModel methodsFor: 'menus' stamp: 'mt 7/23/2011 10:48:23.245'!
browseMenuFor: node
	
	| menu |
	menu := MenuMorph new defaultTarget: self.

	menu
		add: 'Method Source'
		selector: #browseMethod:
		argument: node;
		addLine;
		add: ('Receiver Class [{1}]' format: {node receiverClass})
		selector: #browseReceiverClass:
		argument: node;
		add: ('Result Class [{1}]' format: {node returnClass})
		selector: #browseReturnClass:
		argument: node;
		addLine.
		
	node argumentNames withIndexDo: [:argName :idx |
		menu
		add: ('Class of ''{1}'' [{2}]' format: {
			argName.
			node argumentClasses ifNotNil: [:classes | classes at: idx]})
		target: self
		selector: #browseArgumentClass:index:
		argumentList: {node.idx}].


	^ menu! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/16/2012 15:48:57.445'!
checked

	^ checked ifNil: [false]! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/16/2012 16:52:07.34'!
checked: aBoolean

	aBoolean = checked ifTrue: [^ self].
	checked := aBoolean.
	
	self propertyChanged: #status.! !

!SdCallgraphModel methodsFor: 'item model - hierarchy' stamp: 'mt 2/16/2012 15:31:33.41'!
childAt: index

	^ SdCallgraphModel new
		node: (self node children at: index)! !

!SdCallgraphModel methodsFor: 'item model - hierarchy' stamp: 'mt 2/16/2012 15:30:31.608'!
childCount

	^ self node ifNotNil: [:n | n children size] ifNil: [0]! !

!SdCallgraphModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 15:20:24.59'!
classActivated: aClass

	self emit.! !

!SdCallgraphModel methodsFor: 'menus' stamp: 'mt 7/23/2011 10:48:19.357'!
exploreMenuFor: node
	
	| menu |
	menu := MenuMorph new defaultTarget: self.

	menu
		add: ('Receiver [{1} {2}]' format: {node receiverClass. node receiverId})
		selector: #exploreReceiverObject:
		argument: node;
		add: ('Result [{1} {2}]' format: {node returnClass. node returnId})
		selector: #exploreReturnObject:
		argument: node;
		addLine.
		
	node argumentNames withIndexDo: [:argName :idx |
		menu
		add: ('{1} [{2} {3}]' format: {
			argName.
			node argumentClasses ifNotNil: [:classes | classes at: idx].
			node argumentIds ifNotNil: [:ids | ids at: idx]})
		target: self
		selector: #exploreArgumentObject:index:
		argumentList: {node.idx}].


	^ menu! !

!SdCallgraphModel methodsFor: 'comparing' stamp: 'mt 2/16/2012 15:36:49.772'!
hash

	^ self species hash bitXor: [self node scaledIdentityHash]! !

!SdCallgraphModel methodsFor: 'properties' stamp: 'mt 2/16/2012 15:16:32.77'!
label

	self node isInstantiation ifTrue: [
		^ ('<font color="#{2}">Instantiate <b>{1}</b></font>' format: {
			self node clientClass theNonMetaClass.
			(self node clientClass theNonMetaClass inheritsFrom: TestCase)
				ifTrue: ['AAAAAA']
				ifFalse: ['008000']}) asHtmlText].
			
	self node clientMethod isTestMethod ifTrue: [
		^ ('<font color="#AAAAAA">Run <b>{1}</b></font>' format: {
			self node clientSelector}) asHtmlText].
			
	^ self node receiverClass = node clientClass
		ifTrue: [('{1} \\>\\> <b>{2}</b>' format: {
			self node receiverClass.
			self node clientSelector}) asHtmlText]
		ifFalse: [	('{1} <i>({2})</i> \\>\\> <b>{3}</b>' format: {
			self node receiverClass.
			self node clientClass.
			self node clientSelector}) asHtmlText].! !

!SdCallgraphModel methodsFor: 'menus' stamp: 'mt 2/16/2012 15:10:43.245'!
menu
	
	| menu |
	menu := MenuMorph new.

	menu
		add: 'Browse Code'
		icon: UiSilkIcons scriptCodeIcon
		"help: 'May require additional tracing which may cause a small delay. Be patient.'"
		subMenu: (self browseMenuFor: self node).

	menu
		add: 'Explore Object'
		icon: UiFugueIcons propertyIcon
		"help: 'May require additional tracing which may cause a small delay. Be patient.'"
		subMenu: (self exploreMenuFor: self node).

	self node clientMethod isTestMethod ifFalse: [
		menu
			add: 'View Trace'
			icon: UiFugueIcons nodeSelectIcon
			help: 'Open another trace that passes this method.'
			subMenu: (self traceMenuFor: self node)].
				
	^ menu! !

!SdCallgraphModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 15:20:20.984'!
methodActivated: aMethodReference

	self emit.! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/15/2012 21:09:02.383'!
node

	^ node! !

!SdCallgraphModel methodsFor: 'accessing' stamp: 'mt 2/15/2012 21:08:55.344'!
node: aCallgraphNode

	node := aCallgraphNode.! !

!SdCallgraphModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 15:20:17.057'!
objectActivated: anObject

	self emit.! !

!SdCallgraphModel methodsFor: 'properties' stamp: 'mt 2/16/2012 15:18:00.776'!
receiverIcon
	"Return an iconc representation of the receiver."
	
	^ (self node clientClass inheritsFrom: Morph)
		ifTrue: [self node clientClass widgetClassIcon]
		ifFalse: []

	! !

!SdCallgraphModel methodsFor: 'properties' stamp: 'mt 2/16/2012 15:51:58.737'!
status
	"Used to compute status icons. See SdCallGraphEditor>>initializeTree for more information."

	self flag: #weird.
	^ self node! !

!SdCallgraphModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/26/2011 16:48:01.291'!
traceActivated: aNode

	self emitAlways.! !

!SdCallgraphModel methodsFor: 'menus' stamp: 'mt 2/16/2012 15:12:15.849'!
traceMenuFor: node
	
	| menu |
	menu := MenuMorph new defaultTarget: self.

	(self collectCoveringNodes: node clientMethod)
		"Only choose callgraphs that are different to me."
		reject: [:nodes | nodes first callgraph traceEvent = self node callgraph traceEvent]
		thenDo: [:nodes | menu
			add: ('{1}>>{2}' format: {
				nodes first callgraph traceEvent testClass.
				nodes first callgraph traceEvent testSelector})
			selector: #traceActivated:
			argument: nodes first].
		
	MenuMorph new hasItems ifFalse: [
		^ nil].

	^ menu! !

Object subclass: #SdCodeNode
	uses: TUiItemModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

SdCodeNode class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

SdCodeNode subclass: #SdClassNode
	instanceVariableNames: 'theClass namespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

!SdClassNode class methodsFor: 'custom protocols' stamp: 'mt 2/12/2012 17:38:14.738'!
customProtocolChildAt: index for: aProtocolNode
	
	"--- all ---"
	^ SdMethodNode new
		method: (aProtocolNode theClass methodDict values,
			aProtocolNode theClass theMetaClass methodDict values
			at: index).! !

!SdClassNode class methodsFor: 'custom protocols' stamp: 'mt 2/12/2012 17:38:29.951'!
customProtocolChildCountFor: aProtocolNode

	aProtocolNode protocol = '--- all ---'
		ifTrue: [^ aProtocolNode theClass selectors size +
			aProtocolNode theClass theMetaClass selectors size].
		
	^ 0! !

!SdClassNode class methodsFor: 'custom protocols' stamp: 'mt 2/12/2012 17:14:38.282'!
customProtocols

	^ #('--- all ---')! !

!SdClassNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:35:24.743'!
= anObject

	^ super = anObject
		and: [self theClass == anObject theClass]! !

!SdClassNode methodsFor: 'item model - hierarchy' stamp: 'mt 2/12/2012 17:28:51.258'!
childAt: index

	^ SdProtocolNode new
		theClass: self theClass;
		protocol: (self protocols at: index)! !

!SdClassNode methodsFor: 'item model - hierarchy' stamp: 'mt 2/12/2012 17:13:11.514'!
childCount
	
	^ self protocols size! !

!SdClassNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:03:03.067'!
groupedClassLabel
	"E.g., 'Sd Class Node' plus formatting."
	
	| label cname |
	label := ''.
	(self theClass name startsWith: self namespace)
		ifTrue: [
			label := '<font color="#AAAAAA">', self namespace, '</color>'.
			cname := self theClass name allButFirst: self namespace size]
		ifFalse: [cname := self theClass name].
		
	'[[:upper:]][[:lower:]]*[[:digit:]]*' asRegex matchesIn: cname do: [:token |
		token = self namespace
			ifTrue: [label := label, '<font color="#AAAAAA">', self namespace, '</color>']
			ifFalse: [label := label, String space, token]].
		
	^ label withBlanksTrimmed asHtmlText! !

!SdClassNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:35:36.154'!
hash

	^ super hash bitXor: [self theClass hash]! !

!SdClassNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:03:53.866'!
icon

	^ SdMethodFinder iconForClass: self theClass! !

!SdClassNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:41.886'!
isClassNode

	^ true! !

!SdClassNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:01:23.457'!
namespace
	^ namespace! !

!SdClassNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:01:23.49'!
namespace: anObject
	namespace := anObject! !

!SdClassNode methodsFor: 'item model - properties' stamp: 'mt 2/12/2012 16:43:54.498'!
properties
	
	^ #(groupedClassLabel)! !

!SdClassNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:14:48.776'!
protocols

	^ (self theClass organization categories,
		self theClass theMetaClass organization categories
			reject: [:label | label = 'no messages']) asSet asArray,
		self class customProtocols! !

!SdClassNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:37:35.01'!
theClass
	^ theClass! !

!SdClassNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:37:35.043'!
theClass: anObject
	theClass := anObject! !

!SdCodeNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:34:26.319'!
= anObject

	^ self species == anObject species! !

!SdCodeNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:34:39.123'!
hash

	^ self species hash! !

!SdCodeNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:16.083'!
isClassNode

	^ false! !

!SdCodeNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:19.878'!
isMethodNode

	^ false! !

!SdCodeNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:23.065'!
isProtocolNode

	^ false! !

!SdCodeNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:30.145'!
isSystemCategoryNode

	^ false! !

SdCodeNode subclass: #SdMethodNode
	uses: TSdDynamicAccessor + TSdDynamicMenusForMethod
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

SdMethodNode class
	uses: TSdDynamicAccessor classTrait + TSdDynamicMenusForMethod classTrait
	instanceVariableNames: ''!

!SdMethodNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:38:45.48'!
= anObject

	^ super = anObject
		and: [self method == anObject method]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/14/2012 16:26:49.056'!
author

	| tokens |
	tokens := self timeStamp findTokens: ' '.
	^ tokens
		ifEmpty: [' ']
		ifNotEmpty: [tokens first]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:54:22.325'!
formattedAuthor

	^ ('<font color="#AAAAAA">', self author, '</font>') asHtmlText! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 18:01:04.905'!
formattedCoverage
	
	| numberOfTests |
	self method isTestMethod
		ifTrue: [^ nil].
		
	numberOfTests := self tests size.
	
	^ numberOfTests > 0
		ifTrue: [('<font color="#AAAAAA">', numberOfTests, '</font>') asHtmlText]
		ifFalse: [('<font color="#FF0000">0</font>') asHtmlText]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:50:16.214'!
formattedSelector

	^ self isMeta
		ifTrue: [^ ('<u>', self selector, '</u>') asHtmlText]
		ifFalse: [^ self selector]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/14/2012 16:49:34.129'!
formattedTimeStamp

	^ ('<font color="#AAAAAA">', (
		[self relativeTimeStampFor: (TimeStamp fromMethodTimeStamp: self timeStamp)]
			on: Error
			do: [' ']), '</font>') asHtmlText! !

!SdMethodNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:37:03.671'!
hash

	^ super hash bitXor: [self method hash]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 18:07:36.974'!
icon

	^ SdMethodFinder
		iconForClass: self theClass
		selector: self selector! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:20:32.274'!
isMeta

	^ self method methodClass isMeta! !

!SdMethodNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:08:52.355'!
isMethodNode

	^ true! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 3/22/2012 11:18:47.932'!
menu

	| menu |
	self method isTestMethod ifTrue: [^ nil].
	
	menu := (self menuForMethod: self method)
		ifNotNil: [:m | m addMorphFront: MenuLineMorph new; yourself]
		ifNil: [MenuMorph new].
	
	(self method methodClass isMeta and:[self method numArgs == 0]) ifTrue: [
		
		menu 
		addMorphFront: (MenuItemMorph new
			contents: ('Do It: "{1} {2}"' format: {self theClass theNonMetaClass name. self selector});
			target: self;
			selector: #doIt:;
			arguments: {self method})].
	
	menu 
		addMorphFront: (MenuItemMorph new
			contents: 'Open Method Source';
			target: self;
			selector: #methodActivated:;
			arguments: {self method methodReference}).

	^ menu! !

!SdMethodNode methodsFor: 'dynamic - menus' stamp: 'mt 3/22/2012 11:03:37.907'!
menuForMethod: aCompiledMethod
	
	| nodeGroups menu |
	menu := MenuMorph new.
	[nodeGroups := self collectCoveringNodes: aCompiledMethod]
		on: Error
		do: [^ nil].

	nodeGroups ifEmpty: [^ nil].

	menu
		add: 'Browse Class'
		icon: UiSilkIcons scriptCodeIcon
		subMenu: (self browseMenuForMethodNodes: nodeGroups).

	menu
		add: 'Explore Object'
		icon: UiFugueIcons propertyIcon
		subMenu: (self exploreMenuForMethodNodes: nodeGroups).		
		
	menu
		add: 'View Trace'
		icon: UiFugueIcons nodeSelectIcon
		subMenu: (self traceMenuForMethodNodes: nodeGroups).
	
	(self sendersMenuForMethodNodes: nodeGroups) ifNotNil: [:m |
		menu
			addLine;
			add: 'Senders'
			icon: UiFugueIcons arrowStepIcon
			subMenu: m].
		
	"(self implementorsMenuForMethodNodes: nodeGroups) ifNotNil: [:m |
		menu
			add: 'Implementors'
			icon: UiFugueIcons arrowStepOverIcon
			subMenu: m]."
		
	^ menu! !

!SdMethodNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:16:46.5'!
method
	^ method! !

!SdMethodNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:16:46.532'!
method: anObject
	method := anObject! !

!SdMethodNode methodsFor: 'item model - properties' stamp: 'mt 2/12/2012 18:01:59.946'!
properties
	
	^#(formattedSelector formattedCoverage formattedAuthor formattedTimeStamp)! !

!SdMethodNode methodsFor: 'support' stamp: 'mt 2/12/2012 17:53:29.315'!
relativeTimeStampFor: aTimeStamp
	"Convert the given time stamp into a formatted string."

	| dateString timeString |
	aTimeStamp date = Date today ifTrue: [dateString := 'Today'].
	aTimeStamp date = Date yesterday ifTrue: [dateString := 'Yesterday'].
	dateString ifNil: [dateString := aTimeStamp date printFormat: #(1 2 3 $- 1 1 2)].
	
	timeString := String streamContents:
		[ :aStream | aTimeStamp time print24: true showSeconds: false on: aStream ].
	
	^ dateString, ' ', timeString! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:50:22.845'!
selector

	^ self method selector! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 18:26:55.107'!
tests
	"Coverage information. See Sight-Coverage package."
	
	^ self method isTestMethod
		ifTrue: [#()]
		ifFalse: [self method hasMethodExtension
			ifTrue: [self method methodExtension tests]
			ifFalse: [#()]]! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:50:31.587'!
theClass

	^ self method methodClass! !

!SdMethodNode methodsFor: 'properties' stamp: 'mt 2/12/2012 17:51:37.701'!
timeStamp

	^ self method timeStamp! !

SdCodeNode subclass: #SdProtocolNode
	instanceVariableNames: 'theClass protocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

!SdProtocolNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:37:55.592'!
= anObject

	^ super = anObject
		and: [self theClass = anObject theClass]
		and: [self protocol = anObject protocol]! !

!SdProtocolNode methodsFor: 'item model - hierarchy' stamp: 'mt 2/12/2012 18:30:33.556'!
childAt: index

	| instanceSideSelectors |
	self isCustomProtocol
		ifTrue: [^ SdClassNode customProtocolChildAt: index for: self].
		
	instanceSideSelectors := self organization listAtCategoryNamed: protocol.

	^ SdMethodNode new
		method: (index > instanceSideSelectors size
		ifFalse: [self theClass >> (instanceSideSelectors at: index)]
		ifTrue: [
			| classSideSelectors |
			classSideSelectors := self metaOrganization listAtCategoryNamed: protocol.
			self theClass theMetaClass >> (classSideSelectors at: index - instanceSideSelectors size)]).
! !

!SdProtocolNode methodsFor: 'item model - hierarchy' stamp: 'mt 2/12/2012 18:05:15.465'!
childCount
	
	self isCustomProtocol
		ifTrue: [^ SdClassNode customProtocolChildCountFor: self].
		
	^ (self organization listAtCategoryNamed: self protocol) size
		+ (self metaOrganization listAtCategoryNamed: self protocol) size ! !

!SdProtocolNode methodsFor: 'properties' stamp: 'mt 2/12/2012 18:05:30.616'!
formattedLabel

	^ self isCustomProtocol
		ifTrue: [('<i>', self protocol, '</i>') asHtmlText]
		ifFalse: [self protocol]! !

!SdProtocolNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:38:22.804'!
hash

	^ [super hash
		bitXor: [self theClass hash]]
		bitXor: [self protocol hash]! !

!SdProtocolNode methodsFor: 'properties' stamp: 'mt 2/12/2012 18:05:38.196'!
icon

	^ self isCustomProtocol
			ifTrue: [UiSilkIcons tagBlueIcon]
			ifFalse: [UiSilkIcons tagOrangeIcon]! !

!SdProtocolNode methodsFor: 'testing' stamp: 'mt 2/12/2012 18:05:09.679'!
isCustomProtocol

	^ SdClassNode customProtocols includes: self protocol! !

!SdProtocolNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:09:07.423'!
isProtocolNode

	^ true! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:28:13.384'!
metaOrganization

	^ self theClass theMetaClass organization! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:28:23.188'!
organization

	^ self theClass organization! !

!SdProtocolNode methodsFor: 'item model - properties' stamp: 'mt 2/12/2012 17:47:49.819'!
properties
	
	^ #(formattedLabel)! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:11:45.029'!
protocol
	^ protocol! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:11:45.047'!
protocol: anObject
	protocol := anObject! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:28:38.857'!
theClass
	^ theClass! !

!SdProtocolNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 17:28:38.888'!
theClass: anObject
	theClass := anObject! !

SdCodeNode subclass: #SdSystemCategoryNode
	instanceVariableNames: 'category prefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

!SdSystemCategoryNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:49:36.705'!
= anObject

	^ super = anObject
		and: [self category = anObject category]! !

!SdSystemCategoryNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:01:33.354'!
category
	^ category! !

!SdSystemCategoryNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:01:33.387'!
category: anObject
	category := anObject! !

!SdSystemCategoryNode methodsFor: 'properties' stamp: 'mt 2/12/2012 16:17:23.623'!
categoryShortened

	^ self category = self prefix
		ifTrue: [self category]
		ifFalse: [self category allButFirst: self prefix size + 1]! !

!SdSystemCategoryNode methodsFor: 'item model - hierarchy' stamp: 'mt 2/12/2012 17:01:48.927'!
childAt: index

	^ SdClassNode new
		theClass: (Smalltalk at: (self classes at: index));
		namespace: (SdPackageModel namespaceForCategory: self category)! !

!SdSystemCategoryNode methodsFor: 'item model - hierarchy' stamp: 'mt 2/12/2012 16:39:47.834'!
childCount
	
	^ self classes size! !

!SdSystemCategoryNode methodsFor: 'properties' stamp: 'mt 2/12/2012 16:39:40.692'!
classes

	^ SystemOrganization listAtCategoryNamed: self category! !

!SdSystemCategoryNode methodsFor: 'comparing' stamp: 'mt 2/14/2012 17:52:08.89'!
hash

	^ super hash bitXor: [self category hash]! !

!SdSystemCategoryNode methodsFor: 'properties' stamp: 'mt 2/12/2012 16:19:08.971'!
icon

	(self category matchesRegexIgnoringCase: '.*(test).*')
		ifTrue: [^ UiSilkIcons folderLightbulbIcon].
		
	(self category matchesRegexIgnoringCase: '.*(core|kernel).*')
		ifTrue: [^ UiSilkIcons folderWrenchIcon].
		
	(self category matchesRegexIgnoringCase: '.*(model).*')
		ifTrue: [^ UiSilkIcons folderLinkIcon].
		
	^ UiSilkIcons folderIcon! !

!SdSystemCategoryNode methodsFor: 'testing' stamp: 'mt 2/14/2012 17:09:16.21'!
isSystemCategoryNode

	^ true! !

!SdSystemCategoryNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:01:33.409'!
prefix
	^ prefix! !

!SdSystemCategoryNode methodsFor: 'accessing' stamp: 'mt 2/12/2012 16:01:33.426'!
prefix: anObject
	prefix := anObject! !

!SdSystemCategoryNode methodsFor: 'item model - properties' stamp: 'mt 2/12/2012 16:19:45.613'!
properties
	
	^ #(categoryShortened)! !

Object subclass: #SdCoverageModel
	uses: TUiItemModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Coverage'!

SdCoverageModel class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!SdCoverageModel class methodsFor: 'view creation' stamp: 'mt 1/27/2012 11:13:33.931'!
openView

	| view |
	view := UiTreeView new
		addColumns: {
			((UiItemViewColumnSpec newFrom: {#headerText -> 'Name'. #text -> #label})
				textConverter: [:label | label asHtmlText]).
			UiItemViewColumnSpec newFrom: {#headerText -> 'Size'. #text -> #sizeLabel}};
		model: self new.
		
	view openInWorld.! !

!SdCoverageModel methodsFor: 'item model - hierarchy' stamp: 'mt 1/27/2012 10:34:29.476'!
childAt: index

	^ self children at: index! !

!SdCoverageModel methodsFor: 'item model - signals' stamp: ''!
childChanged: index

	self childrenChangedFrom: index to: index.! !

!SdCoverageModel methodsFor: 'item model - hierarchy' stamp: 'mt 1/27/2012 10:34:22.951'!
childCount
	
	^ self children size! !

!SdCoverageModel methodsFor: 'item model - signals' stamp: ''!
childInserted: index

	self childrenInsertedFrom: index to: index.! !

!SdCoverageModel methodsFor: 'item model - signals' stamp: ''!
childRemoved: index

	self childrenRemovedFrom: index to: index.! !

!SdCoverageModel methodsFor: 'item model - hierarchy' stamp: 'mt 1/27/2012 10:34:14.808'!
children

	^ {SdCoverageTestsNode new. SdCoverageNonTestsNode new}! !

!SdCoverageModel methodsFor: 'item model - signals' stamp: ''!
childrenChangedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageModel methodsFor: 'item model - signals' stamp: ''!
childrenInsertedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageModel methodsFor: 'item model - signals' stamp: ''!
childrenRemovedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageModel methodsFor: 'item model - signals' stamp: ''!
modelReset
	"The internal state has been invalidated. A view needs to refetch all indices."
	
	self emit.! !

!SdCoverageModel methodsFor: 'item model - signals' stamp: ''!
propertiesChanged: someProeprties

	self emit.! !

!SdCoverageModel methodsFor: 'item model - signals' stamp: ''!
propertyChanged: aSymbol
	"A property that may be used in an item view via a colum spec has changed and needs to be updated."

	self propertiesChanged: {aSymbol}.! !

Object subclass: #SdCoverageNonTestNode
	uses: TUiItemModel
	instanceVariableNames: 'nonTestMethodExtension'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Coverage'!

SdCoverageNonTestNode class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!SdCoverageNonTestNode methodsFor: 'item model - hierarchy' stamp: ''!
childAt: index

	self shouldBeImplemented.! !

!SdCoverageNonTestNode methodsFor: 'item model - signals' stamp: ''!
childChanged: index

	self childrenChangedFrom: index to: index.! !

!SdCoverageNonTestNode methodsFor: 'item model - hierarchy' stamp: 'mt 1/27/2012 10:58:43.26'!
childCount
	
	^ 0! !

!SdCoverageNonTestNode methodsFor: 'item model - signals' stamp: ''!
childInserted: index

	self childrenInsertedFrom: index to: index.! !

!SdCoverageNonTestNode methodsFor: 'item model - signals' stamp: ''!
childRemoved: index

	self childrenRemovedFrom: index to: index.! !

!SdCoverageNonTestNode methodsFor: 'item model - signals' stamp: ''!
childrenChangedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageNonTestNode methodsFor: 'item model - signals' stamp: ''!
childrenInsertedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageNonTestNode methodsFor: 'item model - signals' stamp: ''!
childrenRemovedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageNonTestNode methodsFor: 'properties' stamp: 'mt 1/27/2012 11:05:55.053'!
label

	^ '{1} \\>\\> <b>{2}</b>' format: {self theClass name. self selector}! !

!SdCoverageNonTestNode methodsFor: 'item model - signals' stamp: ''!
modelReset
	"The internal state has been invalidated. A view needs to refetch all indices."
	
	self emit.! !

!SdCoverageNonTestNode methodsFor: 'accessing' stamp: 'mt 1/27/2012 10:43:09.181'!
nonTestMethodExtension
	^ nonTestMethodExtension! !

!SdCoverageNonTestNode methodsFor: 'accessing' stamp: 'mt 1/27/2012 10:43:09.207'!
nonTestMethodExtension: anObject
	nonTestMethodExtension := anObject! !

!SdCoverageNonTestNode methodsFor: 'properties' stamp: 'mt 1/31/2012 12:19:42.805'!
numberOfTests

	^ self nonTestMethodExtension tests size! !

!SdCoverageNonTestNode methodsFor: 'item model - signals' stamp: ''!
propertiesChanged: someProeprties

	self emit.! !

!SdCoverageNonTestNode methodsFor: 'item model - signals' stamp: ''!
propertyChanged: aSymbol
	"A property that may be used in an item view via a colum spec has changed and needs to be updated."

	self propertiesChanged: {aSymbol}.! !

!SdCoverageNonTestNode methodsFor: 'properties' stamp: 'mt 1/27/2012 10:47:14.092'!
selector
	
	^ self nonTestMethodExtension clientMethod selector! !

!SdCoverageNonTestNode methodsFor: 'properties' stamp: 'mt 1/27/2012 11:08:42.695'!
sizeLabel

	^ self numberOfTests asString! !

!SdCoverageNonTestNode methodsFor: 'properties' stamp: 'mt 1/27/2012 10:47:07.23'!
theClass
	
	^ self nonTestMethodExtension clientMethod methodClass! !

Object subclass: #SdCoverageNonTestsNode
	uses: TUiItemModel
	instanceVariableNames: 'nonTestMethodExtensions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Coverage'!

SdCoverageNonTestsNode class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!SdCoverageNonTestsNode methodsFor: 'item model - hierarchy' stamp: 'mt 1/27/2012 10:43:47.158'!
childAt: index

	^ SdCoverageNonTestNode new
		nonTestMethodExtension: (self nonTestMethodExtensions at: index)! !

!SdCoverageNonTestsNode methodsFor: 'item model - signals' stamp: ''!
childChanged: index

	self childrenChangedFrom: index to: index.! !

!SdCoverageNonTestsNode methodsFor: 'item model - hierarchy' stamp: 'mt 1/27/2012 10:43:30.602'!
childCount

	^ self nonTestMethodExtensions size! !

!SdCoverageNonTestsNode methodsFor: 'item model - signals' stamp: ''!
childInserted: index

	self childrenInsertedFrom: index to: index.! !

!SdCoverageNonTestsNode methodsFor: 'item model - signals' stamp: ''!
childRemoved: index

	self childrenRemovedFrom: index to: index.! !

!SdCoverageNonTestsNode methodsFor: 'item model - signals' stamp: ''!
childrenChangedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageNonTestsNode methodsFor: 'item model - signals' stamp: ''!
childrenInsertedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageNonTestsNode methodsFor: 'item model - signals' stamp: ''!
childrenRemovedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageNonTestsNode methodsFor: 'properties' stamp: 'mt 1/27/2012 11:04:22.845'!
label

	^ 'Application'! !

!SdCoverageNonTestsNode methodsFor: 'item model - signals' stamp: ''!
modelReset
	"The internal state has been invalidated. A view needs to refetch all indices."
	
	self emit.! !

!SdCoverageNonTestsNode methodsFor: 'accessing' stamp: 'mt 1/31/2012 13:49:03.861'!
nonTestMethodExtensions

	^ nonTestMethodExtensions ifNil: [nonTestMethodExtensions := [
		| selectBlock result |
		result := OrderedCollection new.
		selectBlock := [:m | 
			(m hasMethodExtension and: [m isTestMethod not])
				ifTrue: [result add: m methodExtension]].
	
		ProtoObject allSubclassesDo: [:c |
			c methodsDo: selectBlock.
			c class methodsDo: selectBlock].
		
		result reject: [:ext | ext tests isEmpty]] value ].
! !

!SdCoverageNonTestsNode methodsFor: 'item model - signals' stamp: ''!
propertiesChanged: someProeprties

	self emit.! !

!SdCoverageNonTestsNode methodsFor: 'item model - signals' stamp: ''!
propertyChanged: aSymbol
	"A property that may be used in an item view via a colum spec has changed and needs to be updated."

	self propertiesChanged: {aSymbol}.! !

!SdCoverageNonTestsNode methodsFor: 'properties' stamp: 'mt 1/27/2012 11:09:04.137'!
sizeLabel

	^ ''! !

Object subclass: #SdCoverageTestNode
	uses: TUiItemModel
	instanceVariableNames: 'testMethodExtension'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Coverage'!

SdCoverageTestNode class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!SdCoverageTestNode methodsFor: 'item model - hierarchy' stamp: ''!
childAt: index

	self shouldBeImplemented.! !

!SdCoverageTestNode methodsFor: 'item model - signals' stamp: ''!
childChanged: index

	self childrenChangedFrom: index to: index.! !

!SdCoverageTestNode methodsFor: 'item model - hierarchy' stamp: 'mt 1/27/2012 10:58:53.607'!
childCount
	
	^ 0! !

!SdCoverageTestNode methodsFor: 'item model - signals' stamp: ''!
childInserted: index

	self childrenInsertedFrom: index to: index.! !

!SdCoverageTestNode methodsFor: 'item model - signals' stamp: ''!
childRemoved: index

	self childrenRemovedFrom: index to: index.! !

!SdCoverageTestNode methodsFor: 'item model - signals' stamp: ''!
childrenChangedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageTestNode methodsFor: 'item model - signals' stamp: ''!
childrenInsertedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageTestNode methodsFor: 'item model - signals' stamp: ''!
childrenRemovedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageTestNode methodsFor: 'properties' stamp: 'mt 1/27/2012 11:06:10.231'!
label

	^ '{1} \\>\\> <b>{2}</b>' format: {self testClass. self testSelector}! !

!SdCoverageTestNode methodsFor: 'item model - signals' stamp: ''!
modelReset
	"The internal state has been invalidated. A view needs to refetch all indices."
	
	self emit.! !

!SdCoverageTestNode methodsFor: 'properties' stamp: 'mt 1/31/2012 13:44:15.099'!
numberOfClasses

	^ 0! !

!SdCoverageTestNode methodsFor: 'properties' stamp: 'mt 1/31/2012 13:44:10.876'!
numberOfMethods

	^ self testMethodExtension coverage size! !

!SdCoverageTestNode methodsFor: 'item model - signals' stamp: ''!
propertiesChanged: someProeprties

	self emit.! !

!SdCoverageTestNode methodsFor: 'item model - signals' stamp: ''!
propertyChanged: aSymbol
	"A property that may be used in an item view via a colum spec has changed and needs to be updated."

	self propertiesChanged: {aSymbol}.! !

!SdCoverageTestNode methodsFor: 'properties' stamp: 'mt 1/27/2012 11:08:17.72'!
sizeLabel

	^ '{1} / {2}' format: {self numberOfClasses. self numberOfMethods}! !

!SdCoverageTestNode methodsFor: 'properties' stamp: 'mt 1/27/2012 10:59:32.925'!
testClass

	^ self testMethodExtension clientMethod methodClass! !

!SdCoverageTestNode methodsFor: 'accessing' stamp: 'mt 1/27/2012 10:43:04.312'!
testMethodExtension
	^ testMethodExtension! !

!SdCoverageTestNode methodsFor: 'accessing' stamp: 'mt 1/27/2012 10:43:04.343'!
testMethodExtension: anObject
	testMethodExtension := anObject! !

!SdCoverageTestNode methodsFor: 'properties' stamp: 'mt 1/27/2012 10:59:42.72'!
testSelector

	^ self testMethodExtension clientMethod selector! !

Object subclass: #SdCoverageTestsNode
	uses: TUiItemModel
	instanceVariableNames: 'testMethodExtensions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Coverage'!

SdCoverageTestsNode class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

!SdCoverageTestsNode methodsFor: 'item model - hierarchy' stamp: 'mt 1/27/2012 10:44:03.633'!
childAt: index

	^ SdCoverageTestNode new
		testMethodExtension: (self testMethodExtensions at: index)! !

!SdCoverageTestsNode methodsFor: 'item model - signals' stamp: ''!
childChanged: index

	self childrenChangedFrom: index to: index.! !

!SdCoverageTestsNode methodsFor: 'item model - hierarchy' stamp: 'mt 1/27/2012 10:44:12.602'!
childCount
	
	^ self testMethodExtensions size! !

!SdCoverageTestsNode methodsFor: 'item model - signals' stamp: ''!
childInserted: index

	self childrenInsertedFrom: index to: index.! !

!SdCoverageTestsNode methodsFor: 'item model - signals' stamp: ''!
childRemoved: index

	self childrenRemovedFrom: index to: index.! !

!SdCoverageTestsNode methodsFor: 'item model - signals' stamp: ''!
childrenChangedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageTestsNode methodsFor: 'item model - signals' stamp: ''!
childrenInsertedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageTestsNode methodsFor: 'item model - signals' stamp: ''!
childrenRemovedFrom: startIndex to: endIndex

	self emit.! !

!SdCoverageTestsNode methodsFor: 'properties' stamp: 'mt 1/27/2012 11:04:37.963'!
label

	^ 'Tests'! !

!SdCoverageTestsNode methodsFor: 'item model - signals' stamp: ''!
modelReset
	"The internal state has been invalidated. A view needs to refetch all indices."
	
	self emit.! !

!SdCoverageTestsNode methodsFor: 'item model - signals' stamp: ''!
propertiesChanged: someProeprties

	self emit.! !

!SdCoverageTestsNode methodsFor: 'item model - signals' stamp: ''!
propertyChanged: aSymbol
	"A property that may be used in an item view via a colum spec has changed and needs to be updated."

	self propertiesChanged: {aSymbol}.! !

!SdCoverageTestsNode methodsFor: 'properties' stamp: 'mt 1/27/2012 11:08:56.844'!
sizeLabel

	^ ''! !

!SdCoverageTestsNode methodsFor: 'accessing' stamp: 'mt 1/31/2012 12:21:09.653'!
testMethodExtensions

	^ testMethodExtensions ifNil: [testMethodExtensions := [
		| selectBlock result |
		result := OrderedCollection new.
		selectBlock := [:m | 
			(m hasMethodExtension and: [m isTestMethod])
				ifTrue: [result add: m methodExtension]].
	
		ProtoObject allSubclassesDo: [:c |
			c methodsDo: selectBlock.
			c class methodsDo: selectBlock].
		
		result] value ].
! !

Object subclass: #SdEditorState
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic'!

!SdEditorState methodsFor: 'accessing' stamp: 'mt 7/4/2011 15:45:36.932'!
addState: anEditorState

	^ (self properties at: #children ifAbsentPut: [OrderedCollection new])
		add: anEditorState! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 7/4/2011 18:00:30.59'!
loadCallGraphEditor: anEditor

	anEditor lastTraceItEvent: (self properties at: #lastTraceItEvent).! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 2/15/2012 16:44:13.494'!
loadClassEditor: anEditor

	anEditor theClass: (self properties at: #theClass).
	
	anEditor closeAll.

	(self properties at: #isInEditMode)
		ifTrue: [anEditor switchToEditUi].
		
	anEditor ui findBtn checked: (self properties at: #isFinderActive).
	anEditor ui commentBtn checked: (self properties at: #isCommentVisible).
	anEditor ui definitionBtn checked: (self properties at: #isDefinitionVisible).

	anEditor openMethods: (self properties at: #openMethods).
	anEditor methodEditors withIndexDo: [:me :index |
		((self properties at: #methodEditorsExpanded) at: index)
			ifTrue: [me expand]
			ifFalse: [me collapse]].! !

!SdEditorState methodsFor: 'loading - general' stamp: 'mt 7/4/2011 18:29:52.6'!
loadColumn: aColumn

	aColumn width: (self properties at: #width).
	(self properties at: #editorClasses) withIndexDo: [:editorClass :index |
		| editor |
		editor := editorClass new vResizing: #spaceFill.
		aColumn addMorphBack: editor.
		editor loadState: (self states at: index)].! !

!SdEditorState methodsFor: 'loading - general' stamp: 'mt 7/4/2011 18:28:14.683'!
loadEditor: anEditor

	(self properties at: #isExpanded)
		ifTrue: [anEditor expand]
		ifFalse: [anEditor collapse].! !

!SdEditorState methodsFor: 'loading - general' stamp: 'mt 7/4/2011 18:15:42.415'!
loadIDE: anIDE

	(self properties at: #fixedColumns) do: [:state |
		(anIDE addColumnIn: anIDE inFrontOf: anIDE scrollArea)
			loadState: state].
		
	(self properties at: #scrollableClumns) do: [:state |
		(anIDE addColumnIn: anIDE scrollArea widget inFrontOf: anIDE border)
			loadState: state].
		
	anIDE scrollArea horizontalScrollBar currentValue:
		(self properties at: #scrollOffset).! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 7/4/2011 18:07:09.435'!
loadObjectExplorer: anEditor

	anEditor object: (self properties at: #object).! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 7/4/2011 18:07:41.582'!
loadObjectInspector: anEditor! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 7/4/2011 18:09:13.704'!
loadPackageViewer: anEditor

	anEditor packageName: (self properties at: #packageName).
	anEditor ui treeView currentIndex: (self properties at: #index).! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 7/4/2011 18:10:25.814'!
loadTranscriptEditor: anEditor

	anEditor ui transcriptEdit theText: (self properties at: #text).! !

!SdEditorState methodsFor: 'loading - editors' stamp: 'mt 7/4/2011 18:11:56.884'!
loadWorkspaceEditor: anEditor

	anEditor ui workspaceEdit theText: (self properties at: #text).! !

!SdEditorState methodsFor: 'accessing' stamp: 'mt 7/4/2011 15:46:11.714'!
newState

	^ self addState: SdEditorState new! !

!SdEditorState methodsFor: 'accessing' stamp: 'mt 7/4/2011 15:07:18.576'!
properties

	^ properties ifNil: [properties := Dictionary new]! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 7/4/2011 17:20:02.426'!
saveCallGraphEditor: anEditor

	self properties at: #lastTraceItEvent put: anEditor lastTraceItEvent copy.! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 2/15/2012 16:43:50.267'!
saveClassEditor: anEditor

	self properties
		at: #theClass put: anEditor theClass;
		at: #isInEditMode put: anEditor isInEditMode;
		at: #isFinderActive put: anEditor ui findBtn checked;
		at: #isCommentVisible put: anEditor ui commentBtn checked;
		at: #isDefinitionVisible put: anEditor ui definitionBtn checked;
		at: #openMethods put: anEditor openMethods;
		at: #methodEditorsExpanded put: (anEditor methodEditors collect: [:me | me isExpanded]).! !

!SdEditorState methodsFor: 'saving - general' stamp: 'mt 7/4/2011 17:52:24.393'!
saveColumn: aColumn

	self properties
		at: #editorClasses put: (aColumn submorphs collect: [:morph |
			morph saveState: self newState.
			morph class]);
		at: #width put: aColumn width.! !

!SdEditorState methodsFor: 'saving - general' stamp: 'mt 7/4/2011 17:23:58.324'!
saveEditor: anEditor

	self properties
		at: #timestamp put: TimeStamp now;
		at: #isExpanded put: anEditor isExpanded.! !

!SdEditorState methodsFor: 'saving - general' stamp: 'mt 7/4/2011 17:29:55.361'!
saveIDE: anIDE

	self properties at: #fixedColumns put: (
		anIDE columnsFixed collect: [:column | | newState |
			newState := self newState.
			column saveState: newState.
			newState]).
		
	self properties at: #scrollableClumns put: (
		anIDE columnsScrollable collect: [:column | | newState |
			newState := self newState.
			column saveState: newState.
			newState]).
		
	self properties at: #scrollOffset put: anIDE scrollArea horizontalScrollBar currentValue.! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 7/4/2011 17:16:08.309'!
saveObjectExplorer: anEditor

	self properties at: #object put: anEditor object. "copy?"! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 7/4/2011 15:17:59.163'!
saveObjectInspector: anEditor! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 7/4/2011 17:15:50.283'!
savePackageViewer: anEditor

	self properties
		at: #packageName put: anEditor packageName;
		at: #index put: anEditor ui treeView currentIndex copy. "may break"! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 7/4/2011 17:15:41.839'!
saveTranscriptEditor: anEditor

	self properties at: #text put: anEditor ui transcriptEdit theText copy.! !

!SdEditorState methodsFor: 'saving - editors' stamp: 'mt 7/4/2011 17:16:38.306'!
saveWorkspaceEditor: anEditor

	self properties at: #text put: anEditor ui workspaceEdit theText copy.! !

!SdEditorState methodsFor: 'accessing' stamp: 'mt 7/4/2011 15:28:40.934'!
states
	
	^ self properties at: #children ifAbsent: [OrderedCollection new]! !

Object subclass: #SdFoobar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Testbed'!

!SdFoobar methodsFor: 'as yet unclassified' stamp: 'mt 7/31/2011 20:35:20.112'!
initialize

	^ super initialize! !

Object subclass: #SdObjectExplorerModel
	uses: TUiItemModel + TSdDynamicAccessor
	instanceVariableNames: 'before after node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models'!

!SdObjectExplorerModel commentStamp: '<historical>' prior: 0!
This is a tree model that uses object explorer wrappers to simluate the object explorer in an item view (tree, table, list).!

SdObjectExplorerModel class
	uses: TUiItemModel classTrait + TSdDynamicAccessor classTrait
	instanceVariableNames: ''!

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:12:01.372'!
after

	^ after! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:11:57.011'!
after: aWrapper

	after := aWrapper.! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 16:46:51.462'!
afterIcon

	^ [self after icon ifNil: [SdMethodFinder blankIcon]]
		on: Error do: [SdMethodFinder blankIcon]! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 16:45:53.864'!
afterMenu
	
	^ self menuFor: self afterObject! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:40:57.42'!
afterObject

	^ self after ifNotNil: [:wrapper |
		wrapper withoutListWrapper]! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 17:34:05.699'!
afterText

	| afterString beforeString |
	self after ifNil: [
		^ '<font color="#AAAAAA">\<out of scope\></font>' asHtmlText].

	afterString := [self afterObject asExplorerString]
		on: Error
		do: [nil].
	
	afterString ifNil: [^ '<font color="#FF0000">???</font>' asHtmlText].
	
	beforeString := [self afterObject asExplorerString]
		on: Error
		do: [nil].
	
	afterString = beforeString ifTrue: [
		^ '<font color="#AAAAAA">\<unchanged\></font>' asHtmlText].
	! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:38:11.054'!
base
	"This object will be used to determine the instance variables."

	^ self beforeObject
		ifNil: [self after "use initialized type"]
		ifNotNil: [self before]! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:41:04.431'!
baseObject
	"This object will be used to determine the instance variables."

	^ self base ifNotNil: [:wrapper |
		wrapper withoutListWrapper]! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:11:44.073'!
before

	^ before ! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:11:52.077'!
before: aWrapper

	before := aWrapper.! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 17:03:02.068'!
beforeIcon

	^ [self before icon ifNil: [SdMethodFinder blankIcon]]
		on: Error do: [SdMethodFinder blankIcon]! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 16:45:44.437'!
beforeMenu
	
	^ self menuFor: self beforeObject! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:41:10.214'!
beforeObject

	^ self before ifNotNil: [:wrapper |
		wrapper withoutListWrapper]! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 17:20:20.052'!
beforeText

	self before ifNil: [
		^ '<font color="#AAAAAA">\<out of scope\></font>' asHtmlText].

	^ [self beforeObject asExplorerString]
		on: Error
		do: ['<font color="#FF0000">???</font>' asHtmlText]! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:43:50.415'!
callgraph

	^ self node
		ifNotNil: [:n | n callgraph]! !

!SdObjectExplorerModel methodsFor: 'item model - hierarchy' stamp: 'mt 3/22/2012 16:44:10.516'!
childAt: index

	| baseWrapper |
	baseWrapper := self base contents at: index.
	
	^ SdObjectExplorerModel new
		node: self node;
		before: (self base == self before
			ifTrue: [baseWrapper]
			ifFalse: [self baseObject class ~~ self beforeObject class
				ifTrue: [nil "Type mismatch!!"]
				ifFalse: [self before contents at: index]]);
		after: (self base == self after
			ifTrue: [baseWrapper]
			ifFalse: [self baseObject class ~~ self afterObject class
				ifTrue: [nil "Type mismatch!!"]
				ifFalse: [self after contents at: index]])! !

!SdObjectExplorerModel methodsFor: 'item model - hierarchy' stamp: 'mt 3/22/2012 17:22:40.992'!
childCount

	^ self base
		ifNil: [0]
		ifNotNil: [:wrapper |
			wrapper withoutListWrapper isString
				ifTrue: [0]
				ifFalse: [wrapper contents size]]! !

!SdObjectExplorerModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/26/2011 16:48:57.204'!
classActivated: aClass

	self emitAlways.! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 16:45:36.153'!
menuFor: anObject
	
	| menu |	

	menu := MenuMorph new
		defaultTarget: self.

	menu
		add: ('Browse Class [{1}]' format: {anObject class})
		selector: #classActivated:
		argument: anObject class.
		
	menu
		add: 'Explore'
		selector: #objectActivated:
		argument: anObject.
	
	menu
		addLine;
		add: ('Back to Trace [{1}>>{2}]' format: {
			self callgraph traceEvent testClass.
			self callgraph traceEvent testSelector})
		target: self
		selector: #traceActivated:
		argument: self node.
				
	^ menu! !

!SdObjectExplorerModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/26/2011 16:48:51.427'!
methodActivated: aMethodReference

	self emitAlways.! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:43:06.177'!
node

	^ node! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 16:43:14.268'!
node: aCallgraphNode

	node := aCallgraphNode.! !

!SdObjectExplorerModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/26/2011 16:48:46.93'!
objectActivated: anObject

	self emitAlways.! !

!SdObjectExplorerModel methodsFor: 'accessing' stamp: 'mt 3/22/2012 17:02:33.78'!
setStateChange: anObjectStateChange

	self before: (ObjectExplorerWrapper
		with: anObjectStateChange before
		name: 'root before'
		model: self).
		
	self after: (ObjectExplorerWrapper
		with: anObjectStateChange after
		name: 'root after'
		model: self).
		
	self node: anObjectStateChange node.
	
	self modelReset.! !

!SdObjectExplorerModel methodsFor: 'properties' stamp: 'mt 3/22/2012 17:40:41.173'!
tag

	^ ('<font color="#777777">', self base itemName,'</font>') asHtmlText! !

!SdObjectExplorerModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 7/26/2011 16:48:24.514'!
traceActivated: aNode

	self emitAlways.! !

Object subclass: #SdObjectStateChange
	instanceVariableNames: 'before after node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Support'!

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 14:45:08.471'!
after

	^ after! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 14:45:03.354'!
after: anObject

	after := anObject.! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 14:44:49.012'!
before

	^ before! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 14:44:56.439'!
before: anObject

	before := anObject.! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 15:08:02.314'!
callgraph

	^ self node ifNotNil: [:node | node callgraph]! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 15:07:34.134'!
node

	^ node! !

!SdObjectStateChange methodsFor: 'accessing' stamp: 'mt 7/18/2011 15:07:42.106'!
node: aNode

	node := aNode.! !

Object subclass: #SdPackageModel
	uses: TUiItemModel + TSdDynamicAccessor
	instanceVariableNames: 'packageInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Models-Code'!

SdPackageModel class
	uses: TUiItemModel classTrait + TSdDynamicAccessor classTrait
	instanceVariableNames: 'namespaces'!

!SdPackageModel commentStamp: '<historical>' prior: 0!
This item model can be used to show detailed information about one package.!

SdPackageModel class
	uses: TUiItemModel classTrait + TSdDynamicAccessor classTrait
	instanceVariableNames: 'namespaces'!

!SdPackageModel class methodsFor: 'instance creation' stamp: 'mt 5/17/2011 10:31:42.441'!
forPackageNamed: aString

	^ self new
		packageInfo: (PackageInfo named: aString)! !

!SdPackageModel class methodsFor: 'namespaces' stamp: 'mt 2/12/2012 17:00:34.842'!
guessNamespaceForCategory: aSystemCategory

	| frequency max |
	frequency := Dictionary new.
	
	(SystemOrganization listAtCategoryNamed: aSystemCategory)
		collect: [:className | Smalltalk at: className]
		thenDo: [:class | | combinedTokens |
			"Prefix is uppercase."
			(class name first isUppercase and: [class name second isUppercase])
				ifTrue: [ | p |
					p := ''.
					class name detect: [:char | char isUppercase
						ifTrue: [p := p, char. false]
						ifFalse: [
							p := p allButLast.
							frequency
								at: p
								put: (frequency at: p ifAbsentPut: [0]) + 1. true]]].	

			"Prefix is not uppercase."
			combinedTokens := ''.
			'[[:upper:]][[:lower:]]+' asRegex
				matchesIn: class name
				do: [:token | combinedTokens := combinedTokens, token.
					frequency
						at: combinedTokens
						put: (frequency at: combinedTokens ifAbsentPut: [0]) + 1]].
	
		max := '' -> 0.
		frequency associationsDo: [:assoc |
			assoc value > max value
				ifTrue: [max := assoc]].

	^ max key! !

!SdPackageModel class methodsFor: 'namespaces' stamp: 'mt 2/12/2012 17:00:57.094'!
namespaceForCategory: aSystemCategory

	namespaces ifNil: [namespaces := Dictionary new].
		
	^ namespaces
		at: aSystemCategory
		ifAbsentPut: [self guessNamespaceForCategory: aSystemCategory]! !

!SdPackageModel methodsFor: 'item model - hierarchy' stamp: 'mt 2/12/2012 18:18:26.533'!
childAt: index
	
	^ SdSystemCategoryNode new
		category: (self packageInfo systemCategories at: index);
		prefix: self packageInfo systemCategoryPrefix! !

!SdPackageModel methodsFor: 'item model - hierarchy' stamp: 'mt 2/12/2012 18:19:47.096'!
childCount
	
	^ self packageInfo
		ifNil: [0]
		ifNotNil: [:pkg | pkg systemCategories size]! !

!SdPackageModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 10:52:43.743'!
classActivated: aClass

	self emitAlways.! !

!SdPackageModel methodsFor: 'actions' stamp: 'mt 3/22/2012 11:21:13.141'!
doIt: aCompiledMethod
	"Exectue the given method. The method needs to expect 0 arguments."
	
	Transcript
		cr;
		show: (aCompiledMethod methodClass theNonMetaClass perform: aCompiledMethod selector).! !

!SdPackageModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 10:52:39.206'!
methodActivated: aMethodReference

	self emitAlways.! !

!SdPackageModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 10:52:35.092'!
objectActivated: anObject

	self emitAlways.! !

!SdPackageModel methodsFor: 'accessing' stamp: 'mt 2/14/2012 16:06:35.832'!
packageInfo

	^ packageInfo! !

!SdPackageModel methodsFor: 'accessing' stamp: 'mt 2/14/2012 16:20:10.554'!
packageInfo: aPackageInfo

	aPackageInfo = packageInfo ifTrue: [^ self].

	packageInfo := aPackageInfo.
	
	self modelReset.! !

!SdPackageModel methodsFor: 'dynamic - signals - activation' stamp: 'mt 2/16/2012 10:52:29.093'!
traceActivated: aNode

	self emitAlways.! !

Object subclass: #SdParserHelper
	instanceVariableNames: 'text view selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-Support'!

!SdParserHelper commentStamp: 'mt 4/11/2011 09:38:06.258' prior: 0!
Used for notification of default parser.!

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 5/1/2011 14:28:00.192'!
correctFrom: start to: end with: string

	"Ignore."! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 5/1/2011 14:20:07.806'!
deselect! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 4/13/2011 11:15:37.231'!
notify: aMessage at: aLocation in: aSource

	self view
		notify: (aMessage allButLast: 3) "remove trailing ' ->' "
		at: aLocation
		in: aSource.! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 4/11/2011 09:56:44.834'!
select
! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 4/11/2011 10:13:37.356'!
selectFrom: startIndex to: endIndex

	self selection: (startIndex to: endIndex).! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 5/1/2011 14:20:53.512'!
selectInvisiblyFrom: startIndex to: endIndex

	self selection: (startIndex to: endIndex).! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 5/1/2011 14:24:34.748'!
selectedText

	self selection ifNil: [^ nil].

	^ self text
		copyFrom: self selection first
		to: self selection last! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 10:13:18.346'!
selection

	^ selection! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 10:13:26.415'!
selection: anInterval

	selection := anInterval.! !

!SdParserHelper methodsFor: 'interactive error handling' stamp: 'mt 4/11/2011 09:40:44.679'!
selectionInterval

	^ 1 to: 0! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:41:19.665'!
text

	^ text! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:41:26.804'!
text: stringOrText

	text := stringOrText.! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:46:17.653'!
view

	^ view! !

!SdParserHelper methodsFor: 'accessing' stamp: 'mt 4/11/2011 09:46:25.661'!
view: aMorph

	view := aMorph.! !

Object subclass: #SdPreviewBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Dynamic-UI-Support'!

!SdPreviewBuilder class methodsFor: 'building' stamp: 'mt 7/17/2011 22:21:28.318'!
createClassPreviewFor: aClass

	| classComment preview |
	classComment := aClass theNonMetaClass organization classComment.
	classComment ifEmpty: [^ nil].
	
	preview := UiTextEdit new
		extent: 300@150;
		colorBackground: Color yellow muchLighter paler;
		updateFocusColor: false;  
		scrollingMode: #limit;
		scrollingLimit: 10;
		scrollBarThickness: 9;
		readOnly: true;  
		theText: classComment.
		
	^ preview! !

!SdPreviewBuilder class methodsFor: 'building' stamp: 'mt 7/17/2011 22:11:21.14'!
createMethodPreviewFor: aMethodReference
	
	| preview |	
	preview := SdSourceCodeEdit new
		readOnly: true;
		theClass: aMethodReference actualClass
		selector: aMethodReference selector;
		scrollingMode: #limit;
		scrollingLimit: 10;
		scrollBarThickness: 9;
		displayMode: #highlight;
		colorHighlightedBackground: Color yellow muchLighter paler;
		colorHighlightedBorder: (Color gray: 0.6);
		updateFocusColor: false;
		hideInfoButtons.
	
	preview verticalScrollBar buttonMode: #none.
	
	preview
		reset;
		width: preview optimalWidth.
		
	^ preview! !
